/************************************************************************
*
* Server for the DevCon 2007 in Berlin, Germany
*
* Prerequisites for compiling and using:
* <*> Xbase++ 1.9
* <*> AsiNet  1.9
* <*> Xb2.NET 3.1
* <*> XbzLib  -> http://www.idep.org.uk/xbase/XbZLib14.zip
* <*> BLAT    -> http://www.blat.net/

* <*> RMChart -> http://www.rmchart.com/rmc/downloads/setup/setup.exe
*
*************************************************************************/

#include "devcondefs.ch"
#include "DIRECTRY.CH"
#include "ERROR.CH"
#include "xb2net.ch"
#include "fileio.ch"
#include "Dbstruct.ch"
#include "XbZ_Zip.ch"
#include "service.ch" 
#include "os.ch"
#include "simpleio.ch"
#include "rmchart.CH"
#include "asinet.ch"

#PRAGMA LIBRARY( "ASCOM10.LIB" ) 

#define CRLF   chr(13)+chr(10)

//The following #define lets the program run as a normal program.
//If you install it to run as a service you would have to comment this line out!
#define alsexe

#define BACKUP_DIR          'C:'
#define LW                  'C:'

#define ERR_LOG_FILE        '\ERROR.LOG'
#define WEB_LOG             '\SURFELOG.TXT'
#define APP_ROOT            LW + '\DevCon'
#define WWW_ROOT            APP_ROOT + '\wwwroot'
#define statistik           WWW_ROOT + '\stats'
#define datenpfad           APP_ROOT + '\Daten'
#define logpfad             APP_ROOT + '\LOG'
#define mlogpfad            logpfad + '\mail'
#define mempfad             APP_ROOT + '\PayPal'
#define rempfad             mempfad + '\removed'
#define bestaetigungspfad   APP_ROOT + '\Receipt'
#define SERVER_ERR_LOG_FILE '\DEVCONSERVERERROR.LOG'
#define MELDE_LOG           '\MELDELOG.TXT'

// use your Mailaddress here
#define WEBMASTER           'mail@webmaster.de'

// use your Mailaddress here
#define MAILMASTER          'mail@devconserver.de'

PROCEDURE Main()
local bla, bla2, dat
local i, astructure
local aArgs, istOK
local bOldError, oError
#ifdef alsexe
local nindex
#endif
public texte, laender, sprachen, frsprachen, xbversionen, preisnorm1, preiserm1, preisnorm2, preiserm2, preisnorm3, preiserm3, paypalac, paypalnurl, paypalrurl, paypalcrurl, shinter, chartcontrol, oForm, User, Password, bic, iban, blz, kto, bank, regend, earlybird, latebird, BOUser, BOPassword, speakdat, pcws, dcid
PUBLIC oWebServer, cMailadress1, cMailadress2, cMailuser, cMailpassword, cSMTPserver, cWebserver, aMapGraSizes

MEMVAR->preisnorm1 := 430
MEMVAR->preiserm1 := 180
MEMVAR->preisnorm2 := 480
MEMVAR->preiserm2 := 180
MEMVAR->preisnorm3 := 560
MEMVAR->preiserm3 := 180
MEMVAR->earlybird := 20070616
MEMVAR->latebird := 20071001
MEMVAR->regend := 20071112
MEMVAR->speakdat := 20070303
MEMVAR->aMapGraSizes := Array( 4 )
MEMVAR->shinter := "#FFFFFF"

// provide your SMTP-server here!
MEMVAR->cSMTPserver := "localhost"
// in case your SMTP-server requires authentification, provide your credentials here!
MEMVAR->cMailuser := ""
MEMVAR->cMailpassword := ""

// provide your Webserver here!
MEMVAR->cWebserver := "localhost"

// use your own PayPal-account here!
MEMVAR->paypalac := "mail@domain.de"

MEMVAR->paypalnurl := "http://" + MEMVAR->cWebserver + "/PayPal_IPN_Validate?DevConID="
MEMVAR->paypalrurl := "http://" + MEMVAR->cWebserver + "/PayPal_Return?MenuVar="
MEMVAR->paypalcrurl := "http://" + MEMVAR->cWebserver + "/PayPal_CancelReturn?MenuVar="

MEMVAR->User := "Test"
MEMVAR->Password := "4teSt"
MEMVAR->BOUser := "BOTest"
MEMVAR->BOPassword := "BO4teSt"
MEMVAR->bic := "SWIFT-BIC of your Bank"
MEMVAR->iban := "IBAN of your Bank"
MEMVAR->blz := "BLZ of your Bank"
MEMVAR->kto := "Accountnumber of your Bank"
MEMVAR->bank := "Name of your Bank"

MEMVAR->oForm := XbpDialog():new( AppDesktop() ) 
MEMVAR->oForm:drawingArea:clipChildren := .T. 
MEMVAR->oForm:create( ,,{100,100}, {640,480},, .F. ) 

MEMVAR->chartcontrol := XbpActiveXControl():new( MEMVAR->oForm:drawingArea )

// Create the RMChart object!
MEMVAR->chartcontrol:CLSID := 'RMChart.RMChartX'
bOldError := ErrorBlock( {|e| Break(e)} ) 
BEGIN SEQUENCE 
MEMVAR->chartcontrol:create(,, {10,60},{610,370} ) 
RECOVER USING oError
	SaveToFile( ConvToAnsiCp( "______ RMChart ERROR __________ Object error _________________" + DtoC( Date() ) + "_" + Time() + CRLF + "RMChart cannot be started as it is not installed!" ), SERVER_ERR_LOG_FILE )
	MEMVAR->chartcontrol := NIL
END SEQUENCE 
ErrorBlock( bOldError ) 

//provide the mailaddresses here to send the backups and confirmationmails to
MEMVAR->cMailadress1 := "mail1@domain.de"
MEMVAR->cMailadress2 := "mail2@domain.de"

//Texts to display throughout the app in the different languages...
MEMVAR->texte := array( alle_texte, spr_co )
SET EPOCH TO year( date() ) - 20
MEMVAR->texte[ anrede, spr_de ] := "Anrede:"
MEMVAR->texte[ dattrenner, spr_de ] := "."
MEMVAR->texte[ vorname, spr_de ] := "Vorname:"
MEMVAR->texte[ nachname, spr_de ] := "Nachname:"
MEMVAR->texte[ firma1, spr_de ] := "Firmenname:"
MEMVAR->texte[ abteilung, spr_de ] := "Abteilung:"
MEMVAR->texte[ strasse, spr_de ] := "Stra" + sz + "e:"
MEMVAR->texte[ staat, spr_de ] := "Bundesland/Kanton:"
MEMVAR->texte[ plz, spr_de ] := "Postleitzahl:"
MEMVAR->texte[ ort, spr_de ] := "Ort:"
MEMVAR->texte[ land, spr_de ] := "Land:"
MEMVAR->texte[ email, spr_de ] := "E-Mailadresse:"
MEMVAR->texte[ webseite, spr_de ] := "Webseite:"
MEMVAR->texte[ teilnehmer, spr_de ] := "Ich nehme teil als:"
MEMVAR->texte[ teiltnehmer, spr_de ] := "Teilnehmer"
MEMVAR->texte[ teilpartner, spr_de ] := "(Ehe-)Partner(in)"
MEMVAR->texte[ teilkind, spr_de ] := "Kind"
MEMVAR->texte[ teilfreund, spr_de ] := "Freund(in)"
MEMVAR->texte[ teilredner, spr_de ] := "Redner"
MEMVAR->texte[ teilorgan, spr_de ] := "Organisator"
MEMVAR->texte[ muttersprache, spr_de ] := "Meine Muttersprache:"
MEMVAR->texte[ fremdsprache1, spr_de ] := "Erste Fremdsprache:"
MEMVAR->texte[ fremdsprache2, spr_de ] := "Weitere Fremdsprache:"
MEMVAR->texte[ xbaseversion, spr_de ] := "Ich arbeite bereits mit Xbase++ (Version ausw" + ae + "hlen):"
MEMVAR->texte[ laptop, spr_de ] := "Ich bringe meinen Laptop mit"
MEMVAR->texte[ xbasesprachen, spr_de ] := "Folgende Kenntnisse anderer xbase-Sprachen habe ich:"
MEMVAR->texte[ ksnutze, spr_de ] := "Nutze ich"
MEMVAR->texte[ kshatte, spr_de ] := "Hatte ich genutzt"
MEMVAR->texte[ kskenne, spr_de ] := "Habe ich schon mal geh" + oe + "rt"
MEMVAR->texte[ ksnicht, spr_de ] := "Kenne ich nicht"
MEMVAR->texte[ addons, spr_de ] := "Meine Kenntnisse zu diversen Add-Ons:"
MEMVAR->texte[ addonwill, spr_de ] := "Will ich nutzen"
MEMVAR->texte[ meldedatum, spr_de ] := "Datum der Anmeldung"
MEMVAR->texte[ meldestatus, spr_de ] := "Status der Anmeldung"
MEMVAR->texte[ interessen, spr_de ] := "Meine Interessensschwerpunkte f" + ue + "r diese DevCon:"
MEMVAR->texte[ interja, spr_de ] := "Interessiert mich"
MEMVAR->texte[ internein, spr_de ] := "Interessiert mich nicht"
MEMVAR->texte[ devcons, spr_de ] := "An den folgenden Xbase++-DevCons habe ich bereits teilgenommen:"
MEMVAR->texte[ devcon20011, spr_de ] := "Mailand (Italien) 2001"
MEMVAR->texte[ devcon20012, spr_de ] := "Manchester (USA, NH) 2001"
MEMVAR->texte[ devcon2002, spr_de ] := "Manchester (USA, NH) 2002"
MEMVAR->texte[ devcon2004, spr_de ] := "Venlo (Niederlande) 2004"
MEMVAR->texte[ devcon2006, spr_de ] := "Manchester (USA, NH) 2006"
MEMVAR->texte[ zteilnehmerid, spr_de ] := "Bitte geben Sie die folgende ID bei R" + ue + "ckfragen mit an:"
MEMVAR->texte[ teilnehmerid, spr_de ] := "Ihre ID lautet:"
MEMVAR->texte[ devconueber, spr_de ] := "Anmeldung zur DevCon in Berlin vom 13.11. - 16.11.2007"
MEMVAR->texte[ intsql, spr_de ] := "SQL-Anbindung"
MEMVAR->texte[ intweb, spr_de ] := "Internetanbindung"
MEMVAR->texte[ intmig, spr_de ] := "Migration von Clipper"
MEMVAR->texte[ intactivex, spr_de ] := "Integration von ActiveX"
MEMVAR->texte[ knopfmeld, spr_de ] := "Melden"
MEMVAR->texte[ mitteilnehmer, spr_de ] := "Folgende Personen (jeder " + al + " " + transform( iif( val( dtos( date() ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( date() ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR) kommen mit und nehmen nur am Rahmenprogramm (und Essen) teil:"
MEMVAR->texte[ verwandschaft, spr_de ] := "Art der Beziehung:"
MEMVAR->texte[ statistiktit, spr_de ] := "Die folgenden Angaben helfen uns bei der genauen Planung!"
MEMVAR->texte[ rechnungsan, spr_de ] := "Rechnungsanschrift:"
MEMVAR->texte[ sonstiges, spr_de ] := "Weitere Angaben:"
MEMVAR->texte[ paypaltext, spr_de ] := "Zahlen Sie mit PayPal - schnell, kostenlos und sicher!"
MEMVAR->texte[ statsueber, spr_de ] := "Statistiken zur DevCon in Berlin vom 13.11. - 16.11.2007"
MEMVAR->texte[ statslaender, spr_de ] := "L" + ae + "nder und Sprachen"
MEMVAR->texte[ statsxbase, spr_de ] := "Xbase++-Versionen"
MEMVAR->texte[ statsinter, spr_de ] := "Interessensschwerpunkte"
MEMVAR->texte[ statsxbspr, spr_de ] := "Andere xbase-Sprachen"
MEMVAR->texte[ statsaddon, spr_de ] := "Add-Ons"
MEMVAR->texte[ teilnehmerueber, spr_de ] := "Wer hat sich angemeldet"
MEMVAR->texte[ nameueb, spr_de ] := "Name"
MEMVAR->texte[ firmaueb, spr_de ] := "Firma"
MEMVAR->texte[ stadtueb, spr_de ] := "Stadt"
MEMVAR->texte[ staatueb, spr_de ] := "Bundesland/Kanton"
MEMVAR->texte[ landueb, spr_de ] := "Land"
MEMVAR->texte[ typueb, spr_de ] := "Art der Teilnahme"
MEMVAR->texte[ istbez, spr_de ] := "Angemeldet"
MEMVAR->texte[ istnbez, spr_de ] := "Ausstehend"
MEMVAR->texte[ klicknamespr, spr_de ] := "Klicken Sie auf den Namen der xbase-Sprache, um weitere Informationen zu erhalten!"
MEMVAR->texte[ klicknameadd, spr_de ] := "Klicken Sie auf den Namen des Add-Ons, um weitere Informationen zu erhalten!"
MEMVAR->texte[ charthinweis, spr_de ] := "(Die Grafiken werden innerhalb von 15 Minuten nach einer neuen Meldung aktualisiert)"
MEMVAR->texte[ bearbeiten, spr_de ] := "Bearbeiten"
MEMVAR->texte[ loeschen, spr_de ] := "Ent/L" + oe + "schen"
MEMVAR->texte[ knopfende, spr_de ] := "Fertig"
MEMVAR->texte[ meldebest, spr_de ] := "Meldebest" + ae + "tigung"
MEMVAR->texte[ Meldehinweis, spr_de ] := "Sie sind jetzt f" + ue + "r die DevCon angemeldet! Anbei eine Zusammenfassung Ihrer Angaben:"
MEMVAR->texte[ ueberweistext, spr_de ] := "Bitte zahlen Sie den Gesamtbetrag in H" + oe + "he von ##**## Euro innerhalb von 14 Tagen, da sonst Ihre Anmeldung verf" + ae + "llt!"
MEMVAR->texte[ paypalhin, spr_de ] := "Um per PayPal (z.B. mit Kreditkarte) zu zahlen, klicken Sie einfach auf den folgenden Knopf!"
MEMVAR->texte[ titstatteil, spr_de ] := "Summe der Teilnehmer pro Sprache"
MEMVAR->texte[ titstatspra, spr_de ] := "Deutsch*Franzsisch*Englisch*Spanisch*Portugiesisch*Dnisch*Italienisch*Hollndisch*Norwegisch*Polnisch*Finnisch*Schwedisch*Trkisch*Slowakisch*Ungarisch*Rumnisch*Kroatisch*Tschechisch*Sonstige"
MEMVAR->texte[ titteildevc, spr_de ] := "Wieviele Teilnehmer haben bereits Xbase++-Devcons besucht"
MEMVAR->texte[ anzteildevc, spr_de ] := "noch keine*eine*zwei*drei*vier*alle fnf"
MEMVAR->texte[ titteilinte, spr_de ] := "Teilnehmer sind am interessiertesten an"
MEMVAR->texte[ titdelphi, spr_de ] := "Kenntnisse der Teilnehmer bezglich Delphi"
MEMVAR->texte[ titfoxpro, spr_de ] := "Kenntnisse der Teilnehmer bezglich FoxPro"
MEMVAR->texte[ titflagsh, spr_de ] := "Kenntnisse der Teilnehmer bezglich Flagship"
MEMVAR->texte[ titclippr, spr_de ] := "Kenntnisse der Teilnehmer bezglich Clipper"
MEMVAR->texte[ titclip4w, spr_de ] := "Kenntnisse der Teilnehmer bezglich Clip4Win"
MEMVAR->texte[ titdbase, spr_de ] := "Kenntnisse der Teilnehmer bezglich dBase"
MEMVAR->texte[ titelvo, spr_de ] := "Kenntnisse der Teilnehmer bezglich Visual Objects"
MEMVAR->texte[ titxharbo, spr_de ] := "Kenntnisse der Teilnehmer bezglich xHarbour"
MEMVAR->texte[ titandrsp, spr_de ] := "Welche anderen xbase-Sprachen werden derzeit von den Teilnehmern genutzt"
MEMVAR->texte[ titexaspr, spr_de ] := "Welche anderen xbase-Sprachen wurden bisher von den Teilnehmern genutzt"
MEMVAR->texte[ titnutzxb, spr_de ] := "Wieviele Teilnehmer nutzen bereits Xbase++"
MEMVAR->texte[ stattexxb, spr_de ] := "nutzen bereits Xbase++*nutzen Xbase++ noch nicht"
MEMVAR->texte[ titversxb, spr_de ] := "Welche Versionen von Xbase++ nutzen die Teilnehmer"
MEMVAR->texte[ tittopdow, spr_de ] := "Kenntnisse der Teilnehmer bezglich TopDown"
MEMVAR->texte[ titexpres, spr_de ] := "Kenntnisse der Teilnehmer bezglich eXpress++"
MEMVAR->texte[ titfivewi, spr_de ] := "Kenntnisse der Teilnehmer bezglich FiveWin"
MEMVAR->texte[ titsqlexp, spr_de ] := "Kenntnisse der Teilnehmer bezglich SQLExpress"
MEMVAR->texte[ titxb2net, spr_de ] := "Kenntnisse der Teilnehmer bezglich Xb2.NET"
MEMVAR->texte[ titxclass, spr_de ] := "Kenntnisse der Teilnehmer bezglich XClass++"
MEMVAR->texte[ titxbhcl, spr_de ] := "Kenntnisse der Teilnehmer bezglich xbHCL"
MEMVAR->texte[ titcockpi, spr_de ] := "Kenntnisse der Teilnehmer bezglich Cockpit"
MEMVAR->texte[ titmarsha, spr_de ] := "Kenntnisse der Teilnehmer bezglich MarshallSoft"
MEMVAR->texte[ titlundl, spr_de ] := "Kenntnisse der Teilnehmer bezglich List & Label"
MEMVAR->texte[ titelvpe, spr_de ] := "Kenntnisse der Teilnehmer bezglich VPE"
MEMVAR->texte[ titelrunr, spr_de ] := "Kenntnisse der Teilnehmer bezglich R&R"
MEMVAR->texte[ titaddder, spr_de ] := "Welche Add-Ons werden derzeit von den Teilnehmern genutzt"
MEMVAR->texte[ titaddwil, spr_de ] := "Welche Add-Ons wollen die Teilnehmer noch nutzen"
MEMVAR->texte[ titlaende, spr_de ] := "Aus welchen Lndern kommen die Teilnehmer"
MEMVAR->texte[ titeilver, spr_de ] := "Verteilung der Teilnehmer (Anonym: "
MEMVAR->texte[ tshirt, spr_de ] := "T-Shirt-Gr" + oe + sz + "e"
MEMVAR->texte[ tshuttle, spr_de ] := "Kostenloser Shuttle-Service am 13. November vom Flughafen in das Konferenzhotel (zwischen 8 Uhr und 12 Uhr) und<BR>am 16. November vom Konferenzhotel zum Flughafen (zwischen 17 Uhr und 21 Uhr)"
MEMVAR->texte[ tuhrzeit, spr_de ] := "um SS:MM"
MEMVAR->texte[ tflughafen, spr_de ] := "Ankunft am Flughafen"
MEMVAR->texte[ thotel, spr_de ] := "Abfahrt vom Konferenzhotel"
MEMVAR->texte[ tbank, spr_de ] := "Bank"
MEMVAR->texte[ tkonto, spr_de ] := "Konto"
MEMVAR->texte[ tbeding, spr_de ] := 'Ich akzeptiere die <A href="http://www.xbasedevcon.de/info_d.htm" target="_blank">Teilnahmebedingungen</A>.'
MEMVAR->texte[ teilbpart, spr_de ] := "Business Partner"
MEMVAR->texte[ teilsonst, spr_de ] := "sonstige"
MEMVAR->texte[ textaus, spr_de ] := "* W" + ae + "hlen *"
MEMVAR->texte[ textpcw, spr_de ] := "Der folgende Slot wurde f" + ue + "r Sie am Welcome " + un + " Vendor Day reserviert:"
MEMVAR->texte[ textsaal, spr_de ] := "Saal:"
MEMVAR->texte[ textzeit, spr_de ] := "Zeit:"
MEMVAR->texte[ textthema, spr_de ] := "Thema:"
MEMVAR->texte[ teiltpart, spr_de ] := "Technology Partner"
MEMVAR->texte[ anonym, spr_de ] := "Der Name soll <B>nicht</B> in der Teilnehmerliste auftauchen!"

MEMVAR->texte[ anrede, spr_fr ] := "Titre:"
MEMVAR->texte[ dattrenner, spr_fr ] := "/"
MEMVAR->texte[ vorname, spr_fr ] := "Pr" + er + "nom:"
MEMVAR->texte[ nachname, spr_fr ] := "Nom de famille:"
MEMVAR->texte[ firma1, spr_fr ] := "Raison sociale:"
MEMVAR->texte[ abteilung, spr_fr ] := "D" + er + "partement:"
MEMVAR->texte[ strasse, spr_fr ] := "Rue:"
MEMVAR->texte[ staat, spr_fr ] := "Canton:"
MEMVAR->texte[ plz, spr_fr ] := "Code postal:"
MEMVAR->texte[ ort, spr_fr ] := "Lieu:"
MEMVAR->texte[ land, spr_fr ] := ger + "tat:"
MEMVAR->texte[ email, spr_fr ] := "Adresse email:"
MEMVAR->texte[ webseite, spr_fr ] := "Site du web:"
MEMVAR->texte[ teilnehmer, spr_fr ] := "Je participe " + al + ":"
MEMVAR->texte[ teiltnehmer, spr_fr ] := "Participant/e"
MEMVAR->texte[ teilpartner, spr_fr ] := "Conjoint/e"
MEMVAR->texte[ teilkind, spr_fr ] := "Enfant"
MEMVAR->texte[ teilfreund, spr_fr ] := "Ami/e"
MEMVAR->texte[ teilredner, spr_fr ] := "Orateur"
MEMVAR->texte[ teilorgan, spr_fr ] := "Organisateur"
MEMVAR->texte[ muttersprache, spr_fr ] := "Ma langue maternelle:"
MEMVAR->texte[ fremdsprache1, spr_fr ] := "1<sup>" + el + "re</sup> langue " + er + "trang" + el + "re:"
MEMVAR->texte[ fremdsprache2, spr_fr ] := "2<sup>" + el + "me</sup> langue " + er + "trang" + el + "re:"
MEMVAR->texte[ xbaseversion, spr_fr ] := "J'ai d" + er + "j" + al + " utilis" + er + " logiciel Xbase++ (quelle version):"
MEMVAR->texte[ laptop, spr_fr ] := "Je poss" + el + "de mon Laptop"
MEMVAR->texte[ xbasesprachen, spr_fr ] := "Connaissance des autres languages de la famille xbase:"
MEMVAR->texte[ ksnutze, spr_fr ] := "J'use"
MEMVAR->texte[ kshatte, spr_fr ] := "J'ai utilis" + er
MEMVAR->texte[ kskenne, spr_fr ] := "J'ai entendu un fois"
MEMVAR->texte[ ksnicht, spr_fr ] := "Je ne connais pas"
MEMVAR->texte[ addons, spr_fr ] := "Mes connaissances des outils divers:"
MEMVAR->texte[ addonwill, spr_fr ] := "Je veux utiliser"
MEMVAR->texte[ meldedatum, spr_fr ] := "Date de registration"
MEMVAR->texte[ meldestatus, spr_fr ] := "Statu de registration"
MEMVAR->texte[ interessen, spr_fr ] := "Mes int" + er +"r" + ed + "ts principaux pour ce DevCon:"
MEMVAR->texte[ interja, spr_fr ] := "Je m'int" + er + "resse " + al
MEMVAR->texte[ internein, spr_fr ] := "Je n'inter"  + er + "sse pas"
MEMVAR->texte[ devcons, spr_fr ] := "J'ai d" + er + "j" + al + " particip" + er + " les cours suivantes de Xbase++ - DevCons:"
MEMVAR->texte[ devcon20011, spr_fr ] := "Milan (Italie) 2001"
MEMVAR->texte[ devcon20012, spr_fr ] := "Manchester (USA, NH) 2001"
MEMVAR->texte[ devcon2002, spr_fr ] := "Manchester (USA, NH) 2002"
MEMVAR->texte[ devcon2004, spr_fr ] := "Venlo (Pays-Bas) 2004"
MEMVAR->texte[ devcon2006, spr_fr ] := "Manchester (USA, NH) 2006"
MEMVAR->texte[ zteilnehmerid, spr_fr ] := "Veuillez indiquer le ID suivant pour prende des renseignements:"
MEMVAR->texte[ teilnehmerid, spr_fr ] := "V" + od + "tre ID:"
MEMVAR->texte[ devconueber, spr_fr ] := "Enregistrement du cours DevCon " + al + " Berlin de 13/11/ " + al + " 16/11/2007"
MEMVAR->texte[ intsql, spr_fr ] := "Lien de SQL"
MEMVAR->texte[ intweb, spr_fr ] := "Lien internaut"
MEMVAR->texte[ intmig, spr_fr ] := "Migration de Clipper"
MEMVAR->texte[ intactivex, spr_fr ] := "Int" + er + "gration d'ActiveX"
MEMVAR->texte[ knopfmeld, spr_fr ] := "Enregistrer"
MEMVAR->texte[ mitteilnehmer, spr_fr ] := "Les personnes suivantes (" + al + " chacun " + transform( iif( val( dtos( date() ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( date() ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR) participent et s'inscrirent seulement pour la programme g" + er + "n" + er + "rale (avec repas):"
MEMVAR->texte[ verwandschaft, spr_fr ] := "Lien de parent" + er + ":"
MEMVAR->texte[ statistiktit, spr_fr ] := "Les informations suivantes nous aident pour planer exactement!"
MEMVAR->texte[ rechnungsan, spr_fr ] := "Adresse du payant:"
MEMVAR->texte[ sonstiges, spr_fr ] := "Autres informations:"
MEMVAR->texte[ paypaltext, spr_fr ] := "Payez vous par PayPal - vite, sans charge et s" + er + "cure!"
MEMVAR->texte[ statsueber, spr_fr ] := "Les statistiques de DevCon " + al + " Berlin de 13/11/ " + al + " 16/11/2007"
MEMVAR->texte[ statslaender, spr_fr ] := "Pays et Langues"
MEMVAR->texte[ statsxbase, spr_fr ] := "Les versions de Xbase++"
MEMVAR->texte[ statsinter, spr_fr ] := "Les int" + er + "r" + ed + "ts principaux"
MEMVAR->texte[ statsxbspr, spr_fr ] := "Les autres languages de xbase"
MEMVAR->texte[ statsaddon, spr_fr ] := "Add-Ons"
MEMVAR->texte[ teilnehmerueber, spr_fr ] := "Celui-qui s'a inscrit"
MEMVAR->texte[ nameueb, spr_fr ] := "Nom"
MEMVAR->texte[ firmaueb, spr_fr ] := "Raison sociale"
MEMVAR->texte[ stadtueb, spr_fr ] := "Lieu"
MEMVAR->texte[ staatueb, spr_fr ] := "Canton"
MEMVAR->texte[ landueb, spr_fr ] := ger + "tat"
MEMVAR->texte[ typueb, spr_fr ] := "Particip" + er + " comme ..."
MEMVAR->texte[ istbez, spr_fr ] := "Pay" + er
MEMVAR->texte[ istnbez, spr_fr ] := "Incertain"
MEMVAR->texte[ klicknamespr, spr_fr ] := "Cliquez-vous le nom de language de xbase pour recevoir en plus information!"
MEMVAR->texte[ klicknameadd, spr_fr ] := "Cliquez vous le nom du Add-On pour recevoir en plus informations!"
MEMVAR->texte[ charthinweis, spr_fr ] := "(Les graphiques seront actualis" + er + " dans 15 minutes apr" + el + "s un message nouvel arriv" + er + ")"
MEMVAR->texte[ bearbeiten, spr_fr ] := "Changer"
MEMVAR->texte[ loeschen, spr_fr ] := "Ent/L" + oe + "schen"
MEMVAR->texte[ knopfende, spr_fr ] := "Fin"
MEMVAR->texte[ meldebest, spr_fr ] := "Confirmation d'enregistrement"
MEMVAR->texte[ Meldehinweis, spr_fr ] := "Vous " + ed + "tes inscrit pour DevCon! Attach" + er + " est une sommaire de vos informations personnels:"
MEMVAR->texte[ ueberweistext, spr_fr ] := "Versez vous s.v.p. le somme de ##**## Euro suivant pendant les 14 jours prochains, si non votre enregistrement sera invalable!"
MEMVAR->texte[ paypalhin, spr_fr ] := "Pour payer par PayPal (par exemple avec une carte de cr" + er+ "dit), cliquez vous simplement sur le bouton suivant!"
MEMVAR->texte[ titstatteil, spr_fr ] := "Somme des participants par langue"
MEMVAR->texte[ titstatspra, spr_fr ] := "Allemand*Franais*Anglais*Espagnol*Portugais*Danois*Italien*Hollandais*Norvgien*Polonais*Finnois*Sudois*Turc*Slovaque*Hongrois*Roumain*Croate*Tchque*Autre"
MEMVAR->texte[ titteildevc, spr_fr ] := "Combien de participants ont dj suivi les cours de Xbase+++-DevCons"
MEMVAR->texte[ anzteildevc, spr_fr ] := "non plus*un*deux*trois*quatre*tous les cinq"
MEMVAR->texte[ titteilinte, spr_fr ] := "Participants prfrent le meilleur les"
MEMVAR->texte[ titdelphi, spr_fr ] := "Connaissances de Delphi"
MEMVAR->texte[ titfoxpro, spr_fr ] := "Connaissances de FoxPro"
MEMVAR->texte[ titflagsh, spr_fr ] := "Connaissances de Flagship"
MEMVAR->texte[ titclippr, spr_fr ] := "Connaissances de Clipper"
MEMVAR->texte[ titclip4w, spr_fr ] := "Connaissances de Clip4Win"
MEMVAR->texte[ titdbase, spr_fr ] := "Connaissances de dBase"
MEMVAR->texte[ titelvo, spr_fr ] := "Connaissances de Visual Objects"
MEMVAR->texte[ titxharbo, spr_fr ] := "Connaissances de xHarbour"
MEMVAR->texte[ titandrsp, spr_fr ] := "Quelle autres languages de xbase sont utiliss actuellement par les participants"
MEMVAR->texte[ titexaspr, spr_fr ] := "Quelle autres languages de Xbase taient utiliss jusq'aujourdhui par les participants"
MEMVAR->texte[ titnutzxb, spr_fr ] := "Combien de participants utilisent dj Xbase++"
MEMVAR->texte[ stattexxb, spr_fr ] := "dj utilis Xbase++*pas encore utilis Xbase++"
MEMVAR->texte[ titversxb, spr_fr ] := "Quelle versions de Xbase++ sont utiliss"
MEMVAR->texte[ tittopdow, spr_fr ] := "Connaissances de TopDown"
MEMVAR->texte[ titexpres, spr_fr ] := "Connaissances d'eXpress++"
MEMVAR->texte[ titfivewi, spr_fr ] := "Connaissances de FiveWin"
MEMVAR->texte[ titsqlexp, spr_fr ] := "Connaissances de SQLExpress"
MEMVAR->texte[ titxb2net, spr_fr ] := "Connaissances de Xb2.NET"
MEMVAR->texte[ titxclass, spr_fr ] := "Connaissances de XClass++"
MEMVAR->texte[ titxbhcl, spr_fr ] := "Connaissances de xbHCL"
MEMVAR->texte[ titcockpi, spr_fr ] := "Connaissances de Cockpit"
MEMVAR->texte[ titmarsha, spr_fr ] := "Connaissances de MarshallSoft"
MEMVAR->texte[ titlundl, spr_fr ] := "Connaissances de List & Label"
MEMVAR->texte[ titelvpe, spr_fr ] := "Connaissances de VPE"
MEMVAR->texte[ titelrunr, spr_fr ] := "Connaissances de R&R"
MEMVAR->texte[ titaddder, spr_fr ] := "Quelle Add-Ons sont actuellement utiliss par les participants"
MEMVAR->texte[ titaddwil, spr_fr ] := "Quelle Add-Ons les participants veulent utiliser"
MEMVAR->texte[ titlaende, spr_fr ] := "De quel pays les participants sont venu"
MEMVAR->texte[ titeilver, spr_fr ] := "Distribution des participants (anonyme: "
MEMVAR->texte[ tshirt, spr_fr ] := "Taille du t-shirt"
MEMVAR->texte[ tshuttle, spr_fr ] := "Service de navette libre le 13 novembre de l'a" + er + "roport " + al + " l'h" + od + "tel de conf" + er + "rence (entre 8h et 12h) et le 16 novembre de l'h" + od + "tel de conf" + er + "rence " + al + " l'a" + er + "roport (entre 17h et 21h)"
MEMVAR->texte[ tuhrzeit, spr_fr ] := al + " HH:MM"
MEMVAR->texte[ tflughafen, spr_fr ] := "Arriv" + er + "e " + al + " l'a" + er + "roport"
MEMVAR->texte[ thotel, spr_fr ] := "D" + er + "part de l'h" + od + "tel de conf" + er + "rence"
MEMVAR->texte[ tbank, spr_fr ] := "Banque"
MEMVAR->texte[ tkonto, spr_fr ] := "Compte"
MEMVAR->texte[ tbeding, spr_fr ] := "J'accepte " + '<A href="http://www.xbasedevcon.de/info_e.htm" target="_blank">les conditions de participation</A>.'
MEMVAR->texte[ teilbpart, spr_fr ] := "Business Partner"
MEMVAR->texte[ teilsonst, spr_fr ] := "autre"
MEMVAR->texte[ textaus, spr_fr ] := "* Choisissez *"
MEMVAR->texte[ textpcw, spr_fr ] := 'Le "Slot" suivant a ' + er + 't' + er + ' r' + er + 'serv' + er + ' pour vous au "Welcome " + un + " Vendor Day":'
MEMVAR->texte[ textsaal, spr_fr ] := "Salle:"
MEMVAR->texte[ textzeit, spr_fr ] := "Heure:"
MEMVAR->texte[ textthema, spr_fr ] := "Sujet:"
MEMVAR->texte[ teiltpart, spr_fr ] := "Technology Partner"
MEMVAR->texte[ anonym, spr_fr ] := "The name should <B>not</B> be made visible on the DevCon-Website's attendee list!"

MEMVAR->texte[ anrede, spr_uk ] := "Title:"
MEMVAR->texte[ dattrenner, spr_uk ] := "/"
MEMVAR->texte[ vorname, spr_uk ] := "First name:"
MEMVAR->texte[ nachname, spr_uk ] := "Last name:"
MEMVAR->texte[ firma1, spr_uk ] := "Name of my company:"
MEMVAR->texte[ abteilung, spr_uk ] := "Department:"
MEMVAR->texte[ strasse, spr_uk ] := "Street:"
MEMVAR->texte[ staat, spr_uk ] := "State/region:"
MEMVAR->texte[ plz, spr_uk ] := "Postcode (zipcode):"
MEMVAR->texte[ ort, spr_uk ] := "City:"
MEMVAR->texte[ land, spr_uk ] := "Country:"
MEMVAR->texte[ email, spr_uk ] := "E-mail:"
MEMVAR->texte[ webseite, spr_uk ] := "Website:"
MEMVAR->texte[ teilnehmer, spr_uk ] := "I am participating as:"
MEMVAR->texte[ teiltnehmer, spr_uk ] := "Attendee"
MEMVAR->texte[ teilpartner, spr_uk ] := "Spouse"
MEMVAR->texte[ teilkind, spr_uk ] := "Child"
MEMVAR->texte[ teilfreund, spr_uk ] := "Friend"
MEMVAR->texte[ teilredner, spr_uk ] := "Speaker"
MEMVAR->texte[ teilorgan, spr_uk ] := "Organiser"
MEMVAR->texte[ muttersprache, spr_uk ] := "My native tongue is:"
MEMVAR->texte[ fremdsprache1, spr_uk ] := "First foreign language:"
MEMVAR->texte[ fremdsprache2, spr_uk ] := "Second foreign language:"
MEMVAR->texte[ xbaseversion, spr_uk ] := "I am already using Xbase++ (my version is as follows):"
MEMVAR->texte[ laptop, spr_uk ] := "I bring my own laptop"
MEMVAR->texte[ xbasesprachen, spr_uk ] := "My knowledge regarding other xbase-dialects is as follows:"
MEMVAR->texte[ ksnutze, spr_uk ] := "I am using it"
MEMVAR->texte[ kshatte, spr_uk ] := "I used it"
MEMVAR->texte[ kskenne, spr_uk ] := "I have heard of it"
MEMVAR->texte[ ksnicht, spr_uk ] := "I have not heard of it"
MEMVAR->texte[ addons, spr_uk ] := "My knowledge regarding several add-ons is as follows:"
MEMVAR->texte[ addonwill, spr_uk ] := "I am going to use it"
MEMVAR->texte[ meldedatum, spr_uk ] := "Date of registration"
MEMVAR->texte[ meldestatus, spr_uk ] := "Status of registration"
MEMVAR->texte[ interessen, spr_uk ] := "My points of interest regarding this DevCon are as follows:"
MEMVAR->texte[ interja, spr_uk ] := "I am interested in"
MEMVAR->texte[ internein, spr_uk ] := "I am not interested in"
MEMVAR->texte[ devcons, spr_uk ] := "I already attended the following Xbase++-DevCons:"
MEMVAR->texte[ devcon20011, spr_uk ] := "Milan (Italy) 2001"
MEMVAR->texte[ devcon20012, spr_uk ] := "Manchester (USA, NH) 2001"
MEMVAR->texte[ devcon2002, spr_uk ] := "Manchester (USA, NH) 2002"
MEMVAR->texte[ devcon2004, spr_uk ] := "Venlo (the Netherlands) 2004"
MEMVAR->texte[ devcon2006, spr_uk ] := "Manchester (USA, NH) 2006"
MEMVAR->texte[ zteilnehmerid, spr_uk ] := "Please state the following ID in case of any further enquiries:"
MEMVAR->texte[ teilnehmerid, spr_uk ] := "Your ID:"
MEMVAR->texte[ devconueber, spr_uk ] := "Registration for the DevCon in Berlin from November 13<SUP>th</SUP> to November 16<SUP>th</SUP>, 2007"
MEMVAR->texte[ intsql, spr_uk ] := "Using SQL"
MEMVAR->texte[ intweb, spr_uk ] := "Making your app internet-accessible"
MEMVAR->texte[ intmig, spr_uk ] := "Migration from Clipper"
MEMVAR->texte[ intactivex, spr_uk ] := "Integration of ActiveX"
MEMVAR->texte[ knopfmeld, spr_uk ] := "Submit"
MEMVAR->texte[ mitteilnehmer, spr_uk ] := "The following persons (each one for " + transform( iif( val( dtos( date() ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( date() ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR) are joining and only taking part in the social program (and meals):"
MEMVAR->texte[ verwandschaft, spr_uk ] := "Relationship:"
MEMVAR->texte[ statistiktit, spr_uk ] := "The following answers will help us to thoroughly project the DevCon!"
MEMVAR->texte[ rechnungsan, spr_uk ] := "Invoice address:"
MEMVAR->texte[ sonstiges, spr_uk ] := "Additional information:"
MEMVAR->texte[ paypaltext, spr_uk ] := "Make your payments through PayPal - fast, free and secure!"
MEMVAR->texte[ statsueber, spr_uk ] := "Statistics for the DevCon in Berlin from November 13<SUP>th</SUP> to November 16<SUP>th</SUP>, 2007"
MEMVAR->texte[ statslaender, spr_uk ] := "Countries and languages"
MEMVAR->texte[ statsxbase, spr_uk ] := "Versions of Xbase++"
MEMVAR->texte[ statsinter, spr_uk ] := "Points of interests"
MEMVAR->texte[ statsxbspr, spr_uk ] := "Other xbase-dialects"
MEMVAR->texte[ statsaddon, spr_uk ] := "Add-Ons"
MEMVAR->texte[ teilnehmerueber, spr_uk ] := "Who's registered"
MEMVAR->texte[ nameueb, spr_uk ] := "Name"
MEMVAR->texte[ firmaueb, spr_uk ] := "Company"
MEMVAR->texte[ stadtueb, spr_uk ] := "City"
MEMVAR->texte[ staatueb, spr_uk ] := "State/region"
MEMVAR->texte[ landueb, spr_uk ] := "Country"
MEMVAR->texte[ typueb, spr_uk ] := "Type"
MEMVAR->texte[ istbez, spr_uk ] := "Complete"
MEMVAR->texte[ istnbez, spr_uk ] := "Pending"
MEMVAR->texte[ klicknamespr, spr_uk ] := "Click on the name of the xbase-dialect to see further information!"
MEMVAR->texte[ klicknameadd, spr_uk ] := "Click on the name of the add-on to see further information!"
MEMVAR->texte[ charthinweis, spr_uk ] := "(The charts will be refreshed within 15 minutes after a new registration)"
MEMVAR->texte[ bearbeiten, spr_uk ] := "Edit"
MEMVAR->texte[ loeschen, spr_uk ] := "Delete/Recall"
MEMVAR->texte[ knopfende, spr_uk ] := "Done"
MEMVAR->texte[ meldebest, spr_uk ] := "Confirmation of registration"
MEMVAR->texte[ Meldehinweis, spr_uk ] := "You are now registered for the DevCon! Please find enclosed a summary of your entries:"
MEMVAR->texte[ ueberweistext, spr_uk ] := "Please transfer the amount of ##**## Euro within 14 days otherwise your registration will be canceled!"
MEMVAR->texte[ paypalhin, spr_uk ] := "For paying through PayPal (e.g. using your credit card) just click on the following button!"
MEMVAR->texte[ titstatteil, spr_uk ] := "Amount of attendees per language"
MEMVAR->texte[ titstatspra, spr_uk ] := "German*French*English*Spanish*Portuguese*Danish*Italian*Dutch*Norwegian*Polish*Finnish*Swedish*Turkish*Slovak*Hungarian*Romanian*Croatian*Czech*Other"
MEMVAR->texte[ titteildevc, spr_uk ] := "How many attendees already attended a Xbase++-Devcon"
MEMVAR->texte[ anzteildevc, spr_uk ] := "not one yet*one*two*three*four*all five"
MEMVAR->texte[ titteilinte, spr_uk ] := "Attendees are mostly interested in"
MEMVAR->texte[ titdelphi, spr_uk ] := "Knowledge of attendees regarding Delphi"
MEMVAR->texte[ titfoxpro, spr_uk ] := "Knowledge of attendees regarding FoxPro"
MEMVAR->texte[ titflagsh, spr_uk ] := "Knowledge of attendees regarding Flagship"
MEMVAR->texte[ titclippr, spr_uk ] := "Knowledge of attendees regarding Clipper"
MEMVAR->texte[ titclip4w, spr_uk ] := "Knowledge of attendees regarding Clip4Win"
MEMVAR->texte[ titdbase, spr_uk ] := "Knowledge of attendees regarding dBase"
MEMVAR->texte[ titelvo, spr_uk ] := "Knowledge of attendees regarding Visual Objects"
MEMVAR->texte[ titxharbo, spr_uk ] := "Knowledge of attendees regarding xHarbour"
MEMVAR->texte[ titandrsp, spr_uk ] := "Which other xbase-dialects are the attendees currently using"
MEMVAR->texte[ titexaspr, spr_uk ] := "Which other xbase-dialects have been used by the attendees so far"
MEMVAR->texte[ titnutzxb, spr_uk ] := "How many attendees are already using Xbase++"
MEMVAR->texte[ stattexxb, spr_uk ] := "already using Xbase++*not using Xbase++ yet"
MEMVAR->texte[ titversxb, spr_uk ] := "Which versions of Xbase++ are the attendees using"
MEMVAR->texte[ tittopdow, spr_uk ] := "Knowledge of attendees regarding TopDown"
MEMVAR->texte[ titexpres, spr_uk ] := "Knowledge of attendees regarding eXpress++"
MEMVAR->texte[ titfivewi, spr_uk ] := "Knowledge of attendees regarding FiveWin"
MEMVAR->texte[ titsqlexp, spr_uk ] := "Knowledge of attendees regarding SQLExpress"
MEMVAR->texte[ titxb2net, spr_uk ] := "Knowledge of attendees regarding Xb2.NET"
MEMVAR->texte[ titxclass, spr_uk ] := "Knowledge of attendees regarding XClass++"
MEMVAR->texte[ titxbhcl, spr_uk ] := "Knowledge of attendees regarding xbHCL"
MEMVAR->texte[ titcockpi, spr_uk ] := "Knowledge of attendees regarding Cockpit"
MEMVAR->texte[ titmarsha, spr_uk ] := "Knowledge of attendees regarding MarshallSoft"
MEMVAR->texte[ titlundl, spr_uk ] := "Knowledge of attendees regarding List & Label"
MEMVAR->texte[ titelvpe, spr_uk ] := "Knowledge of attendees regarding VPE"
MEMVAR->texte[ titelrunr, spr_uk ] := "Knowledge of attendees regarding R&R"
MEMVAR->texte[ titaddder, spr_uk ] := "Which add-ons are the attendees currently using"
MEMVAR->texte[ titaddwil, spr_uk ] := "Which add-ons are the attendees going to use"
MEMVAR->texte[ titlaende, spr_uk ] := "From which countries are the attendees coming"
MEMVAR->texte[ titeilver, spr_uk ] := "Types of registrants (anonymous: "
MEMVAR->texte[ tshirt, spr_uk ] := "Size of tee-shirt"
MEMVAR->texte[ tshuttle, spr_uk ] := "Free shuttle service at November 13<SUP>th</SUP> from the airport to the conference hotel (timeframe: between 08:00 CET and 12:00 CET) and<BR>at November 16<SUP>th</SUP> from the conference hotel to the airport (timeframe: between 17:00 CET and 21:00 CET)"
MEMVAR->texte[ tuhrzeit, spr_uk ] := "at HH:MM"
MEMVAR->texte[ tflughafen, spr_uk ] := "Arrival at airport"
MEMVAR->texte[ thotel, spr_uk ] := "Departure from the conference hotel"
MEMVAR->texte[ tbank, spr_uk ] := "Bank"
MEMVAR->texte[ tkonto, spr_uk ] := "Account"
MEMVAR->texte[ tbeding, spr_uk ] := 'I do accept the <A href="http://www.xbasedevcon.de/info_e.htm" target="_blank">conditions for participating</A>.'
MEMVAR->texte[ teilbpart, spr_uk ] := "Business Partner"
MEMVAR->texte[ teilsonst, spr_uk ] := "other"
MEMVAR->texte[ textaus, spr_uk ] := "* Choose *"
MEMVAR->texte[ textpcw, spr_uk ] := "The following slot has been reserved for you during the Welcome " + un + " Vendor Day:"
MEMVAR->texte[ textsaal, spr_uk ] := "Hall:"
MEMVAR->texte[ textzeit, spr_uk ] := "Time:"
MEMVAR->texte[ textthema, spr_uk ] := "Subject:"
MEMVAR->texte[ teiltpart, spr_uk ] := "Technology Partner"
MEMVAR->texte[ anonym, spr_uk ] := "The name should <B>not</B> be made visible on the DevCon-Website's attendee list!"

MEMVAR->texte[ anrede, spr_sp ] := "T" + ir + "tulo:"
MEMVAR->texte[ dattrenner, spr_sp ] := "/"
MEMVAR->texte[ vorname, spr_sp ] := "Nombre:"
MEMVAR->texte[ nachname, spr_sp ] := "Apellidos:"
MEMVAR->texte[ firma1, spr_sp ] := "Compa" + nt + ir + "a:"
MEMVAR->texte[ abteilung, spr_sp ] := "Departamento:"
MEMVAR->texte[ strasse, spr_sp ] := "Calle:"
MEMVAR->texte[ staat, spr_sp ] := "Provincia/Regi" + or + "n Aut" + or + "noma:"
MEMVAR->texte[ plz, spr_sp ] := "C" + or + "digo Postal:"
MEMVAR->texte[ ort, spr_sp ] := "Ciudad:"
MEMVAR->texte[ land, spr_sp ] := "Pa" + ir + "s:"
MEMVAR->texte[ email, spr_sp ] := "E-mail:"
MEMVAR->texte[ webseite, spr_sp ] := "Website:"
MEMVAR->texte[ teilnehmer, spr_sp ] := "Participo como:"
MEMVAR->texte[ teiltnehmer, spr_sp ] := "Visitante"
MEMVAR->texte[ teilpartner, spr_sp ] := "Esposa"
MEMVAR->texte[ teilkind, spr_sp ] := "Hijo"
MEMVAR->texte[ teilfreund, spr_sp ] := "Amigo"
MEMVAR->texte[ teilredner, spr_sp ] := "Orador"
MEMVAR->texte[ teilorgan, spr_sp ] := "Organizador"
MEMVAR->texte[ muttersprache, spr_sp ] := "Mi lengua nativa es:"
MEMVAR->texte[ fremdsprache1, spr_sp ] := "Primer lengua extranjera:"
MEMVAR->texte[ fremdsprache2, spr_sp ] := "Segunda lengua extranjera:"
MEMVAR->texte[ xbaseversion, spr_sp ] := "Ya estoy usando Xbase++ (mi versi" + or + "n es):"
MEMVAR->texte[ laptop, spr_sp ] := "Llevar" + er + " mi laptop"
MEMVAR->texte[ xbasesprachen, spr_sp ] := "Mi conocimiento sobre otros dialectos de xbase es:"
MEMVAR->texte[ ksnutze, spr_sp ] := "Lo estoy usando"
MEMVAR->texte[ kshatte, spr_sp ] := "Lo he usado"
MEMVAR->texte[ kskenne, spr_sp ] := "He oido algo sobre " + er + "l"
MEMVAR->texte[ ksnicht, spr_sp ] := "No he oido nunca sobre " + er + "l"
MEMVAR->texte[ addons, spr_sp ] := "Mis conocimientos sobre las bibliotecas de terceros es:"
MEMVAR->texte[ addonwill, spr_sp ] := "Lo usar" + er
MEMVAR->texte[ meldedatum, spr_sp ] := "Fecha de inscripci" + or + "n"
MEMVAR->texte[ meldestatus, spr_sp ] := "Estado de inscripci" + or + "n"
MEMVAR->texte[ interessen, spr_sp ] := "Mis puntos de inter" + er + "s respecto a esta DevCon son los siguientes:"
MEMVAR->texte[ interja, spr_sp ] := "Me interesa"
MEMVAR->texte[ internein, spr_sp ] := "No me interesa"
MEMVAR->texte[ devcons, spr_sp ] := "Ya he concurrido a las siguientes Xbase++-DevCons:"
MEMVAR->texte[ devcon20011, spr_sp ] := "Milan (Italia) 2001"
MEMVAR->texte[ devcon20012, spr_sp ] := "Manchester (EEUU, NH) 2001"
MEMVAR->texte[ devcon2002, spr_sp ] := "Manchester (EEUU, NH) 2002"
MEMVAR->texte[ devcon2004, spr_sp ] := "Venlo (Holanda) 2004"
MEMVAR->texte[ devcon2006, spr_sp ] := "Manchester (EEUU, NH) 2006"
MEMVAR->texte[ zteilnehmerid, spr_sp ] := "Por favor establezca la siguiente ID en caso de haber m" + ar + "s solicitudes:"
MEMVAR->texte[ teilnehmerid, spr_sp ] := "Su ID:"
MEMVAR->texte[ devconueber, spr_sp ] := "Inscripci" + or + "n para la DevCon en Berlin desde 13 al 16 de Noviembre de 2007"
MEMVAR->texte[ intsql, spr_sp ] := "Usando SQL"
MEMVAR->texte[ intweb, spr_sp ] := "Haciendo su aplicaci" + or + "n accesible a internet"
MEMVAR->texte[ intmig, spr_sp ] := "Migraci" + or + "n desde Clipper"
MEMVAR->texte[ intactivex, spr_sp ] := "Integraci" + or + "n de ActiveX"
MEMVAR->texte[ knopfmeld, spr_sp ] := "Enviar"
MEMVAR->texte[ mitteilnehmer, spr_sp ] := "Las siguientes personas (cada una por  " + transform( iif( val( dtos( date() ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( date() ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EURO) son acompa" + nt + "antes para participar solamente en el programa social (y comidas):"
MEMVAR->texte[ verwandschaft, spr_sp ] := "Relaci" + or + "n:"
MEMVAR->texte[ statistiktit, spr_sp ] := "Las siguientes respuestas nos ayudar" + ar + "n a proyectar a fondo el DevCon!"
MEMVAR->texte[ rechnungsan, spr_sp ] := "Domicilio para facturar:"
MEMVAR->texte[ sonstiges, spr_sp ] := "Informaci" + or + "n adicional:"
MEMVAR->texte[ paypaltext, spr_sp ] := "Realice sus pagos a trav" + er + "s de PayPal - r" + ar + "pido, sin recargo y seguro!"
MEMVAR->texte[ statsueber, spr_sp ] := "Estad" + ir + "sticas de la DevCon en Berlin desde 13 al 16 de Noviembre de 2007"
MEMVAR->texte[ statslaender, spr_sp ] := "Pa" + ir + "ses e idiomas"
MEMVAR->texte[ statsxbase, spr_sp ] := "Versiones de Xbase++"
MEMVAR->texte[ statsinter, spr_sp ] := "Puntos de inter" + er + "s"
MEMVAR->texte[ statsxbspr, spr_sp ] := "Otros dialectos xbase"
MEMVAR->texte[ statsaddon, spr_sp ] := "Bibliotecas de Terceros"
MEMVAR->texte[ teilnehmerueber, spr_sp ] := "Quienes est" + ar + "n registrados"
MEMVAR->texte[ nameueb, spr_sp ] := "Nombre"
MEMVAR->texte[ firmaueb, spr_sp ] := "Compa" + nt + ir + "a"
MEMVAR->texte[ stadtueb, spr_sp ] := "Ciudad"
MEMVAR->texte[ staatueb, spr_sp ] := "Estado/regi" + or + "n"
MEMVAR->texte[ landueb, spr_sp ] := "Pa" + ir + "s"
MEMVAR->texte[ typueb, spr_sp ] := "Tipo"
MEMVAR->texte[ istbez, spr_sp ] := "Completo"
MEMVAR->texte[ istnbez, spr_sp ] := "Pendiente"
MEMVAR->texte[ klicknamespr, spr_sp ] := "Click en el nombre del dialecto xbase para ver m" + ar + "s informaci" + or + "n!"
MEMVAR->texte[ klicknameadd, spr_sp ] := "Click en el nombre de la Biblioteca de Terceros para ver m" + ar + "s informaci" + or + "n!"
MEMVAR->texte[ charthinweis, spr_sp ] := "(Los gr" + ar + "ficos ser" + ar + "n refrescados dentro de los 15 minutos posteriores a una nueva inscripci" + or + "n)"
MEMVAR->texte[ bearbeiten, spr_sp ] := "Modificar"
MEMVAR->texte[ loeschen, spr_sp ] := "Borrar/Recuperar"
MEMVAR->texte[ knopfende, spr_sp ] := "Hecho"
MEMVAR->texte[ meldebest, spr_sp ] := "Confirmaci" + or + "n de inscripci" + or + "n"
MEMVAR->texte[ Meldehinweis, spr_sp ] := "Ahora Ud. est" + ar + " inscripto en la DevCon! Por favor encuentre un sumario adjunto con sus datos ingresados:"
MEMVAR->texte[ ueberweistext, spr_sp ] := "Por favor transfiera el monto de ##**## Euros dentro de los 14 dias o de otro modo su inscripci" + or + "n se cancelar" + ar + "!"
MEMVAR->texte[ paypalhin, spr_sp ] := "Para pagar a trav" + er + "s de PayPal (ej: usando su tarjeta de cr" + er + "dito) s" + or + "lo haga click en el siguiente bot" + or + "n!"
MEMVAR->texte[ titstatteil, spr_sp ] := "Cantidad de concurrentes por idioma"
MEMVAR->texte[ titstatspra, spr_sp ] := "Aleman*Francs*Ingls*Espaol*Portugus*Dans*Italiano*Holands*Noruego*Polaco*Finlands*Sueco*Turco*Eslovaco*Hngaro*Rumano*Croata*Checoeslovaco*Otro"
MEMVAR->texte[ titteildevc, spr_sp ] := "Cuntos concurrentes ya han asistido a un Xbase++-Devcon"
MEMVAR->texte[ anzteildevc, spr_sp ] := "ninguno aun*uno*dos*tres*cuatro*los cinco"
MEMVAR->texte[ titteilinte, spr_sp ] := "Los concurrentes estn mayormente interesados en"
MEMVAR->texte[ titdelphi, spr_sp ] := "Conocimiento de concurrentes respecto a Delphi"
MEMVAR->texte[ titfoxpro, spr_sp ] := "Conocimiento de concurrentes respecto a FoxPro"
MEMVAR->texte[ titflagsh, spr_sp ] := "Conocimiento de concurrentes respecto a Flagship"
MEMVAR->texte[ titclippr, spr_sp ] := "Conocimiento de concurrentes respecto a Clipper"
MEMVAR->texte[ titclip4w, spr_sp ] := "Conocimiento de concurrentes respecto a Clip4Win"
MEMVAR->texte[ titdbase, spr_sp ] := "Conocimiento de concurrentes respecto a dBase"
MEMVAR->texte[ titelvo, spr_sp ] := "Conocimiento de concurrentes respecto a Visual Objects"
MEMVAR->texte[ titxharbo, spr_sp ] := "Conocimiento de concurrentes respecto a xHarbour"
MEMVAR->texte[ titandrsp, spr_sp ] := "Cules otros dialectos xbase estn usando actualmente los concurrentes"
MEMVAR->texte[ titexaspr, spr_sp ] := "Cules otros dialectos xbase han usado los concurrentes"
MEMVAR->texte[ titnutzxb, spr_sp ] := "Cuntos concurrentes ya estn usando Xbase++"
MEMVAR->texte[ stattexxb, spr_sp ] := "ya uso Xbase++*no uso Xbase++ aun"
MEMVAR->texte[ titversxb, spr_sp ] := "Qu versiones de Xbase++ usan los concurrentes"
MEMVAR->texte[ tittopdow, spr_sp ] := "Conocimiento de concurrentes respecto a TopDown"
MEMVAR->texte[ titexpres, spr_sp ] := "Conocimiento de concurrentes respecto a eXpress++"
MEMVAR->texte[ titfivewi, spr_sp ] := "Conocimiento de concurrentes respecto a FiveWin"
MEMVAR->texte[ titsqlexp, spr_sp ] := "Conocimiento de concurrentes respecto a SQLExpress"
MEMVAR->texte[ titxb2net, spr_sp ] := "Conocimiento de concurrentes respecto a Xb2.NET"
MEMVAR->texte[ titxclass, spr_sp ] := "Conocimiento de concurrentes respecto a XClass++"
MEMVAR->texte[ titxbhcl, spr_sp ] := "Conocimiento de concurrentes respecto a xbHCL"
MEMVAR->texte[ titcockpi, spr_sp ] := "Conocimiento de concurrentes respecto a Cockpit"
MEMVAR->texte[ titmarsha, spr_sp ] := "Conocimiento de concurrentes respecto a MarshallSoft"
MEMVAR->texte[ titlundl, spr_sp ] := "Conocimiento de concurrentes respecto a List & Label"
MEMVAR->texte[ titelvpe, spr_sp ] := "Conocimiento de concurrentes respecto a VPE"
MEMVAR->texte[ titelrunr, spr_sp ] := "Conocimiento de concurrentes respecto a R&R"
MEMVAR->texte[ titaddder, spr_sp ] := "Cules Bibliotecas de Terceros estn usando los concurrentes"
MEMVAR->texte[ titaddwil, spr_sp ] := "Cules Bibliotecas de Terceros irn a usar los concurrentes"
MEMVAR->texte[ titlaende, spr_sp ] := "Desde qu pases vienen los concurrentes"
MEMVAR->texte[ titeilver, spr_sp ] := "Tipos de registrantes (annimo: "
MEMVAR->texte[ tshirt, spr_sp ] := "Talle de su remera"
MEMVAR->texte[ tshuttle, spr_sp ] := "Servicio de transporte gratuito el 13 de Noviembre desde el aeropuerto hasta el hotel donde se dar" + ar + " la conferencia (horario: 08:00 a 12:00 hs (Horario Central Europeo)) y el 16 de Noviembre desde ese hotel hasta el aeropuerto (horario: 17:00 a 21:00 hs (Horario Central Europeo))"
MEMVAR->texte[ tuhrzeit, spr_sp ] := "a las HH:MM"
MEMVAR->texte[ tflughafen, spr_sp ] := "Arribo al aeropuerto"
MEMVAR->texte[ thotel, spr_sp ] := "Partida desde el hotel de la conferencia"
MEMVAR->texte[ tbank, spr_sp ] := "Banco"
MEMVAR->texte[ tkonto, spr_sp ] := "Cuenta"
MEMVAR->texte[ tbeding, spr_sp ] := 'Acepto las <A href="http://www.xbasedevcon.de/info_s.htm" target="_blank">condiciones para participar</A>.'
MEMVAR->texte[ teilbpart, spr_sp ] := "Business Partner"
MEMVAR->texte[ teilsonst, spr_sp ] := "Otra"
MEMVAR->texte[ textaus, spr_sp ] := "* Seleccione *"
MEMVAR->texte[ textpcw, spr_sp ] := "El siguiente lugar ha sido reservado por Ud. durante el d" + ir + "a de Pre-Conferencia:"
MEMVAR->texte[ textsaal, spr_sp ] := "Hall:"
MEMVAR->texte[ textzeit, spr_sp ] := "Hora:"
MEMVAR->texte[ textthema, spr_sp ] := "Asunto:"
MEMVAR->texte[ teiltpart, spr_sp ] := "Technology Partner"
MEMVAR->texte[ anonym, spr_sp ] := "Por favor, <B>no</B> publiquen ni mi participaci" + or + "n, ni mi nombre en la p" + ar + "gina Web de la DevCon!"

MEMVAR->texte[ anrede, spr_pt ] := "T" + ir + "tulo:"
MEMVAR->texte[ dattrenner, spr_pt ] := "/"
MEMVAR->texte[ vorname, spr_pt ] := "Nome:"
MEMVAR->texte[ nachname, spr_pt ] := "Sobrenome:"
MEMVAR->texte[ firma1, spr_pt ] := "Empresa:"
MEMVAR->texte[ abteilung, spr_pt ] := "Setor:"
MEMVAR->texte[ strasse, spr_pt ] := "Rua:"
MEMVAR->texte[ staat, spr_pt ] := "Estado/regi" + ati + "o:"
MEMVAR->texte[ plz, spr_pt ] := "CEP:"
MEMVAR->texte[ ort, spr_pt ] := "Cidade:"
MEMVAR->texte[ land, spr_pt ] := "Pa" + ir + "s:"
MEMVAR->texte[ email, spr_pt ] := "E-mail:"
MEMVAR->texte[ webseite, spr_pt ] := "Website:"
MEMVAR->texte[ teilnehmer, spr_pt ] := "Participo como:"
MEMVAR->texte[ teiltnehmer, spr_pt ] := "Acompanhante"
MEMVAR->texte[ teilpartner, spr_pt ] := "Esposa"
MEMVAR->texte[ teilkind, spr_pt ] := "Filho"
MEMVAR->texte[ teilfreund, spr_pt ] := "Amigo"
MEMVAR->texte[ teilredner, spr_pt ] := "Orador"
MEMVAR->texte[ teilorgan, spr_pt ] := "Organizador"
MEMVAR->texte[ muttersprache, spr_pt ] := "Minha l" + ir + "ngua nativa " + er + ":"
MEMVAR->texte[ fremdsprache1, spr_pt ] := "Primeira l" + ir + "ngua estrangeira:"
MEMVAR->texte[ fremdsprache2, spr_pt ] := "Segunda l" + ir + "ngua estrangeira:"
MEMVAR->texte[ xbaseversion, spr_pt ] := "Ja estou usando Xbase++ (minha vers" + ati + "o " + er + "):"
MEMVAR->texte[ laptop, spr_pt ] := "Levo meu laptop"
MEMVAR->texte[ xbasesprachen, spr_pt ] := "Meu conhecimento sobre outras linguagens de xbase " + er + ":"
MEMVAR->texte[ ksnutze, spr_pt ] := "Estou usando"
MEMVAR->texte[ kshatte, spr_pt ] := "Usei"
MEMVAR->texte[ kskenne, spr_pt ] := "J" + ar + " ouvi falar dele"
MEMVAR->texte[ ksnicht, spr_pt ] := "Nunca ouvi falar dele"
MEMVAR->texte[ addons, spr_pt ] := "Meus conhecimentos sobre as bibliotecas de terceiros e:"
MEMVAR->texte[ addonwill, spr_pt ] := "Vou usar"
MEMVAR->texte[ meldedatum, spr_pt ] := "Data da inscri" + cc + ati + "o"
MEMVAR->texte[ meldestatus, spr_pt ] := "Estado da inscri" + cc + ati + "o"
MEMVAR->texte[ interessen, spr_pt ] := "Os temas que me interessam na DevCon s" + ati + "o os seguintes:"
MEMVAR->texte[ interja, spr_pt ] := "Me interessa"
MEMVAR->texte[ internein, spr_pt ] := "N" + ati + "o me interessa"
MEMVAR->texte[ devcons, spr_pt ] := "Ja participei das seguintes Xbase++-DevCons:"
MEMVAR->texte[ devcon20011, spr_pt ] := "Mil" + ati + "o (Italia) 2001"
MEMVAR->texte[ devcon20012, spr_pt ] := "Manchester (EEUU, NH) 2001"
MEMVAR->texte[ devcon2002, spr_pt ] := "Manchester (EEUU, NH) 2002"
MEMVAR->texte[ devcon2004, spr_pt ] := "Venlo (Holanda) 2004"
MEMVAR->texte[ devcon2006, spr_pt ] := "Manchester (EEUU, NH) 2006"
MEMVAR->texte[ zteilnehmerid, spr_pt ] := "Por favor, estabele" + cc + "a a seguinte ID se Vc. tiver alguma d" + ur + "vida:"
MEMVAR->texte[ teilnehmerid, spr_pt ] := "Sua ID:"
MEMVAR->texte[ devconueber, spr_pt ] := "Inscri" + cc + ati + "o para a DevCon em Berlin de 13 a 16 de Novembro de 2007"
MEMVAR->texte[ intsql, spr_pt ] := "Usando SQL"
MEMVAR->texte[ intweb, spr_pt ] := "Fazendo seu sistema acess" + ir + "vel " + ar + " Internet"
MEMVAR->texte[ intmig, spr_pt ] := "Migra" + cc + ati + "o desde Clipper"
MEMVAR->texte[ intactivex, spr_pt ] := "Integra" + cc + ati + "o de ActiveX"
MEMVAR->texte[ knopfmeld, spr_pt ] := "Enviar"
MEMVAR->texte[ mitteilnehmer, spr_pt ] := "As seguintes pessoas (cada uma por " + transform( iif( val( dtos( date() ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( date() ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EURO) s" + ati + "o acompanhantes para participar somente no programa social (e refei" + cc + ot + "es):"
MEMVAR->texte[ verwandschaft, spr_pt ] := "V" + ir + "nculo:"
MEMVAR->texte[ statistiktit, spr_pt ] := "As seguintes respostas ir" + ati + "o nos ajudar a organizar melhor a DevCon. Obrigado!"
MEMVAR->texte[ rechnungsan, spr_pt ] := "Endere" + cc + "o para faturar:"
MEMVAR->texte[ sonstiges, spr_pt ] := "Informa" + cc + ati + "o adicional:"
MEMVAR->texte[ paypaltext, spr_pt ] := "Fa" + cc + "a seu pagamentos a trav" + er + "s de PayPal - r" + ar + "pido, sem sobrecargo e seguro!"
MEMVAR->texte[ statsueber, spr_pt ] := "Estat" + ir + "sticas da DevCon em Berlin desde o 13 ao 16 de Novembro de 2007"
MEMVAR->texte[ statslaender, spr_pt ] := "Pa" + ir + "ses e linguagens"
MEMVAR->texte[ statsxbase, spr_pt ] := "Vers" + ot + "es de Xbase++"
MEMVAR->texte[ statsinter, spr_pt ] := "Pontos de interesse"
MEMVAR->texte[ statsxbspr, spr_pt ] := "Outros dialetos xbase"
MEMVAR->texte[ statsaddon, spr_pt ] := "Bibliotecas de Terceiros"
MEMVAR->texte[ teilnehmerueber, spr_pt ] := "Quem est" + ar + " cadastrado"
MEMVAR->texte[ nameueb, spr_pt ] := "Nome"
MEMVAR->texte[ firmaueb, spr_pt ] := "Empresa"
MEMVAR->texte[ stadtueb, spr_pt ] := "Cidade"
MEMVAR->texte[ staatueb, spr_pt ] := "Estado/regi" + ati + "o"
MEMVAR->texte[ landueb, spr_pt ] := "Pa" + ir + "s"
MEMVAR->texte[ typueb, spr_pt ] := "Tipo"
MEMVAR->texte[ istbez, spr_pt ] := "Completo"
MEMVAR->texte[ istnbez, spr_pt ] := "Pendente"
MEMVAR->texte[ klicknamespr, spr_pt ] := "Clique no nome do dialeto xbase para ver mais informac" + ati + "o!"
MEMVAR->texte[ klicknameadd, spr_pt ] := "Clique no nome da Biblioteca de Terceiros para ver mais informac" + ati + "o!"
MEMVAR->texte[ charthinweis, spr_pt ] := "(Os gr" + ar + "ficos ser" + ati + "o refrescados depois de 15 minutos da uma nova inscri" + cc + ati + "o)"
MEMVAR->texte[ bearbeiten, spr_pt ] := "Alterar"
MEMVAR->texte[ loeschen, spr_pt ] := "Deletar/Recuperar"
MEMVAR->texte[ knopfende, spr_pt ] := "Feito"
MEMVAR->texte[ meldebest, spr_pt ] := "Confirmac" + ati + "o de inscri" + cc + ati + "o"
MEMVAR->texte[ Meldehinweis, spr_pt ] := "Agora Vc. est" + ar + " inscrito na DevCon! Por favor ache o resumo adjunto com seus dados cadastrados:"
MEMVAR->texte[ ueberweistext, spr_pt ] := "Por favor transfira a quantidade de ##**## Euros " + ar + " seguinte conta dentro dos 14 d" + ir + "as ou sua inscri" + cc + ati + "o ir" + ar + " ser cancelada!"
MEMVAR->texte[ paypalhin, spr_pt ] := "Vc. pode pagar at" + er + " a trav" + er + "s de PayPal (ej: usando seu cart" + ati + "o de cr" + er + "dito) - s" + or + " fa" + cc + "a clique no seguinte bot" + ati + "o para pagar!"
MEMVAR->texte[ titstatteil, spr_pt ] := "Quantidade de pessoas por linguagem"
MEMVAR->texte[ titstatspra, spr_pt ] := "Alemo*Francs*Ingls*Espanhol*Portugus*Dans*Italiano*Holands*Noruegus*Polons*Finlands*Sueco*Turco*Eslovaco*Hngaro*Rumano*Croata*Checoeslovaco*Otro"
MEMVAR->texte[ titteildevc, spr_pt ] := "Quntos participantes j tem asistido a uma Xbase++-Devcon"
MEMVAR->texte[ anzteildevc, spr_pt ] := "ainda nenhuma*uma*duas*trs*quatro*as cinco"
MEMVAR->texte[ titteilinte, spr_pt ] := "Os participantes esto maiormente interessados em"
MEMVAR->texte[ titdelphi, spr_pt ] := "Conhecimento dos participantes sobre o Delphi"
MEMVAR->texte[ titfoxpro, spr_pt ] := "Conhecimento dos participantes sobre o FoxPro"
MEMVAR->texte[ titflagsh, spr_pt ] := "Conhecimento dos participantes sobre o Flagship"
MEMVAR->texte[ titclippr, spr_pt ] := "Conhecimento dos participantes sobre o Clipper"
MEMVAR->texte[ titclip4w, spr_pt ] := "Conhecimento dos participantes sobre o Clip4Win"
MEMVAR->texte[ titdbase, spr_pt ] := "Conhecimento dos participantes sobre o dBase"
MEMVAR->texte[ titelvo, spr_pt ] := "Conhecimento dos participantes sobre o Visual Objects"
MEMVAR->texte[ titxharbo, spr_pt ] := "Conhecimento dos participantes sobre o xHarbour"
MEMVAR->texte[ titandrsp, spr_pt ] := "Cuais outros dialetos xbase esto usando actualmente os participantes"
MEMVAR->texte[ titexaspr, spr_pt ] := "Cuais outros dialetos xbase han usado os participantes"
MEMVAR->texte[ titnutzxb, spr_pt ] := "Quntos participantes ja esto usando Xbase++"
MEMVAR->texte[ stattexxb, spr_pt ] := "j uso Xbase++*ainda no uso Xbase++"
MEMVAR->texte[ titversxb, spr_pt ] := "Qu verses de Xbase++ usam os participantes"
MEMVAR->texte[ tittopdow, spr_pt ] := "Conhecimento dos participantes sobre o TopDown"
MEMVAR->texte[ titexpres, spr_pt ] := "Conhecimento dos participantes sobre o eXpress++"
MEMVAR->texte[ titfivewi, spr_pt ] := "Conhecimento dos participantes sobre o FiveWin"
MEMVAR->texte[ titsqlexp, spr_pt ] := "Conhecimento dos participantes sobre o SQLExpress"
MEMVAR->texte[ titxb2net, spr_pt ] := "Conhecimento dos participantes sobre o Xb2.NET"
MEMVAR->texte[ titxclass, spr_pt ] := "Conhecimento dos participantes sobre o XClass++"
MEMVAR->texte[ titxbhcl, spr_pt ] := "Conhecimento dos participantes sobre o xbHCL"
MEMVAR->texte[ titcockpi, spr_pt ] := "Conhecimento dos participantes sobre o Cockpit"
MEMVAR->texte[ titmarsha, spr_pt ] := "Conhecimento dos participantes sobre o MarshallSoft"
MEMVAR->texte[ titlundl, spr_pt ] := "Conhecimento dos participantes sobre o List & Label"
MEMVAR->texte[ titelvpe, spr_pt ] := "Conhecimento dos participantes sobre o VPE"
MEMVAR->texte[ titelrunr, spr_pt ] := "Conhecimento dos participantes sobre o R&R"
MEMVAR->texte[ titaddder, spr_pt ] := "Cuais Bibliotecas de Terceiros esto usando os participantes"
MEMVAR->texte[ titaddwil, spr_pt ] := "Cuais Bibliotecas de Terceiros iro usar os participantes"
MEMVAR->texte[ titlaende, spr_pt ] := "Desde qu pases viro os participantes"
MEMVAR->texte[ titeilver, spr_pt ] := "Tipos de participantes cadastrados (annimo: "
MEMVAR->texte[ tshirt, spr_pt ] := "Tamanho da sua camiseta"
MEMVAR->texte[ tshuttle, spr_pt ] := "Servi" + cc + "o de transporte gratuito no d" + ir + "a 13 de Novembro desde o aeroporto at" + er + " o hotel da confer" + ed + "ncia (hor" + ar + "rio: 08:00 " + ar + "s 12:00 hs (Hor" + ar + "rio Central Europeu)) e no d" +ir + "a 16 de Novembro desde o hotel at" + er + " o aeroporto (hor" + ar + "rio: 17:00 " + ar + "s 21:00 hs (Hor" + ar + "rio Central Europeu))"
MEMVAR->texte[ tuhrzeit, spr_pt ] := al + "s HH:MM"
MEMVAR->texte[ tflughafen, spr_pt ] := "Chegada ao aeroporto"
MEMVAR->texte[ thotel, spr_pt ] := "Sa" + ir + "da desde o hotel da confer" + ed + "ncia"
MEMVAR->texte[ tbank, spr_pt ] := "Banco"
MEMVAR->texte[ tkonto, spr_pt ] := "Conta"
MEMVAR->texte[ teilbpart, spr_pt ] := "Business Partner"
MEMVAR->texte[ teilsonst, spr_pt ] := "Outra"
MEMVAR->texte[ textaus, spr_pt ] := "* Escolha *"
MEMVAR->texte[ tbeding, spr_pt ] := 'Aceito as <A href="http://www.xbasedevcon.de/info_p.htm" target="_blank">condi' + cc + ot + 'es para participar</A>.'
MEMVAR->texte[ textpcw, spr_pt ] := "O seguinte lugar tem sido reservado por Vc. perante o d" + ir + "a da Pre-Confer" + ed + "ncia:"
MEMVAR->texte[ textsaal, spr_pt ] := "Hall:"
MEMVAR->texte[ textzeit, spr_pt ] := "Hora:"
MEMVAR->texte[ textthema, spr_pt ] := "Assunto:"
MEMVAR->texte[ teiltpart, spr_pt ] := "Technology Partner"
MEMVAR->texte[ anonym, spr_pt ] := "The name should <B>not</B> be made visible on the DevCon-Website's attendee list!"

//Countries in the different languages
MEMVAR->laender := {}
Aadd( MEMVAR->laender, { "A", goe + "sterreich", "Autriche", "Austria", "Austria", gar + "ustria", "sterreich", "Autriche", "Austria", "ustria" } )
Aadd( MEMVAR->laender, { "AFG", "Afghanistan", "Afghanistan","Afghanistan", "Afganist" + ar + "n", "Afeganist" + ati + "o", "Afghanistan", "Afghanistan", "Afganistn", "Afeganisto" } )
Aadd( MEMVAR->laender, { "AL", "Albanien", "Albanie", "Albania", "Albania", "Alb" + ad + "nia", "Albanien", "Albanie", "Albania", "Albnia" } )
Aadd( MEMVAR->laender, { "ARM", "Armenien", "Arm" + er + "nie", "Armenia", "Armenia", "Arm" + er + "nia", "Armenien", "Armnie", "Armenia", "Armnia" } )
Aadd( MEMVAR->laender, { "AUS", "Australien", "Australie", "Australia", "Australia", "Austr" + ar + "lia", "Australien", "Australie", "Australia", "Austrlia" } )
Aadd( MEMVAR->laender, { "AZ", "Aserbaidschan", "Azerba" + idp + "djan", "Azerbaijan", "Azerbaiy" + ar + "n", "Azerbaij" + ati + "o", "Aserbaidschan", "Azerbadjan", "Azerbaiyn", "Azerbaijo" } )
Aadd( MEMVAR->laender, { "B", "Belgien", "Belgique", "Belgium", "B" + er + "lgica", "B" + er + "lgica", "Belgien", "Belgique", "Blgica", "Blgica" } )
Aadd( MEMVAR->laender, { "BD", "Bangladesch", "Bangladesh", "Bangladesh", "Bangladesh", "Bangladesch", "Bangladesh", "Bangladesh", "Bangladesh", "Bangladesh" } )
Aadd( MEMVAR->laender, { "BDS", "Barbados", "Barbade", "Barbados", "Barbados", "Barbados", "Barbados", "Barbade", "Barbados", "Barbados" } )
Aadd( MEMVAR->laender, { "BF", "Burkina Faso", "Burkina Faso", "Burkina Faso", "Burkina Faso", "Burkina Faso", "Burkina Faso", "Burkina Faso", "Burkina Faso", "Burkina Faso" } )
Aadd( MEMVAR->laender, { "BG", "Bulgarien", "Bulgarie", "Bulgaria", "Bulgaria", "Bulg" + ar + "ria", "Bulgarien", "Bulgarie", "Bulgaria", "Bulgria" } )
Aadd( MEMVAR->laender, { "BH", "Belize", "Belize", "Belize", "Belice", "Belize", "Belize", "Belize", "Belice", "Belize" } )
Aadd( MEMVAR->laender, { "BIH", "Bosnien und Herzegowina", "Bosnie-Herz" + er + "govine", "Bosnia-Herzegovina", "Bosnia-Herzegovina", "B" + or + "snia-Herzegovina", "Bosnien und Herzegowina", "Bosnie-Herzgovine", "Bosnia-Herzegovina", "Bsnia-Herzegovina" } )
Aadd( MEMVAR->laender, { "BM", "Bermuda", "Bermudes", "Bermuda", "Bermuda", "Bermudas", "Bermuda", "Bermudes", "Bermuda", "Bermudas" } )
Aadd( MEMVAR->laender, { "BOL", "Bolivien", "Bolivie", "Bolivia", "Bolivia", "Bol" + ir + "via", "Bolivien", "Bolivie", "Bolivia", "Bolvia" } )
Aadd( MEMVAR->laender, { "BR", "Brasilien", "Br" + er + "sil", "Brazil", "Brasil", "Brasil", "Brasilien", "Brsil", "Brasil", "Brasil" } )
Aadd( MEMVAR->laender, { "BRN", "Bahrain", "Bahra" + idp + "n", "Bahrain", "Bahrain", "Bahrein", "Bahrain", "Bahran", "Bahrain", "Bahrein" } )
Aadd( MEMVAR->laender, { "BRU", "Brunei", "Brunei", "Brunei", "Brun" + er + "i", "Brunei", "Brunei", "Brunei", "Bruni", "Brunei" } )
Aadd( MEMVAR->laender, { "BS", "Bahamas", "Bahamas", "Bahamas", "Bahamas", "Bahamas", "Bahamas", "Bahamas", "Bahamas", "Bahamas" } )
Aadd( MEMVAR->laender, { "BTN", "Bhutan", "Bhoutan", "Bhutan", "But" + ar + "n", "But" + ati + "o", "Bhutan", "Bhoutan", "Butn", "Buto" } )
Aadd( MEMVAR->laender, { "BY", "Wei" + sz + "russland", "B" + er + "larus", "Belarus", "Belorrusia", "Bielorr" + ur + "ssia", "Weirussland", "Blarus", "Belorrusia", "Bielorrssia" } )
Aadd( MEMVAR->laender, { "C", "Kuba", "Cuba", "Cuba", "Cuba", "Cuba", "Kuba", "Cuba", "Cuba", "Cuba" } )
Aadd( MEMVAR->laender, { "CAM", "Kamerun", "Cameroun", "Cameroon", "Camer" + ur + "n", "Camar" + ot + "es", "Kamerun", "Cameroun", "Camern", "Camares" } )
Aadd( MEMVAR->laender, { "CAY", "Kaimaninseln", gid + "les Ca" + idp + "manes", "Cayman Islands", "Islas Caim" + ar + "n", "Ilhas Caymans", "Kaimaninseln", "les Camanes", "Islas Caimn", "Ilhas Caymans" } )
Aadd( MEMVAR->laender, { "CD", "Demokratische Republik Kongo", "R" + er + "publique d" + er + "mocratique du Congo", "Democratic Republic of the Congo", "Rep" + ur + "blica Democr" + ar + "tica del Congo", "Rep" + ur + "blica Democr" + ar + "tica do Congo", "Demokratische Republik Kongo", "Rpublique dmocratique du Congo", "Repblica Democrtica del Congo", "Repblica Democrtica do Congo" } )
Aadd( MEMVAR->laender, { "CDN", "Kanada", "Canada", "Canada", "Canad" + ar, "Canad" + ar, "Kanada", "Canada", "Canad", "Canad" } )
Aadd( MEMVAR->laender, { "CG", "Montenegro", "Mont" + er + "n" + er + "gro", "Montenegro", "Montenegro", "Montenegro", "Montenegro", "Montngro", "Montenegro", "Montenegro" } )
Aadd( MEMVAR->laender, { "CH", "Schweiz", "Suisse", "Switzerland", "Suiza", "Su" + ir + cc + "a", "Schweiz", "Suisse", "Suiza", "Sua" } )
Aadd( MEMVAR->laender, { "CI", "Elfenbeink" + ue + "ste", "C" + od + "te d'Ivoire", "Ivory Coast", "Costa de Marfil", "Costa do Marfim", "Elfenbeinkste", "Cte d'Ivoire", "Costa de Marfil", "Costa do Marfim" } )
Aadd( MEMVAR->laender, { "CL", "Sri Lanka", "Sri Lanka", "Sri Lanka", "Sri Lanka", "Sri Lanka", "Sri Lanka", "Sri Lanka", "Sri Lanka", "Sri Lanka" } )
Aadd( MEMVAR->laender, { "CN", "China", "Chine", "China", "China", "China", "China", "Chine", "China", "China" } )
Aadd( MEMVAR->laender, { "CO", "Kolumbien", "Colombie", "Colombia", "Colombia", "Col" + od + "mbia", "Kolumbien", "Colombie", "Colombia", "Colmbia" } )
Aadd( MEMVAR->laender, { "CR", "Costa Rica", "Costa Rica", "Costa Rica", "Costa Rica", "Costa Rica", "Costa Rica", "Costa Rica", "Costa Rica", "Costa Rica" } )
Aadd( MEMVAR->laender, { "CY", "Zypern", "Chypre", "Cyprus", "Chipre", "Chipre", "Zypern", "Chypre", "Chipre", "Chipre" } )
Aadd( MEMVAR->laender, { "CZ", "Tschechien", "Tch" + er + "quie", "Czechia", "Rep" + ur + "blica Checa", "Rep" + ur + "blica Checa", "Tschechien", "Tchquie", "Repblica Checa", "Repblica Checa" } )
Aadd( MEMVAR->laender, { "D", "Deutschland", "Allemagne", "Germany", "Alemania", "Alemanha", "Deutschland", "Allemagne", "Alemania", "Alemanha" } )
Aadd( MEMVAR->laender, { "DK", "D" + ae + "nemark", "Danemark", "Denmark", "Dinamarca", "Dinamarca", "Dnemark", "Danemark", "Dinamarca", "Dinamarca" } )
Aadd( MEMVAR->laender, { "DOM", "Dominikanische Republik", "R" + er + "publique Dominicaine", "Dominican Republic", "Rep" + ur + "blica Dominicana", "Rep" + ur + "blica Dominicana", "Dominikanische Republik", "Rpublique Dominicaine", "Repblica Dominicana", "Repblica Dominicana" } )
Aadd( MEMVAR->laender, { "DZ", "Algerien", "Alg" + er + "rie", "Algeria", "Argelia", "Arg" + er + "lia", "Algerien", "Algrie", "Argelia", "Arglia" } )
Aadd( MEMVAR->laender, { "E", "Spanien", "Espagne", "Spain", "Espa" + nt + "a", "Espanha", "Spanien", "Espagne", "Espaa", "Espanha" } )
Aadd( MEMVAR->laender, { "EAK", "Kenia", "Kenya", "Kenya", "Kenia", "Qu" + er + "nia", "Kenia", "Kenya", "Kenia", "Qunia" } )
Aadd( MEMVAR->laender, { "EAT", "Tansania", "Tanzanie", "Tanzania", "Tanzania", "Tanz" + ad + "nia", "Tansania", "Tanzanie", "Tanzania", "Tanznia" } )
Aadd( MEMVAR->laender, { "EAU", "Uganda", "Ouganda", "Uganda", "Uganda", "Uganda", "Uganda", "Ouganda", "Uganda", "Uganda" } )
Aadd( MEMVAR->laender, { "EC", "Ecuador", ger + "quateur", "Ecuador", "Ecuador", "Equador", "Ecuador", "quateur", "Ecuador", "Equador" } )
Aadd( MEMVAR->laender, { "ER", "Eritrea", ger + "rythr" + er + "e", "Eritrea", "Eritrea", "Eritreia", "Eritrea", "rythre", "Eritrea", "Eritreia" } )
Aadd( MEMVAR->laender, { "ES", "El Salvador", "Salvador", "El Salvador", "El Salvador", "El Salvador", "El Salvador", "Salvador", "El Salvador", "El Salvador" } )
Aadd( MEMVAR->laender, { "EST", "Estland", "Estonie", "Estonia", "Estonia", "Est" + or + "nia", "Estland", "Estonie", "Estonia", "Estnia" } )
Aadd( MEMVAR->laender, { "ET", gae + "gypten", ger + "gypte", "Egypt", "Egipto", "Egipto", "gypten", "gypte", "Egipto", "Egipto" } )
Aadd( MEMVAR->laender, { "ETH", gae + "thiopien", ger + "thiopie", "Ethiopia", "Etiop" + ir + "a", "Eti" + or + "pia", "thiopien", "thiopie", "Etiopa", "Etipia" } )
Aadd( MEMVAR->laender, { "F", "Frankreich", "France", "France", "Francia", "Fran" + cc + "a", "Frankreich", "France", "Francia", "Frana" } )
Aadd( MEMVAR->laender, { "FIN", "Finnland", "Finlande", "Finland", "Finlandia", "Finl" + ad + "ndia", "Finnland", "Finlande", "Finlandia", "Finlndia" } )
Aadd( MEMVAR->laender, { "FJI", "Fidschi", "Fidji", "Fiji", "Fiyi", "Fiji", "Fidschi", "Fidji", "Fiyi", "Fiji" } )
Aadd( MEMVAR->laender, { "FL", "Liechtenstein", "Liechtenstein", "Liechtenstein", "Liechtenstein", "Liechtenstein", "Liechtenstein", "Liechtenstein", "Liechtenstein", "Liechtenstein" } )
Aadd( MEMVAR->laender, { "FO", "F" + ae + "r" + oe + "er", gid + "le F" + er + "ro" + er, "Faroe Islands", "Islas Feroe", "Ilhas Fero" + er, "Frer", "le Fro", "Islas Feroe", "Ilhas Fero" } )
Aadd( MEMVAR->laender, { "GB", "Gro" + sz + "britannien", "Royaume-Uni", "United Kingdom", "Reino Unido", "Reino Unido", "Grobritannien", "Royaume-Uni", "Reino Unido", "Reino Unido" } )
Aadd( MEMVAR->laender, { "GBZ", "Gibraltar", "Gibraltar", "Gibraltar", "Gibraltar", "Gibraltar", "Gibraltar", "Gibraltar", "Gibraltar", "Gibraltar" } )
Aadd( MEMVAR->laender, { "GCA", "Guatemala", "Guatemala", "Guatemala", "Guatemala", "Guatemala", "Guatemala", "Guatemala", "Guatemala", "Guatemala" } )
Aadd( MEMVAR->laender, { "GE", "Georgien", "G" + er + "orgie", "Georgia", "Georgia", "Ge" + or + "rgia", "Georgien", "Gorgie", "Georgia", "Gergia" } )
Aadd( MEMVAR->laender, { "GH", "Ghana", "Ghana", "Ghana", "Ghana", "Gana", "Ghana", "Ghana", "Ghana", "Gana" } )
Aadd( MEMVAR->laender, { "GNB", "Guinea-Bissau", "Guin" + er + "e-Bissau", "Guinea-Bissau", "Guinea-Biss" + ar + "u", "Guin" + er + "-Bissau", "Guinea-Bissau", "Guine-Bissau", "Guinea-Bissu", "Guin-Bissau" } )
Aadd( MEMVAR->laender, { "GR", "Griechenland", "Gr" + el + "ce", "Greece", "Grecia", "Gr" + er + "cia", "Griechenland", "Grce", "Grecia", "Grcia" } )
Aadd( MEMVAR->laender, { "GUY", "Guyana", "Guyane", "Guyana", "Guayana", "Guiana", "Guyana", "Guyane", "Guayana", "Guiana" } )
Aadd( MEMVAR->laender, { "H", "Ungarn", "Hongrie", "Hungary", "Hungr" + ir + "a", "Hungria", "Ungarn", "Hongrie", "Hungra", "Hungria" } )
Aadd( MEMVAR->laender, { "HK", "Hongkong", "Hongkong", "Hong Kong", "Hong Kong", "Hong Kong", "Hongkong", "Hongkong", "Hong Kong", "Hong Kong" } )
Aadd( MEMVAR->laender, { "HN", "Honduras", "Honduras", "Honduras", "Honduras", "Honduras", "Honduras", "Honduras", "Honduras", "Honduras" } )
Aadd( MEMVAR->laender, { "HR", "Kroatien", "Croatie", "Croatia", "Croacia", "Cro" + ar + "cia", "Kroatien", "Croatie", "Croacia", "Crocia" } )
Aadd( MEMVAR->laender, { "I", "Italien", "Italie", "Italy", "Italia", "It" + ar + "lia", "Italien", "Italie", "Italia", "Itlia" } )
Aadd( MEMVAR->laender, { "IL", "Israel", "Isra" + edp + "l", "Israel", "Israel", "Israel", "Israel", "Isral", "Israel", "Israel" } )
Aadd( MEMVAR->laender, { "IND", "Indien", "Inde", "India", "India", gir + "ndia", "Indien", "Inde", "India", "ndia" } )
Aadd( MEMVAR->laender, { "IR", "Iran", "Iran", "Iran", "Ir" + ar + "n", "Ir" + ati + "o", "Iran", "Iran", "Irn", "Iro" } )
Aadd( MEMVAR->laender, { "IRL", "Irland", "Irlande", "Ireland", "Irlanda", "Irlanda", "Irland", "Irlande", "Irlanda", "Irlanda" } )
Aadd( MEMVAR->laender, { "IRQ", "Irak", "Iraq", "Iraq", "Iraq", "Iraque", "Irak", "Iraq", "Iraq", "Iraque" } )
Aadd( MEMVAR->laender, { "IS", "Island", "Islande", "Iceland", "Islandia", "Isl" + ad + "ndia", "Island", "Islande", "Islandia", "Islndia" } )
Aadd( MEMVAR->laender, { "J", "Japan", "Japon", "Japan", "Jap" + or + "n", "Jap" + ati + "o", "Japan", "Japon", "Japn", "Japo" } )
Aadd( MEMVAR->laender, { "JA", "Jamaika", "Jama" + idp + "que", "Jamaica", "Jamaica", "Jamaica", "Jamaika", "Jamaque", "Jamaica", "Jamaica" } )
Aadd( MEMVAR->laender, { "JOR", "Jordanien", "Jordanie", "Jordan", "Jordania", "Jord" + ad + "nia", "Jordanien", "Jordanie", "Jordania", "Jordnia" } )
Aadd( MEMVAR->laender, { "K", "Kambodscha", "Cambodge", "Cambodia", "Camboya", "Camboja", "Kambodscha", "Cambodge", "Camboya", "Camboja" } )
Aadd( MEMVAR->laender, { "KS", "Kirgisistan", "Kirghizistan", "Kyrgyzstan", "Kirguist" + ar + "n", "Quirguist" + ati + "o", "Kirgisistan", "Kirghizistan", "Kirguistn", "Quirguisto" } )
Aadd( MEMVAR->laender, { "KWT", "Kuwait", "Koweit", "Kuwait", "Kuwait", "Kuwait", "Kuwait", "Koweit", "Kuwait", "Kuwait" } )
Aadd( MEMVAR->laender, { "KZ", "Kasachstan", "Kazakhstan", "Kazakhstan", "Kazajst" + ar + "n", "Cazaquist" + ati + "o", "Kasachstan", "Kazakhstan", "Kazajstn", "Cazaquisto" } )
Aadd( MEMVAR->laender, { "L", "Luxemburg", "Luxembourg", "Luxemburg", "Luxemburgo", "Luxemburgo", "Luxemburg", "Luxembourg", "Luxemburgo", "Luxemburgo" } )
Aadd( MEMVAR->laender, { "LAO", "Laos", "Laos", "Laos", "Laos", "Laos", "Laos", "Laos", "Laos", "Laos" } )
Aadd( MEMVAR->laender, { "LAR", "Libyen", "Libye", "Libya", "Libia", "L" + ir + "bia", "Libyen", "Libye", "Libia", "Lbia" } )
Aadd( MEMVAR->laender, { "LB", "Liberia", "Lib" + er + "ria", "Liberia", "Liberia", "Lib" + er + "ria", "Liberia", "Libria", "Liberia", "Libria" } )
Aadd( MEMVAR->laender, { "LS", "Lesotho", "Lesotho", "Lesotho", "Lesoto", "Lesoto", "Lesotho", "Lesotho", "Lesoto", "Lesoto" } )
Aadd( MEMVAR->laender, { "LT", "Litauen", "Lituanie", "Lithuania", "Lituania", "Litu" + ad + "nia", "Litauen", "Lituanie", "Lituania", "Litunia" } )
Aadd( MEMVAR->laender, { "LV", "Lettland", "Lettonie", "Latvia", "Letonia", "Let" + or + "nia", "Lettland", "Lettonie", "Letonia", "Letnia" } )
Aadd( MEMVAR->laender, { "M", "Malta", "Malte", "Malta", "Malta", "Malta", "Malta", "Malte", "Malta", "Malta" } )
Aadd( MEMVAR->laender, { "MA", "Marokko", "Maroc", "Morocco", "Marruecos", "Marrocos", "Marokko", "Maroc", "Marruecos", "Marrocos" } )
Aadd( MEMVAR->laender, { "MAL", "Malaysia", "Malaisie", "Malaysia", "Malasia", "Mal" + ar + "sia", "Malaysia", "Malaisie", "Malasia", "Malsia" } )
Aadd( MEMVAR->laender, { "MC", "Monaco", "Monaco", "Monaco", "M" + or + "naco", "M" + or + "naco", "Monaco", "Monaco", "Mnaco", "Mnaco" } )
Aadd( MEMVAR->laender, { "MD", "Moldawien", "Moldavie", "Moldova", "Moldavia", "Mold" + ar + "via", "Moldawien", "Moldavie", "Moldavia", "Moldvia" } )
Aadd( MEMVAR->laender, { "MEX", "Mexiko", "Mexico", "Mexico", "M" + er + "xico", "M" + er + "xico", "Mexiko", "Mexico", "Mxico", "Mxico" } )
Aadd( MEMVAR->laender, { "MK", "Mazedonien", "Mac" + er + "doine", "Macedonia", "Rep" + ur + "blica de Macedonia", "Rep" + ur + "blica da Maced" + or + "nia", "Mazedonien", "Macdoine", "Repblica de Macedonia", "Repblica da Macednia" } )
Aadd( MEMVAR->laender, { "ML", "Mali", "Mali", "Mali", "Mal" + ir, "Mali", "Mali", "Mali", "Mal", "Mali" } )
Aadd( MEMVAR->laender, { "MOZ", "Mosambik", "Mozambique", "Mozambique", "Mozambique", "Mo" + cc + "ambique", "Mosambik", "Mozambique", "Mozambique", "Moambique" } )
Aadd( MEMVAR->laender, { "MS", "Mauritius", gid + "le Maurice", "Mauritius", "Mauricio", "Maur" + ir + "cia", "Mauritius", "le Maurice", "Mauricio", "Maurcia" } )
Aadd( MEMVAR->laender, { "MW", "Malawi", "Malawi", "Malawi", "Malawi", "Malawi", "Malawi", "Malawi", "Malawi", "Malawi" } )
Aadd( MEMVAR->laender, { "MYA", "Myanmar", "Myanmar", "Myanmar", "Myanmar", "Myanmar", "Myanmar", "Myanmar", "Myanmar", "Myanmar" } )
Aadd( MEMVAR->laender, { "N", "Norwegen", "Norv" + el + "ge", "Norway", "Noruega", "Noruega", "Norwegen", "Norvge", "Noruega", "Noruega" } )
Aadd( MEMVAR->laender, { "NA", "Niederl" + ae + "ndische Antillen", "Antilles N" + er + "erlandaises", "Netherlands Antilles", "Antillas Neerlandesas", "Antilhas Neerlandesas", "Niederlndische Antillen", "Antilles Nerlandaises", "Antillas Neerlandesas", "Antilhas Neerlandesas" } )
Aadd( MEMVAR->laender, { "NAM", "Namibia", "Namibie", "Namibia", "Namibia", "Nam" + ir + "bia", "Namibia", "Namibie", "Namibia", "Nambia" } )
Aadd( MEMVAR->laender, { "NEP", "Nepal", "N" + er + "pal", "Nepal", "Nepal", "Nepal", "Nepal", "Npal", "Nepal", "Nepal" } )
Aadd( MEMVAR->laender, { "NIC", "Nicaragua", "Nicaragua", "Nicaragua", "Nicaragua", "Nicar" + ar + "gua", "Nicaragua", "Nicaragua", "Nicaragua", "Nicargua" } )
Aadd( MEMVAR->laender, { "NL", "Niederlande", "Pays-Bas", "Holland", "Pa" + ir + "ses Bajos", "Pa" + ir + "ses Baixos", "Niederlande", "Pays-Bas", "Pases Bajos", "Pases Baixos" } )
Aadd( MEMVAR->laender, { "NZ", "Neuseeland", "Nouvelle-Z" + er + "lande", "New Zealand", "Nueva Zelanda", "Nova Zel" + ad + "ndia", "Neuseeland", "Nouvelle-Zlande", "Nueva Zelanda", "Nova Zelndia" } )
Aadd( MEMVAR->laender, { "OMA", "Oman", "Oman", "Oman", "Om" + ar + "n", "Om" + ati, "Oman", "Oman", "Omn", "Om" } )
Aadd( MEMVAR->laender, { "P", "Portugal", "Portugal", "Portugal", "Portugal", "Portugal", "Portugal", "Portugal", "Portugal", "Portugal" } )
Aadd( MEMVAR->laender, { "PA", "Panama", "Panama", "Panama", "Panam" + ar, "Panam" + ar, "Panama", "Panama", "Panam", "Panam" } )
Aadd( MEMVAR->laender, { "PE", "Peru", "P" + er + "rou", "Peru", "Per" + ur, "Peru", "Peru", "Prou", "Per", "Peru" } )
Aadd( MEMVAR->laender, { "PK", "Pakistan", "Pakistan", "Pakistan", "Pakist" + ar + "n", "Paquist" + ati + "o", "Pakistan", "Pakistan", "Pakistn", "Paquisto" } )
Aadd( MEMVAR->laender, { "PL", "Polen", "Pologne", "Poland", "Polonia", "Pol" + or + "nia", "Polen", "Pologne", "Polonia", "Polnia" } )
Aadd( MEMVAR->laender, { "PNG", "Papua-Neuguinea", "Papouasie-Nouvelle-Guin" + er + "e", "Papua New Guinea", "Pap" + ur + "a Nueva Guinea", "Papua-Nova Guin" + er, "Papua-Neuguinea", "Papouasie-Nouvelle-Guine", "Papa Nueva Guinea", "Papua-Nova Guin" } )
Aadd( MEMVAR->laender, { "PR", "Puerto Rico", "Porto Rico", "Puerto Rico", "Puerto Rico", "Porto Rico", "Puerto Rico", "Porto Rico", "Puerto Rico", "Porto Rico" } )
Aadd( MEMVAR->laender, { "PS", "Pal" + ae + "stina", "Palestine", "Palestine", "Palestina", "Palestina", "Palstina", "Palestine", "Palestina", "Palestina" } )
Aadd( MEMVAR->laender, { "PY", "Paraguay", "Paraguay", "Paraguay", "Paraguay", "Paraguai", "Paraguay", "Paraguay", "Paraguay", "Paraguai" } )
Aadd( MEMVAR->laender, { "Q", "Katar", "Qatar", "Qatar", "Qatar", "Qatar", "Katar", "Qatar", "Qatar", "Qatar" } )
Aadd( MEMVAR->laender, { "RA", "Argentinien", "Argentine", "Argentina", "Argentina", "Argentina", "Argentinien", "Argentine", "Argentina", "Argentina" } )
Aadd( MEMVAR->laender, { "RB", "Botsuana", "Botswana", "Botswana", "Botsuana", "Botswana", "Botsuana", "Botswana", "Botsuana", "Botswana" } )
Aadd( MEMVAR->laender, { "RCA", "Zentralafrikanische Republik", "R" + er + "publique Centrafricaine", "Central African Republic", "Rep" + ur + "blica Centroafricana", "Rep" + ur + "blica Centro-Africana", "Zentralafrikanische Republik", "Rpublique Centrafricaine", "Repblica Centroafricana", "Repblica Centro-Africana" } )
Aadd( MEMVAR->laender, { "RCB", "Republik Kongo", "R" + er + "publique du Congo", "Republic of the Congo", "Rep" + ur + "blica del Congo", "Congo", "Republik Kongo", "Rpublique du Congo", "Repblica del Congo", "Congo" } )
Aadd( MEMVAR->laender, { "RCH", "Chile", "Chili", "Chile", "Chile", "Chile", "Chile", "Chili", "Chile", "Chile" } )
Aadd( MEMVAR->laender, { "RH", "Haiti", "Ha" + idp + "ti", "Haiti", "Hait" + ir, "Haiti", "Haiti", "Hati", "Hait", "Haiti" } )
Aadd( MEMVAR->laender, { "RI", "Indonesien", "Indon" + er +"sie", "Indonesia", "Indonesia", "Indon" + er + "sia", "Indonesien", "Indonsie", "Indonesia", "Indonsia" } )
Aadd( MEMVAR->laender, { "RIM", "Mauretanien", "Mauretanie", "Mauritania", "Mauritania", "Maurit" + ad + "nia", "Mauretanien", "Mauretanie", "Mauritania", "Mauritnia" } )
Aadd( MEMVAR->laender, { "RL", "Libanon", "Liban", "Lebanon", "L" + ir + "bano", "L" + ir + "bano", "Libanon", "Liban", "Lbano", "Lbano" } )
Aadd( MEMVAR->laender, { "RM", "Madagaskar", "Madagascar", "Madagascar", "Madagascar", "Madag" + ar + "scar", "Madagaskar", "Madagascar", "Madagascar", "Madagscar" } )
Aadd( MEMVAR->laender, { "RN", "Niger", "Niger", "Niger", "N" + ir + "ger", "N" + ir + "ger", "Niger", "Niger", "Nger", "Nger" } )
Aadd( MEMVAR->laender, { "RO", "Rum" + ae + "nien", "Roumanie", "Romania", "Rumania", "Rom" + er + "nia", "Rumnien", "Roumanie", "Rumania", "Romnia" } )
Aadd( MEMVAR->laender, { "ROK", "S" + ue + "dkorea", "Cor" + er + "e du Sud", "South Korea", "Corea del Sur", "Coreia do Sul", "Sdkorea", "Core du Sud", "Corea del Sur", "Coreia do Sul" } )
Aadd( MEMVAR->laender, { "ROU", "Uruguay", "Uruguay", "Uruguay", "Uruguay", "Uruguai", "Uruguay", "Uruguay", "Uruguay", "Uruguai" } )
Aadd( MEMVAR->laender, { "RP", "Philippinen", "Philippines", "Philippines", "Filipinas", "Filipinas", "Philippinen", "Philippines", "Filipinas", "Filipinas" } )
Aadd( MEMVAR->laender, { "RSM", "San Marino", "San Marin", "San Marino", "San Marino", "San Marino", "San Marino", "San Marin", "San Marino", "San Marino" } )
Aadd( MEMVAR->laender, { "RUS", "Russland", "Russie", "Russia", "Rusia", "R" + ur + "ssia", "Russland", "Russie", "Rusia", "Rssia" } )
Aadd( MEMVAR->laender, { "RWA", "Ruanda", "Rwanda", "Rwanda", "Ruanda", "Ruanda", "Ruanda", "Rwanda", "Ruanda", "Ruanda" } )
Aadd( MEMVAR->laender, { "S", "Schweden", "Su" + el +"de", "Sweden", "Suecia", "Su" + er + "cia", "Schweden", "Sude", "Suecia", "Sucia" } )
Aadd( MEMVAR->laender, { "SA", "Saudi-Arabien", "Arabie Saoudite", "Saudi Arabia", "Arabia Saudita", "Ar" + ar + "bia Saudita", "Saudi-Arabien", "Arabie Saoudite", "Arabia Saudita", "Arbia Saudita" } )
Aadd( MEMVAR->laender, { "SCV", "Vatikanstadt", "Vatican", "Vatican City", "Ciudad del Vaticano", "Vaticano", "Vatikanstadt", "Vatican", "Ciudad del Vaticano", "Vaticano" } )
Aadd( MEMVAR->laender, { "SD", "Swasiland", "Swaziland", "Swaziland", "Swazilandia", "Suazil" + ad + "ndia", "Swasiland", "Swaziland", "Swazilandia", "Suazilndia" } )
Aadd( MEMVAR->laender, { "SGP", "Singapur", "Singapour", "Singapore", "Singapur", "Singapura", "Singapur", "Singapour", "Singapur", "Singapura" } )
Aadd( MEMVAR->laender, { "SK", "Slowakei", "Slovaquie", "Slovakia", "Eslovaquia", "Eslov" + ar + "quia", "Slowakei", "Slovaquie", "Eslovaquia", "Eslovquia" } )
Aadd( MEMVAR->laender, { "SLO", "Slowenien", "Slov" + er +"nie", "Slovenia", "Eslovenia", "Eslov" + er + "nia", "Slowenien", "Slovnie", "Eslovenia", "Eslovnia" } )
Aadd( MEMVAR->laender, { "SME", "Suriname", "Surinam", "Suriname", "Surinam", "Suriname", "Suriname", "Surinam", "Surinam", "Suriname" } )
Aadd( MEMVAR->laender, { "SN", "Senegal", "S" + er + "n" + er + "gal", "Senegal", "Senegal", "Senegal", "Senegal", "Sngal", "Senegal", "Senegal" } )
Aadd( MEMVAR->laender, { "SR", "Serbien", "Serbie", "Serbia", "Serbia", "S" + er + "rvia", "Serbien", "Serbie", "Serbia", "Srvia" } )
Aadd( MEMVAR->laender, { "SUD", "Sudan", "Soudan", "Sudan", "Sud" + ar + "n", "Sud" + ati + "o", "Sudan", "Soudan", "Sudn", "Sudo" } )
Aadd( MEMVAR->laender, { "SY", "Seychellen", "Seychelles", "Seychelles", "Seychelles", "Seychelles", "Seychellen", "Seychelles", "Seychelles", "Seychelles" } )
Aadd( MEMVAR->laender, { "SYR", "Syrien", "Syrie", "Syria", "Siria", "S" + ir + "ria", "Syrien", "Syrie", "Siria", "Sria" } )
Aadd( MEMVAR->laender, { "T", "Thailand", "Thailande", "Thailand", "Tailandia", "Tail" + ad + "ndia", "Thailand", "Thailande", "Tailandia", "Tailndia" } )
Aadd( MEMVAR->laender, { "TG", "Togo", "Togo", "Togo", "Togo", "Togo", "Togo", "Togo", "Togo", "Togo" } )
Aadd( MEMVAR->laender, { "TJ", "Tadschikistan", "Tadjikistan", "Tadzhikistan", "Tayikist" + ar + "n", "Tadjiquist" + ati + "o", "Tadschikistan", "Tadjikistan", "Tayikistn", "Tadjiquisto" } )
Aadd( MEMVAR->laender, { "TM", "Turkmenistan", "Turkm" + er + "nistan", "Turkmenistan", "Turkmenist" + ar + "n", "Turquemenist" + ati + "o", "Turkmenistan", "Turkmnistan", "Turkmenistn", "Turquemenisto" } )
Aadd( MEMVAR->laender, { "TN", "Tunesien", "Tunisie", "Tunisia", "T" + ur + "nez", "Tun" + ir + "sia", "Tunesien", "Tunisie", "Tnez", "Tunsia" } )
Aadd( MEMVAR->laender, { "TON", "Tonga", "Tonga", "Tonga", "Tonga", "Tonga", "Tonga", "Tonga", "Tonga", "Tonga" } )
Aadd( MEMVAR->laender, { "TR", "T" + ue + "rkei", "Turquie", "Turkey", "Turqu" + ir + "a", "Turquia", "Trkei", "Turquie", "Turqua", "Turquia" } )
Aadd( MEMVAR->laender, { "TT", "Trinidad und Tobago", "Trinit" + er + " et Tobago", "Trinidad and Tobago", "Trinidad y Tobago", "Trinidad e Tobago", "Trinidad und Tobago", "Trinit et Tobago", "Trinidad y Tobago", "Trinidad e Tobago" } )
Aadd( MEMVAR->laender, { "UA", "Ukraine", "Ukraine", "Ukraine", "Ucrania", "Ucr" + ad + "nia", "Ukraine", "Ukraine", "Ucrania", "Ucrnia" } )
Aadd( MEMVAR->laender, { "UAE", "Vereinigte Arabische Emirate", ger + "mirats arabes unis", "United Arab Emirates", "Emiratos " + gar + "rabes Unidos", "Emiratos " + gar + "rabes Unidos", "Vereinigte Arabische Emirate", "mirats arabes unis", "Emiratos rabes Unidos", "Emiratos rabes Unidos" } )
Aadd( MEMVAR->laender, { "USA", "Vereinigte Staaten von Amerika", ger + "tats-Unis d'Am" + er + "rique", "United States of America", "Estados Unidos de Am" + er + "rica", "Estados Unidos da Am" + er + "rica", "Vereinigte Staaten von Amerika", "tats-Unis d'Amrique", "Estados Unidos de Amrica", "Estados Unidos da Amrica" } )
Aadd( MEMVAR->laender, { "UZ", "Usbekistan", "Ouzb" + er + "kistan", "Uzbekistan", "Uzbekist" + ar + "n", "Uzbequist" + ati + "o", "Usbekistan", "Ouzbkistan", "Uzbekistn", "Uzbequisto" } )
Aadd( MEMVAR->laender, { "VN", "Vietnam", "Vietnam", "Vietnam", "Vietnam", "Vietname", "Vietnam", "Vietnam", "Vietnam", "Vietname" } )
Aadd( MEMVAR->laender, { "WAG", "Gambia", "Gambie", "Gambia", "Gambia", "G" + ad + "mbia", "Gambia", "Gambie", "Gambia", "Gmbia" } )
Aadd( MEMVAR->laender, { "WAL", "Sierra Leone", "Sierra Leone", "Sierra Leone", "Sierra Leona", "Serra Leoa", "Sierra Leone", "Sierra Leone", "Sierra Leona", "Serra Leoa" } )
Aadd( MEMVAR->laender, { "WAN", "Nigeria", "Nigeria", "Nigeria", "Nigeria", "Nig" + er + "ria", "Nigeria", "Nigeria", "Nigeria", "Nigria" } )
Aadd( MEMVAR->laender, { "WD", "Dominica", "Dominique", "Dominica", "Dominica", "Dominica", "Dominica", "Dominique", "Dominica", "Dominica" } )
Aadd( MEMVAR->laender, { "WG", "Grenada", "Grenade", "Grenada", "Granada", "Granada", "Grenada", "Grenade", "Granada", "Granada" } )
Aadd( MEMVAR->laender, { "WL", "St. Lucia", "Sainte-Lucie", "St. Lucia", "Santa Luc" + ir + "a", "Santa L" + ur + "cia", "St. Lucia", "Sainte-Lucie", "Santa Luca", "Santa Lcia" } )
Aadd( MEMVAR->laender, { "WS", "Samoa", "Samoa", "Samoa", "Samoa", "Samoa", "Samoa", "Samoa", "Samoa", "Samoa" } )
Aadd( MEMVAR->laender, { "WV", "St. Vincent und die Grenadinen", "Saint-Vincent et les Grenadines", "Saint Vincent and the Grenadines", "San Vicente y las Granadinas", "S" + ati + "o Vicente e Granadinas", "St. Vincent und die Grenadinen", "Saint-Vincent et les Grenadines", "San Vicente y las Granadinas", "So Vicente e Granadinas" } )
Aadd( MEMVAR->laender, { "YAR", "Jemen", "Y" + er + "men", "Yemen", "Yemen", "I" + er + "men", "Jemen", "Ymen", "Yemen", "Imen" } )
Aadd( MEMVAR->laender, { "YV", "Venezuela", "Venezuela", "Venezuela", "Venezuela", "Venezuela", "Venezuela", "Venezuela", "Venezuela", "Venezuela" } )
Aadd( MEMVAR->laender, { "Z", "Sambia", "Zambie", "Zambia", "Zambia", "Z" + ad + "mbia", "Sambia", "Zambie", "Zambia", "Zmbia" } )
Aadd( MEMVAR->laender, { "ZA", "S" + ue + "dafrika", "Afrique du Sud", "South Africa", "Sud" + ar + "frica", gar + "frica do Sul", "Sdafrika", "Afrique du Sud", "Sudfrica", "frica do Sul" } )
Aadd( MEMVAR->laender, { "ZW", "Simbabwe", "Zimbabwe", "Zimbabwe", "Zimbabwe", "Zimbabwe", "Simbabwe", "Zimbabwe", "Zimbabwe", "Zimbabwe" } )

//Arrays used for foreign languages, mother tongue and Xbase++-versions
MEMVAR->xbversionen := { { "Nein", "0" }, { "< 1.5", "1" }, { "1.5x", "2" }, { "1.6x", "3" }, { "1.7x", "4" }, { "1.80", "5" }, { "1.82.294", "6" }, { "1.82.306", "7" }, { "1.9x", "8" } }
MEMVAR->frsprachen := { { "Deutsch", "1" }, { "Fran" + cc + "ais", "2" }, { "English", "3" }, { "Espa" + nt + "ol", "4" }, ;
											{ "Portugu" + ed + "s", "5" }, { "Dansk", "6" }, { "Italiano", "7" }, { "Nederlands", "8" }, { "Norsk", "9" }, ;
											{ "Polski", "10" }, { "Suomi", "11" }, { "Svenska", "12" }, { "T" + ue + "rk" + cc + "e", "13" }, ;
											{ "Slov" + ar + "k", "14" }, { "Magyar", "15" }, { "Rom" + ad + "n", "16" }, { "Hrvatski", "17" }, { "&#268;esk" + yr, "18" }, { " ??? ->", "0" }  }
MEMVAR->sprachen := { { "Deutsch", "1" }, { "Fran" + cc + "ais", "2" }, { "English", "3" }, { "Espa" + nt + "ol", "4" }, ;
											{ "Portugu" + ed + "s", "5" }, { "Dansk", "6" }, { "Italiano", "7" }, { "Nederlands", "8" }, { "Norsk", "9" }, ;
											{ "Polski", "10" }, { "Suomi", "11" }, { "Svenska", "12" }, { "T" + ue + "rk" + cc + "e", "13" }, ;
											{ "Slov" + ar + "k", "14" }, { "Magyar", "15" }, { "Rom" + ad + "n", "16" }, { "Hrvatski", "17" }, { "&#268;esk" + yr, "18" }, { " ??? ->", "99" }  }
asort( MEMVAR->sprachen,,, { | aX, aY | aX[ 1 ] < aY[ 1 ] } )
asort( MEMVAR->frsprachen,,, { | aX, aY | aX[ 1 ] < aY[ 1 ] } )
istOK := .f.
if .not. file( datenpfad + "\pcd.dbf" )
	if PCDanlegen()
		istOK := .t.
	endif
else
	istOK := .t.
endif
if istOK
	MEMVAR->dcid := 0
	if .not. File( mempfad, "D" )
		CreateDir( mempfad )
	else
		dat := Directory( mempfad + "\DC07DE????.*" )
		if len( dat ) > 0
			ASort( dat,,, { | aX, aY | left( aX[ F_NAME ], 10 ) < left( aY[ F_NAME ], 10 ) } )
			MEMVAR->dcid := val( substr( dat[ len( dat ), F_NAME ], 7, 4 ) )
		endif
	endif
	if .not. File( logpfad, "D" )
		CreateDir( logpfad )
	endif
	if .not. File( mlogpfad, "D" )
		CreateDir( mlogpfad )
	endif
	if .not. file( datenpfad + "\devcon.dbf" )
		if anlegen()
			MEMVAR->dcid++
#ifdef alsexe
			MEMVAR->oWebServer := xbHTTPServer():new( INADDR_ANY, 80 )
			if MEMVAR->oWebServer:ErrorCode > 0
				SaveToFile( ConvToAnsiCp( "______ Webserver cannot be started! ________________" + DtoC( Date() ) + "_" + Time() + CRLF + "Errorcode: " + LTrim(Str(MEMVAR->oWebServer:ErrorCode)) + " (" + MEMVAR->oWebServer:ErrorText(MEMVAR->oWebServer:ErrorCode) + ")" ), SERVER_ERR_LOG_FILE )
				Return
			endif
			MEMVAR->oWebServer:LingerTimeout( 120 )													// destroy session after 2 minutes of inactivity
			MEMVAR->oWebServer:MaxConnections := 50                         // max # of active client-threads
			MEMVAR->oWebServer:onMaxConnect   := OnMaxConnect()             // answer being send if max amount of connections is reached
			MEMVAR->oWebServer:RootDir        := WWW_ROOT                   // webroot-directory
			MEMVAR->oWebServer:IndexFile      := "index.html"               // indexfile being send to the client
			MEMVAR->oWebServer:onGET          := {|o| HTTPHandler(o)}       // block being executed in case a HTTP GET is received
			MEMVAR->oWebServer:onPOST         := {|o| HTTPHandler(o)}       // block being executed in case a HTTP POST is received
			MEMVAR->oWebServer:onHTTPError    := {|e| LogError(e,,"80"),break(redirekt())} // log server errors
			MEMVAR->oWebServer:onError        := {|o,n| LogError(o,n,"80")}
			MEMVAR->oWebServer:onInvalidCommand := {|o| o:HTTPResponse:Content := redirekt() }
			MEMVAR->oWebServer:onNotFound     := {|o| o:HTTPResponse:Content := redirekt() }
			MEMVAR->oWebServer:start()
			do while .t.
				logmelde()
				nindex := 0
				do while ( nindex < 15600 )	// 15600*5 = 13 minutes
					nindex++
					Sleep( 5 )
				enddo
			enddo
#else
		  DevConService():start() 
#endif
		endif
	else
		use ( datenpfad + "\devcon.dbf" )
		go top
		do while .not. eof()
			if val( right( devcon->TEILNEHMID, 4 ) ) > MEMVAR->dcid
				MEMVAR->dcid := val( right( devcon->TEILNEHMID, 4 ) )
			endif
			skip
		enddo
		MEMVAR->dcid++
		CreateCharts( MEMVAR->chartcontrol )
#ifdef alsexe
		MEMVAR->oWebServer := xbHTTPServer():new( INADDR_ANY, 80 )
		if MEMVAR->oWebServer:ErrorCode > 0
			SaveToFile( ConvToAnsiCp( "______ Webserver cannot be started! ________________" + DtoC( Date() ) + "_" + Time() + CRLF + "Errorcode: " + LTrim(Str(MEMVAR->oWebServer:ErrorCode)) + " (" + MEMVAR->oWebServer:ErrorText(MEMVAR->oWebServer:ErrorCode) + ")" ), SERVER_ERR_LOG_FILE )
			Return
		endif
		MEMVAR->oWebServer:LingerTimeout( 120 )													// destroy session after 2 minutes of inactivity
		MEMVAR->oWebServer:MaxConnections := 50                         // max # of active client-threads
		MEMVAR->oWebServer:onMaxConnect   := OnMaxConnect()             // answer being send if max amount of connections is reached
		MEMVAR->oWebServer:RootDir        := WWW_ROOT                   // webroot-directory
		MEMVAR->oWebServer:IndexFile      := "index.html"               // indexfile being send to the client
		MEMVAR->oWebServer:onGET          := {|o| HTTPHandler(o)}       // block being executed in case a HTTP GET is received
		MEMVAR->oWebServer:onPOST         := {|o| HTTPHandler(o)}       // block being executed in case a HTTP POST is received
		MEMVAR->oWebServer:onHTTPError    := {|e| LogError(e,,"80"),break(redirekt())} // log server errors
		MEMVAR->oWebServer:onError        := {|o,n| LogError(o,n,"80")}
		MEMVAR->oWebServer:onInvalidCommand := {|o| o:HTTPResponse:Content := redirekt() }
		MEMVAR->oWebServer:onNotFound     := {|o| o:HTTPResponse:Content := redirekt() }
		MEMVAR->oWebServer:start()
		do while .t.
			logmelde()
			nindex := 0
			do while ( nindex < 15600 )	// 15600*5 = 13 minutes
				nindex++
				Sleep( 5 )
			enddo
		enddo
#else
	  DevConService():start() 
#endif
	endif
endif
RETURN 

function anlegen()
local retwert, astructure
retwert := .f.
astructure := {}
if .not. File( APP_ROOT, "D" )
	CreateDir( APP_ROOT )
endif
if .not. File( datenpfad, "D" )
	CreateDir( datenpfad )
endif
AAdd( aStructure, {"ANREDE","N",1,0} )
AAdd( aStructure, {"VORNAME","C",30,0} )
AAdd( aStructure, {"NACHNAME","C",30,0} )
AAdd( aStructure, {"FIRMA1","C",70,0} )
AAdd( aStructure, {"FIRMA2","C",70,0} )
AAdd( aStructure, {"ABTEILUNG","C",30,0} )
AAdd( aStructure, {"STRASSE","C",50,0} )
AAdd( aStructure, {"STAAT","C",25,0} )
AAdd( aStructure, {"PLZ","C",10,0} )
AAdd( aStructure, {"ORT","C",50,0} )
AAdd( aStructure, {"LAND","C",3,0} )
AAdd( aStructure, {"EMAIL","C",50,0} )
AAdd( aStructure, {"WEBSEITE","C",30,0} )
AAdd( aStructure, {"TEILNEHMER","N",1,0} )
AAdd( aStructure, {"MUTTERSPRA","N",2,0} )
AAdd( aStructure, {"MUTTERSPSO","C",20,0} )
AAdd( aStructure, {"FREMDSPRA1","N",2,0} )
AAdd( aStructure, {"FREMDSPRA2","N",2,0} )
AAdd( aStructure, {"VERSION","N",1,0} )
AAdd( aStructure, {"LAPTOP","L",1,0} )
AAdd( aStructure, {"KSDELPHI","N",1,0} )
AAdd( aStructure, {"KSFOXPRO","N",1,0} )
AAdd( aStructure, {"KSFLAGSHIP","N",1,0} )
AAdd( aStructure, {"KSCLIPPER","N",1,0} )
AAdd( aStructure, {"KSCLIP4WIN","N",1,0} )
AAdd( aStructure, {"KSDBASE","N",1,0} )
AAdd( aStructure, {"KSVO","N",1,0} )
AAdd( aStructure, {"KSXHARBOUR","N",1,0} )
AAdd( aStructure, {"SONSTIGE1","C",20,0} )
AAdd( aStructure, {"KSSONSTIG1","N",1,0} )
AAdd( aStructure, {"SONSTIGE2","C",20,0} )
AAdd( aStructure, {"KSSONSTIG2","N",1,0} )
AAdd( aStructure, {"SONSTIGE3","C",20,0} )
AAdd( aStructure, {"KSSONSTIG3","N",1,0} )
AAdd( aStructure, {"KSTOPDOWN","N",1,0} )
AAdd( aStructure, {"KSEXPRESS","N",1,0} )
AAdd( aStructure, {"KSFIVEWIN","N",1,0} )
AAdd( aStructure, {"KSSQLEXPRE","N",1,0} )
AAdd( aStructure, {"KSXCLASS","N",1,0} )
AAdd( aStructure, {"KSXB2NET","N",1,0} )
AAdd( aStructure, {"KSXBHCL","N",1,0} )
AAdd( aStructure, {"KSCOCKPIT","N",1,0} )
AAdd( aStructure, {"KSLLABEL","N",1,0} )
AAdd( aStructure, {"KSVPE","N",1,0} )
AAdd( aStructure, {"KSRUNDR","N",1,0} )
AAdd( aStructure, {"KSMARSHALL","N",1,0} )
AAdd( aStructure, {"ADDONSONS1","C",20,0} )
AAdd( aStructure, {"KSADDOSON1","N",1,0} )
AAdd( aStructure, {"ADDONSONS2","C",20,0} )
AAdd( aStructure, {"KSADDOSON2","N",1,0} )
AAdd( aStructure, {"ADDONSONS3","C",20,0} )
AAdd( aStructure, {"KSADDOSON3","N",1,0} )
AAdd( aStructure, {"ANMELDEDAT","D",8,0} )
AAdd( aStructure, {"ZAHLEINGAN","D",8,0} )
AAdd( aStructure, {"ZAHLART","N",1,0} )
AAdd( aStructure, {"INTSQL","L",1,0} )
AAdd( aStructure, {"INTWEBANB","L",1,0} )
AAdd( aStructure, {"INTMIGRAT","L",1,0} )
AAdd( aStructure, {"INTACTIVEX","L",1,0} )
AAdd( aStructure, {"INTSONSTI1","C",20,0} )
AAdd( aStructure, {"INTSONSTI2","C",20,0} )
AAdd( aStructure, {"INTSONSTI3","C",20,0} )
AAdd( aStructure, {"DEVCON1","L",1,0} )
AAdd( aStructure, {"DEVCON2","L",1,0} )
AAdd( aStructure, {"DEVCON3","L",1,0} )
AAdd( aStructure, {"DEVCON4","L",1,0} )
AAdd( aStructure, {"DEVCON5","L",1,0} )
AAdd( aStructure, {"TEILNEHMID","C",10,0} )
AAdd( aStructure, {"PREIS","N",6,2} )
AAdd( aStructure, {"SHIRT","N",1,0} )
AAdd( aStructure, {"SHUTTLE","N",1,0} )
AAdd( aStructure, {"SHUTTLER","N",1,0} )
AAdd( aStructure, {"UHRAB","C",4,0} )
AAdd( aStructure, {"UHRHIN","C",4,0} )
AAdd( aStructure, {"ANONYM","L",1,0} )

DbCreate( datenpfad + "\devcon", aStructure )
retwert := file( datenpfad + "\devcon.dbf" )
return retwert
 
CLASS DevConService From ServiceApp 
  EXPORTED: 
    CLASS METHOD main 
    CLASS METHOD stop 
  HIDDEN: 
    CLASS VAR lRunning 
    CLASS VAR nindex 
ENDCLASS  
 
// Entry point of service
CLASS METHOD DevConService:main()
LOCAL cLocation, oLog, oCtrl, cServiceName
MEMVAR->oWebServer := xbHTTPServer():new( INADDR_ANY, 80 )
if MEMVAR->oWebServer:ErrorCode > 0
	SaveToFile( ConvToAnsiCp( "______ Webserver cannot be started! ________________" + DtoC( Date() ) + "_" + Time() + CRLF + "Errorcode: " + LTrim(Str(MEMVAR->oWebServer:ErrorCode)) + " (" + MEMVAR->oWebServer:ErrorText(MEMVAR->oWebServer:ErrorCode) + ")" ), SERVER_ERR_LOG_FILE )
	Return
endif
MEMVAR->oWebServer:LingerTimeout( 120 )													// destroy session after 2 minutes of inactivity
MEMVAR->oWebServer:MaxConnections := 50                         // max # of active client-threads
MEMVAR->oWebServer:onMaxConnect   := OnMaxConnect()             // answer being send if max amount of connections is reached
MEMVAR->oWebServer:RootDir        := WWW_ROOT                   // webroot-directory
MEMVAR->oWebServer:IndexFile      := "index.html"               // indexfile being send to the client
MEMVAR->oWebServer:onGET          := {|o| HTTPHandler(o)}       // block being executed in case a HTTP GET is received
MEMVAR->oWebServer:onPOST         := {|o| HTTPHandler(o)}       // block being executed in case a HTTP POST is received
MEMVAR->oWebServer:onHTTPError    := {|e| LogError(e,,"80"),break(redirekt())} // log server errors
MEMVAR->oWebServer:onError        := {|o,n| LogError(o,n,"80")}
MEMVAR->oWebServer:onInvalidCommand := {|o| o:HTTPResponse:Content := redirekt() }
MEMVAR->oWebServer:onNotFound     := {|o| o:HTTPResponse:Content := redirekt() }
MEMVAR->oWebServer:start()
::lRunning := .t.
do while ::lRunning
	logmelde()
	::nindex := 0
	do while ( ::nindex < 15600 )	// 15600*5 = 13 minutes
		::nindex++
		Sleep( 5 )
		if .not. ::lRunning
			::nindex := 15600
		endif
	enddo
enddo
RETURN self 

// Entry point for stop request
CLASS METHOD DevConService:stop() 
	MEMVAR->oWebServer:onError := NIL
	MEMVAR->oWebServer:destroy()
	::lRunning := .f.
RETURN self 

procedure logmelde()
local i, anz, dat, text, dateien, datsatz, sorti, nHandle, ueber, saetze, j, anzdbf, attri, backverz, istbackup, zeit, heute, aktdat
local bSaveError, oError, cPath, cZipFile, oZip, lPfad, k, dbfdat, oMail, oSmtp
DbeSetDefault( "DBFNTX" )
	istbackup := .f.
	zeit := strtran( left( time(), 5 ), ":", "-" )
	if .not. File( LW + '\DEVCONZIP', "D" )
		CreateDir( LW + '\DEVCONZIP' )
	endif
	cZipFile  := upper( LW + "\DEVCONZIP\" + dtos( date() ) + "_" + zeit + ".zip" )
	oZip := XbZLibZip():New()
	oZip:Open( cZipFile, XBZ_OPEN_UPDATE, XBZ_BEST_COMPRESSION )
	attri := .f.
	lpfad := .t.
	dbfdat := {}
	anzdbf := Directory( datenpfad + "\*.*" )
	cPath := upper( datenpfad )
	for j := 1 to len( anzdbf )
		if ( ( "A" $ anzdbf[ j, F_ATTR ] ) .and. ( .not. attri ) )
			attri := .t.
			if lPfad
				oZip:AddFile( cPath )
				lPfad := .f.
			endif
			AEval( anzdbf, { |a| oZip:AddFile( datenpfad + "\" + a[ F_NAME ] ) } )
			AEval( anzdbf, { |a| Aadd( dbfdat, a[ F_NAME ] ) } )
			AEval( anzdbf, { |a| FAttr( datenpfad + "\" + a[ F_NAME ], "-A" ) } )
		endif
	next
	if attri
		backverz := BACKUP_DIR + "\DEVCONBACKUP"
		if .not. file( backverz, "D" )
			CreateDir( backverz )
		endif
		backverz += "\" + alltrim( str( year( Date() ) ) )
		if .not. file( backverz, "D" )
			CreateDir( backverz )
		endif
		backverz += "\" + right( "0" + alltrim( str( month( Date() ) ) ), 2 )
		if .not. file( backverz, "D" )
			CreateDir( backverz )
		endif
		backverz += "\" + right( "0" + alltrim( str( day( Date() ) ) ), 2 )
		if .not. file( backverz, "D" )
			CreateDir( backverz )
		endif
		backverz += "\" + zeit
		if .not. file( backverz, "D" )
			CreateDir( backverz )
		endif
		for j := 1 to len( dbfdat )
			copy file ( datenpfad + "\" + dbfdat[ j ] ) to ( backverz + "\" + dbfdat[ j ] )
		next
		istbackup := .t.
		csvexport()
		oZip:AddFile( LW + "\DEVCONZIP\reg.csv" )
	endif

	oZip:Close()
	if ( .not. istbackup ) .and. ( .not. attri )
		if file( cZipFile )
			delete file ( cZipFile )
		endif
	endif
	if file( cZipFile )
		oMail := MIMEMessage():new()
		oMail:setFrom( MailAddress():new( WEBMASTER ) )
		oMail:addRecipient( MailAddress():new( MEMVAR->cMailadress1 ) )
		oMail:addHeader( "CC", MEMVAR->cMailadress2 )
		oMail:setSubject( "Backupdata from server" )
		oMail:setMessage( "Find enclosed a ZIP with the server's data!" )
		oMail:attachFile( cZipFile )
		oSmtp := SMTPClient():new( MEMVAR->cSMTPserver )
		IF oSmtp:connect( MEMVAR->cMailuser, MEMVAR->cMailpassword )
			oSmtp:send( oMail )
			oSmtp:disconnect()
		ELSE
			SaveToFile( ConvToAnsiCp( "______ Xb2.NET ERROR __________ E-mail error _________________" + DtoC( Date() ) + "_" + Time() + CRLF + "Mail could not be send!" ), SERVER_ERR_LOG_FILE )
		ENDIF

	endif

	bSaveError := ErrorBlock()
	ErrorBlock( {|e| Break(e)} )
	BEGIN SEQUENCE
		dat := Directory( datenpfad + "\devcon.dbf" )
		text := dtoc( dat[ 1, F_WRITE_DATE ] ) + " " + dat[ 1, F_WRITE_TIME ] + "  "
		use ( datenpfad + "\devcon.dbf" ) READONLY SHARED
		go top
		datsatz := 0
		ueber := 0
		saetze := 0
		do while .not. devcon->( eof() )
			if .not. devcon->( Deleted() )
				saetze++
				if .not. empty( devcon->ZAHLEINGAN )
					ueber++
				endif
			else
				datsatz++
			endif
			devcon->( Dbskip() )
		enddo
		use
		text += str( saetze, 10 ) + str( datsatz, 9 ) + " " + str( ueber, 8 )
	RECOVER USING oError
		ErrorBlock( bSaveError )
		text += " can currently not be read!"
	END SEQUENCE

	if .not. File( logpfad, "D" )
		CreateDir( logpfad )
	endif
	nHandle := FCreate( logpfad + MELDE_LOG )
	FWrite(nHandle, ConvToAnsiCP( dtoc( date() ) + " " + time() + " registrations deleted paid" ) + CRLF)
	FWrite(nHandle, ConvToAnsiCP( replicate( " ", 48 ) ) + CRLF)
	FWrite(nHandle, ConvToAnsiCP( text ) + CRLF)
	FClose(nHandle)
	if attri
		CreateCharts( MEMVAR->chartcontrol )
	endif

RETURN

Procedure CreateCharts( RMChartX1 )
Local sTemp, spr[ 19 ], isql, iinter, imig, iactivex, bSaveError, anzdevcons[ 6 ], anz, maxi, i, xbasenutzer, xbasennutzer, sprteil, bla, sTemp2, j, anony
local ksdel[ 4 ], ksfp[ 4 ], ksfs[ 4 ], ksclip[ 4 ], ksclip4[ 4 ], ksdb[ 4 ], ksviso[ 4 ], ksxhar[ 4 ], xbversion[ 8 ], teilnart[ 9 ], oError, alland
local kstd[ 4 ], ksex[ 4 ], ksfw[ 4 ], kssql[ 4 ], ksxb2[ 4 ], ksxcl[ 4 ], ksxbh[ 4 ], kscock[ 4 ], ksmars[ 4 ], ksll[ 4 ], ksvp[ 4 ], ksrr[ 4 ], aspr
if RMChartX1 <> NIL
	isql := 0
	anony := 0
	iinter := 0
	imig := 0
	iactivex := 0
	xbasenutzer := 0
	xbasennutzer := 0
	sprteil := {}
	aspr := { "de", "fr", "uk", "sp", "pt" }
	alland := AClone( MEMVAR->laender )
	asort( alland,,, { | aX, aY | aX[ 1 ] < aY[ 1 ] } )

	AFill( anzdevcons, 0 )
	AFill( teilnart, 0 )
	AFill( xbversion, 0 )
	AFill( spr, 0 )
	AFill( ksdel, 0 )
	AFill( ksfp, 0 )
	AFill( ksfs, 0 )
	AFill( ksclip, 0 )
	AFill( ksclip4, 0 )
	AFill( ksdb, 0 )
	AFill( ksviso, 0 )
	AFill( ksxhar, 0 )
	AFill( kstd, 0 )
	AFill( ksex, 0 )
	AFill( ksfw, 0 )
	AFill( kssql, 0 )
	AFill( ksxb2, 0 )
	AFill( ksxcl, 0 )
	AFill( ksxbh, 0 )
	AFill( kscock, 0 )
	AFill( ksmars, 0 )
	AFill( ksll, 0 )
	AFill( ksvp, 0 )
	AFill( ksrr, 0 )

	bSaveError := ErrorBlock()
	ErrorBlock( {|e| Break(e)} )
	BEGIN SEQUENCE
		use ( datenpfad + "\devcon.dbf" ) READONLY SHARED
		devcon->( DbGoTop() )
		do while .not. devcon->( eof() )
			if .not. devcon->( Deleted() )
				if devcon->ANONYM
					anony++
				endif
				if ( ( devcon->TEILNEHMER == 1 ) .or. ( devcon->TEILNEHMER == 6 )  .or. ( devcon->TEILNEHMER == 8 ) )
					teilnart[ devcon->TEILNEHMER ]++
					anz := 1
					if devcon->DEVCON1
						anz++
					endif
					if devcon->DEVCON2
						anz++
					endif
					if devcon->DEVCON3
						anz++
					endif
					if devcon->DEVCON4
						anz++
					endif
					if devcon->DEVCON5
						anz++
					endif
					anzdevcons[ anz ]++
					if devcon->MUTTERSPRA <> 99
						spr[ devcon->MUTTERSPRA ]++
					else
						spr[ 19 ]++
					endif
					if devcon->FREMDSPRA1 <> 0
						spr[ devcon->FREMDSPRA1 ]++
					endif
					if devcon->FREMDSPRA2 <> 0
						spr[ devcon->FREMDSPRA2 ]++
					endif
					if devcon->INTSQL
						isql++
					endif
					if devcon->INTWEBANB
						iinter++
					endif
					if devcon->INTMIGRAT
						imig++
					endif
					if devcon->INTACTIVEX
						iactivex++
					endif
					ksdel[ devcon->KSDELPHI + 1 ]++
					ksfp[ devcon->KSFOXPRO + 1 ]++
					ksfs[ devcon->KSFLAGSHIP + 1 ]++
					ksclip[ devcon->KSCLIPPER + 1 ]++
					ksclip4[ devcon->KSCLIP4WIN + 1 ]++
					ksdb[ devcon->KSDBASE + 1 ]++
					ksviso[ devcon->KSVO + 1 ]++
					ksxhar[ devcon->KSXHARBOUR + 1 ]++
					kstd[ devcon->KSTOPDOWN + 1 ]++
					ksex[ devcon->KSEXPRESS + 1 ]++
					ksfw[ devcon->KSFIVEWIN + 1 ]++
					kssql[ devcon->KSSQLEXPRE + 1 ]++
					ksxb2[ devcon->KSXB2NET + 1 ]++
					ksxcl[ devcon->KSXCLASS + 1 ]++
					ksxbh[ devcon->KSXBHCL + 1 ]++
					kscock[ devcon->KSCOCKPIT + 1 ]++
					ksmars[ devcon->KSMARSHALL + 1 ]++
					ksll[ devcon->KSLLABEL + 1 ]++
					ksvp[ devcon->KSVPE + 1 ]++
					ksrr[ devcon->KSRUNDR + 1 ]++
					if devcon->VERSION > 0
						xbasenutzer++
						xbversion[ devcon->VERSION ]++
					else
						xbasennutzer++
					endif
					bla := ascan( sprteil, { |a| a[ 1 ] == alltrim( devcon->LAND ) } )
					if bla == 0
						maxi := ascan( alland, { |b| b[ 1 ] == alltrim( devcon->LAND ) } )
						if maxi > 0
							AAdd( sprteil, { alltrim( devcon->LAND ), 1, alland[ maxi, 7 ], alland[ maxi, 8 ], alland[ maxi, 4 ], alland[ maxi, 9 ], alland[ maxi, 10 ]  } )
						else
							AAdd( sprteil, { alltrim( devcon->LAND ), 1, alltrim( devcon->LAND ), alltrim( devcon->LAND ), alltrim( devcon->LAND ), alltrim( devcon->LAND ), alltrim( devcon->LAND )  } )
						endif
					else
						sprteil[ bla, 2 ]++
					endif
				elseif ( devcon->TEILNEHMER > 0 )
					teilnart[ devcon->TEILNEHMER ]++
					if ( devcon->TEILNEHMER == 5 ) .or. ( devcon->TEILNEHMER == 9 )
						if devcon->MUTTERSPRA <> 99
							spr[ devcon->MUTTERSPRA ]++
						else
							spr[ 19 ]++
						endif
						if devcon->FREMDSPRA1 <> 0
							spr[ devcon->FREMDSPRA1 ]++
						endif
						if devcon->FREMDSPRA2 <> 0
							spr[ devcon->FREMDSPRA2 ]++
						endif
						bla := ascan( sprteil, { |a| a[ 1 ] == alltrim( devcon->LAND ) } )
						if bla == 0
							maxi := ascan( alland, { |b| b[ 1 ] == alltrim( devcon->LAND ) } )
							if maxi > 0
								AAdd( sprteil, { alltrim( devcon->LAND ), 1, alland[ maxi, 7 ], alland[ maxi, 8 ], alland[ maxi, 4 ], alland[ maxi, 9 ], alland[ maxi, 10 ]  } )
							else
								AAdd( sprteil, { alltrim( devcon->LAND ), 1, alltrim( devcon->LAND ), alltrim( devcon->LAND ), alltrim( devcon->LAND ), alltrim( devcon->LAND ), alltrim( devcon->LAND )  } )
							endif
						else
							sprteil[ bla, 2 ]++
						endif
					endif
				endif
			endif
			devcon->( DbSkip() )
		enddo
		use
	RECOVER USING oError
		ErrorBlock( bSaveError )
	END SEQUENCE

	if .not. File( statistik, "D" )
		CreateDir( statistik )
	endif

	for j := 1 to spr_co
		sTemp := ""
		maxi := 0
		for i := 1 to 19
			maxi := Max( maxi, spr[ i ] )
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( spr[ i ] ) )
		next
		maxi := Max( maxi, 1 ) // has to be at least 1 to let the chart look nice
		RMChartX1:Reset()
		RMChartX1:SetProperties( 700, Max( ( 12 * maxi ) + 150, 370 ), strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGrid() 
		RMChartX1:Region(1):Grid():SetProperties( strtran( MEMVAR->shinter, "#", "&HFF" ), .F. , 0, 0, 0, 0, RMC_BICOLOR_NONE) 
		//************** Add data axis to region 1 ***************************** 
		RMChartX1:Region(1):AddDataAxis() 
		RMChartX1:Region(1):DataAxis(1):SetProperties( RMC_DATAAXISLEFT, 0, maxi, maxi + 1, 8, Default, Default, RMC_LINESTYLESOLID, 0, "", "", "", RMC_TEXTCENTER) 
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):AddLabelAxis() 
		RMChartX1:Region(1):LabelAxis():SetProperties( 1, 19, RMC_LABELAXISBOTTOM, 8, Default, RMC_TEXTUPWARD, Default, RMC_LINESTYLESOLID ) 
		//************** Add Series 1 to region 1 ******************************* 
		RMChartX1:Region(1):AddBarSeries() 
		RMChartX1:Region(1):BarSeries(1):SetProperties( RMC_BARSINGLE, RMC_BAR_3D, .F. , Transparent, .F. , 1, RMC_VLABEL_NONE, 1, RMC_HATCHBRUSH_OFF) 
		//****** Set data values ****** 
		RMChartX1:Region(1):BarSeries(1):DataString := sTemp 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titstatteil, j ], Default, Default, 10, .T. ) 
		RMChartX1:Region(1):LabelAxis():LabelString := MEMVAR->texte[ titstatspra, j ]
		RMChartX1:Draw2File( statistik + "\sprachen_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 6
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( anzdevcons[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titteildevc, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := MEMVAR->texte[ anzteildevc, j ]
		RMChartX1:Draw2File( statistik + "\devcons_" + aspr[ j ] + ".jpg" )

		maxi := Max( 0, isql )
		maxi := Max( maxi, iinter )
		maxi := Max( maxi, imig )
		maxi := Max( maxi, iactivex )
		maxi := Max( maxi, 1 ) // has to be at least 1 to let the chart look nice
		stemp := alltrim( str( isql ) ) + "*" + alltrim( str( iinter ) ) + "*" + alltrim( str( imig ) ) + "*" + alltrim( str( iactivex ) )
		RMChartX1:Reset()
		RMChartX1:SetProperties( 700, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGrid() 
		RMChartX1:Region(1):Grid():SetProperties( strtran( MEMVAR->shinter, "#", "&HFF" ), .F. , 0, 0, 0, 0, RMC_BICOLOR_NONE) 
		//************** Add data axis to region 1 ***************************** 
		RMChartX1:Region(1):AddDataAxis() 
		RMChartX1:Region(1):DataAxis(1):SetProperties( RMC_DATAAXISBOTTOM, 0, maxi, maxi + 1, 8, Default, Default, RMC_LINESTYLESOLID, 0, "", "", "", RMC_TEXTCENTER) 
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):AddLabelAxis() 
		RMChartX1:Region(1):LabelAxis():SetProperties( 1, 4, RMC_LABELAXISLEFT, 8, Default, RMC_TEXTLEFT, Default, RMC_LINESTYLESOLID ) 
		RMChartX1:Region(1):LabelAxis():LabelString := strtran( strtran( strtran( strtran( strtran( strtran( MEMVAR->texte[ intsql, j ] + "*" + MEMVAR->texte[ intweb, j ] + "*" + MEMVAR->texte[ intmig, j ] + "*" + MEMVAR->texte[ intactivex, j ], "&eacute;", "" ), "&oacute;", "" ), "&aacute;", "" ), "&iacute;", "" ), "&atilde;", "" ), "&ccedil;", "" )
		//************** Add Series 1 to region 1 ******************************* 
		RMChartX1:Region(1):AddBarSeries() 
		RMChartX1:Region(1):BarSeries(1):SetProperties( RMC_BARSINGLE, RMC_BAR_3D, .F. , Transparent, .T. , 1, RMC_VLABEL_NONE, 1, RMC_HATCHBRUSH_OFF) 
		//****** Set data values ****** 
		RMChartX1:Region(1):BarSeries(1):DataString := sTemp 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titteilinte, j ], Default, Default, 10, .T. ) 
		RMChartX1:Draw2File( statistik + "\interessen_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 4
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( ksdel[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titdelphi, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( strtran( strtran( strtran( MEMVAR->texte[ ksnicht, j ] + "*" + MEMVAR->texte[ ksnutze, j ] + "*" + MEMVAR->texte[ kshatte, j ] + "*" + MEMVAR->texte[ kskenne, j ], "&ouml;", "" ), "&eacute;", "" ), "&atilde;", "" ), "&aacute;", "" )
		RMChartX1:Draw2File( statistik + "\ksdelphi_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 4
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( ksfp[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titfoxpro, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( strtran( strtran( strtran( MEMVAR->texte[ ksnicht, j ] + "*" + MEMVAR->texte[ ksnutze, j ] + "*" + MEMVAR->texte[ kshatte, j ] + "*" + MEMVAR->texte[ kskenne, j ], "&ouml;", "" ), "&eacute;", "" ), "&atilde;", "" ), "&aacute;", "" )
		RMChartX1:Draw2File( statistik + "\ksfoxpro_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 4
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( ksfs[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titflagsh, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( strtran( strtran( strtran( MEMVAR->texte[ ksnicht, j ] + "*" + MEMVAR->texte[ ksnutze, j ] + "*" + MEMVAR->texte[ kshatte, j ] + "*" + MEMVAR->texte[ kskenne, j ], "&ouml;", "" ), "&eacute;", "" ), "&atilde;", "" ), "&aacute;", "" )
		RMChartX1:Draw2File( statistik + "\ksflagship_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 4
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( ksclip[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titclippr, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( strtran( strtran( strtran( MEMVAR->texte[ ksnicht, j ] + "*" + MEMVAR->texte[ ksnutze, j ] + "*" + MEMVAR->texte[ kshatte, j ] + "*" + MEMVAR->texte[ kskenne, j ], "&ouml;", "" ), "&eacute;", "" ), "&atilde;", "" ), "&aacute;", "" )
		RMChartX1:Draw2File( statistik + "\ksclipper_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 4
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( ksclip4[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titclip4w, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( strtran( strtran( strtran( MEMVAR->texte[ ksnicht, j ] + "*" + MEMVAR->texte[ ksnutze, j ] + "*" + MEMVAR->texte[ kshatte, j ] + "*" + MEMVAR->texte[ kskenne, j ], "&ouml;", "" ), "&eacute;", "" ), "&atilde;", "" ), "&aacute;", "" )
		RMChartX1:Draw2File( statistik + "\ksclip4win_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 4
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( ksdb[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titdbase, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( strtran( strtran( strtran( MEMVAR->texte[ ksnicht, j ] + "*" + MEMVAR->texte[ ksnutze, j ] + "*" + MEMVAR->texte[ kshatte, j ] + "*" + MEMVAR->texte[ kskenne, j ], "&ouml;", "" ), "&eacute;", "" ), "&atilde;", "" ), "&aacute;", "" )
		RMChartX1:Draw2File( statistik + "\ksdbase_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 4
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( ksviso[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titelvo, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( strtran( strtran( strtran( MEMVAR->texte[ ksnicht, j ] + "*" + MEMVAR->texte[ ksnutze, j ] + "*" + MEMVAR->texte[ kshatte, j ] + "*" + MEMVAR->texte[ kskenne, j ], "&ouml;", "" ), "&eacute;", "" ), "&atilde;", "" ), "&aacute;", "" )
		RMChartX1:Draw2File( statistik + "\ksvo_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 4
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( ksxhar[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titxharbo, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( strtran( strtran( strtran( MEMVAR->texte[ ksnicht, j ] + "*" + MEMVAR->texte[ ksnutze, j ] + "*" + MEMVAR->texte[ kshatte, j ] + "*" + MEMVAR->texte[ kskenne, j ], "&ouml;", "" ), "&eacute;", "" ), "&atilde;", "" ), "&aacute;", "" )
		RMChartX1:Draw2File( statistik + "\ksxharbour_" + aspr[ j ] + ".jpg" )

		sTemp := alltrim( str( ksdel[ 2 ] ) ) + "*" + alltrim( str( ksfp[ 2 ] ) ) + "*" + alltrim( str( ksfs[ 2 ] ) ) + "*" + alltrim( str( ksclip[ 2 ] ) ) + "*" + alltrim( str( ksclip4[ 2 ] ) ) + "*" + alltrim( str( ksdb[ 2 ] ) ) + "*" + alltrim( str( ksviso[ 2 ] ) ) + "*" + alltrim( str( ksxhar[ 2 ] ) )
		maxi := 0
		maxi := Max( maxi, ksdel[ 2 ] )
		maxi := Max( maxi, ksfp[ 2 ] )
		maxi := Max( maxi, ksfs[ 2 ] )
		maxi := Max( maxi, ksclip[ 2 ] )
		maxi := Max( maxi, ksclip4[ 2 ] )
		maxi := Max( maxi, ksdb[ 2 ] )
		maxi := Max( maxi, ksviso[ 2 ] )
		maxi := Max( maxi, ksxhar[ 2 ] )
		maxi := Max( maxi, 1 ) // has to be at least 1 to let the chart look nice
		RMChartX1:Reset()
		MEMVAR->aMapGraSizes[ 2 ] := Max( ( 12 * maxi ) + 150, 370 )
		RMChartX1:SetProperties( 700, MEMVAR->aMapGraSizes[ 2 ], strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion()
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGrid() 
		RMChartX1:Region(1):Grid():SetProperties( strtran( MEMVAR->shinter, "#", "&HFF" ), .F. , 0, 0, 0, 0, RMC_BICOLOR_NONE) 
		//************** Add data axis to region 1 ***************************** 
		RMChartX1:Region(1):AddDataAxis() 
		RMChartX1:Region(1):DataAxis(1):SetProperties( RMC_DATAAXISLEFT, 0, maxi, maxi + 1, 8, Default, Default, RMC_LINESTYLESOLID, 0, "", "", "", RMC_TEXTCENTER) 
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):AddLabelAxis() 
		RMChartX1:Region(1):LabelAxis():SetProperties( 1, 8, RMC_LABELAXISBOTTOM, 8, Default, RMC_TEXTUPWARD, Default, RMC_LINESTYLESOLID ) 
		//************** Add Series 1 to region 1 ******************************* 
		RMChartX1:Region(1):AddBarSeries() 
		RMChartX1:Region(1):BarSeries(1):SetProperties( RMC_BARSINGLE, RMC_BAR_3D, .F. , Transparent, .F. , 1, RMC_VLABEL_NONE, 1, RMC_HATCHBRUSH_OFF) 
		//****** Set data values ****** 
		RMChartX1:Region(1):BarSeries(1):DataString := sTemp 
		// Erst auf Deutsch
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titandrsp, j ], Default, Default, 10, .T. ) 
		RMChartX1:Region(1):LabelAxis():LabelString := "Delphi*FoxPro*Flagship*Clipper*Clip4Win*dBase*Visual Objects*xHarbour"
		RMChartX1:Draw2File( statistik + "\xbasespr_" + aspr[ j ] + ".jpg" )

		sTemp := alltrim( str( ksdel[ 3 ] ) ) + "*" + alltrim( str( ksfp[ 3 ] ) ) + "*" + alltrim( str( ksfs[ 3 ] ) ) + "*" + alltrim( str( ksclip[ 3 ] ) ) + "*" + alltrim( str( ksclip4[ 3 ] ) ) + "*" + alltrim( str( ksdb[ 3 ] ) ) + "*" + alltrim( str( ksviso[ 3 ] ) ) + "*" + alltrim( str( ksxhar[ 3 ] ) )
		maxi := 0
		maxi := Max( maxi, ksdel[ 3 ] )
		maxi := Max( maxi, ksfp[ 3 ] )
		maxi := Max( maxi, ksfs[ 3 ] )
		maxi := Max( maxi, ksclip[ 3 ] )
		maxi := Max( maxi, ksclip4[ 3 ] )
		maxi := Max( maxi, ksdb[ 3 ] )
		maxi := Max( maxi, ksviso[ 3 ] )
		maxi := Max( maxi, ksxhar[ 3 ] )
		maxi := Max( maxi, 1 ) // has to be at least 1 to let the chart look nice
		RMChartX1:Reset()
		MEMVAR->aMapGraSizes[ 1 ] := Max( ( 12 * maxi ) + 150, 370 )
		RMChartX1:SetProperties( 700, MEMVAR->aMapGraSizes[ 1 ], strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGrid() 
		RMChartX1:Region(1):Grid():SetProperties( strtran( MEMVAR->shinter, "#", "&HFF" ), .F. , 0, 0, 0, 0, RMC_BICOLOR_NONE) 
		//************** Add data axis to region 1 ***************************** 
		RMChartX1:Region(1):AddDataAxis() 
		RMChartX1:Region(1):DataAxis(1):SetProperties( RMC_DATAAXISLEFT, 0, maxi, maxi + 1, 8, Default, Default, RMC_LINESTYLESOLID, 0, "", "", "", RMC_TEXTCENTER) 
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):AddLabelAxis() 
		RMChartX1:Region(1):LabelAxis():SetProperties( 1, 8, RMC_LABELAXISBOTTOM, 8, Default, RMC_TEXTUPWARD, Default, RMC_LINESTYLESOLID ) 
		//************** Add Series 1 to region 1 ******************************* 
		RMChartX1:Region(1):AddBarSeries() 
		RMChartX1:Region(1):BarSeries(1):SetProperties( RMC_BARSINGLE, RMC_BAR_3D, .F. , Transparent, .F. , 1, RMC_VLABEL_NONE, 1, RMC_HATCHBRUSH_OFF) 
		//****** Set data values ****** 
		RMChartX1:Region(1):BarSeries(1):DataString := sTemp 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titexaspr, j ], Default, Default, 10, .T. ) 
		RMChartX1:Region(1):LabelAxis():LabelString := "Delphi*FoxPro*Flagship*Clipper*Clip4Win*dBase*Visual Objects*xHarbour"
		RMChartX1:Draw2File( statistik + "\xbasespralt_" + aspr[ j ] + ".jpg" )

		sTemp := alltrim( str( xbasenutzer ) ) + "*" + alltrim( str( xbasennutzer ) )
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titnutzxb, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := MEMVAR->texte[ stattexxb, j ]
		RMChartX1:Draw2File( statistik + "\xbnutzer_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 8
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( xbversion[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titversxb, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := "< 1.5*1.5x*1.6x*1.7x*1.80*1.82.294*1.82.306*1.9x"
		RMChartX1:Draw2File( statistik + "\xbversion_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 4
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( kstd[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ tittopdow, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( strtran( strtran( strtran( MEMVAR->texte[ ksnicht, j ] + "*" + MEMVAR->texte[ ksnutze, j ] + "*" + MEMVAR->texte[ addonwill, j ] + "*" + MEMVAR->texte[ kskenne, j ], "&ouml;", "" ), "&eacute;", "" ), "&atilde;", "" ), "&aacute;", "" )
		RMChartX1:Draw2File( statistik + "\kstopdown_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 4
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( ksex[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titexpres, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( strtran( strtran( strtran( MEMVAR->texte[ ksnicht, j ] + "*" + MEMVAR->texte[ ksnutze, j ] + "*" + MEMVAR->texte[ addonwill, j ] + "*" + MEMVAR->texte[ kskenne, j ], "&ouml;", "" ), "&eacute;", "" ), "&atilde;", "" ), "&aacute;", "" )
		RMChartX1:Draw2File( statistik + "\ksexpress_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 4
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( ksfw[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titfivewi, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( strtran( strtran( strtran( MEMVAR->texte[ ksnicht, j ] + "*" + MEMVAR->texte[ ksnutze, j ] + "*" + MEMVAR->texte[ addonwill, j ] + "*" + MEMVAR->texte[ kskenne, j ], "&ouml;", "" ), "&eacute;", "" ), "&atilde;", "" ), "&aacute;", "" )
		RMChartX1:Draw2File( statistik + "\ksfivewin_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 4
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( kssql[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titsqlexp, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( strtran( strtran( strtran( MEMVAR->texte[ ksnicht, j ] + "*" + MEMVAR->texte[ ksnutze, j ] + "*" + MEMVAR->texte[ addonwill, j ] + "*" + MEMVAR->texte[ kskenne, j ], "&ouml;", "" ), "&eacute;", "" ), "&atilde;", "" ), "&aacute;", "" )
		RMChartX1:Draw2File( statistik + "\kssql_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 4
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( ksxb2[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titxb2net, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( strtran( strtran( strtran( MEMVAR->texte[ ksnicht, j ] + "*" + MEMVAR->texte[ ksnutze, j ] + "*" + MEMVAR->texte[ addonwill, j ] + "*" + MEMVAR->texte[ kskenne, j ], "&ouml;", "" ), "&eacute;", "" ), "&atilde;", "" ), "&aacute;", "" )
		RMChartX1:Draw2File( statistik + "\ksxb2_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 4
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( ksxcl[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titxclass, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( strtran( strtran( strtran( MEMVAR->texte[ ksnicht, j ] + "*" + MEMVAR->texte[ ksnutze, j ] + "*" + MEMVAR->texte[ addonwill, j ] + "*" + MEMVAR->texte[ kskenne, j ], "&ouml;", "" ), "&eacute;", "" ), "&atilde;", "" ), "&aacute;", "" )
		RMChartX1:Draw2File( statistik + "\ksxcl_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 4
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( ksxbh[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titxbhcl, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( strtran( strtran( strtran( MEMVAR->texte[ ksnicht, j ] + "*" + MEMVAR->texte[ ksnutze, j ] + "*" + MEMVAR->texte[ addonwill, j ] + "*" + MEMVAR->texte[ kskenne, j ], "&ouml;", "" ), "&eacute;", "" ), "&atilde;", "" ), "&aacute;", "" )
		RMChartX1:Draw2File( statistik + "\ksxbh_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 4
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( kscock[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titcockpi, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( strtran( strtran( strtran( MEMVAR->texte[ ksnicht, j ] + "*" + MEMVAR->texte[ ksnutze, j ] + "*" + MEMVAR->texte[ addonwill, j ] + "*" + MEMVAR->texte[ kskenne, j ], "&ouml;", "" ), "&eacute;", "" ), "&atilde;", "" ), "&aacute;", "" )
		RMChartX1:Draw2File( statistik + "\kscock_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 4
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( ksmars[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titmarsha, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( strtran( strtran( strtran( MEMVAR->texte[ ksnicht, j ] + "*" + MEMVAR->texte[ ksnutze, j ] + "*" + MEMVAR->texte[ addonwill, j ] + "*" + MEMVAR->texte[ kskenne, j ], "&ouml;", "" ), "&eacute;", "" ), "&atilde;", "" ), "&aacute;", "" )
		RMChartX1:Draw2File( statistik + "\ksmars_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 4
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( ksll[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titlundl, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( strtran( strtran( strtran( MEMVAR->texte[ ksnicht, j ] + "*" + MEMVAR->texte[ ksnutze, j ] + "*" + MEMVAR->texte[ addonwill, j ] + "*" + MEMVAR->texte[ kskenne, j ], "&ouml;", "" ), "&eacute;", "" ), "&atilde;", "" ), "&aacute;", "" )
		RMChartX1:Draw2File( statistik + "\ksll_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 4
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( ksvp[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titelvpe, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( strtran( strtran( strtran( MEMVAR->texte[ ksnicht, j ] + "*" + MEMVAR->texte[ ksnutze, j ] + "*" + MEMVAR->texte[ addonwill, j ] + "*" + MEMVAR->texte[ kskenne, j ], "&ouml;", "" ), "&eacute;", "" ), "&atilde;", "" ), "&aacute;", "" )
		RMChartX1:Draw2File( statistik + "\ksvp_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 4
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( ksrr[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titelrunr, j ], Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( strtran( strtran( strtran( MEMVAR->texte[ ksnicht, j ] + "*" + MEMVAR->texte[ ksnutze, j ] + "*" + MEMVAR->texte[ addonwill, j ] + "*" + MEMVAR->texte[ kskenne, j ], "&ouml;", "" ), "&eacute;", "" ), "&atilde;", "" ), "&aacute;", "" )
		RMChartX1:Draw2File( statistik + "\ksrr_" + aspr[ j ] + ".jpg" )

		sTemp := alltrim( str( kstd[ 2 ] ) ) + "*" + alltrim( str( ksex[ 2 ] ) ) + "*" + alltrim( str( ksfw[ 2 ] ) ) + "*" + alltrim( str( kssql[ 2 ] ) ) + "*" + alltrim( str( ksxb2[ 2 ] ) ) + "*" + alltrim( str( ksxcl[ 2 ] ) ) + "*" + alltrim( str( ksxbh[ 2 ] ) ) + "*" + alltrim( str( kscock[ 2 ] ) ) + "*" + alltrim( str( ksmars[ 2 ] ) ) + "*" + alltrim( str( ksll[ 2 ] ) ) + "*" + alltrim( str( ksvp[ 2 ] ) ) + "*" + alltrim( str( ksrr[ 2 ] ) )
		maxi := 0
		maxi := Max( maxi, kstd[ 2 ] )
		maxi := Max( maxi, ksex[ 2 ] )
		maxi := Max( maxi, ksfw[ 2 ] )
		maxi := Max( maxi, kssql[ 2 ] )
		maxi := Max( maxi, ksxb2[ 2 ] )
		maxi := Max( maxi, ksxcl[ 2 ] )
		maxi := Max( maxi, ksxbh[ 2 ] )
		maxi := Max( maxi, kscock[ 2 ] )
		maxi := Max( maxi, ksmars[ 2 ] )
		maxi := Max( maxi, ksll[ 2 ] )
		maxi := Max( maxi, ksvp[ 2 ] )
		maxi := Max( maxi, ksrr[ 2 ] )
		maxi := Max( maxi, 1 )  // has to be at least 1 to let the chart look nice
		RMChartX1:Reset()
		MEMVAR->aMapGraSizes[ 3 ] := Max( ( 12 * maxi ) + 150, 370 )
		RMChartX1:SetProperties( 700, MEMVAR->aMapGraSizes[ 3 ], strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGrid() 
		RMChartX1:Region(1):Grid():SetProperties( strtran( MEMVAR->shinter, "#", "&HFF" ), .F. , 0, 0, 0, 0, RMC_BICOLOR_NONE) 
		//************** Add data axis to region 1 ***************************** 
		RMChartX1:Region(1):AddDataAxis() 
		RMChartX1:Region(1):DataAxis(1):SetProperties( RMC_DATAAXISLEFT, 0, maxi, maxi + 1, 8, Default, Default, RMC_LINESTYLESOLID, 0, "", "", "", RMC_TEXTCENTER) 
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):AddLabelAxis() 
		RMChartX1:Region(1):LabelAxis():SetProperties( 1, 12, RMC_LABELAXISBOTTOM, 8, Default, RMC_TEXTUPWARD, Default, RMC_LINESTYLESOLID ) 
		//************** Add Series 1 to region 1 ******************************* 
		RMChartX1:Region(1):AddBarSeries() 
		RMChartX1:Region(1):BarSeries(1):SetProperties( RMC_BARSINGLE, RMC_BAR_3D, .F. , Transparent, .F. , 1, RMC_VLABEL_NONE, 1, RMC_HATCHBRUSH_OFF) 
		//****** Set data values ****** 
		RMChartX1:Region(1):BarSeries(1):DataString := sTemp 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titaddder, j ], Default, Default, 10, .T. ) 
		RMChartX1:Region(1):LabelAxis():LabelString := "TopDown*eXpress++*FiveWin*SQLExpress*Xb2.NET*XClass++*xbHCL*Cockpit*MarshallSoft*List & Label*VPE*R&R"
		RMChartX1:Draw2File( statistik + "\addons_" + aspr[ j ] + ".jpg" )

		sTemp := alltrim( str( kstd[ 3 ] ) ) + "*" + alltrim( str( ksex[ 3 ] ) ) + "*" + alltrim( str( ksfw[ 3 ] ) ) + "*" + alltrim( str( kssql[ 3 ] ) ) + "*" + alltrim( str( ksxb2[ 3 ] ) ) + "*" + alltrim( str( ksxcl[ 3 ] ) ) + "*" + alltrim( str( ksxbh[ 3 ] ) ) + "*" + alltrim( str( kscock[ 3 ] ) ) + "*" + alltrim( str( ksmars[ 3 ] ) ) + "*" + alltrim( str( ksll[ 3 ] ) ) + "*" + alltrim( str( ksvp[ 3 ] ) ) + "*" + alltrim( str( ksrr[ 3 ] ) )
		maxi := 0
		maxi := Max( maxi, kstd[ 3 ] )
		maxi := Max( maxi, ksex[ 3 ] )
		maxi := Max( maxi, ksfw[ 3 ] )
		maxi := Max( maxi, kssql[ 3 ] )
		maxi := Max( maxi, ksxb2[ 3 ] )
		maxi := Max( maxi, ksxcl[ 3 ] )
		maxi := Max( maxi, ksxbh[ 3 ] )
		maxi := Max( maxi, kscock[ 3 ] )
		maxi := Max( maxi, ksmars[ 3 ] )
		maxi := Max( maxi, ksll[ 3 ] )
		maxi := Max( maxi, ksvp[ 3 ] )
		maxi := Max( maxi, ksrr[ 3 ] )
		maxi := Max( maxi, 1 )  // has to be at least 1 to let the chart look nice
		RMChartX1:Reset()
		MEMVAR->aMapGraSizes[ 4 ] := Max( ( 12 * maxi ) + 150, 370 )
		RMChartX1:SetProperties( 700, MEMVAR->aMapGraSizes[ 4 ], strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGrid() 
		RMChartX1:Region(1):Grid():SetProperties( strtran( MEMVAR->shinter, "#", "&HFF" ), .F. , 0, 0, 0, 0, RMC_BICOLOR_NONE) 
		//************** Add data axis to region 1 ***************************** 
		RMChartX1:Region(1):AddDataAxis() 
		RMChartX1:Region(1):DataAxis(1):SetProperties( RMC_DATAAXISLEFT, 0, maxi, maxi + 1, 8, Default, Default, RMC_LINESTYLESOLID, 0, "", "", "", RMC_TEXTCENTER) 
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):AddLabelAxis() 
		RMChartX1:Region(1):LabelAxis():SetProperties( 1, 12, RMC_LABELAXISBOTTOM, 8, Default, RMC_TEXTUPWARD, Default, RMC_LINESTYLESOLID ) 
		//************** Add Series 1 to region 1 ******************************* 
		RMChartX1:Region(1):AddBarSeries() 
		RMChartX1:Region(1):BarSeries(1):SetProperties( RMC_BARSINGLE, RMC_BAR_3D, .F. , Transparent, .F. , 1, RMC_VLABEL_NONE, 1, RMC_HATCHBRUSH_OFF) 
		//****** Set data values ****** 
		RMChartX1:Region(1):BarSeries(1):DataString := sTemp 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titaddwil, j ], Default, Default, 10, .T. ) 
		RMChartX1:Region(1):LabelAxis():LabelString := "TopDown*eXpress++*FiveWin*SQLExpress*Xb2.NET*XClass++*xbHCL*Cockpit*MarshallSoft*List & Label*VPE*R&R"
		RMChartX1:Draw2File( statistik + "\addonsw_" + aspr[ j ] + ".jpg" )

		stemp := ""
		stemp2 := ""
		maxi := 0
		SET COLLATION TO GERMAN
		ASort( sprteil,,, {|aX,aY| aX[ 2 + j ] < aY[ 2 + j ] } )   // Array alphabetisch sortieren
		bla := len( sprteil )
		for i := 1 to bla
			if i > 1
				sTemp2 += "*"
				sTemp += "*"
			endif
			sTemp2 += sprteil[ i, 2 + j ]
			sTemp += alltrim( str( sprteil[ i, 2 ] ) )
			maxi := Max( maxi, sprteil[ i, 2 ] )
		next
		maxi := Max( maxi, 1 )  // has to be at least 1 to let the chart look nice
		RMChartX1:Reset()
		RMChartX1:SetProperties( 700, ( bla * 50 ) + 70, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGrid() 
		RMChartX1:Region(1):Grid():SetProperties( strtran( MEMVAR->shinter, "#", "&HFF" ), .F. , 0, 0, 0, 0, RMC_BICOLOR_NONE) 
		//************** Add data axis to region 1 ***************************** 
		RMChartX1:Region(1):AddDataAxis() 
		RMChartX1:Region(1):DataAxis(1):SetProperties( RMC_DATAAXISBOTTOM, 0, maxi, maxi + 1, 8, Default, Default, RMC_LINESTYLESOLID, 0, "", "", "", RMC_TEXTCENTER) 
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):AddLabelAxis() 
		RMChartX1:Region(1):LabelAxis():SetProperties( 1, bla, RMC_LABELAXISLEFT, 8, Default, RMC_TEXTLEFT, Default, RMC_LINESTYLESOLID ) 
		RMChartX1:Region(1):LabelAxis():LabelString := sTemp2
		//************** Add Series 1 to region 1 ******************************* 
		RMChartX1:Region(1):AddBarSeries() 
		RMChartX1:Region(1):BarSeries(1):SetProperties( RMC_BARSINGLE, RMC_BAR_3D, .F. , Transparent, .T. , 1, RMC_VLABEL_NONE, 1, RMC_HATCHBRUSH_OFF) 
		//****** Set data values ****** 
		RMChartX1:Region(1):BarSeries(1):DataString := sTemp 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titlaende, j ], Default, Default, 10, .T. ) 
		RMChartX1:Draw2File( statistik + "\laender_" + aspr[ j ] + ".jpg" )

		sTemp := ""
		for i := 1 to 9
			if i > 1
				sTemp += "*"
			endif
			sTemp += alltrim( str( teilnart[ i ] ) )
		next
		RMChartX1:Reset() 
		RMChartX1:SetProperties( 600, 370, strtran( MEMVAR->shinter, "#", "&HFF" ), RMC_CTRLSTYLEFLAT,"", "Tahoma") 
		//************** Add Region 1 ***************************** 
		RMChartX1:AddRegion() 
		//************** Add caption to region 1 ******************* 
		RMChartX1:Region(1):AddCaption() 
		RMChartX1:Region(1):Caption():SetProperties( MEMVAR->texte[ titeilver, j ] + alltrim( str( anony ) ) + ")", Default, Default, 10, .T. ) 
		//************** Add grid to region 1 ***************************** 
		RMChartX1:Region(1):AddGridlessSeries() 
		RMChartX1:Region(1):GridLessSeries:SeriesStyle = RMC_PIE_3D
		//************** Add label axis to region 1 ***************************** 
		RMChartX1:Region(1):GridLessSeries:ValueLabelOn = RMC_VLABEL_TWIN
		RMChartX1:Region(1):GridLessSeries:DataString := sTemp
		RMChartX1:Region(1):AddLegend()
		RMChartX1:Region(1):Legend:LegendString := strtran( MEMVAR->texte[ teiltnehmer, j ] + "*" + MEMVAR->texte[ teilpartner, j ] + "*" + MEMVAR->texte[ teilkind, j ] + "*" + MEMVAR->texte[ teilfreund, j ] + "*" + MEMVAR->texte[ teilredner, j ] + "*" + MEMVAR->texte[ teilorgan, j ] + "*" + MEMVAR->texte[ teilsonst, j ] + "*" + MEMVAR->texte[ teilbpart, j ] + "*" + MEMVAR->texte[ teiltpart, j ], "&oacute;", "" )
		RMChartX1:Draw2File( statistik + "\teilnehmer_" + aspr[ j ] + ".jpg" )
	next
endif
Return


//-----------------------------------------------------------------------------
PROCEDURE DbeSys()

   IF ! DbeLoad( "DBFDBE", .T.)
      Alert( "Database engine DBFDBE not loaded" , {"OK"} )
   ENDIF

   IF ! DbeLoad( "NTXDBE", .T.)
      Alert( "Database engine NTXDBE not loaded" , {"OK"} )
   ENDIF

   IF ! DbeBuild( "DBFNTX", "DBFDBE", "NTXDBE" )
      Alert( "DBFNTX database engine;could not be created" , {"OK"} )
   ENDIF

   DbeSetDefault( "DBFNTX" )

   Return


STATIC PROCEDURE LogError( oOwner, nErrCode, cport )
   Local i, cError, cProcName

   cError := "______ Xb2.NET ERROR __________ Port: " + iif( valtype( cport ) == "U", "", cport ) + " ___________________" + DtoC( Date() ) + "_" + Time() + CRLF +;
             "App: " + AppName(.t.) + ", Thread: " + LTrim(Str(ThreadID())) + CRLF

   if ValType(oOwner) == "O"
      if oOwner:isDerivedFrom('Error')
         // error generated while processing http server request
         cError += if(oOwner:severity > ES_WARNING, "ERROR ", "WARNING " ) +;
                   if(ValType(oOwner:subSystem)   == "C", oOwner:subSystem, "???" ) + "/" +;
                   if(ValType(oOwner:subCode)     == "N", alltrim(str(oOwner:subCode)), "???" ) + CRLF +;
                   if(ValType(oOwner:cargo)       == "C", oOwner:cargo + CRLF, "" ) +;
                   if(ValType(oOwner:description) == "C", oOwner:description, "" )

         // add either filename or operation
         if !Empty(oOwner:filename)
            cError += ": " + oOwner:filename
         elseif !Empty(oOwner:operation)
            cError += ": " + oOwner:operation
         endif

         if !Empty( oOwner:osCode )
            cError += CRLF + "(OS Error: " + alltrim(str(oOwner:osCode)) + ")"
         endif
      else
         // some kind of socket related error
         if ( alltrim(str(nErrCode)) <> "10038" ) .and. ( alltrim(str(nErrCode)) <> "10054" )
         	cError += "WinSock error: " + alltrim(str(nErrCode)) + " - " + oOwner:ErrorText(nErrCode)
         else
         	cError := ""
         endif
      endif
   endif
	if .not. empty( cError )
	   for i := 2 to 12
	      if Empty(cProcName := ProcName(i))
	         exit
	      endif
	      cError += CRLF+"Called from "+cProcName+"("+LTrim(Str(ProcLine(i)))+")"
	   next

	   SaveToFile( ConvToAnsiCp( cError ), SERVER_ERR_LOG_FILE )
	endif
	 DbCloseAll()
   Return
//-----------------------------------------------------------------------------
FUNCTION SaveToFile( cText, cFileName )
   Local i := 0, nHandle

   if ValType(cText) != "C" .or. Empty(cText)
      Return .f.
   endif
	 if .not. File( logpfad, "D" )
		 CreateDir( logpfad )
	 endif
	 cFileName := logpfad + cFileName

   if FExists(cFileName)
      while (nHandle := FOpen(cFileName, FO_WRITE + FO_DENYWRITE)) < 0
         if ++i > 9
            Return .f.
         endif
         Sleep(20)
      end
      FSeek(nHandle, 0, FS_END)  // position to end of file
   else
      while (nHandle := FCreate(cFileName)) < 0
         if ++i > 9
            Return .f.
         endif
         Sleep(20)
      end
   endif

   FWrite(nHandle, cText + CRLF)
   FClose(nHandle)

   Return .t.

STATIC PROCEDURE HTTPHandler()
Local cResponse, cWebFunction, text1, text2, bla
Local oThread := ThreadObject()  // xbHTTPThread object
Local cAction := oThread:HTTPRequest:Path()
text1 := DtoS( Date() )
text1 := right( text1, 2 ) + "." + substr( text1, 5, 2 ) + "." + substr( text1, 3, 2 )
text1 += strtran( " " + Var2Char( Time() ) + " Thread: " + Str( ThreadID(), 4 ) + space( 2 ) + "Client-IP: " + left( oThread:InetNtoA( oThread:RemoteAddr ) + space( 17 ), 17 ) + oThread:HTTPRequest:StartLine + space( 4 ) + Var2Char( oThread:GetVar( , VAR_QUERY ) ) + space( 4 ) + Var2Char( oThread:GetVar( , VAR_CONTENT ) ), chr( 0 ) )
text2 := strtran( text1, chr( 10 ) )
text1 := strtran( text2, chr( 13 ) )
//Filter login data and paypal-processing-data
bla := at( "CHECKLOGIN", upper( text1 ) )
if bla > 0
	text1 := alltrim( left( text1, bla + 20 ) )
endif
bla := at( "/PAYPAL_IPN_VALIDATE?DEVCONID=", upper( text1 ) )
if bla > 0
	text1 := alltrim( left( text1, bla + 50 ) )
endif
do while len( text1 ) > 175
	SaveToFile( left( text1, 175 ), WEB_LOG )
	text1 := space( 18 ) + substr( text1, 176 )
enddo
SaveToFile( text1, WEB_LOG )

if Len(cAction) > 1
	// Add "DC_" to the requested action so that we can macro compile and execute any
	// request with relative security. Even though the client requests something like
	// "QUIT", it will not cause the server to crash

	cWebFunction := "DC_" + iif(cAction[1] == "/", SubStr(cAction,2) ,cAction)

	if IsFunction( cWebFunction )
		// macro compile and execute the requested function
		&(cWebFunction + "()")
	else
		oThread:HTTPResponse:Content := redirekt()
	endif
	Return
endif
oThread:HTTPResponse:Content := redirekt()

Return

STATIC FUNCTION OnMaxConnect()
   Local oResp := xbHTTPResponse():new()
   oResp:StatusCode := 503
   oResp:Content    := '<html><body bgcolor="' + MEMVAR->shinter + '"><b>Server is temporarily busy!</b><br>Please try your request a little later...</body></html>'
   oResp:Connection := "close"
   // return a properly formatted HTTP response string (with headers and body)
   Return oResp:AsString()

FUNCTION DC_Erste()
local oClient := ThreadObject(), oServer := oClient:Parent, text1
local sprache, spr_xx, recnum, cdat, bla

	sprache := lower( oClient:getVar( "MenuVar" ) )
	do case
	case sprache == "de"
		spr_xx := spr_de
	case sprache == "uk"
		spr_xx := spr_uk
	case sprache == "fr"
		spr_xx := spr_fr
	case sprache == "sp"
		spr_xx := spr_sp
	case sprache == "pt"
		spr_xx := spr_pt
	otherwise
		oClient:HTTPResponse:Content := redirekt()
	endcase

	if val( dtos( date() ) ) > MEMVAR->regend
		cdat := alltrim( str( MEMVAR->regend ) )
		text1 := ConvToANSICp( "<HTML><HEAD>" ) + CRLF
		text1 += ConvToANSICp( '<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">' ) + CRLF
		text1 += ConvToANSICp( '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">' ) + CRLF
		text1 += ConvToANSICp( '<META HTTP-EQUIV="Cache-Control" CONTENT="no-cache">' ) + CRLF
		text1 += ConvToANSICp( '<META HTTP-EQUIV="Expires" CONTENT="-1">' ) + CRLF
		bla := strtran( alltrim( MEMVAR->texte[ devconueber, spr_xx ] ), "</SUP>", "" )
		text1 += ConvToANSICp( "<TITLE>" + strtran( alltrim( bla ), "<SUP>", "" ) + "</TITLE>" )
		text1 += ConvToANSICp( '<link rel="stylesheet" href="devcon.css" type="text/css"></HEAD><BODY' ) + CRLF
		text1 += ConvToANSICp( ' bgcolor="' + MEMVAR->shinter + '">' ) + CRLF
		text1 += ConvToANSICp( '<CENTER>' )
		text1 += ConvToANSICp( '<H1>' + alltrim( MEMVAR->texte[ devconueber, spr_xx ] ) + "</H1>" ) + CRLF
		text1 += ConvToANSICp( '<HR WIDTH="100%">' )
		do case
		case sprache == "de"
			text1 += '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="#F0F0F0">' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%" ALIGN="CENTER"><FONT COLOR="#CC0000"><H1>Sie sind leider zu sp' + ae + 't!</H1></FONT></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%" ALIGN="CENTER"><B>Das Melden war nur bis zum ' + right( cdat, 2 ) + MEMVAR->texte[ dattrenner, spr_xx ] + substr( cdat, 5, 2 ) + MEMVAR->texte[ dattrenner, spr_xx ] + left( cdat, 4 ) + ' m' + oe + 'glich!</B></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>' + CRLF
		case sprache == "uk"
			text1 += '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="#F0F0F0">' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%" ALIGN="CENTER"><FONT COLOR="#CC0000"><H1>Sorry, but you are too late!</H1></FONT></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%" ALIGN="CENTER"><B>Registration was only possible until ' + right( cdat, 2 ) + MEMVAR->texte[ dattrenner, spr_xx ] + substr( cdat, 5, 2 ) + MEMVAR->texte[ dattrenner, spr_xx ] + left( cdat, 4 ) + '!</B></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>' + CRLF
		case sprache == "fr"
			text1 += '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="#F0F0F0">' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%" ALIGN="CENTER"><FONT COLOR="#CC0000"><H1>Pardon, mais vous ' + ed + 'tes trop tard!</H1></FONT></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%" ALIGN="CENTER"><B>L' + "'inscription etait possible jusqu'au " +  + right( cdat, 2 ) + MEMVAR->texte[ dattrenner, spr_xx ] + substr( cdat, 5, 2 ) + MEMVAR->texte[ dattrenner, spr_xx ] + left( cdat, 4 ) + '!</B></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>' + CRLF
		case sprache == "sp"
			text1 += '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="#F0F0F0">' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%" ALIGN="CENTER"><FONT COLOR="#CC0000"><H1>Disculpe, pero llega demasiado tarde!</H1></FONT></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%" ALIGN="CENTER"><B>La inscripci' + or + 'n fue posible hasta el ' + right( cdat, 2 ) + MEMVAR->texte[ dattrenner, spr_xx ] + substr( cdat, 5, 2 ) + MEMVAR->texte[ dattrenner, spr_xx ] + left( cdat, 4 ) + '!</B></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>' + CRLF
		case sprache == "pt"
			text1 += '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="#F0F0F0">' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%" ALIGN="CENTER"><FONT COLOR="#CC0000"><H1>Desculpe, mas chega muito tarde!</H1></FONT></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%" ALIGN="CENTER"><B>A inscri' + cc + ati + 'o foi possivel at' + er + ' o ' + right( cdat, 2 ) + MEMVAR->texte[ dattrenner, spr_xx ] + substr( cdat, 5, 2 ) + MEMVAR->texte[ dattrenner, spr_xx ] + left( cdat, 4 ) + '!</B></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>' + CRLF
		endcase
	else
		OpenDbf()

		text1 := MeldeHeader( "Meldung_eingeben", "F_ANREDE", spr_xx )
		text1 += '<P><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="#CC0000">' + CRLF
		text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%"><H2><FONT COLOR="#FFFFFF">' 
		do case
		case sprache == "de"
			text1 += 'Im Anschlu' + sz + ' an die Anmeldung werden Sie zu PayPal weitergeleitet, um sofort die Teilnahmegeb' + ue + 'hr zu zahlen. Wenn Sie diesen Vorgang abbrechen, sind Sie NICHT angemeldet. Sie m' + ue + 'ssen die Anmeldung dann wiederholen. Es gibt keine M' + oe + 'glichkeit, nach einer abgebrochenen Zahlung den Anmeldevorgang fortzusetzen.</FONT></H2></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%" BGCOLOR="#FFFFFF" ALIGN="CENTER"><B>Bei Problemen mit PayPal finden Sie <A href="http://www.xbasedevcon.de/faq_d.htm" target="_blank">hier</A> weitere Informationen.'
		case sprache == "sp"
			text1 += 'Para efectuar el pago por los costos de inscripci' + or + 'n a trav' + er + 's del servicio Pay Pal, una p' + ar + 'gina Web de Pay Pal se abre autom' + ar + 'ticamente despu' + er + 's Ud. ya ha enviado su formulario de registraci' + or + 'n. Si Ud. aborta este procedimiento del pago, Ud. NO est' + ar + ' inscrito!! En este caso, Ud. debe rellenar el formulario de nuevo para inscribirse.</FONT></H2></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%" BGCOLOR="#FFFFFF" ALIGN="CENTER"><B>En caso de encontrar dificultades usando PayPal, puede encontrar informaci' + or + 'n ' + ur + 'til <A href="http://www.xbasedevcon.de/faq_s.htm" target="_blank">aqu' + ir + '</A>.'
		otherwise
			text1 += 'Right after submitting your registration you are being redirected to PayPal to directly pay the attendance fee. If you are going to cancel this process you have NOT registered for the DevCon. You have to redo the registration process. There is no possibility to resume a cancelled registration process.</FONT></H2></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%" BGCOLOR="#FFFFFF" ALIGN="CENTER"><B>In case you encounter difficulties using PayPal, useful information can be found <A href="http://www.xbasedevcon.de/faq_e.htm" target="_blank">here</A>.'
		endcase
		text1 += '</B></TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%"><P></TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>' + CRLF

		text1 += "<FORM name='Meldung_eingeben' method='post' action='/CheckEntry1?'>" + CRLF
		text1 += '<input type=hidden name="MenuVar" value="' + sprache + '">' + CRLF

		text1 += BuildTable( sprache, 1, .f., Date() )
		text1 += '<BR><HR><BR>' + CRLF

		text1 += '<input type=submit value="' + MEMVAR->texte[ knopfmeld, spr_xx ] + '"></FORM></CENTER>' + CRLF
		text1 += MeldeFooter()

		CloseDbf()
	endif
	oClient:HTTPResponse:Content := text1
return .t.

function redirekt()
local text1
	text1 := '<html>' + CRLF
	text1 += '<head>' + CRLF
	text1 += '<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">' + CRLF
	text1 += '<meta http-equiv="refresh" content="0; URL=/">' + CRLF
	text1 += '<link rel="stylesheet" href="devcon.css" type="text/css">' + CRLF
	text1 += '</head> ' + CRLF
	text1 += '<body bgcolor="' + MEMVAR->shinter + '">' + CRLF
	text1 += '</body>' + CRLF
	text1 += '</html>' + CRLF
return text1

FUNCTION BuildTable( spr, wasdenn, lalltypes, dDatum )
	local oClient := ThreadObject(), oServer := oClient:Parent
	LOCAL x, text, text1, spr_xx, alleFelder, recnum, text2, y, hinter, vorder, thinter, tfarbe1, tfarbe2, uehint, ueber, markhin, alland, aSaal, aZeit

	alleFelder := oClient:getCargo( "FELDER" )
	hinter := "#00E3FF"
	vorder := "#00C3FF"
	tfarbe1 := "#000000"
	tfarbe2 := "#000000"
	thinter := "#CCFFFF"
	uehint := "#003366"
	ueber := "#FFFFFF"
	markhin := "#CC0000"

	if alleFelder == NIL
		alleFelder := array( I_GESAMTFELDER )
		alleFelder[ I_ANREDE ] := "0"
		alleFelder[ I_VORNAME ] := ""
		alleFelder[ I_NACHNAME ] := ""
		alleFelder[ I_FIRMA1 ] := ""
		alleFelder[ I_FIRMA2 ] := ""
		alleFelder[ I_ABTEILUNG ] := ""
		alleFelder[ I_STRASSE ] := ""
		alleFelder[ I_STAAT ] := ""
		alleFelder[ I_PLZ ] := ""
		alleFelder[ I_ORT ] := ""
		alleFelder[ I_EMAIL ] := ""
		alleFelder[ I_WEBSEITE ] := ""
		alleFelder[ I_TEILNEHMER ] := "0"
		alleFelder[ I_MUTTERSPRA ] := "0"
		alleFelder[ I_LAND ] := "0"
		alleFelder[ I_MUTTERSPSO ] := ""
		alleFelder[ I_FREMDSPRA1 ] := "0"
		alleFelder[ I_FREMDSPRA2 ] := "0"
		alleFelder[ I_VERSION ] := "0"
		alleFelder[ I_LAPTOP ] := .F.
		alleFelder[ I_SHIRT ] := "0"
		alleFelder[ I_KSDELPHI ] := "0"
		alleFelder[ I_KSFOXPRO ] := "0"
		alleFelder[ I_KSFLAGSHIP ] := "0"
		alleFelder[ I_KSCLIPPER ] := "0"
		alleFelder[ I_KSCLIP4WIN ] := "0"
		alleFelder[ I_KSDBASE ] := "0"
		alleFelder[ I_KSVO ] := "0"
		alleFelder[ I_KSXHARBOUR ] := "0"
		alleFelder[ I_SONSTIGE1 ] := ""
		alleFelder[ I_KSSONSTIG1 ] := "3"
		alleFelder[ I_SONSTIGE2 ] := ""
		alleFelder[ I_KSSONSTIG2 ] := "3"
		alleFelder[ I_SONSTIGE3 ] := ""
		alleFelder[ I_KSSONSTIG3 ] := "3"
		alleFelder[ I_KSTOPDOWN ] := "0"
		alleFelder[ I_KSEXPRESS ] := "0"
		alleFelder[ I_KSFIVEWIN ] := "0"
		alleFelder[ I_KSSQLEXPRE ] := "0"
		alleFelder[ I_KSXCLASS ] := "0"
		alleFelder[ I_KSXB2NET ] := "0"
		alleFelder[ I_KSXBHCL ] := "0"
		alleFelder[ I_KSCOCKPIT ] := "0"
		alleFelder[ I_KSLLABEL ] := "0"
		alleFelder[ I_KSVPE ] := "0"
		alleFelder[ I_KSRUNDR ] := "0"
		alleFelder[ I_KSMARSHALL ] := "0"
		alleFelder[ I_ADDONSONS1 ] := ""
		alleFelder[ I_KSADDOSON1 ] := "3"
		alleFelder[ I_ADDONSONS2 ] := ""
		alleFelder[ I_KSADDOSON2 ] := "3"
		alleFelder[ I_ADDONSONS3 ] := ""
		alleFelder[ I_KSADDOSON3 ] := "3"
		alleFelder[ I_INTSQL ] := .F.
		alleFelder[ I_INTWEBANB ] := .F.
		alleFelder[ I_INTMIGRAT ] := .F.
		alleFelder[ I_INTACTIVEX ] :=.F. 
		alleFelder[ I_INTSONSTI1 ] := ""
		alleFelder[ I_INTSONSTI2 ] := ""
		alleFelder[ I_INTSONSTI3 ] := ""
		alleFelder[ I_DEVCON1 ] := .F.
		alleFelder[ I_DEVCON2 ] := .F.
		alleFelder[ I_DEVCON3 ] := .F.
		alleFelder[ I_DEVCON4 ] := .F.
		alleFelder[ I_DEVCON5 ] := .F.
		alleFelder[ I_TEILNEHMID ] := ""
		alleFelder[ I_ANREDE1 ] := "0"
		alleFelder[ I_VORNAME1 ] := ""
		alleFelder[ I_NACHNAME1 ] := ""
		alleFelder[ I_TEILNEHMER1 ] := "0"
		alleFelder[ I_SHIRT1 ] := "0"
		alleFelder[ I_ANREDE2 ] := "0"
		alleFelder[ I_VORNAME2 ] := ""
		alleFelder[ I_NACHNAME2 ] := ""
		alleFelder[ I_TEILNEHMER2 ] := "0"
		alleFelder[ I_SHIRT2 ] := "0"
		alleFelder[ I_ANREDE3 ] := "0"
		alleFelder[ I_VORNAME3 ] := ""
		alleFelder[ I_NACHNAME3 ] := ""
		alleFelder[ I_TEILNEHMER3 ] := "0"
		alleFelder[ I_SHIRT3 ] := "0"
		alleFelder[ I_SHUTTLE ] := "0"
		alleFelder[ I_SHUTTLER ] := "0"
		alleFelder[ I_UHRAB ] := ""
		alleFelder[ I_UHRHIN ] := ""
		alleFelder[ I_ACCEPT ] := .F.
		alleFelder[ I_SAAL ] := "0"
		alleFelder[ I_ZEIT ] := "0"
		alleFelder[ I_THEMA ] := ""
		alleFelder[ I_ANONYM ] := .F.
		alleFelder[ I_ANONYM1 ] := .F.
		alleFelder[ I_ANONYM2 ] := .F.
		alleFelder[ I_ANONYM3 ] := .F.
	endif

	text2 := ""
	do case
	case spr == "de"
		spr_xx := spr_de
		MEMVAR->frsprachen[ 1, 1 ] := "Keine"
		SET COLLATION TO GERMAN
	case spr == "uk"
		spr_xx := spr_uk
		MEMVAR->frsprachen[ 1, 1 ] := "None"
		MEMVAR->xbversionen[ 1, 1 ] := "None"
		SET COLLATION TO SYSTEM
	case spr == "fr"
		spr_xx := spr_fr
		MEMVAR->frsprachen[ 1, 1 ] := "Aucune"
		MEMVAR->xbversionen[ 1, 1 ] := "Aucune"
		SET COLLATION TO FRENCH
	case spr == "sp"
		spr_xx := spr_sp
		MEMVAR->frsprachen[ 1, 1 ] := "Ninguno"
		MEMVAR->xbversionen[ 1, 1 ] := "Ninguno"
		SET COLLATION TO SPANISH
	case spr == "pt"
		spr_xx := spr_pt
		MEMVAR->frsprachen[ 1, 1 ] := "Nenhuma"
		MEMVAR->xbversionen[ 1, 1 ] := "Nenhuma"
		SET COLLATION TO PORTUGUESE
	endcase

	text2 += '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0>'
	text2 += '<TR><TD WIDTH="100%">' + NBSP + '</TD></TR></TABLE>' + CRLF

	text2 += '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + uehint + '">'
	text2 += '<TR><TD WIDTH="100%"><CENTER><FONT COLOR="' + ueber + '" SIZE=+1><B>' + MEMVAR->texte[ rechnungsan, spr_xx ] + '</B></FONT></CENTER></TD></TR></TABLE>' + CRLF
	text2 += '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '">' + CRLF
	text2 += '<TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="20%"><FONT COLOR="' + markhin + '"><B>' + MEMVAR->texte[ anrede, spr_xx ] + '</B></FONT><BR>'
	if wasdenn > 3
		text2 += CRLF + "<I>"
		do case
		case alleFelder[ I_ANREDE ] == "1"
			text2 += 'Mr.'
		case alleFelder[ I_ANREDE ] == "2"
			text2 += 'Mrs.'
		case alleFelder[ I_ANREDE ] == "3"
			text2 += 'Ms.'
		case alleFelder[ I_ANREDE ] == "4"
			text2 += 'Miss.'
		endcase
		text2 += "</I>"
	else
		text2 += CRLF + '<select name="F_ANREDE">'
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_ANREDE ] == "0", ' selected', '') + '>' + MEMVAR->texte[ textaus, spr_xx ]
		do case
		case spr == "de"
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ANREDE ] == "1", ' selected', '') + '>Herr'
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ANREDE ] $ "234", ' selected', '') + '>Frau'
		case spr == "fr"
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ANREDE ] == "1", ' selected', '') + '>M.'
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ANREDE ] $ "234", ' selected', '') + '>Mme'
		case spr == "uk"
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ANREDE ] == "1", ' selected', '') + '>Mr.'
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_ANREDE ] == "3", ' selected', '') + '>Ms.'
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ANREDE ] == "2", ' selected', '') + '>Mrs.'
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="4"' + iif( alleFelder[ I_ANREDE ] == "4", ' selected', '') + '>Miss.'
		case spr == "sp"
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ANREDE ] == "1", ' selected', '') + '>Sr.'
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ANREDE ] == "2", ' selected', '') + '>Sra.'
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_ANREDE ] $ "34", ' selected', '') + '>Srita.'
		case spr == "pt"
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ANREDE ] == "1", ' selected', '') + '>Sr.'
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ANREDE ] == "2", ' selected', '') + '>Sra.'
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_ANREDE ] $ "34", ' selected', '') + '>Senhorita'
		endcase
		text2 += CRLF + '</select>'
	endif
	text2 += CRLF + '</TD><TD WIDTH="35%"><FONT COLOR="' + markhin + '"><B>' + MEMVAR->texte[ vorname, spr_xx ] + '</B></FONT><BR>'
	if wasdenn > 3
		text2 += '<I>' + alleFelder[ I_VORNAME ] + '</I>'
	else
		text2 += '<input type=text name="F_VORNAME" value="' + alleFelder[ I_VORNAME ] + '" SIZE=30 MAXLENGTH=30>'
	endif
	text2 += CRLF + '</TD><TD WIDTH="35%"><FONT COLOR="' + markhin + '"><B>' + MEMVAR->texte[ nachname, spr_xx ] + '</B></FONT><BR>'
	if wasdenn > 3
		text2 += '<I>' + alleFelder[ I_NACHNAME ] + '</I>'
	else
		text2 += '<input type=text name="F_NACHNAME" value="' + alleFelder[ I_NACHNAME ] + '" SIZE=30 MAXLENGTH=30>'
	endif
	text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%"><B>' + MEMVAR->texte[ firma1, spr_xx ] + '</B><BR>' + CRLF
	if wasdenn > 3
		if empty( alleFelder[ I_FIRMA1 ] )
			text2 += NBSP
		else
			text2 += CRLF + '<I>' + alleFelder[ I_FIRMA1 ] + '</I>'
		endif
		text2 += '<BR>'
		if empty( alleFelder[ I_FIRMA2 ] )
			text2 += NBSP
		else
			text2 += CRLF + '<I>' + alleFelder[ I_FIRMA2 ] + '</I><BR>'
		endif
		text2 += '<BR>'
	else
		text2 += CRLF + '<input type=text name="F_FIRMA1" value="' + alleFelder[ I_FIRMA1 ] + '" SIZE=70 MAXLENGTH=70><BR>'
		text2 += CRLF + '<input type=text name="F_FIRMA2" value="' + alleFelder[ I_FIRMA2 ] + '" SIZE=70 MAXLENGTH=70><BR>'
	endif
	text2 += '<B>' + MEMVAR->texte[ abteilung, spr_xx ] + '</B><BR>'
	if wasdenn > 3
		if empty( alleFelder[ I_ABTEILUNG ] )
			text2 += NBSP
		else
			text2 += CRLF + '<I>' + alleFelder[ I_ABTEILUNG ] + '</I><BR>'
		endif
	else
		text2 += CRLF + '<input type=text name="F_ABTEILUNG" value="' + alleFelder[ I_ABTEILUNG ] + '" SIZE=30 MAXLENGTH=30><BR>'
	endif
	text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="75%"><FONT COLOR="' + markhin + '"><B>' + MEMVAR->texte[ strasse, spr_xx ] + '</B></FONT><BR>' + CRLF
	if wasdenn > 3
		text2 += CRLF + '<I>' + alleFelder[ I_STRASSE ] + '</I></TD>'
	else
		text2 += CRLF + '<input type=text name="F_STRASSE" value="' + alleFelder[ I_STRASSE ] + '" SIZE=50 MAXLENGTH=50></TD>'
	endif
	if wasdenn == 2
		text2 += CRLF + '<TD WIDTH="15%"><FONT COLOR="' + markhin + '"><B>Registrant' + "'s-ID:</B><BR><B>" + alleFelder[ I_TEILNEHMID ] + '</B></FONT></TD>'
	else
		text2 += CRLF + '<TD WIDTH="15%">' + NBSP + '</TD>'
	endif
	text2 += CRLF + '<TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>'

	text2 += '</TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '">' + CRLF
	text2 += '<TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="25%"><FONT COLOR="' + markhin + '"><B>' + MEMVAR->texte[ land, spr_xx ] + '</B></FONT><BR>'

	alland := AClone( MEMVAR->laender )
	asort( alland,,, { | aX, aY | aX[ spr_xx + 1 ] < aY[ spr_xx + 1 ] } )

	if wasdenn > 3
		y := ascan( alland, { |a| alleFelder[ I_LAND ] == a[ 1 ] } )
		if y > 0
			text2 += "<I>" + alland[ y, spr_uk + 1 ] + "</I>"
		else
			text2 += NBSP
		endif
	else
		y := len( alland )
		text2 += CRLF + '<select name="F_LAND">'
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_LAND ] == "0", ' selected', '') + '>' + MEMVAR->texte[ textaus, spr_xx ]
		for x := 1 to y
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="' + alland[ x, 1 ] + '"' + iif( alleFelder[ I_LAND ] == alland[ x, 1 ], ' selected', '') + '>' + alland[ x, spr_xx + 1 ]
		next
		text2 += CRLF + '</select>'
	endif
	text2 += CRLF + '</TD><TD WIDTH="20%"><FONT COLOR="' + markhin + '"><B>' + MEMVAR->texte[ staat, spr_xx ] + '</B></FONT><BR>'
	if wasdenn > 3
		text2 += CRLF + '<I>' + alleFelder[ I_STAAT ] + '</I>'
	else
		text2 += CRLF + '<input type=text name="F_STAAT" value="' + alleFelder[ I_STAAT ] + '" SIZE=25 MAXLENGTH=25>'
	endif
	text2 += CRLF + '</TD><TD WIDTH="10%"><FONT COLOR="' + markhin + '"><B>' + MEMVAR->texte[ plz, spr_xx ] + '</B></FONT><BR>'
	if wasdenn > 3
		text2 += CRLF + '<I>' + alleFelder[ I_PLZ ] + '</I>'
	else
		text2 += CRLF + '<input type=text name="F_PLZ" value="' + alleFelder[ I_PLZ ] + '" SIZE=10 MAXLENGTH=10>'
	endif
	text2 += CRLF + '</TD><TD WIDTH="35%"><FONT COLOR="' + markhin + '"><B>' + MEMVAR->texte[ ort, spr_xx ] + '</B></FONT><BR>'
	if wasdenn > 3
		text2 += CRLF + '<I>' + alleFelder[ I_ORT ] + '</I>'
	else
		text2 += CRLF + '<input type=text name="F_ORT" value="' + alleFelder[ I_ORT ] + '" SIZE=50 MAXLENGTH=50>'
	endif
	text2 += '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>'
	text2 += CRLF + '<TR><TD WIDTH="5%">' + NBSP + '<TD WIDTH="25%">' + NBSP + '</TD><TD WIDTH="20%">' + NBSP + '</TD><TD WIDTH="10%">' + NBSP + '</TD><TD WIDTH="35%">' + NBSP + '</TD></TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>'
	text2 += CRLF + '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0><TR><TD WIDTH="100%">' + NBSP + '</TD></TR></TABLE>'
	text2 += CRLF + '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + uehint + '"><TR><TD WIDTH="100%"><CENTER><FONT COLOR="' + ueber + '" SIZE=+1><B>' + MEMVAR->texte[ sonstiges, spr_xx ] + '</B></FONT></CENTER></TD></TR></TABLE>'
	text2 += CRLF + '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="40%"><FONT COLOR="' + markhin + '"><B>' + MEMVAR->texte[ email, spr_xx ] + '</B></FONT><BR>' + CRLF
	if wasdenn > 3
		text2 += CRLF + '<I>' + alleFelder[ I_EMAIL ] + '</I>'
	else
		text2 += CRLF + '<input type=text name="F_EMAIL" value="' + alleFelder[ I_EMAIL ] + '" SIZE=30 MAXLENGTH=50>'
	endif
	text2 += CRLF + '</TD><TD WIDTH="25%"><B>' + MEMVAR->texte[ webseite, spr_xx ] + '</B><BR>'
	if wasdenn > 3
		if empty( alleFelder[ I_WEBSEITE ] )
			text2 += NBSP
		else
			text2 += CRLF + '<I>' + alleFelder[ I_WEBSEITE ] + '</I>'
		endif
	else
		text2 += CRLF + '<input type=text name="F_WEBSEITE" value="' + alleFelder[ I_WEBSEITE ] + '" SIZE=30 MAXLENGTH=30>'
	endif
	text2 += '</TD><TD WIDTH="25%"><FONT COLOR="' + markhin + '"><B>' + MEMVAR->texte[ teilnehmer, spr_xx ] + '</B></FONT><BR>'
	if lalltypes
		text2 += CRLF + '<select name="F_TEILNEHMER">'
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_TEILNEHMER ] == "0", ' selected', '') + '>' + MEMVAR->texte[ textaus, spr_xx ]
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_TEILNEHMER ] == "1", ' selected', '') + '>' + MEMVAR->texte[ teiltnehmer, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preisnorm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preisnorm2, MEMVAR->preisnorm3 ) ), "@E ###.##" ) + " EUR)"
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_TEILNEHMER ] == "2", ' selected', '') + '>' + MEMVAR->texte[ teilpartner, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR)"
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_TEILNEHMER ] == "3", ' selected', '') + '>' + MEMVAR->texte[ teilkind, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR)"
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="4"' + iif( alleFelder[ I_TEILNEHMER ] == "4", ' selected', '') + '>' + MEMVAR->texte[ teilfreund, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR)"
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="5"' + iif( alleFelder[ I_TEILNEHMER ] == "5", ' selected', '') + '>' + MEMVAR->texte[ teilredner, spr_xx ] + " (" + transform( 0, "@E ###.##" ) + " EUR)"
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="6"' + iif( alleFelder[ I_TEILNEHMER ] == "6", ' selected', '') + '>' + MEMVAR->texte[ teilorgan, spr_xx ] + " (" + transform( 0, "@E ###.##" ) + " EUR)"
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="8"' + iif( alleFelder[ I_TEILNEHMER ] == "8", ' selected', '') + '>' + MEMVAR->texte[ teilbpart, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preisnorm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preisnorm2, MEMVAR->preisnorm3 ) ), "@E ###.##" ) + " EUR)"
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="9"' + iif( alleFelder[ I_TEILNEHMER ] == "9", ' selected', '') + '>' + MEMVAR->texte[ teiltpart, spr_xx ] + " (" + transform( 0, "@E ###.##" ) + " EUR)"
		text2 += CRLF + '</select>'
	else
		if wasdenn < 4
			text2 += CRLF + '<select name="F_TEILNEHMER">'
		endif
		if wasdenn == 1
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_TEILNEHMER ] == "0", ' selected', '') + '>' + MEMVAR->texte[ textaus, spr_xx ]
		endif
		if wasdenn < 3
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_TEILNEHMER ] == "1", ' selected', '') + '>' + MEMVAR->texte[ teiltnehmer, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preisnorm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preisnorm2, MEMVAR->preisnorm3 ) ), "@E ###.##" ) + " EUR)"
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="8"' + iif( alleFelder[ I_TEILNEHMER ] == "8", ' selected', '') + '>' + MEMVAR->texte[ teilbpart, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preisnorm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preisnorm2, MEMVAR->preisnorm3 ) ), "@E ###.##" ) + " EUR)"
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_TEILNEHMER ] == "2", ' selected', '') + '>' + MEMVAR->texte[ teilpartner, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR)"
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_TEILNEHMER ] == "3", ' selected', '') + '>' + MEMVAR->texte[ teilkind, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR)"
		endif
		if wasdenn == 2
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="4"' + iif( alleFelder[ I_TEILNEHMER ] == "4", ' selected', '') + '>' + MEMVAR->texte[ teilfreund, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR)"
		endif
		if wasdenn > 3
			text2 += '<I>'
			do case
			case alleFelder[ I_TEILNEHMER ] == "1"
				text2 += MEMVAR->texte[ teiltnehmer, spr_uk ]
			case alleFelder[ I_TEILNEHMER ] == "2"
				text2 += MEMVAR->texte[ teilpartner, spr_uk ]
			case alleFelder[ I_TEILNEHMER ] == "3"
				text2 += MEMVAR->texte[ teilkind, spr_uk ]
			case alleFelder[ I_TEILNEHMER ] == "4"
				text2 += MEMVAR->texte[ teilfreund, spr_uk ]
			case alleFelder[ I_TEILNEHMER ] == "5"
				text2 += MEMVAR->texte[ teilredner, spr_uk ] 
			case alleFelder[ I_TEILNEHMER ] == "6"
				text2 += MEMVAR->texte[ teilorgan, spr_uk ]
			case alleFelder[ I_TEILNEHMER ] == "7"
				text2 += MEMVAR->texte[ teilsonst, spr_uk ]
			case alleFelder[ I_TEILNEHMER ] == "8"
				text2 += MEMVAR->texte[ teilbpart, spr_uk ]
			case alleFelder[ I_TEILNEHMER ] == "9"
				text2 += MEMVAR->texte[ teiltpart, spr_uk ]
			otherwise
				text2 += NBSP
			endcase
			text2 += "</I>"
		else
			if ( wasdenn == 2 ) .or. ( val( dtos( date() ) ) < MEMVAR->speakdat )
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="5"' + iif( alleFelder[ I_TEILNEHMER ] == "5", ' selected', '') + '>' + MEMVAR->texte[ teilredner, spr_xx ] + " (" + transform( 0, "@E ###.##" ) + " EUR)"
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="6"' + iif( alleFelder[ I_TEILNEHMER ] == "6", ' selected', '') + '>' + MEMVAR->texte[ teilorgan, spr_xx ] + " (" + transform( 0, "@E ###.##" ) + " EUR)"
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="9"' + iif( alleFelder[ I_TEILNEHMER ] == "9", ' selected', '') + '>' + MEMVAR->texte[ teiltpart, spr_xx ] + " (" + transform( 0, "@E ###.##" ) + " EUR)"
			elseif wasdenn == 3
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="5"' + iif( alleFelder[ I_TEILNEHMER ] == "5", ' selected', '') + '>' + MEMVAR->texte[ teilredner, spr_xx ] + " (" + transform( 0, "@E ###.##" ) + " EUR)"
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="9"' + iif( alleFelder[ I_TEILNEHMER ] == "9", ' selected', '') + '>' + MEMVAR->texte[ teiltpart, spr_xx ] + " (" + transform( 0, "@E ###.##" ) + " EUR)"
			endif
			text2 += CRLF + '</select>'
		endif
	endif
	text2 += '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>'
	text2 += CRLF + '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD>' + CRLF
	text2 += CRLF + '</TD><TD WIDTH="40%"><FONT COLOR="' + markhin + '"><B>' + MEMVAR->texte[ muttersprache, spr_xx ] + '</B></FONT>'
	text2 += CRLF + '</TD><TD WIDTH="25%"><B>' + MEMVAR->texte[ fremdsprache1, spr_xx ] + '</B>'
	text2 += CRLF + '</TD><TD WIDTH="25%"><B>' + MEMVAR->texte[ fremdsprache2, spr_xx ] + '</B>'
	text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>'

	text2 += CRLF + '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR><TD WIDTH="5%">' + NBSP + '</TD>' + CRLF
	text2 += CRLF + '<TD WIDTH="13%">'

	if wasdenn > 3
		y := ascan( MEMVAR->sprachen, { |a| alleFelder[ I_MUTTERSPRA ] == a[ 2 ] } )
		if y > 0
			text2 += "<I>" + MEMVAR->sprachen[ y, 1 ] + "</I>"
		endif
	else
		y := len( MEMVAR->sprachen )
		text2 += CRLF + '<select name="F_MUTTERSPRA">'
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_MUTTERSPRA ] == "0", ' selected', '') + '>' + MEMVAR->texte[ textaus, spr_xx ]
		for x := 1 to y
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="' + MEMVAR->sprachen[ x, 2 ] + '"' + iif( alleFelder[ I_MUTTERSPRA ] == MEMVAR->sprachen[ x, 2 ], ' selected', '') + '>' + MEMVAR->sprachen[ x, 1 ]
		next
		text2 += CRLF + '</select>'
	endif
	text2 += CRLF + '</TD><TD WIDTH="27%">' + NBSP
	if wasdenn > 3
		if empty( alleFelder[ I_MUTTERSPSO ] )
			text2 += NBSP
		else
			text2 += "<I>" + alleFelder[ I_MUTTERSPSO ] + "</I>"
		endif
	else
		text2 += CRLF + '<input type=text name="F_MUTTERSPSO" value="' + alleFelder[ I_MUTTERSPSO ] + '" SIZE=20 MAXLENGTH=20>'
	endif
	text2 += CRLF + '</TD><TD WIDTH="25%">'
	if wasdenn > 3
		y := ascan( MEMVAR->frsprachen, { |a| alleFelder[ I_FREMDSPRA1 ] == a[ 2 ] } )
		if y > 0
			text2 += "<I>" + MEMVAR->frsprachen[ y, 1 ] + "</I>"
		endif
	else
		y := len( MEMVAR->frsprachen )
		text2 += CRLF + '<select name="F_FREMDSPRA1">'
		for x := 1 to y
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="' + MEMVAR->frsprachen[ x, 2 ] + '"' + iif( alleFelder[ I_FREMDSPRA1 ] == MEMVAR->frsprachen[ x, 2 ], ' selected', '') + '>' + MEMVAR->frsprachen[ x, 1 ]
		next
		text2 += CRLF + '</select>'
	endif
	text2 += CRLF + '</TD><TD WIDTH="25%">'
	if wasdenn > 3
		y := ascan( MEMVAR->frsprachen, { |a| alleFelder[ I_FREMDSPRA2 ] == a[ 2 ] } )
		if y > 0
			text2 += "<I>" + MEMVAR->frsprachen[ y, 1 ] + "</I>"
		endif
	else
		y := len( MEMVAR->frsprachen )
		text2 += CRLF + '<select name="F_FREMDSPRA2">'
		for x := 1 to y
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="' + MEMVAR->frsprachen[ x, 2 ] + '"' + iif( alleFelder[ I_FREMDSPRA2 ] == MEMVAR->frsprachen[ x, 2 ], ' selected', '') + '>' + MEMVAR->frsprachen[ x, 1 ]
		next
		text2 += CRLF + '</select>'
	endif
	text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>'

	if wasdenn == 2
		text2 += CRLF + '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="15%"><B>Date of payment:</B><BR>' + CRLF
		text2 += '<input type=text name="F_ZAHLEINGAN" value="' + alleFelder[ I_ZAHLEINGAN ] + '" SIZE=10 MAXLENGTH=10>' + NBSP + '<input type="button" value="<->" onclick="Datum()">'
		text2 += CRLF + '</TD><TD WIDTH="25%"><B>Type of payment:</B><BR>'
		y := len( MEMVAR->xbversionen )
		text2 += CRLF + '<select name="F_ZAHLART">'
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_ZAHLART ] == "0", ' selected', '') + '>' + NBSP
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ZAHLART ] == "1", ' selected', '') + '>PayPal'
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_ZAHLART ] == "3", ' selected', '') + '>Money transfer'
		text2 += CRLF + '</select>'
		text2 += CRLF + '</TD><TD WIDTH="15%"><B>Amount:</B><BR>'
		text2 += '<input type=text name="F_PREIS" value="' + alleFelder[ I_PREIS ] + '" SIZE=6 MAXLENGTH=6>'
		text2 += CRLF + '</TD><TD WIDTH="20%">'
		text2 += '<input type=checkbox name="F_LAPTOP" value="on"' + iif( alleFelder[ I_LAPTOP ], "checked", "" ) + '><B>' + MEMVAR->texte[ laptop, spr_xx ] + '</B>'
		text2 += CRLF + '</TD><TD WIDTH="15%"><FONT COLOR="' + markhin + '"><B>' + MEMVAR->texte[ tshirt, spr_xx ] + '</B></FONT><BR>'
		text2 += CRLF + '<select name="F_SHIRT">'
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_SHIRT ] == "0", ' selected', '') + '>' + NBSP
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="6"' + iif( alleFelder[ I_SHIRT ] == "6", ' selected', '') + '>XS'
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_SHIRT ] == "1", ' selected', '') + '>S'
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_SHIRT ] == "2", ' selected', '') + '>M'
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_SHIRT ] == "3", ' selected', '') + '>L'
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="4"' + iif( alleFelder[ I_SHIRT ] == "4", ' selected', '') + '>XL'
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="5"' + iif( alleFelder[ I_SHIRT ] == "5", ' selected', '') + '>XXL'
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="7"' + iif( alleFelder[ I_SHIRT ] == "7", ' selected', '') + '>XXXL'
		text2 += CRLF + '</select>'
		text2 += CRLF + '<TD WIDTH="5%">' + NBSP + '</TD></TR>'
		text2 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="15%">' + NBSP + '</TD><TD WIDTH="25%"><input type=checkbox name="F_ANONYM" value="on"' + iif( alleFelder[ I_ANONYM ], "checked", "" ) + '>' + MEMVAR->texte[ anonym, spr_xx ] + '</TD><TD WIDTH="15%">' + NBSP + '</TD><TD WIDTH="20%">' + NBSP + '</TD><TD WIDTH="15%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>'
		text2 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="15%">' + NBSP + '</TD><TD WIDTH="25%">' + NBSP + '</TD><TD WIDTH="15%">' + NBSP + '</TD><TD WIDTH="20%">' + NBSP + '</TD><TD WIDTH="15%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>'
	else
		text2 += CRLF + '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="40%">' + iif( wasdenn >= 3, NBSP, '<B>' + MEMVAR->texte[ xbaseversion, spr_xx ] + '</B><BR>' ) + CRLF
		if wasdenn < 3
			y := len( MEMVAR->xbversionen )
			text2 += CRLF + '<select name="F_VERSION">'
			for x := 1 to y
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="' + MEMVAR->xbversionen[ x, 2 ] + '"' + iif( alleFelder[ I_VERSION ] == MEMVAR->xbversionen[ x, 2 ], ' selected', '') + '>' + MEMVAR->xbversionen[ x, 1 ]
			next
			text2 += CRLF + '</select>'
		endif
		text2 += CRLF + '</TD><TD WIDTH="25%">'
		if wasdenn > 3
			text2 += '<I>' + iif( alleFelder[ I_LAPTOP ], MEMVAR->texte[ laptop, spr_uk ], NBSP ) + '</I>'
		else
			text2 += '<input type=checkbox name="F_LAPTOP" value="on"' + iif( alleFelder[ I_LAPTOP ], "checked", "" ) + '><B>' + MEMVAR->texte[ laptop, spr_xx ] + '</B>'
		endif
		text2 += CRLF + '</TD><TD WIDTH="25%"><FONT COLOR="' + markhin + '"><B>' + MEMVAR->texte[ tshirt, spr_xx ] + '</B></FONT><BR>'
		if wasdenn > 3
			text2 += "<I>"
			do case
			case alleFelder[ I_SHIRT ] == "0"
				text2 += NBSP
			case alleFelder[ I_SHIRT ] == "1"
				text2 += 'S'
			case alleFelder[ I_SHIRT ] == "2"
				text2 += 'M'
			case alleFelder[ I_SHIRT ] == "3"
				text2 += 'L'
			case alleFelder[ I_SHIRT ] == "4"
				text2 += 'XL'
			case alleFelder[ I_SHIRT ] == "5"
				text2 += 'XXL'
			case alleFelder[ I_SHIRT ] == "6"
				text2 += 'XS'
			case alleFelder[ I_SHIRT ] == "7"
				text2 += 'XXXL'
			endcase
			text2 += "</I>"
		else
			text2 += CRLF + '<select name="F_SHIRT">'
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_SHIRT ] == "0", ' selected', '') + '>' + NBSP
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="6"' + iif( alleFelder[ I_SHIRT ] == "6", ' selected', '') + '>XS'
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_SHIRT ] == "1", ' selected', '') + '>S'
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_SHIRT ] == "2", ' selected', '') + '>M'
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_SHIRT ] == "3", ' selected', '') + '>L'
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="4"' + iif( alleFelder[ I_SHIRT ] == "4", ' selected', '') + '>XL'
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="5"' + iif( alleFelder[ I_SHIRT ] == "5", ' selected', '') + '>XXL'
			text2 += CRLF + chr( xbeK_TAB ) + '<option value="7"' + iif( alleFelder[ I_SHIRT ] == "7", ' selected', '') + '>XXXL'
			text2 += CRLF + '</select>'
		endif
		text2 += CRLF + '<TD WIDTH="5%">' + NBSP + '</TD></TR>'
		text2 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="40%">'
		if wasdenn > 3
			text2 += iif( alleFelder[ I_ANONYM ], "<I>" + MEMVAR->texte[ anonym, spr_xx ] + "</I>", NBSP )
		else
			text2 += '<input type=checkbox name="F_ANONYM" value="on"' + iif( alleFelder[ I_ANONYM ], "checked", "" ) + '>' + MEMVAR->texte[ anonym, spr_xx ]
		endif
		text2 += '</TD><TD WIDTH="25%">' + NBSP + '</TD><TD WIDTH="25%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>'
		text2 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="40%">' + NBSP + '</TD><TD WIDTH="25%">' + NBSP + '</TD><TD WIDTH="25%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>'
		if ( wasdenn < 3 ) .or. ( wasdenn > 4 )
			text2 += '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '">'
			if wasdenn < 3
				text2 += '<TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%"><CENTER><input type=checkbox name="F_ACCEPT" value="on"' + iif( alleFelder[ I_ACCEPT ], "checked", "" ) + '><FONT COLOR="' + markhin + '"><B>' + MEMVAR->texte[ tbeding, spr_xx ] + '</B></FONT></CENTER></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>'
			endif
			text2 += '<TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>'
			text2 += '<TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%"><CENTER><B>' + MEMVAR->texte[ devcons, iif( wasdenn < 3, spr_xx, spr_uk ) ] + '</B></CENTER>'
			text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%">'
			if wasdenn > 4
				text2 += "<I>" + iif( alleFelder[ I_DEVCON1 ], MEMVAR->texte[ devcon20011, spr_uk ], NBSP ) + "</I>"
			else
				text2 += '<input type=checkbox name="F_DEVCON1" value="on"' + iif( alleFelder[ I_DEVCON1 ], "checked", "" ) + '>' + MEMVAR->texte[ devcon20011, spr_xx ]
			endif
			text2 += CRLF + '</TD><TD WIDTH="30%">'
			if wasdenn > 4
				text2 += "<I>" + iif( alleFelder[ I_DEVCON2 ], MEMVAR->texte[ devcon20012, spr_uk ], NBSP ) + "</I>"
			else
				text2 += '<input type=checkbox name="F_DEVCON2" value="on"' + iif( alleFelder[ I_DEVCON2 ], "checked", "" ) + '>' + MEMVAR->texte[ devcon20012, spr_xx ]
			endif
			text2 += CRLF + '</TD><TD WIDTH="30%">'
			if wasdenn > 4
				text2 += "<I>" + iif( alleFelder[ I_DEVCON3 ], MEMVAR->texte[ devcon2002, spr_uk ], NBSP ) + "</I>"
			else
				text2 += '<input type=checkbox name="F_DEVCON3" value="on"' + iif( alleFelder[ I_DEVCON3 ], "checked", "" ) + '>' + MEMVAR->texte[ devcon2002, spr_xx ]
			endif
			text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%">'
			if wasdenn > 4
				text2 += "<I>" + iif( alleFelder[ I_DEVCON4 ], MEMVAR->texte[ devcon2004, spr_uk ], NBSP ) + "</I>"
			else
				text2 += '<input type=checkbox name="F_DEVCON4" value="on"' + iif( alleFelder[ I_DEVCON4 ], "checked", "" ) + '>' + MEMVAR->texte[ devcon2004, spr_xx ]
			endif
			text2 += CRLF + '</TD><TD WIDTH="30%">'
			if wasdenn > 4
				text2 += "<I>" + iif( alleFelder[ I_DEVCON5 ], MEMVAR->texte[ devcon2006, spr_uk ], NBSP ) + "</I>"
			else
				text2 += '<input type=checkbox name="F_DEVCON5" value="on"' + iif( alleFelder[ I_DEVCON5 ], "checked", "" ) + '>' + MEMVAR->texte[ devcon2006, spr_xx ]
			endif
			text2 += CRLF + '</TD><TD WIDTH="30%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>'
			text2 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%">' + NBSP + '</TD><TD WIDTH="30%">' + NBSP + '</TD><TD WIDTH="30%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>'
		endif
		if wasdenn <> 4
			text2 += '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%"><CENTER><B>' + MEMVAR->texte[ mitteilnehmer, spr_xx ] + '</B></CENTER>'
			text2 += '<TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '">' + CRLF
			text2 += '<TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="8%"><B>' + MEMVAR->texte[ anrede, iif( wasdenn < 4, spr_xx, spr_uk ) ] + '</B><BR>'
			if wasdenn > 4
				text2 += CRLF + "<I>" + iif( alleFelder[ I_ANREDE1 ] == "0", NBSP, iif( alleFelder[ I_ANREDE1 ] == "1", "Herr", "Frau" ) ) + "</I>"
			else
				text2 += CRLF + '<select name="F_ANREDE1">'
				do case
				case spr == "de"
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_ANREDE1 ] == "0", ' selected', '') + '>' + NBSP
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ANREDE1 ] == "1", ' selected', '') + '>Herr'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ANREDE1 ] $ "234", ' selected', '') + '>Frau'
				case spr == "fr"
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_ANREDE1 ] == "0", ' selected', '') + '>' + NBSP
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ANREDE1 ] == "1", ' selected', '') + '>M.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ANREDE1 ] $ "234", ' selected', '') + '>Mme'
				case spr == "uk"
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_ANREDE1 ] == "0", ' selected', '') + '>' + NBSP
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ANREDE1 ] == "1", ' selected', '') + '>Mr.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_ANREDE1 ] == "3", ' selected', '') + '>Ms.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ANREDE1 ] == "2", ' selected', '') + '>Mrs.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="4"' + iif( alleFelder[ I_ANREDE1 ] == "4", ' selected', '') + '>Miss.'
				case spr == "sp"
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_ANREDE1 ] == "0", ' selected', '') + '>' + NBSP
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ANREDE1 ] == "1", ' selected', '') + '>Sr.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ANREDE1 ] == "2", ' selected', '') + '>Sra.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_ANREDE1 ] $ "34", ' selected', '') + '>Srita.'
				case spr == "pt"
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_ANREDE1 ] == "0", ' selected', '') + '>' + NBSP
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ANREDE1 ] == "1", ' selected', '') + '>Sr.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ANREDE1 ] == "2", ' selected', '') + '>Sra.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_ANREDE1 ] $ "34", ' selected', '') + '>Senhorita'
				endcase
				text2 += CRLF + '</select>'
			endif
			text2 += CRLF + '</TD><TD WIDTH="23%"><B>' + MEMVAR->texte[ vorname, iif( wasdenn < 4, spr_xx, spr_uk ) ] + '</B><BR>'
			if wasdenn > 4
				text2 += '<I>' + iif( empty( alleFelder[ I_VORNAME1 ] ), NBSP, alltrim( alleFelder[ I_VORNAME1 ] ) ) + '</I>'
			else
				text2 += '<input type=text name="F_VORNAME1" value="' + alleFelder[ I_VORNAME1 ] + '" SIZE=30 MAXLENGTH=30>'
			endif
			text2 += CRLF + '</TD><TD WIDTH="23%"><B>' + MEMVAR->texte[ nachname, iif( wasdenn < 4, spr_xx, spr_uk ) ] + '</B><BR>'
			if wasdenn > 4
				text2 += '<I>' + iif( empty( alleFelder[ I_NACHNAME1 ] ), NBSP, alltrim( alleFelder[ I_NACHNAME1 ] ) ) + '</I>'
			else
				text2 += '<input type=text name="F_NACHNAME1" value="' + alleFelder[ I_NACHNAME1 ] + '" SIZE=30 MAXLENGTH=30>'
			endif
			text2 += CRLF + '</TD><TD WIDTH="18%"><B>' + MEMVAR->texte[ verwandschaft, iif( wasdenn < 4, spr_xx, spr_uk ) ] + '</B><BR>'
			if wasdenn > 4
				text2 += '<I>'
				do case
				case alleFelder[ I_TEILNEHMER1 ] == "1"
					text2 += MEMVAR->texte[ teiltnehmer, spr_uk ]
				case alleFelder[ I_TEILNEHMER1 ] == "2"
					text2 += MEMVAR->texte[ teilpartner, spr_uk ]
				case alleFelder[ I_TEILNEHMER1 ] == "3"
					text2 += MEMVAR->texte[ teilkind, spr_uk ]
				case alleFelder[ I_TEILNEHMER1 ] == "4"
					text2 += MEMVAR->texte[ teilfreund, spr_uk ]
				case alleFelder[ I_TEILNEHMER1 ] == "5"
					text2 += MEMVAR->texte[ teilredner, spr_uk ] 
				case alleFelder[ I_TEILNEHMER1 ] == "6"
					text2 += MEMVAR->texte[ teilorgan, spr_uk ]
				case alleFelder[ I_TEILNEHMER1 ] == "7"
					text2 += MEMVAR->texte[ teilsonst, spr_uk ]
				case alleFelder[ I_TEILNEHMER1 ] == "8"
					text2 += MEMVAR->texte[ teilbpart, spr_uk ]
				case alleFelder[ I_TEILNEHMER1 ] == "9"
					text2 += MEMVAR->texte[ teiltpart, spr_uk ]
				otherwise
					text2 += NBSP
				endcase
				text2 += "</I>"
			else
				text2 += CRLF + '<select name="F_TEILNEHMER1">'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_TEILNEHMER1 ] == "0", ' selected', '') + '>' + NBSP
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_TEILNEHMER1 ] == "2", ' selected', '') + '>' + MEMVAR->texte[ teilpartner, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR)"
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_TEILNEHMER1 ] == "3", ' selected', '') + '>' + MEMVAR->texte[ teilkind, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR)"
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="4"' + iif( alleFelder[ I_TEILNEHMER1 ] == "4", ' selected', '') + '>' + MEMVAR->texte[ teilfreund, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR)"
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="7"' + iif( alleFelder[ I_TEILNEHMER1 ] == "7", ' selected', '') + '>' + MEMVAR->texte[ teilsonst, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR)"
				text2 += CRLF + '</select>'
			endif

			text2 += CRLF + '</TD><TD WIDTH="10%"><B>' + MEMVAR->texte[ tshirt, iif( wasdenn < 4, spr_xx, spr_uk ) ] + '</B><BR>'
			if wasdenn > 4
				text2 += "<I>"
				do case
				case alleFelder[ I_SHIRT1 ] == "0"
					text2 += NBSP
				case alleFelder[ I_SHIRT1 ] == "1"
					text2 += 'S'
				case alleFelder[ I_SHIRT1 ] == "2"
					text2 += 'M'
				case alleFelder[ I_SHIRT1 ] == "3"
					text2 += 'L'
				case alleFelder[ I_SHIRT1 ] == "4"
					text2 += 'XL'
				case alleFelder[ I_SHIRT1 ] == "5"
					text2 += 'XXL'
				case alleFelder[ I_SHIRT1 ] == "6"
					text2 += 'XS'
				case alleFelder[ I_SHIRT1 ] == "7"
					text2 += 'XXXL'
				endcase
				text2 += "</I>"
			else
				text2 += CRLF + '<select name="F_SHIRT1">'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_SHIRT1 ] == "0", ' selected', '') + '> '
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="6"' + iif( alleFelder[ I_SHIRT1 ] == "6", ' selected', '') + '>XS'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_SHIRT1 ] == "1", ' selected', '') + '>S'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_SHIRT1 ] == "2", ' selected', '') + '>M'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_SHIRT1 ] == "3", ' selected', '') + '>L'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="4"' + iif( alleFelder[ I_SHIRT1 ] == "4", ' selected', '') + '>XL'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="5"' + iif( alleFelder[ I_SHIRT1 ] == "5", ' selected', '') + '>XXL'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="7"' + iif( alleFelder[ I_SHIRT1 ] == "7", ' selected', '') + '>XXXL'
				text2 += CRLF + '</select>'
			endif

			text2 += CRLF + '</TD><TD WIDTH="8%">' + MEMVAR->texte[ anonym, iif( wasdenn < 4, spr_xx, spr_uk ) ] + '<BR>'
			if wasdenn > 4
				if alleFelder[ I_ANONYM1 ]
					text2 += "<I>"
					do case
					case spr_xx == spr_de
						text2 += "Ja"
					case spr_xx == spr_sp
						text2 += "S" + ir
					case spr_xx == spr_fr
						text2 += "Oui"
					otherwise
						text2 += "Yes"
					endcase
					text2 += "</I>"
				else
					text2 += NBSP
				endif
			else
				text2 += CRLF + '<input type=checkbox name="F_ANONYM1" value="on"' + iif( alleFelder[ I_ANONYM1 ], "checked", "" ) + '>'
			endif

			text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>'
			text2 += '<TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="8%">'
			if wasdenn > 4
				text2 += CRLF + "<I>" + iif( alleFelder[ I_ANREDE2 ] == "0", NBSP, iif( alleFelder[ I_ANREDE2 ] == "1", "Herr", "Frau" ) ) + "</I>"
			else
				text2 += CRLF + '<select name="F_ANREDE2">'
				do case
				case spr == "de"
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_ANREDE2 ] == "0", ' selected', '') + '>' + NBSP
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ANREDE2 ] == "1", ' selected', '') + '>Herr'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ANREDE2 ] $ "234", ' selected', '') + '>Frau'
				case spr == "fr"
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_ANREDE2 ] == "0", ' selected', '') + '>' + NBSP
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ANREDE2 ] == "1", ' selected', '') + '>M.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ANREDE2 ] $ "234", ' selected', '') + '>Mme'
				case spr == "uk"
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_ANREDE2 ] == "0", ' selected', '') + '>' + NBSP
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ANREDE2 ] == "1", ' selected', '') + '>Mr.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_ANREDE2 ] == "3", ' selected', '') + '>Ms.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ANREDE2 ] == "2", ' selected', '') + '>Mrs.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="4"' + iif( alleFelder[ I_ANREDE2 ] == "4", ' selected', '') + '>Miss.'
				case spr == "sp"
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_ANREDE2 ] == "0", ' selected', '') + '>' + NBSP
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ANREDE2 ] == "1", ' selected', '') + '>Sr.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ANREDE2 ] == "2", ' selected', '') + '>Sra.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_ANREDE2 ] $ "34", ' selected', '') + '>Srita.'
				case spr == "pt"
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_ANREDE2 ] == "0", ' selected', '') + '>' + NBSP
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ANREDE2 ] == "1", ' selected', '') + '>Sr.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ANREDE2 ] == "2", ' selected', '') + '>Sra.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_ANREDE2 ] $ "34", ' selected', '') + '>Senhorita'
				endcase
				text2 += CRLF + '</select>'
			endif
			text2 += CRLF + '</TD><TD WIDTH="23%">'
			if wasdenn > 4
				text2 += '<I>' + iif( empty( alleFelder[ I_VORNAME2 ] ), NBSP, alltrim( alleFelder[ I_VORNAME2 ] ) ) + '</I>'
			else
				text2 += '<input type=text name="F_VORNAME2" value="' + alleFelder[ I_VORNAME2 ] + '" SIZE=30 MAXLENGTH=30>'
			endif
			text2 += CRLF + '</TD><TD WIDTH="23%">'
			if wasdenn > 4
				text2 += '<I>' + iif( empty( alleFelder[ I_NACHNAME2 ] ), NBSP, alltrim( alleFelder[ I_NACHNAME2 ] ) ) + '</I>'
			else
				text2 += '<input type=text name="F_NACHNAME2" value="' + alleFelder[ I_NACHNAME2 ] + '" SIZE=30 MAXLENGTH=30>'
			endif
			text2 += CRLF + '</TD><TD WIDTH="18%">'
			if wasdenn > 4
				text2 += '<I>'
				do case
				case alleFelder[ I_TEILNEHMER1 ] == "1"
					text2 += MEMVAR->texte[ teiltnehmer, spr_uk ]
				case alleFelder[ I_TEILNEHMER2 ] == "2"
					text2 += MEMVAR->texte[ teilpartner, spr_uk ]
				case alleFelder[ I_TEILNEHMER2 ] == "3"
					text2 += MEMVAR->texte[ teilkind, spr_uk ]
				case alleFelder[ I_TEILNEHMER2 ] == "4"
					text2 += MEMVAR->texte[ teilfreund, spr_uk ]
				case alleFelder[ I_TEILNEHMER2 ] == "5"
					text2 += MEMVAR->texte[ teilredner, spr_uk ] 
				case alleFelder[ I_TEILNEHMER2 ] == "6"
					text2 += MEMVAR->texte[ teilorgan, spr_uk ]
				case alleFelder[ I_TEILNEHMER2 ] == "7"
					text2 += MEMVAR->texte[ teilsonst, spr_uk ]
				case alleFelder[ I_TEILNEHMER2 ] == "8"
					text2 += MEMVAR->texte[ teilbpart, spr_uk ]
				case alleFelder[ I_TEILNEHMER2 ] == "9"
					text2 += MEMVAR->texte[ teiltpart, spr_uk ]
				otherwise
					text2 += NBSP
				endcase
				text2 += "</I>"
			else
				text2 += CRLF + '<select name="F_TEILNEHMER2">'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_TEILNEHMER2 ] == "0", ' selected', '') + '>' + NBSP
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_TEILNEHMER2 ] == "2", ' selected', '') + '>' + MEMVAR->texte[ teilpartner, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR)"
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_TEILNEHMER2 ] == "3", ' selected', '') + '>' + MEMVAR->texte[ teilkind, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR)"
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="4"' + iif( alleFelder[ I_TEILNEHMER2 ] == "4", ' selected', '') + '>' + MEMVAR->texte[ teilfreund, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR)"
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="7"' + iif( alleFelder[ I_TEILNEHMER2 ] == "7", ' selected', '') + '>' + MEMVAR->texte[ teilsonst, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR)"
				text2 += CRLF + '</select>'
			endif

			text2 += CRLF + '</TD><TD WIDTH="10%">'
			if wasdenn > 4
				text2 += "<I>"
				do case
				case alleFelder[ I_SHIRT2 ] == "0"
					text2 += NBSP
				case alleFelder[ I_SHIRT2 ] == "1"
					text2 += 'S'
				case alleFelder[ I_SHIRT2 ] == "2"
					text2 += 'M'
				case alleFelder[ I_SHIRT2 ] == "3"
					text2 += 'L'
				case alleFelder[ I_SHIRT2 ] == "4"
					text2 += 'XL'
				case alleFelder[ I_SHIRT2 ] == "5"
					text2 += 'XXL'
				case alleFelder[ I_SHIRT2 ] == "6"
					text2 += 'XS'
				case alleFelder[ I_SHIRT2 ] == "7"
					text2 += 'XXXL'
				endcase
				text2 += "</I>"
			else
				text2 += CRLF + '<select name="F_SHIRT2">'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_SHIRT2 ] == "0", ' selected', '') + '> '
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="6"' + iif( alleFelder[ I_SHIRT2 ] == "6", ' selected', '') + '>XS'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_SHIRT2 ] == "1", ' selected', '') + '>S'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_SHIRT2 ] == "2", ' selected', '') + '>M'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_SHIRT2 ] == "3", ' selected', '') + '>L'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="4"' + iif( alleFelder[ I_SHIRT2 ] == "4", ' selected', '') + '>XL'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="5"' + iif( alleFelder[ I_SHIRT2 ] == "5", ' selected', '') + '>XXL'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="7"' + iif( alleFelder[ I_SHIRT2 ] == "7", ' selected', '') + '>XXXL'
				text2 += CRLF + '</select>'
			endif

			text2 += CRLF + '</TD><TD WIDTH="8%">'
			if wasdenn > 4
				if alleFelder[ I_ANONYM2 ]
					text2 += "<I>"
					do case
					case spr_xx == spr_de
						text2 += "Ja"
					case spr_xx == spr_sp
						text2 += "S" + ir
					case spr_xx == spr_fr
						text2 += "Oui"
					otherwise
						text2 += "Yes"
					endcase
					text2 += "</I>"
				else
					text2 += NBSP
				endif
			else
				text2 += CRLF + '<input type=checkbox name="F_ANONYM2" value="on"' + iif( alleFelder[ I_ANONYM2 ], "checked", "" ) + '>'
			endif

			text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>'
			text2 += '<TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="8%">'
			if wasdenn > 4
				text2 += CRLF + "<I>" + iif( alleFelder[ I_ANREDE3 ] == "0", NBSP, iif( alleFelder[ I_ANREDE3 ] == "1", "Herr", "Frau" ) ) + "</I>"
			else
				text2 += CRLF + '<select name="F_ANREDE3">'
				do case
				case spr == "de"
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_ANREDE3 ] == "0", ' selected', '') + '>' + NBSP
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ANREDE3 ] == "1", ' selected', '') + '>Herr'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ANREDE3 ] $ "234", ' selected', '') + '>Frau'
				case spr == "fr"
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_ANREDE3 ] == "0", ' selected', '') + '>' + NBSP
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ANREDE3 ] == "1", ' selected', '') + '>M.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ANREDE3 ] $ "234", ' selected', '') + '>Mme'
				case spr == "uk"
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_ANREDE3 ] == "0", ' selected', '') + '>' + NBSP
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ANREDE3 ] == "1", ' selected', '') + '>Mr.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_ANREDE3 ] == "3", ' selected', '') + '>Ms.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ANREDE3 ] == "2", ' selected', '') + '>Mrs.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="4"' + iif( alleFelder[ I_ANREDE3 ] == "4", ' selected', '') + '>Miss.'
				case spr == "sp"
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_ANREDE3 ] == "0", ' selected', '') + '>' + NBSP
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ANREDE3 ] == "1", ' selected', '') + '>Sr.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ANREDE3 ] == "2", ' selected', '') + '>Sra.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_ANREDE3 ] $ "34", ' selected', '') + '>Srita.'
				case spr == "pt"
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_ANREDE3 ] == "0", ' selected', '') + '>' + NBSP
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ANREDE3 ] == "1", ' selected', '') + '>Sr.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ANREDE3 ] == "2", ' selected', '') + '>Sra.'
					text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_ANREDE3 ] $ "34", ' selected', '') + '>Senhorita'
				endcase
				text2 += CRLF + '</select>'
			endif
			text2 += CRLF + '</TD><TD WIDTH="23%">'
			if wasdenn > 4
				text2 += '<I>' + iif( empty( alleFelder[ I_VORNAME3 ] ), NBSP, alltrim( alleFelder[ I_VORNAME3 ] ) ) + '</I>'
			else
				text2 += '<input type=text name="F_VORNAME3" value="' + alleFelder[ I_VORNAME3 ] + '" SIZE=30 MAXLENGTH=30>'
			endif
			text2 += CRLF + '</TD><TD WIDTH="23%">'
			if wasdenn > 4
				text2 += '<I>' + iif( empty( alleFelder[ I_NACHNAME3 ] ), NBSP, alltrim( alleFelder[ I_NACHNAME3 ] ) ) + '</I>'
			else
				text2 += '<input type=text name="F_NACHNAME3" value="' + alleFelder[ I_NACHNAME3 ] + '" SIZE=30 MAXLENGTH=30>'
			endif
			text2 += CRLF + '</TD><TD WIDTH="18%">'
			if wasdenn > 4
				text2 += '<I>'
				do case
				case alleFelder[ I_TEILNEHMER3 ] == "1"
					text2 += MEMVAR->texte[ teiltnehmer, spr_uk ]
				case alleFelder[ I_TEILNEHMER3 ] == "2"
					text2 += MEMVAR->texte[ teilpartner, spr_uk ]
				case alleFelder[ I_TEILNEHMER3 ] == "3"
					text2 += MEMVAR->texte[ teilkind, spr_uk ]
				case alleFelder[ I_TEILNEHMER3 ] == "4"
					text2 += MEMVAR->texte[ teilfreund, spr_uk ]
				case alleFelder[ I_TEILNEHMER3 ] == "5"
					text2 += MEMVAR->texte[ teilredner, spr_uk ] 
				case alleFelder[ I_TEILNEHMER3 ] == "6"
					text2 += MEMVAR->texte[ teilorgan, spr_uk ]
				case alleFelder[ I_TEILNEHMER3 ] == "7"
					text2 += MEMVAR->texte[ teilsonst, spr_uk ]
				case alleFelder[ I_TEILNEHMER3 ] == "8"
					text2 += MEMVAR->texte[ teilbpart, spr_uk ]
				case alleFelder[ I_TEILNEHMER3 ] == "9"
					text2 += MEMVAR->texte[ teiltpart, spr_uk ]
				otherwise
					text2 += NBSP
				endcase
				text2 += "</I>"
			else
				text2 += CRLF + '<select name="F_TEILNEHMER3">'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_TEILNEHMER3 ] == "0", ' selected', '') + '>' + NBSP
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_TEILNEHMER3 ] == "2", ' selected', '') + '>' + MEMVAR->texte[ teilpartner, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR)"
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_TEILNEHMER3 ] == "3", ' selected', '') + '>' + MEMVAR->texte[ teilkind, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR)"
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="4"' + iif( alleFelder[ I_TEILNEHMER3 ] == "4", ' selected', '') + '>' + MEMVAR->texte[ teilfreund, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR)"
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="7"' + iif( alleFelder[ I_TEILNEHMER3 ] == "7", ' selected', '') + '>' + MEMVAR->texte[ teilsonst, spr_xx ] + " (" + transform( iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) ), "@E ###.##" ) + " EUR)"
				text2 += CRLF + '</select>'
			endif

			text2 += CRLF + '</TD><TD WIDTH="10%">'
			if wasdenn > 4
				text2 += "<I>"
				do case
				case alleFelder[ I_SHIRT3 ] == "0"
					text2 += NBSP
				case alleFelder[ I_SHIRT3 ] == "1"
					text2 += 'S'
				case alleFelder[ I_SHIRT3 ] == "2"
					text2 += 'M'
				case alleFelder[ I_SHIRT3 ] == "3"
					text2 += 'L'
				case alleFelder[ I_SHIRT3 ] == "4"
					text2 += 'XL'
				case alleFelder[ I_SHIRT3 ] == "5"
					text2 += 'XXL'
				case alleFelder[ I_SHIRT3 ] == "6"
					text2 += 'XS'
				case alleFelder[ I_SHIRT3 ] == "7"
					text2 += 'XXXL'
				endcase
				text2 += "</I>"
			else
				text2 += CRLF + '<select name="F_SHIRT3">'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_SHIRT3 ] == "0", ' selected', '') + '> '
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="6"' + iif( alleFelder[ I_SHIRT3 ] == "6", ' selected', '') + '>XS'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_SHIRT3 ] == "1", ' selected', '') + '>S'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_SHIRT3 ] == "2", ' selected', '') + '>M'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_SHIRT3 ] == "3", ' selected', '') + '>L'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="4"' + iif( alleFelder[ I_SHIRT3 ] == "4", ' selected', '') + '>XL'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="5"' + iif( alleFelder[ I_SHIRT3 ] == "5", ' selected', '') + '>XXL'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="7"' + iif( alleFelder[ I_SHIRT3 ] == "7", ' selected', '') + '>XXXL'
				text2 += CRLF + '</select>'
			endif

			text2 += CRLF + '</TD><TD WIDTH="8%">'
			if wasdenn > 4
				if alleFelder[ I_ANONYM3 ]
					text2 += "<I>"
					do case
					case spr_xx == spr_de
						text2 += "Ja"
					case spr_xx == spr_sp
						text2 += "S" + ir
					case spr_xx == spr_fr
						text2 += "Oui"
					otherwise
						text2 += "Yes"
					endcase
					text2 += "</I>"
				else
					text2 += NBSP
				endif
			else
				text2 += CRLF + '<input type=checkbox name="F_ANONYM3" value="on"' + iif( alleFelder[ I_ANONYM3 ], "checked", "" ) + '>'
			endif

			text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>'
			text2 += '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '">'
			text2 += '<TR><TD WIDTH="100%">' + NBSP + '</TD></TR></TABLE>' + CRLF
		endif
	endif

	if wasdenn <> 4
		text2 += CRLF + '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%" align="center"><B>' + MEMVAR->texte[ tshuttle, iif( wasdenn < 4, spr_xx, spr_uk ) ] + '</B>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="25%"><B>' + MEMVAR->texte[ tflughafen, iif( wasdenn < 4, spr_xx, spr_uk ) ] + '</B><BR>'
		if wasdenn > 4
			text2 += "<I>"
			do case
			case alleFelder[ I_SHUTTLE ] == "0"
				text2 += 'No need to pick up'
			case alleFelder[ I_SHUTTLE ] == "1"
				text2 += 'From Tegel (TXL) airport'
			case alleFelder[ I_SHUTTLE ] == "2"
				text2 += 'From Sch' + oe + 'nefeld (SXF) airport'
			endcase
			text2 += "</I>"
		else
			text2 += CRLF + '<select name="F_SHUTTLE">'
			do case
			case spr_xx == spr_de
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_SHUTTLE ] == "0", ' selected', '') + '>Abholen nicht n' + oe + 'tig'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_SHUTTLE ] == "1", ' selected', '') + '>Flughafen Tegel (TXL)'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_SHUTTLE ] == "2", ' selected', '') + '>Flughafen Sch' + oe + 'nefeld (SXF)'
			case spr_xx == spr_fr
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_SHUTTLE ] == "0", ' selected', '') + '>Recevoir n' + "'est pas n" + er + "cessaire"
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_SHUTTLE ] == "1", ' selected', '') + '>A' + er + 'roport Tegel (TXL)'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_SHUTTLE ] == "2", ' selected', '') + '>A' + er + 'roport Sch' + oe + 'nefeld (SXF)'
			case spr_xx == spr_sp
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_SHUTTLE ] == "0", ' selected', '') + '>No es necesario ir a buscarme'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_SHUTTLE ] == "1", ' selected', '') + '>Aeropuerto Tegel (TXL)'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_SHUTTLE ] == "2", ' selected', '') + '>Aeropuerto Sch' +oe + 'nefeld (SXF)'
			case spr_xx == spr_pt
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_SHUTTLE ] == "0", ' selected', '') + '>N' + ati + 'o ' + er + ' necess' + ar + 'rio buscarme no Aeroporto'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_SHUTTLE ] == "1", ' selected', '') + '>aeroporto Tegel (TXL)'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_SHUTTLE ] == "2", ' selected', '') + '>aeroporto Sch' +oe + 'nefeld (SXF)'
			otherwise
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_SHUTTLE ] == "0", ' selected', '') + '>No need to pick me up'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_SHUTTLE ] == "1", ' selected', '') + '>Tegel airport (TXL)'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_SHUTTLE ] == "2", ' selected', '') + '>Sch' + oe + 'nefeld airport (SXF)'
			endcase
			text2 += CRLF + '</select>'
		endif
		text2 += '</TD><TD WIDTH="15%"><B>' + MEMVAR->texte[ tuhrzeit, iif( wasdenn < 4, spr_xx, spr_uk ) ] + '</B><BR>'
		if wasdenn > 4
			text2 += "<I>" + iif( empty( alleFelder[ I_UHRAB ] ), NBSP, alleFelder[ I_UHRAB ] ) + "</I>"
		else
			text2 += '<input type=text name="F_UHRAB" value="' + alleFelder[ I_UHRAB ] + '" SIZE=5 MAXLENGTH=5>'
		endif
		text2 += '</TD><TD WIDTH="25%"><B>' + MEMVAR->texte[ thotel, iif( wasdenn < 4, spr_xx, spr_uk ) ] + '</B><BR>'
		if wasdenn > 4
			text2 += "<I>"
			do case
			case alleFelder[ I_SHUTTLER ] == "0"
				text2 += 'No need driving to the airport!'
			case alleFelder[ I_SHUTTLER ] == "1"
				text2 += 'To Tegel (TXL) airport'
			case alleFelder[ I_SHUTTLER ] == "2"
				text2 += 'To Sch' + oe + 'nefeld (SXF) airport'
			endcase
			text2 += "</I>"
		else
			text2 += CRLF + '<select name="F_SHUTTLER">'
			do case
			case spr_xx == spr_de
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_SHUTTLER ] == "0", ' selected', '') + '>Bringen nicht n' + oe + 'tig!'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_SHUTTLER ] == "1", ' selected', '') + '>zum Flughafen Tegel (TXL)'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_SHUTTLER ] == "2", ' selected', '') + '>zum Flughafen Sch' + oe + 'nefeld (SXF)'
			case spr_xx == spr_fr
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_SHUTTLER ] == "0", ' selected', '') + '>Reconduire n' + "'est pas n" + er + "cessaire"
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_SHUTTLER ] == "1", ' selected', '') + '>' + al + " l'a" + er + "roport Tegel (TXL)"
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_SHUTTLER ] == "2", ' selected', '') + '>' + al + " l'a" + er + "roport Sch" + oe + "nefeld (SXF)"
			case spr_xx == spr_sp
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_SHUTTLER ] == "0", ' selected', '') + '>No necesitan llevarme al aeropuerto'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_SHUTTLER ] == "1", ' selected', '') + '>al Aeropuerto Tegel (TXL)'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_SHUTTLER ] == "2", ' selected', '') + '>al Aeropuerto Sch' +oe + 'nefeld (SXF)'
			case spr_xx == spr_pt
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_SHUTTLER ] == "0", ' selected', '') + '>N' + ati + 'o preciso transporte at' + er + ' o aeroporto'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_SHUTTLER ] == "1", ' selected', '') + '>ao aeroporto Tegel (TXL)'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_SHUTTLER ] == "2", ' selected', '') + '>ao aeroporto Sch' +oe + 'nefeld (SXF)'
			otherwise
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_SHUTTLER ] == "0", ' selected', '') + '>No need to drive me to the airport'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_SHUTTLER ] == "1", ' selected', '') + '>to Tegel airport (TXL)'
				text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_SHUTTLER ] == "2", ' selected', '') + '>to Sch' + oe + 'nefeld airport (SXF)'
			endcase
			text2 += CRLF + '</select>'
		endif
		text2 += '</TD><TD WIDTH="25%"><B>' + MEMVAR->texte[ tuhrzeit, iif( wasdenn < 4, spr_xx, spr_uk ) ] + '</B><BR>'
		if wasdenn > 4
			text2 += "<I>" + iif( empty( alleFelder[ I_UHRHIN ] ), NBSP, alleFelder[ I_UHRHIN ] ) + "</I>"
		else
			text2 += CRLF + '<input type=text name="F_UHRHIN" value="' + alleFelder[ I_UHRHIN ] + '" SIZE=5 MAXLENGTH=5>'
		endif
		text2 += '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>'
		text2 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="25%">' + NBSP + '</TD><TD WIDTH="15%">' + NBSP + '</TD><TD WIDTH="25%">' + NBSP + '</TD><TD WIDTH="25%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>'
	endif	

	if wasdenn < 2
		text2 += '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0>'
		text2 += '<TR><TD WIDTH="100%">' + NBSP + '</TD></TR>' + CRLF
		text2 += '<TR><TD WIDTH="100%"><CENTER><H1>' + MEMVAR->texte[ statistiktit, spr_xx ] + '</H1></CENTER></TD></TR>' + CRLF
		text2 += '<TR><TD WIDTH="100%">' + NBSP + '</TD></TR></TABLE>' + CRLF

		text2 += '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + uehint + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%"><CENTER><FONT COLOR="' + ueber + '" SIZE=+1><B>' + MEMVAR->texte[ xbasesprachen, spr_xx ] + '</B></FONT></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%">' + NBSP
		text2 += CRLF + '</TD><TD WIDTH="15%"><CENTER><B>' + MEMVAR->texte[ ksnutze, spr_xx ] + '</B></CENTER></TD><TD WIDTH="15%"><CENTER><B>' + MEMVAR->texte[ kshatte, spr_xx ] + '</B></CENTER></TD><TD WIDTH="15%"><CENTER><B>' + MEMVAR->texte[ kskenne, spr_xx ] + '</B></CENTER></TD><TD WIDTH="15%"><CENTER><B>' + MEMVAR->texte[ ksnicht, spr_xx ] + '</B></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '"><B>Delphi</B></FONT>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSDELPHI" value="1"' + iif( alleFelder[ I_KSDELPHI ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSDELPHI" value="2"' + iif( alleFelder[ I_KSDELPHI ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSDELPHI" value="3"' + iif( alleFelder[ I_KSDELPHI ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSDELPHI" value="0"' + iif( alleFelder[ I_KSDELPHI ] == "0", "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + vorder +'"><FONT COLOR="' + tfarbe2 + '"><B>FoxPro</B></FONT>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSFOXPRO" value="1"' + iif( alleFelder[ I_KSFOXPRO ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSFOXPRO" value="2"' + iif( alleFelder[ I_KSFOXPRO ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSFOXPRO" value="3"' + iif( alleFelder[ I_KSFOXPRO ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSFOXPRO" value="0"' + iif( alleFelder[ I_KSFOXPRO ] == "0", "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '"><B>Flagship</B></FONT>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSFLAGSHIP" value="1"' + iif( alleFelder[ I_KSFLAGSHIP ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSFLAGSHIP" value="2"' + iif( alleFelder[ I_KSFLAGSHIP ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSFLAGSHIP" value="3"' + iif( alleFelder[ I_KSFLAGSHIP ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSFLAGSHIP" value="0"' + iif( alleFelder[ I_KSFLAGSHIP ] == "0", "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + vorder +'"><FONT COLOR="' + tfarbe2 + '"><B>Clipper</B></FONT>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSCLIPPER" value="1"' + iif( alleFelder[ I_KSCLIPPER ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSCLIPPER" value="2"' + iif( alleFelder[ I_KSCLIPPER ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSCLIPPER" value="3"' + iif( alleFelder[ I_KSCLIPPER ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSCLIPPER" value="0"' + iif( alleFelder[ I_KSCLIPPER ] == "0", "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '"><B>Clip4Win</B></FONT>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSCLIP4WIN" value="1"' + iif( alleFelder[ I_KSCLIP4WIN ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSCLIP4WIN" value="2"' + iif( alleFelder[ I_KSCLIP4WIN ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSCLIP4WIN" value="3"' + iif( alleFelder[ I_KSCLIP4WIN ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSCLIP4WIN" value="0"' + iif( alleFelder[ I_KSCLIP4WIN ] == "0", "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + vorder +'"><FONT COLOR="' + tfarbe2 + '"><B>dBase</B></FONT>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSDBASE" value="1"' + iif( alleFelder[ I_KSDBASE ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSDBASE" value="2"' + iif( alleFelder[ I_KSDBASE ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSDBASE" value="3"' + iif( alleFelder[ I_KSDBASE ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSDBASE" value="0"' + iif( alleFelder[ I_KSDBASE ] == "0", "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '"><B>Visual Objects</B></FONT>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSVO" value="1"' + iif( alleFelder[ I_KSVO ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSVO" value="2"' + iif( alleFelder[ I_KSVO ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSVO" value="3"' + iif( alleFelder[ I_KSVO ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSVO" value="0"' + iif( alleFelder[ I_KSVO ] == "0", "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + vorder +'"><FONT COLOR="' + tfarbe2 + '"><B>xHarbour</B></FONT>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSXHARBOUR" value="1"' + iif( alleFelder[ I_KSXHARBOUR ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSXHARBOUR" value="2"' + iif( alleFelder[ I_KSXHARBOUR ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSXHARBOUR" value="3"' + iif( alleFelder[ I_KSXHARBOUR ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSXHARBOUR" value="0"' + iif( alleFelder[ I_KSXHARBOUR ] == "0", "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + hinter +'"><input type=text name="F_SONSTIGE1" value="' + alleFelder[ I_SONSTIGE1 ] + '" SIZE=20 MAXLENGTH=20>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSSONSTIG1" value="1"' + iif( alleFelder[ I_KSSONSTIG1 ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSSONSTIG1" value="2"' + iif( alleFelder[ I_KSSONSTIG1 ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSSONSTIG1" value="3"' + iif( alleFelder[ I_KSSONSTIG1 ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%">' + NBSP //<input type=radio name="F_KSSONSTIG1" value="0"' + iif( alleFelder[ I_KSSONSTIG1 ] == "0", "checked", "" ) + '>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + vorder +'"><input type=text name="F_SONSTIGE2" value="' + alleFelder[ I_SONSTIGE2 ] + '" SIZE=20 MAXLENGTH=20>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSSONSTIG2" value="1"' + iif( alleFelder[ I_KSSONSTIG2 ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSSONSTIG2" value="2"' + iif( alleFelder[ I_KSSONSTIG2 ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSSONSTIG2" value="3"' + iif( alleFelder[ I_KSSONSTIG2 ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%">' + NBSP //<input type=radio name="F_KSSONSTIG2" value="0"' + iif( alleFelder[ I_KSSONSTIG2 ] == "0", "checked", "" ) + '>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + hinter +'"><input type=text name="F_SONSTIGE3" value="' + alleFelder[ I_SONSTIGE3 ] + '" SIZE=20 MAXLENGTH=20>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSSONSTIG3" value="1"' + iif( alleFelder[ I_KSSONSTIG3 ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSSONSTIG3" value="2"' + iif( alleFelder[ I_KSSONSTIG3 ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSSONSTIG3" value="3"' + iif( alleFelder[ I_KSSONSTIG3 ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%">' + NBSP //<input type=radio name="F_KSSONSTIG3" value="0"' + iif( alleFelder[ I_KSSONSTIG3 ] == "0", "checked", "" ) + '>'

		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>'
		text2 += CRLF + '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%">' + NBSP + '</TD><TD WIDTH="15%">' + NBSP + '</TD><TD WIDTH="15%">' + NBSP + '</TD><TD WIDTH="15%">' + NBSP + '</TD><TD WIDTH="15%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>'
		text2 += CRLF + '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0><TR><TD WIDTH="100%">' + NBSP + '</TD></TR></TABLE>' + CRLF

		text2 += '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + uehint + '"><TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%"><CENTER><FONT COLOR="' + ueber + '" SIZE=+1><B>' + MEMVAR->texte[ addons, spr_xx ] + '</B></FONT></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%">' + NBSP
		text2 += CRLF + '</TD><TD WIDTH="15%"><CENTER><B>' + MEMVAR->texte[ ksnutze, spr_xx ] + '</B></CENTER></TD><TD WIDTH="15%"><CENTER><B>' + MEMVAR->texte[ addonwill, spr_xx ] + '</B></CENTER></TD><TD WIDTH="15%"><CENTER><B>' + MEMVAR->texte[ kskenne, spr_xx ] + '</B></CENTER></TD><TD WIDTH="15%"><CENTER><B>' + MEMVAR->texte[ ksnicht, spr_xx ] + '</B></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '"><B>TopDown</B></FONT>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSTOPDOWN" value="1"' + iif( alleFelder[ I_KSTOPDOWN ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSTOPDOWN" value="2"' + iif( alleFelder[ I_KSTOPDOWN ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSTOPDOWN" value="3"' + iif( alleFelder[ I_KSTOPDOWN ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSTOPDOWN" value="0"' + iif( alleFelder[ I_KSTOPDOWN ] == "0", "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + vorder +'"><FONT COLOR="' + tfarbe2 + '"><B>eXpress++</B></FONT>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSEXPRESS" value="1"' + iif( alleFelder[ I_KSEXPRESS ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSEXPRESS" value="2"' + iif( alleFelder[ I_KSEXPRESS ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSEXPRESS" value="3"' + iif( alleFelder[ I_KSEXPRESS ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSEXPRESS" value="0"' + iif( alleFelder[ I_KSEXPRESS ] == "0", "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '"><B>FiveWin</B></FONT>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSFIVEWIN" value="1"' + iif( alleFelder[ I_KSFIVEWIN ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSFIVEWIN" value="2"' + iif( alleFelder[ I_KSFIVEWIN ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSFIVEWIN" value="3"' + iif( alleFelder[ I_KSFIVEWIN ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSFIVEWIN" value="0"' + iif( alleFelder[ I_KSFIVEWIN ] == "0", "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + vorder +'"><FONT COLOR="' + tfarbe2 + '"><B>SQLExpress</B></FONT>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSSQLEXPRE" value="1"' + iif( alleFelder[ I_KSSQLEXPRE ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSSQLEXPRE" value="2"' + iif( alleFelder[ I_KSSQLEXPRE ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSSQLEXPRE" value="3"' + iif( alleFelder[ I_KSSQLEXPRE ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSSQLEXPRE" value="0"' + iif( alleFelder[ I_KSSQLEXPRE ] == "0", "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '"><B>Xb2.NET</B></FONT>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSXB2NET" value="1"' + iif( alleFelder[ I_KSXB2NET ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSXB2NET" value="2"' + iif( alleFelder[ I_KSXB2NET ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSXB2NET" value="3"' + iif( alleFelder[ I_KSXB2NET ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSXB2NET" value="0"' + iif( alleFelder[ I_KSXB2NET ] == "0", "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + vorder +'"><FONT COLOR="' + tfarbe2 + '"><B>XClass++</B></FONT>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSXCLASS" value="1"' + iif( alleFelder[ I_KSXCLASS ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSXCLASS" value="2"' + iif( alleFelder[ I_KSXCLASS ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSXCLASS" value="3"' + iif( alleFelder[ I_KSXCLASS ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSXCLASS" value="0"' + iif( alleFelder[ I_KSXCLASS ] == "0", "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '"><B>xbHCL</B></FONT>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSXBHCL" value="1"' + iif( alleFelder[ I_KSXBHCL ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSXBHCL" value="2"' + iif( alleFelder[ I_KSXBHCL ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSXBHCL" value="3"' + iif( alleFelder[ I_KSXBHCL ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSXBHCL" value="0"' + iif( alleFelder[ I_KSXBHCL ] == "0", "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + vorder +'"><FONT COLOR="' + tfarbe2 + '"><B>Cockpit</B></FONT>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSCOCKPIT" value="1"' + iif( alleFelder[ I_KSCOCKPIT ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSCOCKPIT" value="2"' + iif( alleFelder[ I_KSCOCKPIT ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSCOCKPIT" value="3"' + iif( alleFelder[ I_KSCOCKPIT ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSCOCKPIT" value="0"' + iif( alleFelder[ I_KSCOCKPIT ] == "0", "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '"><B>MarshallSoft</B></FONT>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSMARSHALL" value="1"' + iif( alleFelder[ I_KSMARSHALL ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSMARSHALL" value="2"' + iif( alleFelder[ I_KSMARSHALL ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSMARSHALL" value="3"' + iif( alleFelder[ I_KSMARSHALL ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSMARSHALL" value="0"' + iif( alleFelder[ I_KSMARSHALL ] == "0", "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + vorder +'"><FONT COLOR="' + tfarbe2 + '"><B>List &amp; Label</B></FONT>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSLLABEL" value="1"' + iif( alleFelder[ I_KSLLABEL ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSLLABEL" value="2"' + iif( alleFelder[ I_KSLLABEL ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSLLABEL" value="3"' + iif( alleFelder[ I_KSLLABEL ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSLLABEL" value="0"' + iif( alleFelder[ I_KSLLABEL ] == "0", "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '"><B>VPE</B></FONT>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSVPE" value="1"' + iif( alleFelder[ I_KSVPE ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSVPE" value="2"' + iif( alleFelder[ I_KSVPE ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSVPE" value="3"' + iif( alleFelder[ I_KSVPE ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSVPE" value="0"' + iif( alleFelder[ I_KSVPE ] == "0", "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + vorder +'"><FONT COLOR="' + tfarbe2 + '"><B>R&amp;R</B></FONT>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSRUNDR" value="1"' + iif( alleFelder[ I_KSRUNDR ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSRUNDR" value="2"' + iif( alleFelder[ I_KSRUNDR ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSRUNDR" value="3"' + iif( alleFelder[ I_KSRUNDR ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSRUNDR" value="0"' + iif( alleFelder[ I_KSRUNDR ] == "0", "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + hinter +'"><input type=text name="F_ADDONSONS1" value="' + alleFelder[ I_ADDONSONS1 ] + '" SIZE=20 MAXLENGTH=20>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSADDOSON1" value="1"' + iif( alleFelder[ I_KSADDOSON1 ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSADDOSON1" value="2"' + iif( alleFelder[ I_KSADDOSON1 ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSADDOSON1" value="3"' + iif( alleFelder[ I_KSADDOSON1 ] == "3", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%">' + NBSP //<input type=radio name="F_KSADDOSON1" value="0"' + iif( alleFelder[ I_KSADDOSON1 ] == "0", "checked", "" ) + '>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + vorder +'"><input type=text name="F_ADDONSONS2" value="' + alleFelder[ I_ADDONSONS2 ] + '" SIZE=20 MAXLENGTH=20>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSADDOSON2" value="1"' + iif( alleFelder[ I_KSADDOSON2 ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSADDOSON2" value="2"' + iif( alleFelder[ I_KSADDOSON2 ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_KSADDOSON2" value="3"' + iif( alleFelder[ I_KSADDOSON2 ] == "3", "checked", "" ) + '></TD><TD WIDTH="15%">' + NBSP //<input type=radio name="F_KSADDOSON2" value="0"' + iif( alleFelder[ I_KSADDOSON2 ] == "0", "checked", "" ) + '>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + hinter +'"><input type=text name="F_ADDONSONS3" value="' + alleFelder[ I_ADDONSONS3 ] + '" SIZE=20 MAXLENGTH=20>'
		text2 += '</TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSADDOSON3" value="1"' + iif( alleFelder[ I_KSADDOSON3 ] == "1", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSADDOSON3" value="2"' + iif( alleFelder[ I_KSADDOSON3 ] == "2", "checked", "" ) + '></CENTER></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_KSADDOSON3" value="3"' + iif( alleFelder[ I_KSADDOSON3 ] == "3", "checked", "" ) + '></TD><TD WIDTH="15%">' + NBSP //<input type=radio name="F_KSADDOSON3" value="0"' + iif( alleFelder[ I_KSADDOSON3 ] == "0", "checked", "" ) + '>'

		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>'
		text2 += CRLF + '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%">' + NBSP + '</TD><TD WIDTH="15%">' + NBSP + '</TD><TD WIDTH="15%">' + NBSP + '</TD><TD WIDTH="15%">' + NBSP + '</TD><TD WIDTH="15%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>'
		text2 += CRLF + '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0><TR><TD WIDTH="100%">' + NBSP + '</TD></TR></TABLE>' + CRLF

		text2 += '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + uehint + '"><TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%"><CENTER><FONT COLOR="' + ueber + '" SIZE=+1><B>' + MEMVAR->texte[ interessen, spr_xx ] + '</B></FONT></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%">' + NBSP
		text2 += CRLF + '</TD><TD WIDTH="20%"><CENTER><B>' + MEMVAR->texte[ interja, spr_xx ] + '</B></CENTER></TD><TD WIDTH="20%"><CENTER><B>' + MEMVAR->texte[ internein, spr_xx ] + '</B></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="20%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '"><B>' + MEMVAR->texte[ intsql, spr_xx ] + '</B></FONT>'
		text2 += '</TD><TD WIDTH="20%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_INTSQL" value="1"' + iif( alleFelder[ I_INTSQL ], "checked", "" ) + '></CENTER></TD><TD WIDTH="20%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_INTSQL" value="2"' + iif( .not. alleFelder[ I_INTSQL ], "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="20%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + vorder +'"><FONT COLOR="' + tfarbe2 + '"><B>' + MEMVAR->texte[ intweb, spr_xx ] + '</B></FONT>'
		text2 += '</TD><TD WIDTH="20%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_INTWEBANB" value="1"' + iif( alleFelder[ I_INTWEBANB ], "checked", "" ) + '></CENTER></TD><TD WIDTH="20%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_INTWEBANB" value="2"' + iif( .not. alleFelder[ I_INTWEBANB ], "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="20%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '"><B>' + MEMVAR->texte[ intmig, spr_xx ] + '</B></FONT>'
		text2 += '</TD><TD WIDTH="20%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_INTMIGRAT" value="1"' + iif( alleFelder[ I_INTMIGRAT ], "checked", "" ) + '></CENTER></TD><TD WIDTH="20%" BGCOLOR="' + hinter +'"><CENTER><input type=radio name="F_INTMIGRAT" value="2"' + iif( .not. alleFelder[ I_INTMIGRAT ], "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="20%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + vorder +'"><FONT COLOR="' + tfarbe2 + '"><B>' + MEMVAR->texte[ intactivex, spr_xx ] + '</B></FONT>'
		text2 += '</TD><TD WIDTH="20%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_INTACTIVEX" value="1"' + iif( alleFelder[ I_INTACTIVEX ], "checked", "" ) + '></CENTER></TD><TD WIDTH="20%" BGCOLOR="' + vorder +'"><CENTER><input type=radio name="F_INTACTIVEX" value="2"' + iif( .not. alleFelder[ I_INTACTIVEX ], "checked", "" ) + '></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="20%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + hinter +'"><input type=text name="F_INTSONSTI1" value="' + alleFelder[ I_INTSONSTI1 ] + '" SIZE=20 MAXLENGTH=20>'
		text2 += '</TD><TD WIDTH="20%">' + NBSP + '</TD><TD WIDTH="20%">' + NBSP
		text2 += CRLF + '</TD><TD WIDTH="20%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + vorder +'"><input type=text name="F_INTSONSTI2" value="' + alleFelder[ I_INTSONSTI2 ] + '" SIZE=20 MAXLENGTH=20>'
		text2 += '</TD><TD WIDTH="20%">' + NBSP + '</TD><TD WIDTH="20%">' + NBSP
		text2 += CRLF + '</TD><TD WIDTH="20%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%" BGCOLOR="' + hinter +'"><input type=text name="F_INTSONSTI3" value="' + alleFelder[ I_INTSONSTI3 ] + '" SIZE=20 MAXLENGTH=20>'
		text2 += '</TD><TD WIDTH="20%">' + NBSP + '</TD><TD WIDTH="20%">' + NBSP
		text2 += CRLF + '</TD><TD WIDTH="20%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>'

		text2 += CRLF + '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="30%">' + NBSP + '</TD><TD WIDTH="20%">' + NBSP + '</TD><TD WIDTH="20%">' + NBSP + '</TD><TD WIDTH="20%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>'
		text2 += CRLF + '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0><TR><TD WIDTH="100%">' + NBSP + '</TD></TR></TABLE>'
	elseif ( wasdenn > 2 ) .and. ( wasdenn < 5 )
		text2 += CRLF + '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0><TR><TD WIDTH="100%">' + NBSP + '</TD></TR></TABLE>' + CRLF
		text2 += '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + uehint + '"><TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%"><CENTER><FONT COLOR="' + ueber + '" SIZE=+1><B>Workshop am Welcome ' + un + ' Vendor Day</B></FONT></CENTER>'
		text2 += CRLF + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR valign="middle"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="15%"><B>' + MEMVAR->texte[ textsaal, spr_uk ] + '</B><BR>'
		text2 += CRLF + '<select name="F_SAAL">'
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_SAAL ] == "0", ' selected', '') + '>' + NBSP
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_SAAL ] == "1", ' selected', '') + '>hall 1'
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_SAAL ] == "2", ' selected', '') + '>hall 2'
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_SAAL ] == "3", ' selected', '') + '>little hall'
		text2 += CRLF + '</select>'
		y:= len( MEMVAR->pcws )
		aSaal := { "hall 1", "hall 2", "little hall" }
		aZeit := { "13:00", "14:30", "16:00", "17:30" }
		for x := 1 to y
			if .not. ( alleFelder[ I_TEILNEHMID ] == MEMVAR->pcws[ x, 3 ] )
				text2 += CRLF + '<BR>' + aSaal[ MEMVAR->pcws[ x, 1 ] ]
			endif
		next
		text2 += CRLF + '</TD><TD WIDTH="15%"><B>' + MEMVAR->texte[ textzeit, spr_uk ] + '</B><BR>'
		text2 += CRLF + '<select name="F_ZEIT">'
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="0"' + iif( alleFelder[ I_ZEIT ] == "0", ' selected', '') + '>' + NBSP
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="1"' + iif( alleFelder[ I_ZEIT ] == "1", ' selected', '') + '>13:00'
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="2"' + iif( alleFelder[ I_ZEIT ] == "2", ' selected', '') + '>14:30'
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="3"' + iif( alleFelder[ I_ZEIT ] == "3", ' selected', '') + '>16:00'
		text2 += CRLF + chr( xbeK_TAB ) + '<option value="4"' + iif( alleFelder[ I_ZEIT ] == "4", ' selected', '') + '>17:30'
		text2 += CRLF + '</select>'
		for x := 1 to y
			if .not. ( alleFelder[ I_TEILNEHMID ] == MEMVAR->pcws[ x, 3 ] )
				text2 += CRLF + '<BR>' + aZeit[ MEMVAR->pcws[ x, 2 ] ] + " o'clock"
			endif
		next
		text2 += CRLF + '</TD><TD WIDTH="60%"><B>' + MEMVAR->texte[ textthema, spr_uk ] + '</B><BR>'
		text2 += CRLF + '<textarea name="F_THEMA" cols="70" rows="10">' + alleFelder[ I_THEMA ] + '</textarea></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>'
		text2 += CRLF + '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="15%">' + NBSP + '</TD><TD WIDTH="15%">' + NBSP + '</TD><TD WIDTH="60%">' + NBSP + '</TD></TR></TABLE>'
	
	endif

	oClient:setCargo( "FELDER", alleFelder )

RETURN text2


PROCEDURE OpenDBF()
	IF Select( "Melde" ) > 0
		RETURN
	ENDIF

	USE ( datenpfad + "\devcon" ) NEW ALIAS Melde

	IF Select( "PCW" ) > 0
		RETURN
	ENDIF

	USE ( datenpfad + "\pcd" ) NEW ALIAS PCW
RETURN


PROCEDURE CloseDBF()
	IF Select( "Melde" ) > 0
		SELECT Melde
		IF Used()
			DbCloseArea()
		ENDIF
	endif
	IF Select( "PCW" ) > 0
		SELECT PCW
		IF Used()
			DbCloseArea()
		ENDIF
	endif
RETURN

FUNCTION MeldeHeader( formname, feldname, spr )
	local text1, bla
	text1 := ConvToANSICp( "<HTML><HEAD>" ) + CRLF
	text1 += ConvToANSICp( '<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">' ) + CRLF
	text1 += ConvToANSICp( '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">' ) + CRLF
	text1 += ConvToANSICp( '<META HTTP-EQUIV="Cache-Control" CONTENT="no-cache">' ) + CRLF
	text1 += ConvToANSICp( '<META HTTP-EQUIV="Expires" CONTENT="-1">' ) + CRLF
	bla := strtran( alltrim( MEMVAR->texte[ devconueber, spr ] ), "</SUP>", "" )
	text1 += ConvToANSICp( "<TITLE>" + strtran( alltrim( bla ), "<SUP>", "" ) + "</TITLE>" ) + CRLF
	text1 += ConvToANSICp( '<link rel="stylesheet" href="devcon.css" type="text/css"></HEAD><BODY' ) + CRLF
	if .not. empty( feldname )
		text1 += ConvToANSICp( ' onload="self.focus();document.' + formname + '.' + feldname + '.focus()"' )
	endif
	text1 += ConvToANSICp( ' bgcolor="' + MEMVAR->shinter + '">' ) + CRLF
	text1 += ConvToANSICp( '<CENTER>' )
	text1 += ConvToANSICp( '<H1>' + alltrim( MEMVAR->texte[ devconueber, spr ] ) + "</H1>" ) + CRLF
	text1 += ConvToANSICp( '<HR WIDTH="100%">' )
RETURN text1

FUNCTION EditAttendeeHeader( formname, feldname, spr )
	local text1, bla
	text1 := ConvToANSICp( "<HTML><HEAD>" ) + CRLF
	text1 += ConvToANSICp( '<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">' ) + CRLF
	text1 += ConvToANSICp( '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">' ) + CRLF
	text1 += ConvToANSICp( '<META HTTP-EQUIV="Cache-Control" CONTENT="no-cache">' ) + CRLF
	text1 += ConvToANSICp( '<META HTTP-EQUIV="Expires" CONTENT="-1">' ) + CRLF
	bla := strtran( alltrim( MEMVAR->texte[ devconueber, spr ] ), "</SUP>", "" )
	text1 += ConvToANSICp( "<TITLE>" + strtran( alltrim( bla ), "<SUP>", "" ) + "</TITLE>" ) + CRLF
	text1 += '<script type="text/javascript">' + CRLF
	text1 += '<!--' + CRLF
	text1 += 'function Datum() {' + CRLF
	text1 += '   document.' + formname + '.F_ZAHLEINGAN.value = "' + DToC( Date() ) + '";' + CRLF
	text1 += '   document.' + formname + '.F_ZAHLART.value = "3";' + CRLF
	text1 += '}' + CRLF
	text1 += '//-->' + CRLF
	text1 += '</script>' + CRLF
	text1 += ConvToANSICp( '<link rel="stylesheet" href="devcon.css" type="text/css"></HEAD><BODY' ) + CRLF
	if .not. empty( feldname )
		text1 += ConvToANSICp( ' onload="self.focus();document.' + formname + '.' + feldname + '.focus()"' )
	endif
	text1 += ConvToANSICp( ' bgcolor="' + MEMVAR->shinter + '">' ) + CRLF
	text1 += ConvToANSICp( '<CENTER>' )
	text1 += ConvToANSICp( '<H1>' + alltrim( MEMVAR->texte[ devconueber, spr ] ) + "</H1>" ) + CRLF
	text1 += ConvToANSICp( '<HR WIDTH="100%">' )
RETURN text1

FUNCTION Fehlermeldung( title, text )
local text1
	text1 := '<CENTER><P><TABLE WIDTH="500" BORDER="0" CELLPADDING="4" CELLSPACING="0">' + CRLF
	text1 += '<TR><TD WIDTH="34" BGCOLOR="#000066" HEIGHT="30">&nbsp;</TD>'
	text1 += '<TD VALIGN="MIDDLE" ALIGN="LEFT" BGCOLOR="#000066" HEIGHT="30" WIDTH="450">'
	text1 += '<FONT FACE="Tahoma, Arial, Helvetica, sans-serif" SIZE="2" COLOR="' + MEMVAR->shinter + '">'
	text1 += "<B>" + title + "</B></FONT></TD></TR>" + CRLF
	text1 += '<TR BGCOLOR="#CCCCCC"><TD WIDTH="34">&nbsp;</TD>'
	text1 += '<TD  VALIGN="TOP" WIDTH="450"><font face="Tahoma, Arial, Helvetica, sans-serif" size="2">'
	text1 += "&nbsp;<BR>" + text + "<BR>&nbsp;</FONT></TD></TR>" + CRLF
	text1 += "</TABLE><P>" + CRLF
	text1 += "</CENTER><P><P>" + CRLF
RETURN text1

/*
 * Create the HTML footer used by almost all pages
 */
FUNCTION MeldeFooter()
Local oClient  := ThreadObject()
local sprache, text

	text := '<P><HR width="80%"><P>'
	text += CRLF + '<table BORDER="0" CELLSPACING="0" CELLPADDING="0" ALIGN="CENTER" width="80%">'
	text += CRLF + '<tr><td width="10%">'
	text += CRLF + '<a href="http://www.alaska-software.com/" target="_blank"><img src="http://' + MEMVAR->cWebserver + '/headpic.gif" width="210" height="100" border="0" alt="Alaska Software"></a>'
	text += '</td><td width="60%" align=center><a href="http://www.rmchart.com/" target="_blank"><img src="http://' + MEMVAR->cWebserver + '/rmchart.gif" width="228" height="99" border="0" alt="RMChart"></a></td><td width="10%">' + CRLF
	text += CRLF + '<a href="http://www.xb2.net/" target="_blank"><img src="http://' + MEMVAR->cWebserver + '/powered.gif" width="102" height="70" border="0" alt="Xb2.NET" align="right"></a>'
	text += CRLF + '</td></tr></table></BODY></HTML>'

RETURN text

FUNCTION SaveEntry( satz, text1, art, lAusgabe, alleFelder )
	local oClient := ThreadObject()
	LOCAL cTime      := ( val( left( time(), 2 ) ) * 100 ) + val( substr( time(), 4, 2 ) )
	local sprache, sch, lRLock, i
	local text, n, dDatum, aFile
	local fehlertext, ueberschr

	SET EPOCH TO year( date() ) - 20
	SET DATE FORMAT TO "dd.mm.yyyy"

	ueberschr := ""
	fehlertext := ""
	if art == 4
		n := ascan( MEMVAR->pcws, { |a| a[ 3 ] == alleFelder[ I_TEILNEHMID ] } )
		if n > 0
			if val( alleFelder[ I_SAAL ] ) > 0
				select PCW
				PCW->( DbGoTop() )
				do while ( .not. PCW->( eof() ) ) .and. ( PCW->TEILNEHMID <> alleFelder[ I_TEILNEHMID ] )
					skip
				enddo
				if ( PCW->TEILNEHMID == alleFelder[ I_TEILNEHMID ] )
					i := 0
					DO WHILE ( .NOT. ( lRLock := DbRLock( recno() ) ) ) .and. ( i < 3 )
						Sleep( 50 )
						i++
					ENDDO
					IF ! lRLock
						if lAusgabe
							do case
							case sprache == "de"
								ueberschr := "Datei nicht verf" + ue + "gbar"
								fehlertext := "Ihre Eingaben k" + oe + "nnen zur Zeit leider nicht verarbeitet werden!"
							case sprache == "fr"
								ueberschr := "Fichier n'est pas offert"
								fehlertext := "C'est pas possible de stocker votre entr" + er + "e au moment!"
							case sprache == "uk"
								ueberschr := "Unavailable file"
								fehlertext := "Sorry, your data cannot be processed at the moment!"
							case sprache == "sp"
								ueberschr := "Fichero no disponible"
								fehlertext := "Disculpe, sus datos no pueden ser procesados en este momento!"
							case sprache == "pt"
								ueberschr := "Arquivo n" + ati + "o dispon" + ir + "vel"
								fehlertext := "Desculpe, seus dados n" + ati + "o poden serem processados neste momento!"
							endcase
							oClient:HTTPResponse:Content := '<html><head><meta http-equiv="content-type" content="text/html; charset=ISO-8859-1"><title>' + ueberschr + '</title><link rel="stylesheet" href="devcon.css" type="text/css"></head><body BGCOLOR="' + MEMVAR->shinter + '">' + Fehlermeldung( ueberschr, fehlertext ) + "</BODY></HTML>"
						endif
						CloseDbf()
						RETURN .f.
					ENDIF
					PCW->ZEIT := val( alleFelder[ I_ZEIT ] )
					PCW->SAAL := val( alleFelder[ I_SAAL ] )
					MemoWrit( datenpfad + "\" + alleFelder[ I_TEILNEHMID ] + ".pcw", alleFelder[ I_THEMA ] )
				endif
			else
				Select PCW
				PCW->( DbCloseArea() )
				USE ( datenpfad + "\pcd" ) NEW ALIAS PCW EXCLUSIVE
				PCW->( DbGoTop() )
				do while ( .not. PCW->( eof() ) ) .and. ( PCW->TEILNEHMID <> alleFelder[ I_TEILNEHMID ] )
					skip
				enddo
				if ( PCW->TEILNEHMID == alleFelder[ I_TEILNEHMID ] )
					PCW->( DbDelete() )
					PCW->( DbPack() )
					delete file ( datenpfad + "\" + alleFelder[ I_TEILNEHMID ] + ".pcw" )
				endif
			endif
		elseif val( alleFelder[ I_SAAL ] ) > 0
			select PCW
			PCW->( DbGoTop() )
			do while ( .not. PCW->( eof() ) ) .and. ( PCW->TEILNEHMID <> alleFelder[ I_TEILNEHMID ] )
				skip
			enddo
			if ( PCW->TEILNEHMID <> alleFelder[ I_TEILNEHMID ] )
				append blank
				PCW->TEILNEHMID := alleFelder[ I_TEILNEHMID ] 
			endif
			PCW->ZEIT := val( alleFelder[ I_ZEIT ] )
			PCW->SAAL := val( alleFelder[ I_SAAL ] )
			MemoWrit( datenpfad + "\" + alleFelder[ I_TEILNEHMID ] + ".pcw", alleFelder[ I_THEMA ] )
		endif
	else
		select Melde
		if ( ( satz == 0 ) .and. ( art <> 2 ) )
			append blank
		else
			goto satz
		endif

		i := 0
		DO WHILE ( .NOT. ( lRLock := DbRLock( recno() ) ) ) .and. ( i < 3 )
			Sleep( 50 )
			i++
		ENDDO
		IF ! lRLock
			if lAusgabe
				do case
				case sprache == "de"
					ueberschr := "Datei nicht verf" + ue + "gbar"
					fehlertext := "Ihre Eingaben k" + oe + "nnen zur Zeit leider nicht verarbeitet werden!"
				case sprache == "fr"
					ueberschr := "Fichier n'est pas offert"
					fehlertext := "C'est pas possible de stocker votre entr" + er + "e au moment!"
				case sprache == "uk"
					ueberschr := "Unavailable file"
					fehlertext := "Sorry, your data cannot be processed at the moment!"
				case sprache == "sp"
					ueberschr := "Fichero no disponible"
					fehlertext := "Disculpe, sus datos no pueden ser procesados en este momento!"
				case sprache == "pt"
					ueberschr := "Arquivo n" + ati + "o dispon" + ir + "vel"
					fehlertext := "Desculpe, seus dados n" + ati + "o poden serem processados neste momento!"
				endcase
				oClient:HTTPResponse:Content := '<html><head><meta http-equiv="content-type" content="text/html; charset=ISO-8859-1"><title>' + ueberschr + '</title><link rel="stylesheet" href="devcon.css" type="text/css"></head><body BGCOLOR="' + MEMVAR->shinter + '">' + Fehlermeldung( ueberschr, fehlertext ) + "</BODY></HTML>"
			else
				SaveToFile( ConvToAnsiCp( "______ Xb2.NET ERROR __________ Access error _________________" + DtoC( Date() ) + "_" + Time() + CRLF + "Data cannot be stored!" ), SERVER_ERR_LOG_FILE )
			endif
			CloseDbf()
			RETURN .f.
		ENDIF
		dDatum := date()
		if ( art == 1 ) .and. ( .not. empty( text1 ) )
			aFile := Directory( mempfad + "\" + text1 + ".MEM" )
			if len( aFile ) > 0
				dDatum := aFile[ 1, F_CREATION_DATE ]
			endif
		endif

		if ( ( art == 2 ) .and. ( satz == Melde->( recno() ) ) ) .or. ( art == 1 ) .or. ( art == 3 )

			Melde->ANREDE := val( alleFelder[ I_ANREDE ] )
			Melde->VORNAME := ConvToOEMCp( alleFelder[ I_VORNAME ] )
			Melde->NACHNAME := ConvToOEMCp( alleFelder[ I_NACHNAME ] )
			Melde->FIRMA1 := ConvToOEMCp( alleFelder[ I_FIRMA1 ] )
			Melde->FIRMA2 := ConvToOEMCp( alleFelder[ I_FIRMA2 ] )
			Melde->ABTEILUNG := ConvToOEMCp( alleFelder[ I_ABTEILUNG ] )
			Melde->STRASSE := ConvToOEMCp( alleFelder[ I_STRASSE ] )
			Melde->PLZ := ConvToOEMCp( alleFelder[ I_PLZ ] )
			Melde->ORT := ConvToOEMCp( alleFelder[ I_ORT ] )
			Melde->STAAT := ConvToOEMCp( alleFelder[ I_STAAT ] )
			Melde->LAND := ConvToOEMCp( alleFelder[ I_LAND ] )
			Melde->EMAIL := ConvToOEMCp( alleFelder[ I_EMAIL ] )
			Melde->WEBSEITE := ConvToOEMCp( alleFelder[ I_WEBSEITE ] )
			Melde->TEILNEHMER := val( alleFelder[ I_TEILNEHMER ] )
			Melde->MUTTERSPRA := val( alleFelder[ I_MUTTERSPRA ] )
			Melde->MUTTERSPSO := ConvToOEMCp( alleFelder[ I_MUTTERSPSO ] )
			Melde->FREMDSPRA1 := val( alleFelder[ I_FREMDSPRA1 ] )
			Melde->FREMDSPRA2 := val( alleFelder[ I_FREMDSPRA2 ] )
			Melde->LAPTOP := alleFelder[ I_LAPTOP ]
			Melde->SHIRT := val( alleFelder[ I_SHIRT ] )
			Melde->SHUTTLE := val( alleFelder[ I_SHUTTLE ] )
			Melde->SHUTTLER := val( alleFelder[ I_SHUTTLER ] )
			Melde->UHRAB := iif( .not. empty( alleFelder[ I_UHRAB ] ), right( "0000" + strtran( alleFelder[ I_UHRAB ], ":", "" ), 4 ), "" )
			Melde->UHRHIN := iif( .not. empty( alleFelder[ I_UHRHIN ] ), right( "0000" + strtran( alleFelder[ I_UHRHIN ], ":", "" ), 4 ), "" )
			Melde->ANONYM := alleFelder[ I_ANONYM ]
			if art == 1
				Melde->VERSION := val( alleFelder[ I_VERSION ] )
				Melde->DEVCON1 := alleFelder[ I_DEVCON1 ]
				Melde->DEVCON2 := alleFelder[ I_DEVCON2 ]
				Melde->DEVCON3 := alleFelder[ I_DEVCON3 ]
				Melde->DEVCON4 := alleFelder[ I_DEVCON4 ]
				Melde->DEVCON5 := alleFelder[ I_DEVCON5 ]
				Melde->KSDELPHI := val( alleFelder[ I_KSDELPHI ] )
				Melde->KSFOXPRO := val( alleFelder[ I_KSFOXPRO ] )
				Melde->KSFLAGSHIP := val( alleFelder[ I_KSFLAGSHIP ] )
				Melde->KSCLIPPER := val( alleFelder[ I_KSCLIPPER ] )
				Melde->KSCLIP4WIN := val( alleFelder[ I_KSCLIP4WIN ] )
				Melde->KSDBASE := val( alleFelder[ I_KSDBASE ] )
				Melde->KSVO := val( alleFelder[ I_KSVO ] )
				Melde->KSXHARBOUR := val( alleFelder[ I_KSXHARBOUR ] )
				Melde->SONSTIGE1 := ConvToOEMCp( alleFelder[ I_SONSTIGE1 ] )
				Melde->KSSONSTIG1 := val( alleFelder[ I_KSSONSTIG1 ] )
				Melde->SONSTIGE2 := ConvToOEMCp( alleFelder[ I_SONSTIGE2 ] )
				Melde->KSSONSTIG2 := val( alleFelder[ I_KSSONSTIG2 ] )
				Melde->SONSTIGE3 := ConvToOEMCp( alleFelder[ I_SONSTIGE3 ] )
				Melde->KSSONSTIG3 := val( alleFelder[ I_KSSONSTIG3 ] )
				Melde->KSTOPDOWN := val( alleFelder[ I_KSTOPDOWN ] )
				Melde->KSEXPRESS := val( alleFelder[ I_KSEXPRESS ] )
				Melde->KSFIVEWIN := val( alleFelder[ I_KSFIVEWIN ] )
				Melde->KSSQLEXPRE := val( alleFelder[ I_KSSQLEXPRE ] )
				Melde->KSXCLASS := val( alleFelder[ I_KSXCLASS ] )
				Melde->KSXB2NET := val( alleFelder[ I_KSXB2NET ] )
				Melde->KSXBHCL := val( alleFelder[ I_KSXBHCL ] )
				Melde->KSCOCKPIT := val( alleFelder[ I_KSCOCKPIT ] )
				Melde->KSLLABEL := val( alleFelder[ I_KSLLABEL ] )
				Melde->KSVPE := val( alleFelder[ I_KSVPE ] )
				Melde->KSRUNDR := val( alleFelder[ I_KSRUNDR ] )
				Melde->KSMARSHALL := val( alleFelder[ I_KSMARSHALL ] )
				Melde->ADDONSONS1 := ConvToOEMCp( alleFelder[ I_ADDONSONS1 ] )
				Melde->KSADDOSON1 := val( alleFelder[ I_KSADDOSON1 ] )
				Melde->ADDONSONS2 := ConvToOEMCp( alleFelder[ I_ADDONSONS2 ] )
				Melde->KSADDOSON2 := val( alleFelder[ I_KSADDOSON2 ] )
				Melde->ADDONSONS3 := ConvToOEMCp( alleFelder[ I_ADDONSONS3 ] )
				Melde->KSADDOSON3 := val( alleFelder[ I_KSADDOSON3 ] )
				Melde->INTSQL := alleFelder[ I_INTSQL ]
				Melde->INTWEBANB := alleFelder[ I_INTWEBANB ]
				Melde->INTMIGRAT := alleFelder[ I_INTMIGRAT ]
				Melde->INTACTIVEX := alleFelder[ I_INTACTIVEX ]
				Melde->INTSONSTI1 := ConvToOEMCp( alleFelder[ I_INTSONSTI1 ] )
				Melde->INTSONSTI2 := ConvToOEMCp( alleFelder[ I_INTSONSTI2 ] )
				Melde->INTSONSTI3 := ConvToOEMCp( alleFelder[ I_INTSONSTI3 ] )
				Melde->ANMELDEDAT := dDatum
				if ( val( alleFelder[ I_TEILNEHMER ] ) == 1 ) .or. ( val( alleFelder[ I_TEILNEHMER ] ) == 8 )
					Melde->PREIS := iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preisnorm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preisnorm2, MEMVAR->preisnorm3 ) )
				elseif ( val( alleFelder[ I_TEILNEHMER ] ) < 5 ) .or. ( val( alleFelder[ I_TEILNEHMER ] ) == 7 )
					Melde->PREIS := iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) )
				else
					Melde->PREIS := 0
				endif
				if alleFelder[ I_ZAHLART ] <> NIL
					Melde->ZAHLEINGAN := CtoD( alleFelder[ I_ZAHLEINGAN ] )
					Melde->ZAHLART := val( alleFelder[ I_ZAHLART ] )
				endif
			elseif art == 2
				Melde->PREIS := val( alleFelder[ I_PREIS ] )
				Melde->ZAHLEINGAN := CtoD( alleFelder[ I_ZAHLEINGAN ] )
				Melde->ZAHLART := val( alleFelder[ I_ZAHLART ] )
			else
				Melde->ANMELDEDAT := dDatum
			endif
			Melde->( DbCommit() )
			Melde->( DbSkip( 0 ) )
			if art <> 2
				if empty( text1 )
					if empty( alleFelder[ I_TEILNEHMID ] )
						text1 := "DC07DE" + right( "0000" + alltrim( str( MEMVAR->dcid++ ) ), 4 )
					else
						text1 := alleFelder[ I_TEILNEHMID ]
					endif
				endif
				Melde->TEILNEHMID := text1
				Melde->( DbCommit() )
				Melde->( DbSkip( 0 ) )

				if .not. empty( alleFelder[ I_NACHNAME1 ] )
					append blank
					i := 0
					DO WHILE ( .NOT. ( lRLock := DbRLock( recno() ) ) ) .and. ( i < 3 )
						Sleep( 50 )
						i++
					ENDDO
					IF ! lRLock
						if lAusgabe
							do case
							case sprache == "de"
								ueberschr := "Datei nicht verf" + ue + "gbar"
								fehlertext := "Ihre Eingaben k" + oe + "nnen zur Zeit leider nicht verarbeitet werden!"
							case sprache == "fr"
								ueberschr := "Fichier n'est pas offert"
								fehlertext := "C'est pas possible de stocker votre entr" + er + "e au moment!"
							case sprache == "uk"
								ueberschr := "Unavailable file"
								fehlertext := "Sorry, your data cannot be processed at the moment!"
							case sprache == "sp"
								ueberschr := "Fichero no disponible"
								fehlertext := "Disculpe, sus datos no pueden ser procesados en este momento!"
							case sprache == "pt"
								ueberschr := "Arquivo n" + ati + "o dispon" + ir + "vel"
								fehlertext := "Desculpe, seus dados n" + ati + "o poden serem processados neste momento!"
							endcase
							oClient:HTTPResponse:Content := '<html><head><meta http-equiv="content-type" content="text/html; charset=ISO-8859-1"><title>' + ueberschr + '</title><link rel="stylesheet" href="devcon.css" type="text/css"></head><body BGCOLOR="' + MEMVAR->shinter + '">' + Fehlermeldung( ueberschr, fehlertext ) + "</BODY></HTML>"
						else
							SaveToFile( ConvToAnsiCp( "______ Xb2.NET ERROR __________ Access error _________________" + DtoC( Date() ) + "_" + Time() + CRLF + "Data cannot be stored!" ), SERVER_ERR_LOG_FILE )
						endif
						CloseDbf()
						RETURN .f.
					ENDIF
					Melde->ANREDE := val( alleFelder[ I_ANREDE1 ] )
					Melde->VORNAME := ConvToOEMCp( alleFelder[ I_VORNAME1 ] )
					Melde->NACHNAME := ConvToOEMCp( alleFelder[ I_NACHNAME1 ] )
					Melde->TEILNEHMER := val( alleFelder[ I_TEILNEHMER1 ] )
					Melde->FIRMA1 := ConvToOEMCp( alleFelder[ I_FIRMA1 ] )
					Melde->FIRMA2 := ConvToOEMCp( alleFelder[ I_FIRMA2 ] )
					Melde->ABTEILUNG := ConvToOEMCp( alleFelder[ I_ABTEILUNG ] )
					Melde->STRASSE := ConvToOEMCp( alleFelder[ I_STRASSE ] )
					Melde->PLZ := ConvToOEMCp( alleFelder[ I_PLZ ] )
					Melde->ORT := ConvToOEMCp( alleFelder[ I_ORT ] )
					Melde->STAAT := ConvToOEMCp( alleFelder[ I_STAAT ] )
					Melde->LAND := ConvToOEMCp( alleFelder[ I_LAND ] )
					Melde->EMAIL := ConvToOEMCp( alleFelder[ I_EMAIL ] )
					Melde->WEBSEITE := ConvToOEMCp( alleFelder[ I_WEBSEITE ] )
					Melde->ANMELDEDAT := dDatum
					Melde->MUTTERSPRA := val( alleFelder[ I_MUTTERSPRA ] )
					Melde->MUTTERSPSO := ConvToOEMCp( alleFelder[ I_MUTTERSPSO ] )
					Melde->SHIRT := val( alleFelder[ I_SHIRT1 ] )
					Melde->ANONYM := alleFelder[ I_ANONYM1 ]
					Melde->SHUTTLE := val( alleFelder[ I_SHUTTLE ] )
					Melde->SHUTTLER := val( alleFelder[ I_SHUTTLER ] )
					Melde->UHRAB := iif( .not. empty( alleFelder[ I_UHRAB ] ), right( "0000" + strtran( alleFelder[ I_UHRAB ], ":", "" ), 4 ), "" )
					Melde->UHRHIN := iif( .not. empty( alleFelder[ I_UHRHIN ] ), right( "0000" + strtran( alleFelder[ I_UHRHIN ], ":", "" ), 4 ), "" )
					Melde->TEILNEHMID := text1
					if val( alleFelder[ I_TEILNEHMER1 ] ) == 1
						Melde->PREIS := iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preisnorm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preisnorm2, MEMVAR->preisnorm3 ) )
					else
						Melde->PREIS := iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) )
					endif
					Melde->( DbCommit() )
					Melde->( DbSkip( 0 ) )
				endif
				if .not. empty( alleFelder[ I_NACHNAME2 ] )
					append blank
					i := 0
					DO WHILE ( .NOT. ( lRLock := DbRLock( recno() ) ) ) .and. ( i < 3 )
						Sleep( 50 )
						i++
					ENDDO
					IF ! lRLock
						if lAusgabe
							do case
							case sprache == "de"
								ueberschr := "Datei nicht verf" + ue + "gbar"
								fehlertext := "Ihre Eingaben k" + oe + "nnen zur Zeit leider nicht verarbeitet werden!"
							case sprache == "fr"
								ueberschr := "Fichier n'est pas offert"
								fehlertext := "C'est pas possible de stocker votre entr" + er + "e au moment!"
							case sprache == "uk"
								ueberschr := "Unavailable file"
								fehlertext := "Sorry, your data cannot be processed at the moment!"
							case sprache == "sp"
								ueberschr := "Fichero no disponible"
								fehlertext := "Disculpe, sus datos no pueden ser procesados en este momento!"
							case sprache == "pt"
								ueberschr := "Arquivo n" + ati + "o dispon" + ir + "vel"
								fehlertext := "Desculpe, seus dados n" + ati + "o poden serem processados neste momento!"
							endcase
							oClient:HTTPResponse:Content := '<html><head><meta http-equiv="content-type" content="text/html; charset=ISO-8859-1"><title>' + ueberschr + '</title><link rel="stylesheet" href="devcon.css" type="text/css"></head><body BGCOLOR="' + MEMVAR->shinter + '">' + Fehlermeldung( ueberschr, fehlertext ) + "</BODY></HTML>"
						else
							SaveToFile( ConvToAnsiCp( "______ Xb2.NET ERROR __________ Access error _________________" + DtoC( Date() ) + "_" + Time() + CRLF + "Data cannot be stored!" ), SERVER_ERR_LOG_FILE )
						endif
						CloseDbf()
						RETURN .f.
					ENDIF
					Melde->ANREDE := val( alleFelder[ I_ANREDE2 ] )
					Melde->VORNAME := ConvToOEMCp( alleFelder[ I_VORNAME2 ] )
					Melde->NACHNAME := ConvToOEMCp( alleFelder[ I_NACHNAME2 ] )
					Melde->TEILNEHMER := val( alleFelder[ I_TEILNEHMER2 ] )
					Melde->FIRMA1 := ConvToOEMCp( alleFelder[ I_FIRMA1 ] )
					Melde->FIRMA2 := ConvToOEMCp( alleFelder[ I_FIRMA2 ] )
					Melde->ABTEILUNG := ConvToOEMCp( alleFelder[ I_ABTEILUNG ] )
					Melde->STRASSE := ConvToOEMCp( alleFelder[ I_STRASSE ] )
					Melde->PLZ := ConvToOEMCp( alleFelder[ I_PLZ ] )
					Melde->ORT := ConvToOEMCp( alleFelder[ I_ORT ] )
					Melde->STAAT := ConvToOEMCp( alleFelder[ I_STAAT ] )
					Melde->LAND := ConvToOEMCp( alleFelder[ I_LAND ] )
					Melde->EMAIL := ConvToOEMCp( alleFelder[ I_EMAIL ] )
					Melde->WEBSEITE := ConvToOEMCp( alleFelder[ I_WEBSEITE ] )
					Melde->ANMELDEDAT := dDatum
					Melde->MUTTERSPRA := val( alleFelder[ I_MUTTERSPRA ] )
					Melde->MUTTERSPSO := ConvToOEMCp( alleFelder[ I_MUTTERSPSO ] )
					Melde->SHIRT := val( alleFelder[ I_SHIRT2 ] )
					Melde->ANONYM := alleFelder[ I_ANONYM2 ]
					Melde->SHUTTLE := val( alleFelder[ I_SHUTTLE ] )
					Melde->SHUTTLER := val( alleFelder[ I_SHUTTLER ] )
					Melde->UHRAB := iif( .not. empty( alleFelder[ I_UHRAB ] ), right( "0000" + strtran( alleFelder[ I_UHRAB ], ":", "" ), 4 ), "" )
					Melde->UHRHIN := iif( .not. empty( alleFelder[ I_UHRHIN ] ), right( "0000" + strtran( alleFelder[ I_UHRHIN ], ":", "" ), 4 ), "" )
					Melde->TEILNEHMID := text1
					if val( alleFelder[ I_TEILNEHMER2 ] ) == 1
						Melde->PREIS := iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preisnorm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preisnorm2, MEMVAR->preisnorm3 ) )
					else
						Melde->PREIS := iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) )
					endif
					Melde->( DbCommit() )
					Melde->( DbSkip( 0 ) )
				endif
				if .not. empty( alleFelder[ I_NACHNAME3 ] )
					append blank
					i := 0
					DO WHILE ( .NOT. ( lRLock := DbRLock( recno() ) ) ) .and. ( i < 3 )
						Sleep( 50 )
						i++
					ENDDO
					IF ! lRLock
						if lAusgabe
							do case
							case sprache == "de"
								ueberschr := "Datei nicht verf" + ue + "gbar"
								fehlertext := "Ihre Eingaben k" + oe + "nnen zur Zeit leider nicht verarbeitet werden!"
							case sprache == "fr"
								ueberschr := "Fichier n'est pas offert"
								fehlertext := "C'est pas possible de stocker votre entr" + er + "e au moment!"
							case sprache == "uk"
								ueberschr := "Unavailable file"
								fehlertext := "Sorry, your data cannot be processed at the moment!"
							case sprache == "sp"
								ueberschr := "Fichero no disponible"
								fehlertext := "Disculpe, sus datos no pueden ser procesados en este momento!"
							case sprache == "pt"
								ueberschr := "Arquivo n" + ati + "o dispon" + ir + "vel"
								fehlertext := "Desculpe, seus dados n" + ati + "o poden serem processados neste momento!"
							endcase
							oClient:HTTPResponse:Content := '<html><head><meta http-equiv="content-type" content="text/html; charset=ISO-8859-1"><title>' + ueberschr + '</title><link rel="stylesheet" href="devcon.css" type="text/css"></head><body BGCOLOR="' + MEMVAR->shinter + '">' + Fehlermeldung( ueberschr, fehlertext ) + "</BODY></HTML>"
						else
							SaveToFile( ConvToAnsiCp( "______ Xb2.NET ERROR __________ Access error _________________" + DtoC( Date() ) + "_" + Time() + CRLF + "Data cannot be stored!" ), SERVER_ERR_LOG_FILE )
						endif
						CloseDbf()
						RETURN .f.
					ENDIF
					Melde->ANREDE := val( alleFelder[ I_ANREDE3 ] )
					Melde->VORNAME := ConvToOEMCp( alleFelder[ I_VORNAME3 ] )
					Melde->NACHNAME := ConvToOEMCp( alleFelder[ I_NACHNAME3 ] )
					Melde->TEILNEHMER := val( alleFelder[ I_TEILNEHMER3 ] )
					Melde->FIRMA1 := ConvToOEMCp( alleFelder[ I_FIRMA1 ] )
					Melde->FIRMA2 := ConvToOEMCp( alleFelder[ I_FIRMA2 ] )
					Melde->ABTEILUNG := ConvToOEMCp( alleFelder[ I_ABTEILUNG ] )
					Melde->STRASSE := ConvToOEMCp( alleFelder[ I_STRASSE ] )
					Melde->PLZ := ConvToOEMCp( alleFelder[ I_PLZ ] )
					Melde->ORT := ConvToOEMCp( alleFelder[ I_ORT ] )
					Melde->STAAT := ConvToOEMCp( alleFelder[ I_STAAT ] )
					Melde->LAND := ConvToOEMCp( alleFelder[ I_LAND ] )
					Melde->EMAIL := ConvToOEMCp( alleFelder[ I_EMAIL ] )
					Melde->WEBSEITE := ConvToOEMCp( alleFelder[ I_WEBSEITE ] )
					Melde->ANMELDEDAT := dDatum
					Melde->MUTTERSPRA := val( alleFelder[ I_MUTTERSPRA ] )
					Melde->MUTTERSPSO := ConvToOEMCp( alleFelder[ I_MUTTERSPSO ] )
					Melde->SHIRT := val( alleFelder[ I_SHIRT3 ] )
					Melde->ANONYM := alleFelder[ I_ANONYM3 ]
					Melde->SHUTTLE := val( alleFelder[ I_SHUTTLE ] )
					Melde->SHUTTLER := val( alleFelder[ I_SHUTTLER ] )
					Melde->UHRAB := iif( .not. empty( alleFelder[ I_UHRAB ] ), right( "0000" + strtran( alleFelder[ I_UHRAB ], ":", "" ), 4 ), "" )
					Melde->UHRHIN := iif( .not. empty( alleFelder[ I_UHRHIN ] ), right( "0000" + strtran( alleFelder[ I_UHRHIN ], ":", "" ), 4 ), "" )
					Melde->TEILNEHMID := text1
					if val( alleFelder[ I_TEILNEHMER3 ] ) == 1
						Melde->PREIS := iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preisnorm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preisnorm2, MEMVAR->preisnorm3 ) )
					else
						Melde->PREIS := iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) )
					endif
					Melde->( DbCommit() )
					Melde->( DbSkip( 0 ) )
				endif
				if art == 3
					select PCW
					PCW->( DbGoTop() )
					do while ( .not. PCW->( eof() ) ) .and. ( PCW->TEILNEHMID <> text1 )
						skip
					enddo
					if ( PCW->TEILNEHMID <> text1 )
						append blank
						PCW->TEILNEHMID := text1
					endif
					i := 0
					DO WHILE ( .NOT. ( lRLock := DbRLock( recno() ) ) ) .and. ( i < 3 )
						Sleep( 50 )
						i++
					ENDDO
					IF ! lRLock
						if lAusgabe
							do case
							case sprache == "de"
								ueberschr := "Datei nicht verf" + ue + "gbar"
								fehlertext := "Ihre Eingaben k" + oe + "nnen zur Zeit leider nicht verarbeitet werden!"
							case sprache == "fr"
								ueberschr := "Fichier n'est pas offert"
								fehlertext := "C'est pas possible de stocker votre entr" + er + "e au moment!"
							case sprache == "uk"
								ueberschr := "Unavailable file"
								fehlertext := "Sorry, your data cannot be processed at the moment!"
							case sprache == "sp"
								ueberschr := "Fichero no disponible"
								fehlertext := "Disculpe, sus datos no pueden ser procesados en este momento!"
							case sprache == "pt"
								ueberschr := "Arquivo n" + ati + "o dispon" + ir + "vel"
								fehlertext := "Desculpe, seus dados n" + ati + "o poden serem processados neste momento!"
							endcase
							oClient:HTTPResponse:Content := '<html><head><meta http-equiv="content-type" content="text/html; charset=ISO-8859-1"><title>' + ueberschr + '</title><link rel="stylesheet" href="devcon.css" type="text/css"></head><body BGCOLOR="' + MEMVAR->shinter + '">' + Fehlermeldung( ueberschr, fehlertext ) + "</BODY></HTML>"
						endif
						CloseDbf()
						RETURN .f.
					ENDIF
					PCW->ZEIT := val( alleFelder[ I_ZEIT ] )
					PCW->SAAL := val( alleFelder[ I_SAAL ] )
					MemoWrit( datenpfad + "\" + text1 + ".pcw", alleFelder[ I_THEMA ] )
				endif
			endif
		elseif lAusgabe
			oClient:HTTPResponse:Content := '<html><head><meta http-equiv="content-type" content="text/html; charset=ISO-8859-1"><title>Zugriffsfehler</title><link rel="stylesheet" href="devcon.css" type="text/css"></head><body BGCOLOR="' + MEMVAR->shinter + '">' + Fehlermeldung( "Zugriffsfehler", "Daten konnten nicht geschrieben werden!" ) + "</BODY></HTML>"
		else
			SaveToFile( ConvToAnsiCp( "______ Xb2.NET ERROR __________ Access error _________________" + DtoC( Date() ) + "_" + Time() + CRLF + "Data cannot be stored!" ), SERVER_ERR_LOG_FILE )
		endif
	endif
return .t.

FUNCTION DC_CheckEntry1()
	local oClient := ThreadObject(), oServer := oClient:Parent
	local fehlertext, ueberschr, fehlerobj
	local alleFelder, sprache, text1, spr_xx
	local bla, bla1, bla2, datum2, satz, std, minu, nhandle
	local oForm, oHttp, oResp, oMail, oSMTP

	alleFelder := oClient:getCargo( "FELDER" )
	if alleFelder == NIL
		alleFelder := array( I_GESAMTFELDER )
	endif
	alleFelder[ I_ANREDE ] := oClient:getVar( "F_ANREDE" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_VORNAME" ) ), 1 )
	alleFelder[ I_VORNAME ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_NACHNAME" ) ), 1 )
	alleFelder[ I_NACHNAME ] := bla2
	alleFelder[ I_FIRMA1 ] := erszeichen( oClient:getVar( "F_FIRMA1" ) )
	alleFelder[ I_FIRMA2 ] := erszeichen( oClient:getVar( "F_FIRMA2" ) )
	alleFelder[ I_ABTEILUNG ] := erszeichen( oClient:getVar( "F_ABTEILUNG" ) )
	alleFelder[ I_STRASSE ] := erszeichen( oClient:getVar( "F_STRASSE" ) )
	alleFelder[ I_LAND ] := oClient:getVar( "F_LAND" )
	alleFelder[ I_STAAT ] := upper( erszeichen( oClient:getVar( "F_STAAT" ) ) )
	alleFelder[ I_PLZ ] := erszeichen( oClient:getVar( "F_PLZ" ) )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_ORT" ) ), 1 )
	alleFelder[ I_ORT ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_EMAIL ] := erszeichen( oClient:getVar( "F_EMAIL" ) )
	alleFelder[ I_WEBSEITE ] := erszeichen( oClient:getVar( "F_WEBSEITE" ) )
	alleFelder[ I_TEILNEHMER ] := oClient:getVar( "F_TEILNEHMER" )
	alleFelder[ I_MUTTERSPRA ] := oClient:getVar( "F_MUTTERSPRA" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_MUTTERSPSO" ) ), 1 )
	alleFelder[ I_MUTTERSPSO ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_FREMDSPRA1 ] := oClient:getVar( "F_FREMDSPRA1" )
	alleFelder[ I_FREMDSPRA2 ] := oClient:getVar( "F_FREMDSPRA2" )
	alleFelder[ I_VERSION ] := oClient:getVar( "F_VERSION" )
	alleFelder[ I_LAPTOP ] := ( oClient:getVar( "F_LAPTOP" ) == "on" )
	alleFelder[ I_DEVCON1 ] := ( oClient:getVar( "F_DEVCON1" ) == "on" )
	alleFelder[ I_DEVCON2 ] := ( oClient:getVar( "F_DEVCON2" ) == "on" )
	alleFelder[ I_DEVCON3 ] := ( oClient:getVar( "F_DEVCON3" ) == "on" )
	alleFelder[ I_DEVCON4 ] := ( oClient:getVar( "F_DEVCON4" ) == "on" )
	alleFelder[ I_DEVCON5 ] := ( oClient:getVar( "F_DEVCON5" ) == "on" )
	alleFelder[ I_ANONYM ] := ( oClient:getVar( "F_ANONYM" ) == "on" )
	alleFelder[ I_ANONYM1 ] := ( oClient:getVar( "F_ANONYM1" ) == "on" )
	alleFelder[ I_ANONYM2 ] := ( oClient:getVar( "F_ANONYM2" ) == "on" )
	alleFelder[ I_ANONYM3 ] := ( oClient:getVar( "F_ANONYM3" ) == "on" )
	alleFelder[ I_ANREDE1 ] := oClient:getVar( "F_ANREDE1" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_VORNAME1" ) ), 1 )
	alleFelder[ I_VORNAME1 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_NACHNAME1" ) ), 1 )
	alleFelder[ I_NACHNAME1 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_TEILNEHMER1 ] := oClient:getVar( "F_TEILNEHMER1" )
	alleFelder[ I_ANREDE2 ] := oClient:getVar( "F_ANREDE2" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_VORNAME2" ) ), 1 )
	alleFelder[ I_VORNAME2 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_NACHNAME2" ) ), 1 )
	alleFelder[ I_NACHNAME2 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_TEILNEHMER2 ] := oClient:getVar( "F_TEILNEHMER2" )
	alleFelder[ I_ANREDE3 ] := oClient:getVar( "F_ANREDE3" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_VORNAME3" ) ), 1 )
	alleFelder[ I_VORNAME3 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_NACHNAME3" ) ), 1 )
	alleFelder[ I_NACHNAME3 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_TEILNEHMER3 ] := oClient:getVar( "F_TEILNEHMER3" )
	alleFelder[ I_KSDELPHI ] := oClient:getVar( "F_KSDELPHI" )
	alleFelder[ I_KSFOXPRO ] := oClient:getVar( "F_KSFOXPRO" )
	alleFelder[ I_KSFLAGSHIP ] := oClient:getVar( "F_KSFLAGSHIP" )
	alleFelder[ I_KSCLIPPER ] := oClient:getVar( "F_KSCLIPPER" )
	alleFelder[ I_KSCLIP4WIN ] := oClient:getVar( "F_KSCLIP4WIN" )
	alleFelder[ I_KSDBASE ] := oClient:getVar( "F_KSDBASE" )
	alleFelder[ I_KSVO ] := oClient:getVar( "F_KSVO" )
	alleFelder[ I_KSXHARBOUR ] := oClient:getVar( "F_KSXHARBOUR" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_SONSTIGE1" ) ), 1 )
	alleFelder[ I_SONSTIGE1 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_KSSONSTIG1 ] := oClient:getVar( "F_KSSONSTIG1" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_SONSTIGE2" ) ), 1 )
	alleFelder[ I_SONSTIGE2 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_KSSONSTIG2 ] := oClient:getVar( "F_KSSONSTIG2" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_SONSTIGE3" ) ), 1 )
	alleFelder[ I_SONSTIGE3 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_KSSONSTIG3 ] := oClient:getVar( "F_KSSONSTIG3" )
	alleFelder[ I_KSTOPDOWN ] := oClient:getVar( "F_KSTOPDOWN" )
	alleFelder[ I_KSEXPRESS ] := oClient:getVar( "F_KSEXPRESS" )
	alleFelder[ I_KSFIVEWIN ] := oClient:getVar( "F_KSFIVEWIN" )
	alleFelder[ I_KSSQLEXPRE ] := oClient:getVar( "F_KSSQLEXPRE" )
	alleFelder[ I_KSXB2NET ] := oClient:getVar( "F_KSXB2NET" )
	alleFelder[ I_KSXCLASS ] := oClient:getVar( "F_KSXCLASS" )
	alleFelder[ I_KSXBHCL ] := oClient:getVar( "F_KSXBHCL" )
	alleFelder[ I_KSCOCKPIT ] := oClient:getVar( "F_KSCOCKPIT" )
	alleFelder[ I_KSMARSHALL ] := oClient:getVar( "F_KSMARSHALL" )
	alleFelder[ I_KSLLABEL ] := oClient:getVar( "F_KSLLABEL" )
	alleFelder[ I_KSVPE ] := oClient:getVar( "F_KSVPE" )
	alleFelder[ I_KSRUNDR ] := oClient:getVar( "F_KSRUNDR" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_ADDONSONS1" ) ), 1 )
	alleFelder[ I_ADDONSONS1 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_KSADDOSON1 ] := oClient:getVar( "F_KSADDOSON1" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_ADDONSONS2" ) ), 1 )
	alleFelder[ I_ADDONSONS2 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_KSADDOSON2 ] := oClient:getVar( "F_KSADDOSON2" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_ADDONSONS3" ) ), 1 )
	alleFelder[ I_ADDONSONS3 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_KSADDOSON3 ] := oClient:getVar( "F_KSADDOSON3" )
	alleFelder[ I_INTSQL ] := ( oClient:getVar( "F_INTSQL" ) == "1" )
	alleFelder[ I_INTWEBANB ] := ( oClient:getVar( "F_INTWEBANB" ) == "1" )
	alleFelder[ I_INTMIGRAT ] := ( oClient:getVar( "F_INTMIGRAT" ) == "1" )
	alleFelder[ I_INTACTIVEX ] := ( oClient:getVar( "F_INTACTIVEX" ) == "1" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_INTSONSTI1" ) ), 1 )
	alleFelder[ I_INTSONSTI1 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_INTSONSTI2" ) ), 1 )
	alleFelder[ I_INTSONSTI2 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_INTSONSTI3" ) ), 1 )
	alleFelder[ I_INTSONSTI3 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_SHIRT ] := oClient:getVar( "F_SHIRT" )
	alleFelder[ I_SHIRT1 ] := oClient:getVar( "F_SHIRT1" )
	alleFelder[ I_SHIRT2 ] := oClient:getVar( "F_SHIRT2" )
	alleFelder[ I_SHIRT3 ] := oClient:getVar( "F_SHIRT3" )
	alleFelder[ I_SHUTTLE ] := oClient:getVar( "F_SHUTTLE" )
	alleFelder[ I_SHUTTLER ] := oClient:getVar( "F_SHUTTLER" )
	alleFelder[ I_UHRAB ] := oClient:getVar( "F_UHRAB" )
	alleFelder[ I_UHRHIN ] := oClient:getVar( "F_UHRHIN" )
	alleFelder[ I_ACCEPT ] := ( oClient:getVar( "F_ACCEPT" ) == "on" )

	oClient:setCargo( "FELDER", alleFelder )

	sprache := lower( oClient:getVar( "MenuVar" ) )
	if ( sprache == NIL )
		oClient:HTTPResponse:Content := redirekt()
	else

		fehlertext := ""
		ueberschr := ""
		fehlerobj := ""
		do case
		case sprache == "de"
			spr_xx := spr_de
		case sprache == "fr"
			spr_xx := spr_fr
		case sprache == "uk"
			spr_xx := spr_uk
		case sprache == "sp"
			spr_xx := spr_sp
		case sprache == "pt"
			spr_xx := spr_pt
		endcase
		if alleFelder[ I_ANREDE ] == "0"
			do case
			case sprache == "de"
				fehlertext += "W" + ae + "hlen Sie die Anrede aus!"
			case sprache == "fr"
				fehlertext += "Choisez vous le titre, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please select the title!"
			case sprache == "sp"
				fehlertext += "Por favor seleccione el t" + ir + "tulo!"
			case sprache == "pt"
				fehlertext += "Por favor escolha o t" + ir + "tulo!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_ANREDE"
			endif
		endif
		if empty( alleFelder[ I_VORNAME ] )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Geben Sie Ihren Vornamen ein!"
			case sprache == "fr"
				fehlertext += "Appelez v" + od + "tre nom de famille, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please enter your first name!"
			case sprache == "sp"
				fehlertext += "Por favor ingrese su Nombre!"
			case sprache == "pt"
				fehlertext += "Por favor cadastre seu Nome!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_VORNAME"
			endif
		endif
		if empty( alleFelder[ I_NACHNAME ] )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Geben Sie Ihren Nachnamen ein!"
			case sprache == "fr"
				fehlertext += "Appelez v" + od + "tre pr" + er + "nom, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please enter your last name!"
			case sprache == "sp"
				fehlertext += "Por favor ingrese su Apellido!"
			case sprache == "pt"
				fehlertext += "Por favor cadastre seu Sobrenome!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_NACHNAME"
			endif
		endif
		if empty( alleFelder[ I_STRASSE ] )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Geben Sie Ihre Stra" + sz + "e ein!"
			case sprache == "fr"
				fehlertext += "Appelez v" + od + "tre rue, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please enter your street!"
			case sprache == "sp"
				fehlertext += "Por favor, ingrese su calle!"
			case sprache == "pt"
				fehlertext += "Por favor, cadastre seu endere" + cc + "o!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_STRASSE"
			endif
		endif
		if alleFelder[ I_LAND ] == "0"
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "W" + ae + "hlen Sie Ihr Land aus!"
			case sprache == "fr"
				fehlertext += "Choisissez v" + od + "tre " + er + "tat, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please choose your country!"
			case sprache == "sp"
				fehlertext += "Por favor, seleccione su pa" + ir + "s!"
			case sprache == "pt"
				fehlertext += "Por favor, escolha seu pa" + ir + "s!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_LAND"
			endif
		endif
		if empty( alleFelder[ I_STAAT ] )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Geben Sie Ihr Bundesland bzw. Kanton ein!"
			case sprache == "fr"
				fehlertext += "Appelez v" + od + "tre canton, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please enter your county or region!"
			case sprache == "sp"
				fehlertext += "Por favor, ingrese su Provincia o Regi" + or + "n Aut" + or + "noma!"
			case sprache == "pt"
				fehlertext += "Por favor, cadastre seu estado ou regi" + ati + "o!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_STAAT"
			endif
		endif
		if empty( alleFelder[ I_PLZ ] )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Geben Sie Ihre Postleitzahl ein!"
			case sprache == "fr"
				fehlertext += "Appelez v" + od + "tre code postal, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please enter your postcode (zipcode)!"
			case sprache == "sp"
				fehlertext += "Por favor, ingrese su c" + or + "digo postal (zipcode)!"
			case sprache == "pt"
				fehlertext += "Por favor, cadastre seu c" + or + "digo postal (CEP)!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_PLZ"
			endif
		endif
		if empty( alleFelder[ I_ORT ] )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Geben Sie Ihren Ort ein!"
			case sprache == "fr"
				fehlertext += "Appelez v" + od + "tre lieu, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please enter your city!"
			case sprache == "sp"
				fehlertext += "Por favor, ingrese su ciudad!"
			case sprache == "pt"
				fehlertext += "Por favor, cadastre sua cidade!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_ORT"
			endif
		endif
		if empty( alleFelder[ I_EMAIL ] )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Geben Sie Ihre E-Mailadresse ein!"
			case sprache == "fr"
				fehlertext += "Entrez vous votre adresse e-mail!"
			case sprache == "uk"
				fehlertext += "Please provide your e-mail-address!"
			case sprache == "sp"
				fehlertext += "Por favor, informe su direcci" + or + "n de e-mail!"
			case sprache == "pt"
				fehlertext += "Por favor, informe seu endere" + cc + "o de e-mail!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_EMAIL"
			endif
		else
			bla := alltrim( alleFelder[ I_EMAIL ] )
			datum2 := at( "@", bla )
			if ( datum2 == 0 ) .or. ( at( ".", bla, datum2 + 1 ) == 0 )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "Geben Sie eine g" + ue + "ltige E-Mailadresse ein!"
				case sprache == "fr"
					fehlertext += "Entrez vous une adresse e-mail valable!"
				case sprache == "uk"
					fehlertext += "Please provide a valid e-mail-address!"
				case sprache == "sp"
					fehlertext += "Por favor, informe una direcci" + or + "n v" + ar + "lida de e-mail!"
				case sprache == "pt"
					fehlertext += "Por favor, informe um endere" + cc + "o v" + ar + "lido de e-mail!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_EMAIL"
				endif
			endif
		endif
		if ( .not. empty( alleFelder[ I_WEBSEITE ] ) ) .and. ( at( ".", alltrim( alleFelder[ I_WEBSEITE ] ) ) == 0 )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Geben Sie eine g" + ue + "ltige Webseitenadresse ein!"
			case sprache == "fr"
				fehlertext += "Entrez vous une adresse valable du site de web!"
			case sprache == "uk"
				fehlertext += "Please provide a valid website-address!"
			case sprache == "sp"
				fehlertext += "Por favor, informe una direcci" + or + "n v" + ar + "lida para su website!"
			case sprache == "pt"
				fehlertext += "Por favor, informe um endere" + cc + "o v" + ar + "lido para seu website!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_WEBSEITE"
			endif
		endif
		if alleFelder[ I_TEILNEHMER ] == "0"
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "W" + ae + "hlen Sie Ihre Art der Teilnahme aus!"
			case sprache == "fr"
				fehlertext += "Choisissez v" + od + "tre forme de participation, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please choose the type of your participation!"
			case sprache == "sp"
				fehlertext += "Por favor, seleccione su tipo de participaci" + or + "n!"
			case sprache == "pt"
				fehlertext += "Por favor, escolha seu tipo de participa" + cc + ati + "o!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_TEILNEHMER"
			endif
		endif
		if alleFelder[ I_MUTTERSPRA ] == "0"
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "W" + ae + "hlen Sie Ihre Muttersprache aus!"
			case sprache == "fr"
				fehlertext += "Choisez v" + od + "tre langue maternelle, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please choose your native tongue!"
			case sprache == "sp"
				fehlertext += "Por favor, seleccione su lengua nativa!"
			case sprache == "pt"
				fehlertext += "Por favor, escolha sua linguagen nativa!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_MUTTERSPSO"
			endif
		endif
		if empty( alleFelder[ I_MUTTERSPSO ] ) .and. ( alleFelder[ I_MUTTERSPRA ] == "99" )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Geben Sie Ihre Muttersprache ein!"
			case sprache == "fr"
				fehlertext += "Appelez v" + od + "tre langue maternelle, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please provide your native tongue!"
			case sprache == "sp"
				fehlertext += "Por favor, informe su lengua nativa!"
			case sprache == "pt"
				fehlertext += "Por favor, informe sua linguagen nativa!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_MUTTERSPSO"
			endif
		endif
		if val( alleFelder[ I_SHIRT ] ) == 0
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "W" + ae + "hlen Sie Ihre T-Shirt-Gr" + oe + sz + "e aus!"
			case sprache == "fr"
				fehlertext += "Choisez v" + od + "tre taille du t-shirt, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please select your size of tee-shirt!"
			case sprache == "sp"
				fehlertext += "Por favor seleccione su talla de remera!"
			case sprache == "pt"
				fehlertext += "Por favor escolha o tamanho da sua camiseta!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_SHIRT"
			endif
		endif
		if .not. alleFelder[ I_ACCEPT ]
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Sie m" + ue + "ssen die Teilnahmebedingungen akzeptieren!"
			case sprache == "fr"
				fehlertext += "Il faut que vous acceptez les conditions de participation!"
			case sprache == "uk"
				fehlertext += "You have to accept the conditions for participating!"
			case sprache == "sp"
				fehlertext += "Debe aceptar las condiciones para participar!"
			case sprache == "pt"
				fehlertext += "Voc" + ed + " tem que aceitar as condi" + cc + ot + "es para participar!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_ACCEPT"
			endif
		endif
		if .not. ( empty( alleFelder[ I_VORNAME1 ] ) .and. empty( alleFelder[ I_NACHNAME1 ] ) )
			if alleFelder[ I_ANREDE1 ] == "0"
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "W" + ae + "hlen Sie die Anrede der ersten Sie begleitenden Person aus!"
				case sprache == "fr"
					fehlertext += "Choisez vous le titre donn" + er + " de votre premier compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please select the title of the first person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor seleccione el t" + ir + "tulo de su primer acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor escolha o t" + ir + "tulo do seu primer acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_ANREDE1"
				endif
			endif
			if empty( alleFelder[ I_VORNAME1 ] )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "Geben Sie den Vornamen der ersten Sie begleitenden Person ein!"
				case sprache == "fr"
					fehlertext += "Entrez vous le pr" + er + "nom de votre premier compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please enter the first name of the first person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor ingrese el Nombre de su primer acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor cadastre o Nome do seu primer acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_VORNAME1"
				endif
			endif
			if empty( alleFelder[ I_NACHNAME1 ] )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "Geben Sie den Nachnamen der ersten Sie begleitenden Person ein!"
				case sprache == "fr"
					fehlertext += "Entrez vous le nom de votre premier compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please enter the last name of the first person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor ingrese el Apellido de su primer acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor cadastre o Sobrenome do seu primer acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_NACHNAME1"
				endif
			endif
			if alleFelder[ I_TEILNEHMER1 ] == "0"
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "W" + ae + "hlen Sie das Verwandtschaftsverh" + ae + "ltnis zu der ersten Sie begleitenden Person aus!"
				case sprache == "fr"
					fehlertext += "Choisez vous le lien de parent" + er + " de votre premier compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please select the kind of relationship with the first person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor ingrese el tipo de relaci" + or + "n con su primer acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor cadastre o tipo de amarra" + cc + ati + "o com seu primer acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_TEILNEHMER1"
				endif
			endif
			if val( alleFelder[ I_SHIRT1 ] ) == 0
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "W" + ae + "hlen Sie die T-Shirt-Gr" + oe + sz + "e der ersten Sie begleitenden Person aus!"
				case sprache == "fr"
					fehlertext += "Choisez vous le taille du t-shirt de votre premier compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please select the size of tee-shirt of the first person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor seleccione la talla de remera de su primer acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor escolha o tamanho da camiseta do seu primer acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_SHIRT1"
				endif
			endif
		endif
		if .not. ( empty( alleFelder[ I_VORNAME2 ] ) .and. empty( alleFelder[ I_NACHNAME2 ] ) )
			if alleFelder[ I_ANREDE2 ] == "0"
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "W" + ae + "hlen Sie die Anrede der zweiten Sie begleitenden Person aus!"
				case sprache == "fr"
					fehlertext += "Choisez vous le titre donn" + er + " de votre deuxi" + el + "me compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please select the title of the second person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor seleccione el t" + ir + "tulo de su segundo acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor escolha o t" + ir + "tulo do seu segundo acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_ANREDE2"
				endif
			endif
			if empty( alleFelder[ I_VORNAME2 ] )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "Geben Sie den Vornamen der zweiten Sie begleitenden Person ein!"
				case sprache == "fr"
					fehlertext += "Entrez vous le pr" + er + "nom de votre deuxi" + el + "me compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please enter the first name of the second person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor ingrese el Nombre de su segundo acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor cadastre o Nome do seu segundo acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_VORNAME2"
				endif
			endif
			if empty( alleFelder[ I_NACHNAME2 ] )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "Geben Sie den Nachnamen der zweiten Sie begleitenden Person ein!"
				case sprache == "fr"
					fehlertext += "Entrez vous le nom de votre deuxi" + el + "me compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please enter the last name of the second person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor ingrese el Apellido de su segundo acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor cadastre o Sobrenome do seu segundo acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_NACHNAME2"
				endif
			endif
			if alleFelder[ I_TEILNEHMER2 ] == "0"
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "W" + ae + "hlen Sie das Verwandtschaftsverh" + ae + "ltnis zu der zweiten Sie begleitenden Person aus!"
				case sprache == "fr"
					fehlertext += "Choisez vous le lien de parent" + er + " de votre deuxi" + el + "me compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please select the kind of relationship with the second person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor ingrese el tipo de relaci" + or + "n con su segundo acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor cadastre o tipo de amarra" + cc + ati + "o com seu segundo acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_TEILNEHMER2"
				endif
			endif
			if val( alleFelder[ I_SHIRT2 ] ) == 0
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "W" + ae + "hlen Sie die T-Shirt-Gr" + oe + sz + "e der zweiten Sie begleitenden Person aus!"
				case sprache == "fr"
					fehlertext += "Choisez vous le taille du t-shirt de votre deuxi" + el + "me compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please select the size of tee-shirt of the second person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor seleccione la talla de remera de su segundo acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor escolha o tamanho da camiseta do seu segundo acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_SHIRT2"
				endif
			endif
		endif
		if .not. ( empty( alleFelder[ I_VORNAME3 ] ) .and. empty( alleFelder[ I_NACHNAME3 ] ) )
			if alleFelder[ I_ANREDE3 ] == "0"
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "W" + ae + "hlen Sie die Anrede der dritten Sie begleitenden Person aus!"
				case sprache == "fr"
					fehlertext += "Choisez vous le titre donn" + er + " de votre tierce compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please select the title of the third person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor seleccione el t" + ir + "tulo de su tercer acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor escolha o t" + ir + "tulo do seu tercer acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_ANREDE3"
				endif
			endif
			if empty( alleFelder[ I_VORNAME3 ] )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "Geben Sie den Vornamen der dritten Sie begleitenden Person ein!"
				case sprache == "fr"
					fehlertext += "Entrez vous le pr" + er + "nom de votre tierce compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please enter the first name of the third person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor ingrese el Nombre de su tercer acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor cadastre o Nome do seu tercer acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_VORNAME3"
				endif
			endif
			if empty( alleFelder[ I_NACHNAME3 ] )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "Geben Sie den Nachnamen der dritten Sie begleitenden Person ein!"
				case sprache == "fr"
					fehlertext += "Entrez vous le nom de votre tierce compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please enter the last name of the third person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor ingrese el Apellido de su tercer acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor cadastre o Sobrenome do seu tercer acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_NACHNAME3"
				endif
			endif
			if alleFelder[ I_TEILNEHMER3 ] == "0"
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "W" + ae + "hlen Sie das Verwandtschaftsverh" + ae + "ltnis zu der dritten Sie begleitenden Person aus!"
				case sprache == "fr"
					fehlertext += "Choisez vous le lien de parent" + er + " de votre tierce compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please select the kind of relationship with the third person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor ingrese el tipo de relaci" + or + "n con su tercer acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor cadastre o tipo de amarra" + cc + ati + "o com seu tercer acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_TEILNEHMER3"
				endif
			endif
			if val( alleFelder[ I_SHIRT3 ] ) == 0
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "W" + ae + "hlen Sie die T-Shirt-Gr" + oe + sz + "e der dritten Sie begleitenden Person aus!"
				case sprache == "fr"
					fehlertext += "Choisez vous le taille du t-shirt de votre tierce compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please select the size of tee-shirt of the third person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor seleccione la talla de remera de su tercer acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor escolha o tamanho da camiseta do seu tercer acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_SHIRT3"
				endif
			endif
		endif
		if ( alleFelder[ I_SHUTTLE ] <> "0" ) .and. ( empty( alleFelder[ I_UHRAB ] ) )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Wenn Sie vom Flughafen abgeholt werden wollen, m" + ue + "ssen Sie auch eine Uhrzeit angeben!"
			case sprache == "fr"
				fehlertext += "Si vous voulez " + ed + "tre recu " + al + " l'a" + er + "roport, vous devez aussi indiquer l'heure accordante!"
			case sprache == "uk"
				fehlertext += "If you want to be picked up from the airport you have to provide the time!"
			case sprache == "sp"
				fehlertext += "Si desea transporte desde el aeropuerto debe informar la hora!"
			case sprache == "pt"
				fehlertext += "Se deseja transporte desde o aeroporto debe informar uma hora!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_UHRAB"
			endif
		elseif ( alleFelder[ I_SHUTTLE ] == "0" ) .and. ( .not. empty( alleFelder[ I_UHRAB ] ) )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Wenn Sie eine Zeit angeben, zu der Sie abgeholt werden wollen, m" + ue + "ssen Sie auch den Flughafen ausw" + ae + "hlen!"
			case sprache == "fr"
				fehlertext += "Si vous indiquez l'heure de recevoir, vous devez aussi choisir l'a" + er + "roport!"
			case sprache == "uk"
				fehlertext += "If you provide the time you want to be picked up from the airport you also have to choose the airport!"
			case sprache == "sp"
				fehlertext += "Si informa la hora a la que desea transporte desde el aeropuerto tambi" + er + "n debe elegir un aeropuerto!"
			case sprache == "pt"
				fehlertext += "Se informa a hora na que deseja transporte desde o aeroporto tamb" + er + "m tem que escolher um aeroporto!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_SHUTTLE"
			endif
		elseif ( alleFelder[ I_SHUTTLE ] <> "0" ) .and. ( .not. empty( alleFelder[ I_UHRAB ] ) )
			satz := at( ":", alleFelder[ I_UHRAB ] )
			if satz > 0
				std := val( left( alleFelder[ I_UHRAB ], satz - 1 ) )
				minu := val( substr( alleFelder[ I_UHRAB ], satz + 1 ) )
			else
				std := val( left( right( "0000" + alltrim( alleFelder[ I_UHRAB ] ), 4 ), 2 ) )
				minu := val( right( "0000" + alltrim( alleFelder[ I_UHRAB ] ), 2 ) )
			endif
			if ( std < 0 ) .or. ( std > 24 ) .or. ( minu < 0 ) .or. ( minu > 59 )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "Bitte geben Sie eine g" + ue + "ltige Abholzeit ein!"
				case sprache == "fr"
					fehlertext += "Veullez saisir une heure valide de recevoir s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please provide a valid pickup-time!"
				case sprache == "sp"
					fehlertext += "Por favor informe una hora v" + ar + "lida para el transporte al arribo!"
				case sprache == "pt"
					fehlertext += "Por favor informe uma hora v" + ar + "lida para o transporte na chegada!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_UHRAB"
				endif
			else
				satz := (std * 100 ) + minu
				if ( satz < 800 ) .or. ( satz > 1200 )
					if .not. empty( fehlertext )
						fehlertext += "<BR>"
					endif
					do case
					case sprache == "de"
						fehlertext += "Das Abholen am Flughafen ist nur zwischen 8 Uhr und 12 Uhr m" + oe + "glich!"
					case sprache == "fr"
						fehlertext += "Recevoir " + al + " l'a" + er + "roport est de 8h " + al + " 12h!"
					case sprache == "uk"
						fehlertext += "Pickup at the airport is only possible between 08:00 CET and 12:00 CET!"
					case sprache == "sp"
						fehlertext += "El transporte desde el aeropuerto es posible solamente entre las 08:00 hs y 12:00 hs (Horario Central Europeo)!"
					case sprache == "pt"
						fehlertext += "O transporte desde o aeroporto eh poss" + ir + "vel somente entre as 08:00 hs e 12:00 hs (Hor" + ar + "rio Central Europeu)!"
					endcase
					if empty( fehlerobj )
						fehlerobj := "F_UHRAB"
					endif
				endif
			endif
			alleFelder[ I_UHRAB ] := right( "00" + alltrim( str( std ) ), 2 ) + ":" + right( "00" + alltrim( str( minu ) ), 2 )
		endif
		if ( alleFelder[ I_SHUTTLER ] <> "0" ) .and. ( empty( alleFelder[ I_UHRHIN ] ) )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Wenn Sie zum Flughafen gebracht werden wollen, m" + ue + "ssen Sie auch eine Uhrzeit angeben!"
			case sprache == "fr"
				fehlertext += "Si vous voulez " + ed + "tre reconduit " + al + " l'a" + er + "roport, vous devez aussi indiquer l'heure accordante!"
			case sprache == "uk"
				fehlertext += "If you want to be taken to the airport you have to provide the time!"
			case sprache == "sp"
				fehlertext += "Si desea transporte hasta el aeropuerto debe informar la hora!"
			case sprache == "pt"
				fehlertext += "Se deseja transporte hasta o aeroporto debe informar uma hora!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_UHRHIN"
			endif
		elseif ( alleFelder[ I_SHUTTLER ] == "0" ) .and. ( .not. empty( alleFelder[ I_UHRHIN ] ) )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Wenn Sie eine Zeit angeben, zu der Sie gebracht werden wollen, m" + ue + "ssen Sie auch den Flughafen ausw" + ae + "hlen!"
			case sprache == "fr"
				fehlertext += "Si vous indiquez l'heure pour " + ed + "tre reconduit " + al + " l'a" + er + "roport, vous devez aussi choisir l'a" + er + "roport!"
			case sprache == "uk"
				fehlertext += "If you provide the time you want to be taken to the airport you also have to choose the airport!"
			case sprache == "sp"
				fehlertext += "Si informa la hora a la que desea transporte hacia el aeropuerto tambi" + er + "n debe elegir un aeropuerto!"
			case sprache == "pt"
				fehlertext += "Se informa a hora na que deseja transporte at" + er + " o aeroporto tamb" + er + "m tem que escolher um aeroporto!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_SHUTTLER"
			endif
		elseif ( alleFelder[ I_SHUTTLER ] <> "0" ) .and. ( .not. empty( alleFelder[ I_UHRHIN ] ) )
			satz := at( ":", alleFelder[ I_UHRHIN ] )
			if satz > 0
				std := val( left( alleFelder[ I_UHRHIN ], satz - 1 ) )
				minu := val( substr( alleFelder[ I_UHRHIN ], satz + 1 ) )
			else
				std := val( left( right( "0000" + alltrim( alleFelder[ I_UHRHIN ] ), 4 ), 2 ) )
				minu := val( right( "0000" + alltrim( alleFelder[ I_UHRHIN ] ), 2 ) )
			endif
			if ( std < 0 ) .or. ( std > 24 ) .or. ( minu < 0 ) .or. ( minu > 59 )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "Bitte geben Sie eine g" + ue + "ltige Abfahrtszeit ein!"
				case sprache == "fr"
					fehlertext += "Veullez saisir une heure valide du d" + er + "part s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please provide a valid departure time!"
				case sprache == "sp"
					fehlertext += "Por favor informe una hora v" + ar + "lida para el transporte al regreso!"
				case sprache == "pt"
					fehlertext += "Por favor informe uma hora v" + ar + "lida para o transporte na volta!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_UHRHIN"
				endif
			else
				satz := (std * 100 ) + minu
				if ( satz < 1700 ) .or. ( satz > 2100 )
					if .not. empty( fehlertext )
						fehlertext += "<BR>"
					endif
					do case
					case sprache == "de"
						fehlertext += "Das Bringen zum Flughafen ist nur zwischen 17 Uhr und 21 Uhr m" + oe + "glich!"
					case sprache == "fr"
						fehlertext += "Reconduire " + al + " l'a" + er + "roport est de 17h " + al + " 21h!"
					case sprache == "uk"
						fehlertext += "You can only be taken to the airport between 17:00 CET and 21:00 CET!"
					case sprache == "sp"
						fehlertext += "El transporte hacia el aeropuerto es posible solamente entre las 17:00 hs y 21:00 hs (Horario Central Europeo)!"
					case sprache == "pt"
						fehlertext += "O transporte at" + er + " o aeroporto eh poss" + ir + "vel somente entre as 17:00 hs e 21:00 hs (Hor" + ar + "rio Central Europeu)!"
					endcase
					if empty( fehlerobj )
						fehlerobj := "F_UHRHIN"
					endif
				endif
			endif
			alleFelder[ I_UHRHIN ] := right( "00" + alltrim( str( std ) ), 2 ) + ":" + right( "00" + alltrim( str( minu ) ), 2 )
		endif

		IF .not. Empty( fehlertext )
			do case
			case sprache == "de"
				ueberschr := "Fehlerhafte Eingabe, bitte korrigieren"
			case sprache == "fr"
				ueberschr := "L'entr" + er +"e est erron" + er + ", corrigez s'il vous pla" + id + "t"
			case sprache == "uk"
				ueberschr := "Wrong input, please correct"
			case sprache == "sp"
				ueberschr := "Entrada err" + or + "nea, por favor corrija"
			case sprache == "pt"
				ueberschr := "Entrada errada, por favor acerte"
			endcase
		ENDIF

		if .not. empty( ueberschr )
			text1 := MeldeHeader( "Meldung_eingeben", fehlerobj, spr_xx )
			text1 += Fehlermeldung( ueberschr, fehlertext )

			text1 += "<FORM name='Meldung_eingeben' method='post' action='/CheckEntry1?'>" + CRLF
			text1 += "<input type=hidden name='" + oServer:SessionTag + "' value='" + oClient:GetSessionHandle() + "'>" + CRLF
			text1 += '<input type=hidden name="MenuVar" value="' + sprache + '">' + CRLF

			text1 += BuildTable( sprache, 1, .f., Date() )
			text1 += '<BR><HR><BR>' + CRLF

			text1 += '<input type=submit value="' + MEMVAR->texte[ knopfmeld, spr_xx ] + '">' + CRLF
			text1 += "</FORM></CENTER>" + MeldeFooter()

		else

			std := 0
			if ( val( alleFelder[ I_TEILNEHMER ] ) == 1 ) .or. ( val( alleFelder[ I_TEILNEHMER ] ) == 8 )
				std := iif( val( dtos( date() ) ) < MEMVAR->earlybird, MEMVAR->preisnorm1, iif( val( dtos( date() ) ) < MEMVAR->latebird, MEMVAR->preisnorm2, MEMVAR->preisnorm3 ) )
			elseif ( val( alleFelder[ I_TEILNEHMER ] ) < 5 ) .or. ( val( alleFelder[ I_TEILNEHMER ] ) == 7 )
				std := iif( val( dtos( date() ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( date() ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) )
			else
				std := "0"
			endif
			if val( alleFelder[ I_TEILNEHMER1 ] ) == 1
				std += iif( val( dtos( date() ) ) < MEMVAR->earlybird, MEMVAR->preisnorm1, iif( val( dtos( date() ) ) < MEMVAR->latebird, MEMVAR->preisnorm2, MEMVAR->preisnorm3 ) )
			elseif val( alleFelder[ I_TEILNEHMER1 ] ) > 1
				std += iif( val( dtos( date() ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( date() ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) )
			endif
			if val( alleFelder[ I_TEILNEHMER2 ] ) == 1
				std += iif( val( dtos( date() ) ) < MEMVAR->earlybird, MEMVAR->preisnorm1, iif( val( dtos( date() ) ) < MEMVAR->latebird, MEMVAR->preisnorm2, MEMVAR->preisnorm3 ) )
			elseif val( alleFelder[ I_TEILNEHMER2 ] ) > 1
				std += iif( val( dtos( date() ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( date() ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) )
			endif
			if val( alleFelder[ I_TEILNEHMER3 ] ) == 1
				std += iif( val( dtos( date() ) ) < MEMVAR->earlybird, MEMVAR->preisnorm1, iif( val( dtos( date() ) ) < MEMVAR->latebird, MEMVAR->preisnorm2, MEMVAR->preisnorm3 ) )
			elseif val( alleFelder[ I_TEILNEHMER3 ] ) > 1
				std += iif( val( dtos( date() ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( date() ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) )
			endif
			alleFelder[ I_PREIS ] := alltrim( str( std, 6, 2 ) )
			alleFelder[ I_TEILNEHMID ] := "DC07DE" + right( "0000" + alltrim( str( MEMVAR->dcid++ ) ), 4 )
			nHandle := FCreate( mempfad + "\" + alleFelder[ I_TEILNEHMID ] + ".MEM" )
			FWrite( nHandle, Var2Bin( alleFelder ) )
			FClose( nHandle )
				oMail := MIMEMessage():new()
				oMail:setFrom( MailAddress():new( WEBMASTER ) )
				oMail:addRecipient( MailAddress():new( MEMVAR->cMailadress1 ) )
				oMail:addHeader( "CC", MEMVAR->cMailadress2 )
	      oMail:setSubject( "Anmeld[eversuch|ung] zur DevCon 2007" )
				oMail:setMessage( "Es gibt eine weitere (versuchte) Anmeldung zur DevCon!" + CRLF + "Name: " + alltrim( alleFelder[ I_VORNAME ] ) + " " + alltrim( alleFelder[ I_NACHNAME ] ) + CRLF + "E-Mail: " + alltrim( alleFelder[ I_EMAIL ] ) )
//				oMail:setMessage( "Es gibt eine weitere (versuchte) Anmeldung zur DevCon!" + CRLF + "Name: " + alltrim( alleFelder[ I_VORNAME ] ) + " " + alltrim( alleFelder[ I_NACHNAME ] ) )
				oSmtp := SMTPClient():new( MEMVAR->cSMTPserver )
				IF oSmtp:connect( MEMVAR->cMailuser, MEMVAR->cMailpassword )
					oSmtp:send( oMail )
					oSmtp:disconnect()
				ELSE
					SaveToFile( ConvToAnsiCp( "______ Xb2.NET ERROR __________ E-mail error _________________" + DtoC( Date() ) + "_" + Time() + CRLF + "E-mail cannot be send!" ), SERVER_ERR_LOG_FILE )
				ENDIF

			bla := alleFelder[ I_LAND ]
			std := val( alleFelder[ I_MUTTERSPRA ] )
			bla1 := ""
			do case
				case std == 1
					bla1 := "DE"
				case std == 2
					bla1 := "FR"
				case std == 3
					bla1 := "US"
				case std == 4
					bla1 := "ES"
				case std == 5
					bla1 := "PT"
				case std == 6
					bla1 := "DK"
				case std == 7
					bla1 := "IT"
				case std == 8
					bla1 := "NL"
				case std == 9
					bla1 := "NO"
				case std == 10
					bla1 := "PL"
				case std == 11
					bla1 := "FI"
				case std == 12
					bla1 := "SE"
				case std == 13
					bla1 := "TR"
				case std == 14
					bla1 := "SK"
				case std == 15
					bla1 := "HU"
				case std == 18
					bla1 := "CZ"
			endcase
			do case
				case bla == "A"
					bla := "AT"
				case bla == "AUS"
					bla := "AU"
				case bla == "B"
					bla := "BE"
				case bla == "CDN"
					bla := "CA"
				case bla == "D"
					bla := "DE"
				case bla == "DOM"
					bla := "DO"
					if empty( bla1 )
						bla1 := "DO"
					endif
				case bla == "E"
					bla := "ES"
				case bla == "EST"
					bla := "EE"
					if empty( bla1 )
						bla1 := "EE"
					endif
				case bla == "F"
					bla := "FR"
				case bla == "FIN"
					bla := "FI"
				case bla == "H"
					bla := "HU"
				case bla == "I"
					bla := "IT"
				case bla == "IND"
					bla := "IN"
					if empty( bla1 )
						bla1 := "IN"
					endif
				case bla == "IRL"
					bla := "IE"
				case bla == "J"
					bla := "JP"
				case bla == "JA"
					bla := "JM"
				case bla == "L"
					bla := "LU"
					if empty( bla1 )
						bla1 := "LU"
					endif
				case bla == "M"
					bla := "MT"
					if empty( bla1 )
						bla1 := "MT"
					endif
				case bla == "MAL"
					bla := "MY"
					if empty( bla1 )
						bla1 := "MY"
					endif
				case bla == "MEX"
					bla := "MX"
					if empty( bla1 )
						bla1 := "MX"
					endif
				case bla == "N"
					bla := "NO"
				case bla == "P"
					bla := "PT"
				case bla == "RA"
					bla := "AR"
					if empty( bla1 )
						bla1 := "AR"
					endif
				case bla == "RC"
					bla := "CN"
					if empty( bla1 )
						bla1 := "CN"
					endif
				case bla == "RCH"
					bla := "CL"
					if empty( bla1 )
						bla1 := "CL"
					endif
				case bla == "ROK"
					bla := "KR"
				case bla == "ROU"
					bla := "UY"
				case bla == "S"
					bla := "SE"
				case bla == "SGP"
					bla := "SG"
					if empty( bla1 )
						bla1 := "SG"
					endif
				case bla == "SLO"
					bla := "SI"
					if empty( bla1 )
						bla1 := "SI"
					endif
				case bla == "T"
					bla := "TH"
				case bla == "USA"
					bla := "US"
				case bla == "YV"
					bla := "VE"
			endcase
			if empty( bla1 )
				bla1 := "US"
			endif

			oHttp := xbHTTPClient():new()
			oHttp:Transport := VIA_WININET
			oForm := xbForm():new()
			oForm:MimeType := "text/html; charset=UTF-8"
			oForm:SetVar( "cmd", "_xclick" )
			oForm:SetVar( "business", MEMVAR->paypalac )
			oForm:SetVar( "currency_code", "EUR" )
			oForm:SetVar( "item_name", "DevCon 2007 - ID: " + alleFelder[ I_TEILNEHMID ] )
			oForm:SetVar( "city", alltrim( alleFelder[ I_ORT ] ) )
			oForm:SetVar( "address1", alltrim( alleFelder[ I_STRASSE ] ) )
			oForm:SetVar( "country", bla )
			oForm:SetVar( "email", alltrim( alleFelder[ I_EMAIL ] ) )
			oForm:SetVar( "first_name", alltrim( alleFelder[ I_VORNAME ] ) )
			oForm:SetVar( "last_name", alltrim( alleFelder[ I_NACHNAME ] ) )
			oForm:SetVar( "lc", upper( bla1 ) )
			if bla <> "DE"
				oForm:SetVar( "state", alltrim( alleFelder[ I_STAAT ] ) )
			endif
			oForm:SetVar( "rm", "2" )
			oForm:SetVar( "zip", alltrim( alleFelder[ I_PLZ ] ) )
			oForm:SetVar( "amount", alleFelder[ I_PREIS ] )
			oForm:SetVar( "notify_url", MEMVAR->paypalnurl + alleFelder[ I_TEILNEHMID ] )
			oForm:SetVar( "return", MEMVAR->paypalrurl + sprache )
			oForm:SetVar( "cancel_return", MEMVAR->paypalcrurl + sprache )
			
			oResp := oHttp:Execute( "https://www.paypal.com/cgi-bin/webscr","POST",oForm )
			if oResp == NIL
				text1 := '<html><head><meta http-equiv="content-type" content="text/html; charset=ISO-8859-1"><title>Error: PayPal not working!</title><link rel="stylesheet" href="devcon.css" type="text/css"></head><body BGCOLOR="#FFFFFF">' + "<B>Error:</B> <I>" + str(oHttp:ErrorCode) + '</T><P>' + oHttp:ErrorMessage + '<P>' + oHttp:ErrorSource + '<HR></BODY></HTML>'
			else
				text1 := oResp:Content
			endif
		endif


		if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
			oClient:HTTPResponse:CompressLevel := 7
		endif
		oClient:HTTPResponse:Content := text1
	endif
RETURN .t.

FUNCTION DC_CheckEntry5()
	local oClient := ThreadObject(), oServer := oClient:Parent
	local fehlertext, ueberschr, fehlerobj, aMems
	local alleFelder, sprache, text1, spr_xx, dDatum, DevConID
	local bla, bla1, bla2, datum2, satz, std, minu, nhandle, sch

	alleFelder := oClient:getCargo( "FELDER" )
	if alleFelder == NIL
		alleFelder := array( I_GESAMTFELDER )
	endif
	alleFelder[ I_ANREDE ] := oClient:getVar( "F_ANREDE" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_VORNAME" ) ), 1 )
	alleFelder[ I_VORNAME ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_NACHNAME" ) ), 1 )
	alleFelder[ I_NACHNAME ] := bla2
	alleFelder[ I_FIRMA1 ] := erszeichen( oClient:getVar( "F_FIRMA1" ) )
	alleFelder[ I_FIRMA2 ] := erszeichen( oClient:getVar( "F_FIRMA2" ) )
	alleFelder[ I_ABTEILUNG ] := erszeichen( oClient:getVar( "F_ABTEILUNG" ) )
	alleFelder[ I_STRASSE ] := erszeichen( oClient:getVar( "F_STRASSE" ) )
	alleFelder[ I_LAND ] := oClient:getVar( "F_LAND" )
	alleFelder[ I_STAAT ] := upper( erszeichen( oClient:getVar( "F_STAAT" ) ) )
	alleFelder[ I_PLZ ] := erszeichen( oClient:getVar( "F_PLZ" ) )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_ORT" ) ), 1 )
	alleFelder[ I_ORT ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_EMAIL ] := erszeichen( oClient:getVar( "F_EMAIL" ) )
	alleFelder[ I_WEBSEITE ] := erszeichen( oClient:getVar( "F_WEBSEITE" ) )
	alleFelder[ I_TEILNEHMER ] := oClient:getVar( "F_TEILNEHMER" )
	alleFelder[ I_MUTTERSPRA ] := oClient:getVar( "F_MUTTERSPRA" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_MUTTERSPSO" ) ), 1 )
	alleFelder[ I_MUTTERSPSO ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_FREMDSPRA1 ] := oClient:getVar( "F_FREMDSPRA1" )
	alleFelder[ I_FREMDSPRA2 ] := oClient:getVar( "F_FREMDSPRA2" )
	alleFelder[ I_VERSION ] := oClient:getVar( "F_VERSION" )
	alleFelder[ I_LAPTOP ] := ( oClient:getVar( "F_LAPTOP" ) == "on" )
	alleFelder[ I_DEVCON1 ] := ( oClient:getVar( "F_DEVCON1" ) == "on" )
	alleFelder[ I_DEVCON2 ] := ( oClient:getVar( "F_DEVCON2" ) == "on" )
	alleFelder[ I_DEVCON3 ] := ( oClient:getVar( "F_DEVCON3" ) == "on" )
	alleFelder[ I_DEVCON4 ] := ( oClient:getVar( "F_DEVCON4" ) == "on" )
	alleFelder[ I_DEVCON5 ] := ( oClient:getVar( "F_DEVCON5" ) == "on" )
	alleFelder[ I_ANONYM ] := ( oClient:getVar( "F_ANONYM" ) == "on" )
	alleFelder[ I_ANONYM1 ] := ( oClient:getVar( "F_ANONYM1" ) == "on" )
	alleFelder[ I_ANONYM2 ] := ( oClient:getVar( "F_ANONYM2" ) == "on" )
	alleFelder[ I_ANONYM3 ] := ( oClient:getVar( "F_ANONYM3" ) == "on" )
	alleFelder[ I_ANREDE1 ] := oClient:getVar( "F_ANREDE1" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_VORNAME1" ) ), 1 )
	alleFelder[ I_VORNAME1 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_NACHNAME1" ) ), 1 )
	alleFelder[ I_NACHNAME1 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_TEILNEHMER1 ] := oClient:getVar( "F_TEILNEHMER1" )
	alleFelder[ I_ANREDE2 ] := oClient:getVar( "F_ANREDE2" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_VORNAME2" ) ), 1 )
	alleFelder[ I_VORNAME2 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_NACHNAME2" ) ), 1 )
	alleFelder[ I_NACHNAME2 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_TEILNEHMER2 ] := oClient:getVar( "F_TEILNEHMER2" )
	alleFelder[ I_ANREDE3 ] := oClient:getVar( "F_ANREDE3" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_VORNAME3" ) ), 1 )
	alleFelder[ I_VORNAME3 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_NACHNAME3" ) ), 1 )
	alleFelder[ I_NACHNAME3 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_TEILNEHMER3 ] := oClient:getVar( "F_TEILNEHMER3" )
	alleFelder[ I_KSDELPHI ] := oClient:getVar( "F_KSDELPHI" )
	alleFelder[ I_KSFOXPRO ] := oClient:getVar( "F_KSFOXPRO" )
	alleFelder[ I_KSFLAGSHIP ] := oClient:getVar( "F_KSFLAGSHIP" )
	alleFelder[ I_KSCLIPPER ] := oClient:getVar( "F_KSCLIPPER" )
	alleFelder[ I_KSCLIP4WIN ] := oClient:getVar( "F_KSCLIP4WIN" )
	alleFelder[ I_KSDBASE ] := oClient:getVar( "F_KSDBASE" )
	alleFelder[ I_KSVO ] := oClient:getVar( "F_KSVO" )
	alleFelder[ I_KSXHARBOUR ] := oClient:getVar( "F_KSXHARBOUR" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_SONSTIGE1" ) ), 1 )
	alleFelder[ I_SONSTIGE1 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_KSSONSTIG1 ] := oClient:getVar( "F_KSSONSTIG1" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_SONSTIGE2" ) ), 1 )
	alleFelder[ I_SONSTIGE2 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_KSSONSTIG2 ] := oClient:getVar( "F_KSSONSTIG2" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_SONSTIGE3" ) ), 1 )
	alleFelder[ I_SONSTIGE3 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_KSSONSTIG3 ] := oClient:getVar( "F_KSSONSTIG3" )
	alleFelder[ I_KSTOPDOWN ] := oClient:getVar( "F_KSTOPDOWN" )
	alleFelder[ I_KSEXPRESS ] := oClient:getVar( "F_KSEXPRESS" )
	alleFelder[ I_KSFIVEWIN ] := oClient:getVar( "F_KSFIVEWIN" )
	alleFelder[ I_KSSQLEXPRE ] := oClient:getVar( "F_KSSQLEXPRE" )
	alleFelder[ I_KSXB2NET ] := oClient:getVar( "F_KSXB2NET" )
	alleFelder[ I_KSXCLASS ] := oClient:getVar( "F_KSXCLASS" )
	alleFelder[ I_KSXBHCL ] := oClient:getVar( "F_KSXBHCL" )
	alleFelder[ I_KSCOCKPIT ] := oClient:getVar( "F_KSCOCKPIT" )
	alleFelder[ I_KSMARSHALL ] := oClient:getVar( "F_KSMARSHALL" )
	alleFelder[ I_KSLLABEL ] := oClient:getVar( "F_KSLLABEL" )
	alleFelder[ I_KSVPE ] := oClient:getVar( "F_KSVPE" )
	alleFelder[ I_KSRUNDR ] := oClient:getVar( "F_KSRUNDR" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_ADDONSONS1" ) ), 1 )
	alleFelder[ I_ADDONSONS1 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_KSADDOSON1 ] := oClient:getVar( "F_KSADDOSON1" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_ADDONSONS2" ) ), 1 )
	alleFelder[ I_ADDONSONS2 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_KSADDOSON2 ] := oClient:getVar( "F_KSADDOSON2" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_ADDONSONS3" ) ), 1 )
	alleFelder[ I_ADDONSONS3 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_KSADDOSON3 ] := oClient:getVar( "F_KSADDOSON3" )
	alleFelder[ I_INTSQL ] := ( oClient:getVar( "F_INTSQL" ) == "1" )
	alleFelder[ I_INTWEBANB ] := ( oClient:getVar( "F_INTWEBANB" ) == "1" )
	alleFelder[ I_INTMIGRAT ] := ( oClient:getVar( "F_INTMIGRAT" ) == "1" )
	alleFelder[ I_INTACTIVEX ] := ( oClient:getVar( "F_INTACTIVEX" ) == "1" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_INTSONSTI1" ) ), 1 )
	alleFelder[ I_INTSONSTI1 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_INTSONSTI2" ) ), 1 )
	alleFelder[ I_INTSONSTI2 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_INTSONSTI3" ) ), 1 )
	alleFelder[ I_INTSONSTI3 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_SHIRT ] := oClient:getVar( "F_SHIRT" )
	alleFelder[ I_SHIRT1 ] := oClient:getVar( "F_SHIRT1" )
	alleFelder[ I_SHIRT2 ] := oClient:getVar( "F_SHIRT2" )
	alleFelder[ I_SHIRT3 ] := oClient:getVar( "F_SHIRT3" )
	alleFelder[ I_SHUTTLE ] := oClient:getVar( "F_SHUTTLE" )
	alleFelder[ I_SHUTTLER ] := oClient:getVar( "F_SHUTTLER" )
	alleFelder[ I_UHRAB ] := oClient:getVar( "F_UHRAB" )
	alleFelder[ I_UHRHIN ] := oClient:getVar( "F_UHRHIN" )
	alleFelder[ I_ACCEPT ] := ( oClient:getVar( "F_ACCEPT" ) == "on" )

	oClient:setCargo( "FELDER", alleFelder )

	sprache := lower( oClient:getVar( "MenuVar" ) )
	dDatum := StoD( oClient:getVar( "Datum" ) )
	DevConID := oClient:getVar( "DevConID" )
	if ( sprache == NIL )
		oClient:HTTPResponse:Content := redirekt()
	else

		fehlertext := ""
		ueberschr := ""
		fehlerobj := ""
		do case
		case sprache == "de"
			spr_xx := spr_de
		case sprache == "fr"
			spr_xx := spr_fr
		case sprache == "uk"
			spr_xx := spr_uk
		case sprache == "sp"
			spr_xx := spr_sp
		case sprache == "pt"
			spr_xx := spr_pt
		endcase
		if alleFelder[ I_ANREDE ] == "0"
			do case
			case sprache == "de"
				fehlertext += "W" + ae + "hlen Sie die Anrede aus!"
			case sprache == "fr"
				fehlertext += "Choisez vous le titre, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please select the title!"
			case sprache == "sp"
				fehlertext += "Por favor seleccione el t" + ir + "tulo!"
			case sprache == "pt"
				fehlertext += "Por favor escolha o t" + ir + "tulo!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_ANREDE"
			endif
		endif
		if empty( alleFelder[ I_VORNAME ] )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Geben Sie Ihren Vornamen ein!"
			case sprache == "fr"
				fehlertext += "Appelez v" + od + "tre nom de famille, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please enter your first name!"
			case sprache == "sp"
				fehlertext += "Por favor ingrese su Nombre!"
			case sprache == "pt"
				fehlertext += "Por favor cadastre seu Nome!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_VORNAME"
			endif
		endif
		if empty( alleFelder[ I_NACHNAME ] )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Geben Sie Ihren Nachnamen ein!"
			case sprache == "fr"
				fehlertext += "Appelez v" + od + "tre pr" + er + "nom, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please enter your last name!"
			case sprache == "sp"
				fehlertext += "Por favor ingrese su Apellido!"
			case sprache == "pt"
				fehlertext += "Por favor cadastre seu Sobrenome!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_NACHNAME"
			endif
		endif
		if empty( alleFelder[ I_STRASSE ] )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Geben Sie Ihre Stra" + sz + "e ein!"
			case sprache == "fr"
				fehlertext += "Appelez v" + od + "tre rue, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please enter your street!"
			case sprache == "sp"
				fehlertext += "Por favor, ingrese su calle!"
			case sprache == "pt"
				fehlertext += "Por favor, cadastre seu endere" + cc + "o!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_STRASSE"
			endif
		endif
		if alleFelder[ I_LAND ] == "0"
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "W" + ae + "hlen Sie Ihr Land aus!"
			case sprache == "fr"
				fehlertext += "Choisissez v" + od + "tre " + er + "tat, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please choose your country!"
			case sprache == "sp"
				fehlertext += "Por favor, seleccione su pa" + ir + "s!"
			case sprache == "pt"
				fehlertext += "Por favor, escolha seu pa" + ir + "s!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_LAND"
			endif
		endif
		if empty( alleFelder[ I_STAAT ] )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Geben Sie Ihr Bundesland bzw. Kanton ein!"
			case sprache == "fr"
				fehlertext += "Appelez v" + od + "tre canton, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please enter your county or region!"
			case sprache == "sp"
				fehlertext += "Por favor, ingrese su Provincia o Regi" + or + "n Aut" + or + "noma!"
			case sprache == "pt"
				fehlertext += "Por favor, cadastre seu estado ou regi" + ati + "o!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_STAAT"
			endif
		endif
		if empty( alleFelder[ I_PLZ ] )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Geben Sie Ihre Postleitzahl ein!"
			case sprache == "fr"
				fehlertext += "Appelez v" + od + "tre code postal, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please enter your postcode (zipcode)!"
			case sprache == "sp"
				fehlertext += "Por favor, ingrese su c" + or + "digo postal (zipcode)!"
			case sprache == "pt"
				fehlertext += "Por favor, cadastre seu c" + or + "digo postal (CEP)!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_PLZ"
			endif
		endif
		if empty( alleFelder[ I_ORT ] )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Geben Sie Ihren Ort ein!"
			case sprache == "fr"
				fehlertext += "Appelez v" + od + "tre lieu, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please enter your city!"
			case sprache == "sp"
				fehlertext += "Por favor, ingrese su ciudad!"
			case sprache == "pt"
				fehlertext += "Por favor, cadastre sua cidade!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_ORT"
			endif
		endif
		if empty( alleFelder[ I_EMAIL ] )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Geben Sie Ihre E-Mailadresse ein!"
			case sprache == "fr"
				fehlertext += "Entrez vous votre adresse e-mail!"
			case sprache == "uk"
				fehlertext += "Please provide your e-mail-address!"
			case sprache == "sp"
				fehlertext += "Por favor, informe su direcci" + or + "n de e-mail!"
			case sprache == "pt"
				fehlertext += "Por favor, informe seu endere" + cc + "o de e-mail!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_EMAIL"
			endif
		else
			bla := alltrim( alleFelder[ I_EMAIL ] )
			datum2 := at( "@", bla )
			if ( datum2 == 0 ) .or. ( at( ".", bla, datum2 + 1 ) == 0 )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "Geben Sie eine g" + ue + "ltige E-Mailadresse ein!"
				case sprache == "fr"
					fehlertext += "Entrez vous une adresse e-mail valable!"
				case sprache == "uk"
					fehlertext += "Please provide a valid e-mail-address!"
				case sprache == "sp"
					fehlertext += "Por favor, informe una direcci" + or + "n v" + ar + "lida de e-mail!"
				case sprache == "pt"
					fehlertext += "Por favor, informe um endere" + cc + "o v" + ar + "lido de e-mail!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_EMAIL"
				endif
			endif
		endif
		if ( .not. empty( alleFelder[ I_WEBSEITE ] ) ) .and. ( at( ".", alltrim( alleFelder[ I_WEBSEITE ] ) ) == 0 )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Geben Sie eine g" + ue + "ltige Webseitenadresse ein!"
			case sprache == "fr"
				fehlertext += "Entrez vous une adresse valable du site de web!"
			case sprache == "uk"
				fehlertext += "Please provide a valid website-address!"
			case sprache == "sp"
				fehlertext += "Por favor, informe una direcci" + or + "n v" + ar + "lida para su website!"
			case sprache == "pt"
				fehlertext += "Por favor, informe um endere" + cc + "o v" + ar + "lido para seu website!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_WEBSEITE"
			endif
		endif
		if alleFelder[ I_TEILNEHMER ] == "0"
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "W" + ae + "hlen Sie Ihre Art der Teilnahme aus!"
			case sprache == "fr"
				fehlertext += "Choisissez v" + od + "tre forme de participation, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please choose the type of your participation!"
			case sprache == "sp"
				fehlertext += "Por favor, seleccione su tipo de participaci" + or + "n!"
			case sprache == "pt"
				fehlertext += "Por favor, escolha seu tipo de participa" + cc + ati + "o!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_TEILNEHMER"
			endif
		endif
		if alleFelder[ I_MUTTERSPRA ] == "0"
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "W" + ae + "hlen Sie Ihre Muttersprache aus!"
			case sprache == "fr"
				fehlertext += "Choisez v" + od + "tre langue maternelle, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please choose your native tongue!"
			case sprache == "sp"
				fehlertext += "Por favor, seleccione su lengua nativa!"
			case sprache == "pt"
				fehlertext += "Por favor, escolha sua linguagen nativa!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_MUTTERSPSO"
			endif
		endif
		if empty( alleFelder[ I_MUTTERSPSO ] ) .and. ( alleFelder[ I_MUTTERSPRA ] == "99" )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Geben Sie Ihre Muttersprache ein!"
			case sprache == "fr"
				fehlertext += "Appelez v" + od + "tre langue maternelle, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please provide your native tongue!"
			case sprache == "sp"
				fehlertext += "Por favor, informe su lengua nativa!"
			case sprache == "pt"
				fehlertext += "Por favor, informe sua linguagen nativa!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_MUTTERSPSO"
			endif
		endif
		if val( alleFelder[ I_SHIRT ] ) == 0
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "W" + ae + "hlen Sie Ihre T-Shirt-Gr" + oe + sz + "e aus!"
			case sprache == "fr"
				fehlertext += "Choisez v" + od + "tre taille du t-shirt, s.v.p.!"
			case sprache == "uk"
				fehlertext += "Please select your size of tee-shirt!"
			case sprache == "sp"
				fehlertext += "Por favor seleccione su talla de remera!"
			case sprache == "pt"
				fehlertext += "Por favor escolha o tamanho da sua camiseta!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_SHIRT"
			endif
		endif
		if .not. alleFelder[ I_ACCEPT ]
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Sie m" + ue + "ssen die Teilnahmebedingungen akzeptieren!"
			case sprache == "fr"
				fehlertext += "Il faut que vous acceptez les conditions de participation!"
			case sprache == "uk"
				fehlertext += "You have to accept the conditions for participating!"
			case sprache == "sp"
				fehlertext += "Debe aceptar las condiciones para participar!"
			case sprache == "pt"
				fehlertext += "Voc" + ed + " tem que aceitar as condi" + cc + ot + "es para participar!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_ACCEPT"
			endif
		endif
		if .not. ( empty( alleFelder[ I_VORNAME1 ] ) .and. empty( alleFelder[ I_NACHNAME1 ] ) )
			if alleFelder[ I_ANREDE1 ] == "0"
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "W" + ae + "hlen Sie die Anrede der ersten Sie begleitenden Person aus!"
				case sprache == "fr"
					fehlertext += "Choisez vous le titre donn" + er + " de votre premier compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please select the title of the first person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor seleccione el t" + ir + "tulo de su primer acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor escolha o t" + ir + "tulo do seu primer acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_ANREDE1"
				endif
			endif
			if empty( alleFelder[ I_VORNAME1 ] )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "Geben Sie den Vornamen der ersten Sie begleitenden Person ein!"
				case sprache == "fr"
					fehlertext += "Entrez vous le pr" + er + "nom de votre premier compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please enter the first name of the first person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor ingrese el Nombre de su primer acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor cadastre o Nome do seu primer acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_VORNAME1"
				endif
			endif
			if empty( alleFelder[ I_NACHNAME1 ] )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "Geben Sie den Nachnamen der ersten Sie begleitenden Person ein!"
				case sprache == "fr"
					fehlertext += "Entrez vous le nom de votre premier compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please enter the last name of the first person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor ingrese el Apellido de su primer acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor cadastre o Sobrenome do seu primer acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_NACHNAME1"
				endif
			endif
			if alleFelder[ I_TEILNEHMER1 ] == "0"
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "W" + ae + "hlen Sie das Verwandtschaftsverh" + ae + "ltnis zu der ersten Sie begleitenden Person aus!"
				case sprache == "fr"
					fehlertext += "Choisez vous le lien de parent" + er + " de votre premier compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please select the kind of relationship with the first person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor ingrese el tipo de relaci" + or + "n con su primer acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor cadastre o tipo de amarra" + cc + ati + "o com seu primer acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_TEILNEHMER1"
				endif
			endif
			if val( alleFelder[ I_SHIRT1 ] ) == 0
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "W" + ae + "hlen Sie die T-Shirt-Gr" + oe + sz + "e der ersten Sie begleitenden Person aus!"
				case sprache == "fr"
					fehlertext += "Choisez vous le taille du t-shirt de votre premier compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please select the size of tee-shirt of the first person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor seleccione la talla de remera de su primer acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor escolha o tamanho da camiseta do seu primer acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_SHIRT1"
				endif
			endif
		endif
		if .not. ( empty( alleFelder[ I_VORNAME2 ] ) .and. empty( alleFelder[ I_NACHNAME2 ] ) )
			if alleFelder[ I_ANREDE2 ] == "0"
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "W" + ae + "hlen Sie die Anrede der zweiten Sie begleitenden Person aus!"
				case sprache == "fr"
					fehlertext += "Choisez vous le titre donn" + er + " de votre deuxi" + el + "me compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please select the title of the second person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor seleccione el t" + ir + "tulo de su segundo acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor escolha o t" + ir + "tulo do seu segundo acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_ANREDE2"
				endif
			endif
			if empty( alleFelder[ I_VORNAME2 ] )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "Geben Sie den Vornamen der zweiten Sie begleitenden Person ein!"
				case sprache == "fr"
					fehlertext += "Entrez vous le pr" + er + "nom de votre deuxi" + el + "me compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please enter the first name of the second person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor ingrese el Nombre de su segundo acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor cadastre o Nome do seu segundo acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_VORNAME2"
				endif
			endif
			if empty( alleFelder[ I_NACHNAME2 ] )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "Geben Sie den Nachnamen der zweiten Sie begleitenden Person ein!"
				case sprache == "fr"
					fehlertext += "Entrez vous le nom de votre deuxi" + el + "me compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please enter the last name of the second person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor ingrese el Apellido de su segundo acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor cadastre o Sobrenome do seu segundo acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_NACHNAME2"
				endif
			endif
			if alleFelder[ I_TEILNEHMER2 ] == "0"
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "W" + ae + "hlen Sie das Verwandtschaftsverh" + ae + "ltnis zu der zweiten Sie begleitenden Person aus!"
				case sprache == "fr"
					fehlertext += "Choisez vous le lien de parent" + er + " de votre deuxi" + el + "me compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please select the kind of relationship with the second person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor ingrese el tipo de relaci" + or + "n con su segundo acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor cadastre o tipo de amarra" + cc + ati + "o com seu segundo acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_TEILNEHMER2"
				endif
			endif
			if val( alleFelder[ I_SHIRT2 ] ) == 0
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "W" + ae + "hlen Sie die T-Shirt-Gr" + oe + sz + "e der zweiten Sie begleitenden Person aus!"
				case sprache == "fr"
					fehlertext += "Choisez vous le taille du t-shirt de votre deuxi" + el + "me compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please select the size of tee-shirt of the second person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor seleccione la talla de remera de su segundo acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor escolha o tamanho da camiseta do seu segundo acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_SHIRT2"
				endif
			endif
		endif
		if .not. ( empty( alleFelder[ I_VORNAME3 ] ) .and. empty( alleFelder[ I_NACHNAME3 ] ) )
			if alleFelder[ I_ANREDE3 ] == "0"
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "W" + ae + "hlen Sie die Anrede der dritten Sie begleitenden Person aus!"
				case sprache == "fr"
					fehlertext += "Choisez vous le titre donn" + er + " de votre tierce compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please select the title of the third person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor seleccione el t" + ir + "tulo de su tercer acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor escolha o t" + ir + "tulo do seu tercer acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_ANREDE3"
				endif
			endif
			if empty( alleFelder[ I_VORNAME3 ] )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "Geben Sie den Vornamen der dritten Sie begleitenden Person ein!"
				case sprache == "fr"
					fehlertext += "Entrez vous le pr" + er + "nom de votre tierce compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please enter the first name of the third person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor ingrese el Nombre de su tercer acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor cadastre o Nome do seu tercer acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_VORNAME3"
				endif
			endif
			if empty( alleFelder[ I_NACHNAME3 ] )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "Geben Sie den Nachnamen der dritten Sie begleitenden Person ein!"
				case sprache == "fr"
					fehlertext += "Entrez vous le nom de votre tierce compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please enter the last name of the third person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor ingrese el Apellido de su tercer acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor cadastre o Sobrenome do seu tercer acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_NACHNAME3"
				endif
			endif
			if alleFelder[ I_TEILNEHMER3 ] == "0"
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "W" + ae + "hlen Sie das Verwandtschaftsverh" + ae + "ltnis zu der dritten Sie begleitenden Person aus!"
				case sprache == "fr"
					fehlertext += "Choisez vous le lien de parent" + er + " de votre tierce compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please select the kind of relationship with the third person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor ingrese el tipo de relaci" + or + "n con su tercer acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor cadastre o tipo de amarra" + cc + ati + "o com seu tercer acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_TEILNEHMER3"
				endif
			endif
			if val( alleFelder[ I_SHIRT3 ] ) == 0
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "W" + ae + "hlen Sie die T-Shirt-Gr" + oe + sz + "e der dritten Sie begleitenden Person aus!"
				case sprache == "fr"
					fehlertext += "Choisez vous le taille du t-shirt de votre tierce compagnon, s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please select the size of tee-shirt of the third person joining you!"
				case sprache == "sp"
					fehlertext += "Por favor seleccione la talla de remera de su tercer acompa" + nt + "ante!"
				case sprache == "pt"
					fehlertext += "Por favor escolha o tamanho da camiseta do seu tercer acompanhante!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_SHIRT3"
				endif
			endif
		endif
		if ( alleFelder[ I_SHUTTLE ] <> "0" ) .and. ( empty( alleFelder[ I_UHRAB ] ) )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Wenn Sie vom Flughafen abgeholt werden wollen, m" + ue + "ssen Sie auch eine Uhrzeit angeben!"
			case sprache == "fr"
				fehlertext += "Si vous voulez " + ed + "tre recu " + al + " l'a" + er + "roport, vous devez aussi indiquer l'heure accordante!"
			case sprache == "uk"
				fehlertext += "If you want to be picked up from the airport you have to provide the time!"
			case sprache == "sp"
				fehlertext += "Si desea transporte desde el aeropuerto debe informar la hora!"
			case sprache == "pt"
				fehlertext += "Se deseja transporte desde o aeroporto debe informar uma hora!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_UHRAB"
			endif
		elseif ( alleFelder[ I_SHUTTLE ] == "0" ) .and. ( .not. empty( alleFelder[ I_UHRAB ] ) )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Wenn Sie eine Zeit angeben, zu der Sie abgeholt werden wollen, m" + ue + "ssen Sie auch den Flughafen ausw" + ae + "hlen!"
			case sprache == "fr"
				fehlertext += "Si vous indiquez l'heure de recevoir, vous devez aussi choisir l'a" + er + "roport!"
			case sprache == "uk"
				fehlertext += "If you provide the time you want to be picked up from the airport you also have to choose the airport!"
			case sprache == "sp"
				fehlertext += "Si informa la hora a la que desea transporte desde el aeropuerto tambi" + er + "n debe elegir un aeropuerto!"
			case sprache == "pt"
				fehlertext += "Se informa a hora na que deseja transporte desde o aeroporto tamb" + er + "m tem que escolher um aeroporto!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_SHUTTLE"
			endif
		elseif ( alleFelder[ I_SHUTTLE ] <> "0" ) .and. ( .not. empty( alleFelder[ I_UHRAB ] ) )
			satz := at( ":", alleFelder[ I_UHRAB ] )
			if satz > 0
				std := val( left( alleFelder[ I_UHRAB ], satz - 1 ) )
				minu := val( substr( alleFelder[ I_UHRAB ], satz + 1 ) )
			else
				std := val( left( right( "0000" + alltrim( alleFelder[ I_UHRAB ] ), 4 ), 2 ) )
				minu := val( right( "0000" + alltrim( alleFelder[ I_UHRAB ] ), 2 ) )
			endif
			if ( std < 0 ) .or. ( std > 24 ) .or. ( minu < 0 ) .or. ( minu > 59 )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "Bitte geben Sie eine g" + ue + "ltige Abholzeit ein!"
				case sprache == "fr"
					fehlertext += "Veullez saisir une heure valide de recevoir s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please provide a valid pickup-time!"
				case sprache == "sp"
					fehlertext += "Por favor informe una hora v" + ar + "lida para el transporte al arribo!"
				case sprache == "pt"
					fehlertext += "Por favor informe uma hora v" + ar + "lida para o transporte na chegada!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_UHRAB"
				endif
			else
				satz := (std * 100 ) + minu
				if ( satz < 800 ) .or. ( satz > 1200 )
					if .not. empty( fehlertext )
						fehlertext += "<BR>"
					endif
					do case
					case sprache == "de"
						fehlertext += "Das Abholen am Flughafen ist nur zwischen 8 Uhr und 12 Uhr m" + oe + "glich!"
					case sprache == "fr"
						fehlertext += "Recevoir " + al + " l'a" + er + "roport est de 8h " + al + " 12h!"
					case sprache == "uk"
						fehlertext += "Pickup at the airport is only possible between 08:00 CET and 12:00 CET!"
					case sprache == "sp"
						fehlertext += "El transporte desde el aeropuerto es posible solamente entre las 08:00 hs y 12:00 hs (Horario Central Europeo)!"
					case sprache == "pt"
						fehlertext += "O transporte desde o aeroporto eh poss" + ir + "vel somente entre as 08:00 hs e 12:00 hs (Hor" + ar + "rio Central Europeu)!"
					endcase
					if empty( fehlerobj )
						fehlerobj := "F_UHRAB"
					endif
				endif
			endif
			alleFelder[ I_UHRAB ] := right( "00" + alltrim( str( std ) ), 2 ) + ":" + right( "00" + alltrim( str( minu ) ), 2 )
		endif
		if ( alleFelder[ I_SHUTTLER ] <> "0" ) .and. ( empty( alleFelder[ I_UHRHIN ] ) )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Wenn Sie zum Flughafen gebracht werden wollen, m" + ue + "ssen Sie auch eine Uhrzeit angeben!"
			case sprache == "fr"
				fehlertext += "Si vous voulez " + ed + "tre reconduit " + al + " l'a" + er + "roport, vous devez aussi indiquer l'heure accordante!"
			case sprache == "uk"
				fehlertext += "If you want to be taken to the airport you have to provide the time!"
			case sprache == "sp"
				fehlertext += "Si desea transporte hasta el aeropuerto debe informar la hora!"
			case sprache == "pt"
				fehlertext += "Se deseja transporte hasta o aeroporto debe informar uma hora!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_UHRHIN"
			endif
		elseif ( alleFelder[ I_SHUTTLER ] == "0" ) .and. ( .not. empty( alleFelder[ I_UHRHIN ] ) )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			do case
			case sprache == "de"
				fehlertext += "Wenn Sie eine Zeit angeben, zu der Sie gebracht werden wollen, m" + ue + "ssen Sie auch den Flughafen ausw" + ae + "hlen!"
			case sprache == "fr"
				fehlertext += "Si vous indiquez l'heure pour " + ed + "tre reconduit " + al + " l'a" + er + "roport, vous devez aussi choisir l'a" + er + "roport!"
			case sprache == "uk"
				fehlertext += "If you provide the time you want to be taken to the airport you also have to choose the airport!"
			case sprache == "sp"
				fehlertext += "Si informa la hora a la que desea transporte hacia el aeropuerto tambi" + er + "n debe elegir un aeropuerto!"
			case sprache == "pt"
				fehlertext += "Se informa a hora na que deseja transporte at" + er + " o aeroporto tamb" + er + "m tem que escolher um aeroporto!"
			endcase
			if empty( fehlerobj )
				fehlerobj := "F_SHUTTLER"
			endif
		elseif ( alleFelder[ I_SHUTTLER ] <> "0" ) .and. ( .not. empty( alleFelder[ I_UHRHIN ] ) )
			satz := at( ":", alleFelder[ I_UHRHIN ] )
			if satz > 0
				std := val( left( alleFelder[ I_UHRHIN ], satz - 1 ) )
				minu := val( substr( alleFelder[ I_UHRHIN ], satz + 1 ) )
			else
				std := val( left( right( "0000" + alltrim( alleFelder[ I_UHRHIN ] ), 4 ), 2 ) )
				minu := val( right( "0000" + alltrim( alleFelder[ I_UHRHIN ] ), 2 ) )
			endif
			if ( std < 0 ) .or. ( std > 24 ) .or. ( minu < 0 ) .or. ( minu > 59 )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				do case
				case sprache == "de"
					fehlertext += "Bitte geben Sie eine g" + ue + "ltige Abfahrtszeit ein!"
				case sprache == "fr"
					fehlertext += "Veullez saisir une heure valide du d" + er + "part s.v.p.!"
				case sprache == "uk"
					fehlertext += "Please provide a valid departure time!"
				case sprache == "sp"
					fehlertext += "Por favor informe una hora v" + ar + "lida para el transporte al regreso!"
				case sprache == "pt"
					fehlertext += "Por favor informe uma hora v" + ar + "lida para o transporte na volta!"
				endcase
				if empty( fehlerobj )
					fehlerobj := "F_UHRHIN"
				endif
			else
				satz := (std * 100 ) + minu
				if ( satz < 1700 ) .or. ( satz > 2100 )
					if .not. empty( fehlertext )
						fehlertext += "<BR>"
					endif
					do case
					case sprache == "de"
						fehlertext += "Das Bringen zum Flughafen ist nur zwischen 17 Uhr und 21 Uhr m" + oe + "glich!"
					case sprache == "fr"
						fehlertext += "Reconduire " + al + " l'a" + er + "roport est de 17h " + al + " 21h!"
					case sprache == "uk"
						fehlertext += "You can only be taken to the airport between 17:00 CET and 21:00 CET!"
					case sprache == "sp"
						fehlertext += "El transporte hacia el aeropuerto es posible solamente entre las 17:00 hs y 21:00 hs (Horario Central Europeo)!"
					case sprache == "pt"
						fehlertext += "O transporte at" + er + " o aeroporto eh poss" + ir + "vel somente entre as 17:00 hs e 21:00 hs (Hor" + ar + "rio Central Europeu)!"
					endcase
					if empty( fehlerobj )
						fehlerobj := "F_UHRHIN"
					endif
				endif
			endif
			alleFelder[ I_UHRHIN ] := right( "00" + alltrim( str( std ) ), 2 ) + ":" + right( "00" + alltrim( str( minu ) ), 2 )
		endif

		IF .not. Empty( fehlertext )
			do case
			case sprache == "de"
				ueberschr := "Fehlerhafte Eingabe, bitte korrigieren"
			case sprache == "fr"
				ueberschr := "L'entr" + er +"e est erron" + er + ", corrigez s'il vous pla" + id + "t"
			case sprache == "uk"
				ueberschr := "Wrong input, please correct"
			case sprache == "sp"
				ueberschr := "Entrada err" + or + "nea, por favor corrija"
			case sprache == "pt"
				ueberschr := "Entrada errada, por favor acerte"
			endcase
		ENDIF

		if .not. empty( ueberschr )
			text1 := MeldeHeader( "Meldung_eingeben", fehlerobj, spr_xx )
			text1 += Fehlermeldung( ueberschr, fehlertext )

			text1 += "<FORM name='Meldung_eingeben' method='post' action='/CheckEntry5?'>" + CRLF
			text1 += "<input type=hidden name='" + oServer:SessionTag + "' value='" + oClient:GetSessionHandle() + "'>" + CRLF
			text1 += '<input type=hidden name="MenuVar" value="' + sprache + '">' + CRLF
			text1 += '<input type=hidden name="Datum" value="' + dtos( dDatum ) + '">' + CRLF

			text1 += BuildTable( sprache, 1, .t., dDatum )
			text1 += '<BR><HR><BR>' + CRLF

			text1 += '<input type=submit value="' + MEMVAR->texte[ knopfmeld, spr_xx ] + '">' + CRLF
			text1 += "</FORM></CENTER>" + MeldeFooter()
			if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
				oClient:HTTPResponse:CompressLevel := 7
			endif
			oClient:HTTPResponse:Content := text1
		else
			do case
			case val( alleFelder[ I_MUTTERSPRA ] ) == spr_de
				sprache := "de"
			case val( alleFelder[ I_MUTTERSPRA ] ) == spr_fr
				sprache := "fr"
			case val( alleFelder[ I_MUTTERSPRA ] ) == spr_sp
				sprache := "sp"
			case val( alleFelder[ I_MUTTERSPRA ] ) == spr_pt
				sprache := "pt"
			otherwise
				sprache := "uk"
			endcase
			OpenDbf()
			sch := DevConID
			satz := 0
			if SaveEntry( @satz, @sch, 1, .t., alleFelder )
				CloseDbf()
				Druckausgabe( sprache, sch, alleFelder, .f., dDatum )
				aMems := Directory( mempfad + "\" + sch + ".*" )
				AEval( aMems, { |a| FErase( mempfad + "\" + a[ F_NAME ] ) } )
				DC_PayPalStati()
			else
				CloseDbf()
				return .f.
			endif
		endif
	endif
RETURN .t.

FUNCTION DC_PayPal_CancelReturn()
local oClient := ThreadObject()
local sprache, text1, spr_xx, bla
	sprache := oClient:GetVar( "MenuVar" )
	do case
	case sprache == "de"
		spr_xx := spr_de
	case sprache == "fr"
		spr_xx := spr_fr
	case sprache == "sp"
		spr_xx := spr_sp
	case sprache == "pt"
		spr_xx := spr_pt
	otherwise
		spr_xx := spr_uk
	endcase
	text1 := MeldeHeader( "", "", spr_xx )
	text1 += '<B>'
	if upper( sprache ) == "DE"
		text1 += "Da Sie den Zahlungsvorgang abgebrochen haben, wurde Ihre Anmeldung nicht angenommen!"
	elseif upper( sprache ) == "FR"
		text1 += gal + " cause de votre interruption du paiement votre enregistration n'est pas accept" + er + "e!"
	elseif upper( sprache ) == "SP"
		text1 += "Como Ud. ha cancelado el procedimiento de pago, se ha cancelado su inscripci" + or + "n!"
	else
		text1 += "As you have cancelled the payment process your registration has not been accepted!"
	endif
	
	text1 += '</B><BR>' + CRLF
	text1 += "</CENTER>" + MeldeFooter()
	if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
		oClient:HTTPResponse:CompressLevel := 7
	endif
	oClient:HTTPResponse:Content := text1
RETURN .t.

FUNCTION DC_PayPal_Return()
local oClient := ThreadObject()
local sprache, text1, spr_xx, bla
	sprache := oClient:GetVar( "MenuVar" )
	do case
	case sprache == "de"
		spr_xx := spr_de
	case sprache == "fr"
		spr_xx := spr_fr
	case sprache == "sp"
		spr_xx := spr_sp
	case sprache == "pt"
		spr_xx := spr_pt
	otherwise
		spr_xx := spr_uk
	endcase
	text1 := MeldeHeader( "", "", spr_xx )
	if upper( sprache ) == "DE"
		text1 += "<B>Vielen Dank!</B><BR>Sobald die Zahlung unserem Konto gutgeschrieben wurde, erhalten Sie eine Best" + ae + "tigung per Email!"
	elseif upper( sprache ) == "FR"
		text1 += "<B>Merci beaucoup!</B><BR>D" + el + "s que le paiement est cr" + er + "dit" + er + " " + al + " notre compte, vous serez confirm" + er + " par courrier " + er + "lectronique!"
	elseif upper( sprache ) == "SP"
		text1 += "<B>Gracias por inscribirse!</B><BR>En cuanto los fondos se hayan acreditado en nuestra cuenta corriente, le mandaremos una confirmaci" + or + "n por e-mail!"
	else
		text1 += "<B>Thank you!</B><BR>As soon as your money has been transfered into our account a confirmation will be sent to you via e-mail!"
	endif
	
	text1 += '<BR><HR><BR>' + CRLF
	text1 += "</CENTER>" + MeldeFooter()
	if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
		oClient:HTTPResponse:CompressLevel := 7
	endif
	oClient:HTTPResponse:Content := text1
RETURN .t.

FUNCTION DC_PayPal_IPN_Validate()
local oClient := ThreadObject()
local oHttp, oForm, oResp, aVar, nHandle, aLogs, sprache, aFile
local cDevConID, cFiles, aFiles, nI, nLen, sch, satz, bla, dDatum
local PP_PS, PP_RE, PP_MGR, PP_PGR, alleFelder, RespCont, oMail, oSmtp
	cDevConID := oClient:GetVar( "DevConID" )
	aVar := oClient:GetVar(, VAR_CONTENT)
	PP_PS := oClient:GetVar( "payment_status" )
	PP_RE := oClient:GetVar( "receiver_email" )
	PP_MGR := oClient:GetVar( "mc_gross" )
	PP_PGR := oClient:GetVar( "payment_gross" )
	aLogs := Directory( mempfad + "\" + cDevConID + ".*.LOG" )
	nHandle := FCreate( mempfad + "\" + cDevConID + "." + right( "00" + alltrim( str( len( aLogs ) + 1 ) ), 2 ) + ".LOG" )
	FWrite( nHandle, strtran( var2char( aVar ), "}, ", "}," + CRLF ) )
	FClose( nHandle )
	oHttp := xbHTTPClient():new()
	oHttp:Transport := VIA_WININET
	oForm := xbForm():new()
	oForm:SetVar( aVar )
	oForm:SetVar( "cmd", "_notify-validate" )
	oResp := oHttp:Execute("https://www.paypal.com/cgi-bin/webscr","POST",oForm)
	if oResp == NIL
		aLogs := Directory( mempfad + "\" + cDevConID + ".*.ERR" )
		nHandle := FCreate( mempfad + "\" + cDevConID + "." + right( "00" + alltrim( str( len( aLogs ) + 1 ) ), 2 ) + ".ERR" )
		FWrite( nHandle, "Error: " + str( oHttp:ErrorCode ) + CRLF )
		FWrite( nHandle, "       " + oHttp:ErrorMessage + CRLF )
		FWrite( nHandle, "       " + oHttp:ErrorSource + CRLF )
		FClose( nHandle )
		aFiles := Directory( mempfad + "\" + cDevConID + ".*" )
		nLen := len( aFiles )
		cFiles := {}
		for nI := 1 to nLen
			if upper( right( aFiles[ nI, F_NAME ], 3 ) ) <> "MEM"
				Aadd( cFiles, mempfad + "\" + aFiles[ nI, F_NAME ] )
			endif
		next
		oMail := MIMEMessage():new()
		oMail:setFrom( MailAddress():new( WEBMASTER ) )
		oMail:addRecipient( MailAddress():new( MEMVAR->cMailadress1 ) )
		oMail:addHeader( "CC", MEMVAR->cMailadress2 )
		oMail:setSubject( "!! Error during PayPal-transaction !!" )
		oMail:setMessage( "Please find attached the errorlogs of DevCon-ID #" + cDevConID + "!" )
		AEval( cFiles, {|cFile| oMail:attachFile( cFile ) } )
		oSmtp := SMTPClient():new( MEMVAR->cSMTPserver )
		IF oSmtp:connect( MEMVAR->cMailuser, MEMVAR->cMailpassword )
			oSmtp:send( oMail )
			oSmtp:disconnect()
		ELSE
			SaveToFile( ConvToAnsiCp( "______ Xb2.NET ERROR __________ E-mail error _________________" + DtoC( Date() ) + "_" + Time() + CRLF + "E-mail cannot be send!" ), SERVER_ERR_LOG_FILE )
			SaveToFile( ConvToAnsiCp( "______ PayPal ERROR ___________ PayPal-transaction error _____" + DtoC( Date() ) + "_" + Time() + CRLF + "Transaction not processed! DevCon-ID: " + cDevConID ), SERVER_ERR_LOG_FILE )
		endif
	else
		RespCont := oResp:Content
		aLogs := Directory( mempfad + "\" + cDevConID + ".*.LOG" )
		nHandle := FCreate( mempfad + "\" + cDevConID + "." + right( "00" + alltrim( str( len( aLogs ) + 1 ) ), 2 ) + ".LOG" )
		FWrite( nHandle, RespCont )
		FClose( nHandle )
		aFiles := Directory( mempfad + "\" + cDevConID + ".*" )
		if upper( RespCont ) == "VERIFIED"
			if ( upper( MEMVAR->PAYPALAC ) == upper( PP_RE ) ) .and. ( upper( PP_PS ) == "COMPLETED" )
				if file( mempfad + "\" + cDevConID + ".MEM" )
					aFile := Directory( mempfad + "\" + cDevConID + ".MEM" )
					if len( aFile ) > 0
						dDatum := aFile[ 1, F_CREATION_DATE ]
					else
						dDatum := Date()
					endif
					nHandle := FOpen( mempfad + "\" + cDevConID + ".MEM" )
					sch := FSeek( nHandle, 0 , FS_END )
					bla := space( sch )
					FSeek( nHandle, 0 , FS_SET )
					FRead( nHandle, @bla, sch )
					FClose( nHandle )
					alleFelder := Bin2Var( bla )
					if ( val( alleFelder[ I_PREIS ] ) == val( PP_MGR ) ) .or. ( val( alleFelder[ I_PREIS ] ) == val( PP_PGR ) )
						do case
						case val( alleFelder[ I_MUTTERSPRA ] ) == spr_de
							sprache := "de"
						case val( alleFelder[ I_MUTTERSPRA ] ) == spr_fr
							sprache := "fr"
						case val( alleFelder[ I_MUTTERSPRA ] ) == spr_sp
							sprache := "sp"
						case val( alleFelder[ I_MUTTERSPRA ] ) == spr_pt
							sprache := "pt"
						otherwise
							sprache := "uk"
						endcase
						alleFelder[ I_ZAHLEINGAN ] := DtoC( Date() )
						alleFelder[ I_ZAHLART ] := "1"
						OpenDbf()
						sch := ""
						satz := 0
						if SaveEntry( @satz, @sch, 1, .f., alleFelder )
							CloseDbf()
							Druckausgabe( sprache, sch, alleFelder, .f., dDatum )
							AEval( aFiles, { |a| FErase( mempfad + "\" + a[ F_NAME ] ) } )
						else
							CloseDbf()
							return .f.
						endif
					else
						nLen := len( aFiles )
						cFiles := {}
						for nI := 1 to nLen
							if upper( right( aFiles[ nI, F_NAME ], 3 ) ) <> "MEM"
								Aadd( cFiles, mempfad + "\" + aFiles[ nI, F_NAME ] )
							endif
						next
						oMail := MIMEMessage():new()
						oMail:setFrom( MailAddress():new( WEBMASTER ) )
						oMail:addRecipient( MailAddress():new( MEMVAR->cMailadress1 ) )
						oMail:addHeader( "CC", MEMVAR->cMailadress2 )
						oMail:setSubject( "!! Invalid PayPal-payment (amount) DevCon-ID: " + cDevConID + " !!" )
						oMail:setMessage( "Please find attached the errorlogs of DevCon-ID #" + cDevConID + "!" )
						AEval( cFiles, {|cFile| oMail:attachFile( cFile ) } )
						oSmtp := SMTPClient():new( MEMVAR->cSMTPserver )
						IF oSmtp:connect( MEMVAR->cMailuser, MEMVAR->cMailpassword )
							oSmtp:send( oMail )
							oSmtp:disconnect()
						ELSE
							SaveToFile( ConvToAnsiCp( "______ Xb2.NET ERROR __________ E-mail error _________________" + DtoC( Date() ) + "_" + Time() + CRLF + "E-mail cannot be send!" ), SERVER_ERR_LOG_FILE )
							SaveToFile( ConvToAnsiCp( "______ PayPal ERROR ___________ Fraud amount _________________" + DtoC( Date() ) + "_" + Time() + CRLF + "Transaction-amount differs from the invoice-amount! DevCon-ID: " + cDevConID ), SERVER_ERR_LOG_FILE )
						endif
					endif
				endif
			elseif upper( MEMVAR->PAYPALAC ) <> upper( PP_RE )
				nLen := len( aFiles )
				cFiles := {}
				for nI := 1 to nLen
					if upper( right( aFiles[ nI, F_NAME ], 3 ) ) <> "MEM"
						Aadd( cFiles, mempfad + "\" + aFiles[ nI, F_NAME ] )
					endif
				next
				oMail := MIMEMessage():new()
				oMail:setFrom( MailAddress():new( WEBMASTER ) )
				oMail:addRecipient( MailAddress():new( MEMVAR->cMailadress1 ) )
				oMail:addHeader( "CC", MEMVAR->cMailadress2 )
				oMail:setSubject( "!! Invalid PayPal-payment (receiveraccount) DevCon-ID: " + cDevConID + " !!" )
				oMail:setMessage( "Please find attached the errorlogs of DevCon-ID #" + cDevConID + "!" )
				AEval( cFiles, {|cFile| oMail:attachFile( cFile ) } )
				oSmtp := SMTPClient():new( MEMVAR->cSMTPserver )
				IF oSmtp:connect( MEMVAR->cMailuser, MEMVAR->cMailpassword )
					oSmtp:send( oMail )
					oSmtp:disconnect()
				ELSE
					SaveToFile( ConvToAnsiCp( "______ Xb2.NET ERROR __________ E-mail error _________________" + DtoC( Date() ) + "_" + Time() + CRLF + "E-mail cannot be send!" ), SERVER_ERR_LOG_FILE )
					SaveToFile( ConvToAnsiCp( "______ PayPal ERROR ___________ Fraud receiver _______________" + DtoC( Date() ) + "_" + Time() + CRLF + "PayPal-receiveraccount is different to the one received back! DevCon-ID: " + cDevConID ), SERVER_ERR_LOG_FILE )
				endif
			endif
		else
			nLen := len( aFiles )
			cFiles := {}
			for nI := 1 to nLen
				if upper( right( aFiles[ nI, F_NAME ], 3 ) ) <> "MEM"
					Aadd( cFiles, mempfad + "\" + aFiles[ nI, F_NAME ] )
				endif
			next
			oMail := MIMEMessage():new()
			oMail:setFrom( MailAddress():new( WEBMASTER ) )
			oMail:addRecipient( MailAddress():new( MEMVAR->cMailadress1 ) )
			oMail:addHeader( "CC", MEMVAR->cMailadress2 )
			oMail:setSubject( "!! Invalid PayPal-payment DevCon-ID: " + cDevConID + " !!" )
			oMail:setMessage( "Please find attached the errorlogs of DevCon-ID #" + cDevConID + "!" )
			AEval( cFiles, {|cFile| oMail:attachFile( cFile ) } )
			oSmtp := SMTPClient():new( MEMVAR->cSMTPserver )
			IF oSmtp:connect( MEMVAR->cMailuser, MEMVAR->cMailpassword )
				oSmtp:send( oMail )
				oSmtp:disconnect()
			ELSE
				SaveToFile( ConvToAnsiCp( "______ Xb2.NET ERROR __________ E-mail error _________________" + DtoC( Date() ) + "_" + Time() + CRLF + "E-mail cannot be send!" ), SERVER_ERR_LOG_FILE )
				SaveToFile( ConvToAnsiCp( "______ PayPal ERROR ___________ Invalid PayPal-payment _______" + DtoC( Date() ) + "_" + Time() + CRLF + "PayPal-transaction invalid! DevCon-ID: " + cDevConID ), SERVER_ERR_LOG_FILE )
			endif
		endif
	endif

RETURN .t.

PROCEDURE Druckausgabe( sprache, sch, Felder, anzeige, dDatum )
local oClient := ThreadObject(), 	thinter, nHandle, ueberschr, fehlertext
local spr_xx, alle, nr, bla, bla1, bla2, nsum, text, lRlock, i, text1, anred, aSaal, aZeit

	do case
	case sprache == "de"
		spr_xx := spr_de
		if Felder[ I_ANREDE ] $ "234"
			anred := "Frau"
		else
			anred := "Herr"
		endif
	case sprache == "fr"
		spr_xx := spr_fr
		if Felder[ I_ANREDE ] $ "234"
			anred := "Mme"
		else
			anred := "M."
		endif
	case sprache == "uk"
		spr_xx := spr_uk
		if Felder[ I_ANREDE ] == "2"
			anred := "Mrs."
		elseif Felder[ I_ANREDE ] == "3"
			anred := "Ms."
		elseif Felder[ I_ANREDE ] == "4"
			anred := "Miss."
		else
			anred := "Mr."
		endif
	case sprache == "sp"
		spr_xx := spr_sp
		if Felder[ I_ANREDE ] == "2"
			anred := "Sra."
		elseif Felder[ I_ANREDE ] $ "34"
			anred := "Srita."
		else
			anred := "Sr."
		endif
	case sprache == "pt"
		spr_xx := spr_pt
		if Felder[ I_ANREDE ] == "2"
			anred := "Sra."
		elseif Felder[ I_ANREDE ] $ "34"
			anred := "Senhorita"
		else
			anred := "Sr."
		endif
	endcase

	thinter := "#CCFFFF"

	text1 := '<html> ' + CRLF
	text1 += '<head>' + CRLF
	text1 += '<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">' + CRLF
	text1 += '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">' + CRLF
	text1 += '<META HTTP-EQUIV="Cache-Control" CONTENT="no-cache">' + CRLF
	text1 += '<META HTTP-EQUIV="Expires" CONTENT="-1">' + CRLF
	bla := strtran( alltrim( MEMVAR->texte[ devconueber, spr_xx ] ), "</SUP>", "" )
	text1 += "<TITLE>" + strtran( alltrim( bla ), "<SUP>", "" ) + "</TITLE>" + CRLF
  text1 += '<STYLE TYPE="text/css">' + CRLF
	text1 += 'body { margin-left:0Px; margin-right:0Px; margin-top:0Px; margin-bottom:0Px; }' + CRLF
	text1 += 'div,p,td,ul,ol,input,textarea { font-family:Verdana,Arial,Helvetica,Sans Serif; font-size:10Pt; text-decoration:none; }' + CRLF
	text1 += 'h1 { margin-top:24Px; margin-bottom:6Px; font-family:Verdana,Arial,Helvetica,Sans Serif; color:#333333; font-size:13Pt; text-decoration:none; }' + CRLF
	text1 += 'h2 { margin-top:12Px; margin-bottom:6Px; font-family:Verdana,Arial,Helvetica,Sans Serif; color:#333333; font-size:12Pt; text-decoration:none; }' + CRLF
	text1 += 'h3 { margin-top:12Px; margin-bottom:6Px; font-family:Verdana,Arial,Helvetica,Sans Serif; color:#333333; font-size:11Pt; text-decoration:none; }' + CRLF
	text1 += 'h4 { margin-top:12Px; margin-bottom:3Px; font-family:Verdana,Arial,Helvetica,Sans Serif; color:#333333; font-size:10Pt; text-decoration:none; font-weight:bold; }' + CRLF
	text1 += 'h5 { margin-top:12Px; margin-bottom:3Px; font-family:Verdana,Arial,Helvetica,Sans Serif; color:#333333; font-size:8Pt; text-decoration:none; font-weight:bold; }' + CRLF
	text1 += 'th { font-weight:bold; font-size:11Pt; text-align:left; color:#333333; background-color:#cccccc; }' + CRLF
	text1 += 'a { text-decoration:none; font-weight:bold }' + CRLF
	text1 += 'a:link { color: #990000; text-decoration:none }' + CRLF
	text1 += 'a:active { color: #990000; text-decoration:none }' + CRLF
	text1 += 'a:visited { color: #660000; text-decoration:none }' + CRLF
	text1 += 'a:hover { color: #cc0000; text-decoration:underline }' + CRLF
	text1 += 'em { text-decoration:none; font-style:italic; font-weight:bold }' + CRLF
	text1 += '.content { margin-top:0Px; margin-bottom:0Px; }' + CRLF
	text1 += '.pager { margin-top:24Px; text-align:center; font-size:8Pt; }' + CRLF
	text1 += '</STYLE></HEAD>' + CRLF
	text1 += '<body bgcolor="' + MEMVAR->shinter + '">' + CRLF
	text1 += '<CENTER>'
	text1 += '<H1>' + alltrim( MEMVAR->texte[ devconueber, spr_xx ] ) + "</H1>" + CRLF
	text1 += '<HR WIDTH="100%"><P>' + CRLF
	text1 += '<H2>' + alltrim( MEMVAR->texte[ meldebest, spr_xx ] ) + "</H2>" + CRLF
	text1 += '<HR WIDTH="80%"><P>' + CRLF
	text1 += '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + CRLF
	text1 += '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
	text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%"><B>' + MEMVAR->texte[ nameueb, spr_xx ] + ':</B><BR><I>' + anred + " " + alltrim( Felder[ I_VORNAME ] ) + " " + alltrim( Felder[ I_NACHNAME ] ) + '</I>' + CRLF
	text1 += '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
	text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%"><B>' + MEMVAR->texte[ firmaueb, spr_xx ] + ':</B><BR><I>' + alltrim( alltrim( Felder[ I_FIRMA1 ] ) + " " + alltrim( Felder[ I_FIRMA2 ] ) ) + '</I>' + CRLF
	text1 += '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
	text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%"><B>' + MEMVAR->texte[ abteilung, spr_xx ] + '</B><BR><I>' + alltrim( Felder[ I_ABTEILUNG ] ) + '</I>' + CRLF
	text1 += '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>' + CRLF
	text1 += '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="20%"><B>' + CRLF
	do case
	case sprache == "de"
		text1 += 'Ihre Anschrift:'
	case sprache == "fr"
		text1 += 'V' + od + 'tre adresse:'
	case sprache == "uk"
		text1 += 'Your address:'
	case sprache == "sp"
		text1 += 'Su domicilio:'
	case sprache == "pt"
		text1 += 'Seu Endere' + cc + 'o:'
	endcase
	text1 += '</B></TD><TD WIDTH="70%"><I>' + alltrim( Felder[ I_STRASSE ] ) + '<BR>'
	text1 += alltrim( Felder[ I_STAAT ] ) + " "
	text1 += alltrim( Felder[ I_PLZ ] ) + " " + alltrim( Felder[ I_ORT ] ) + '<BR>' + alltrim( Felder[ I_LAND ] )
	text1 += '</I></TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>' + CRLF
	do case
	case sprache == "de"
		anred := 'Sie nehmen teil als:</B><BR><I>'
	case sprache == "fr"
		anred := 'Inscrirez vous comme:</B><BR><I>'
	case sprache == "uk"
		anred := 'You are participating as:</B><BR><I>'
	case sprache == "sp"
		anred := 'Ud est' + ar + ' participando como:</B><BR><I>'
	case sprache == "pt"
		anred := 'Vc. est' + ar + ' participando como:</B><BR><I>'
	endcase
	text1 += '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="20%"><B>' + anred + CRLF
	do case
	case Felder[ I_TEILNEHMER ] == "1"
		text1 += MEMVAR->texte[ teiltnehmer, spr_xx ]
	case Felder[ I_TEILNEHMER ] == "2"
		text1 += MEMVAR->texte[ teilpartner, spr_xx ]
	case Felder[ I_TEILNEHMER ] == "3"
		text1 += MEMVAR->texte[ teilkind, spr_xx ]
	case Felder[ I_TEILNEHMER ] == "4"
		text1 += MEMVAR->texte[ teilfreund, spr_xx ]
	case Felder[ I_TEILNEHMER ] == "5"
		text1 += MEMVAR->texte[ teilredner, spr_xx ]
	case Felder[ I_TEILNEHMER ] == "6"
		text1 += MEMVAR->texte[ teilorgan, spr_xx ]
	case Felder[ I_TEILNEHMER ] == "7"
		text1 += MEMVAR->texte[ teilsonst, spr_xx ]
	case Felder[ I_TEILNEHMER ] == "8"
		text1 += MEMVAR->texte[ teilbpart, spr_xx ]
	case Felder[ I_TEILNEHMER ] == "9"
		text1 += MEMVAR->texte[ teiltpart, spr_xx ]
	endcase
	do case
	case sprache == "de"
		anred := 'Ihre E-Mailadresse lautet:</B><BR><I>'
	case sprache == "fr"
		anred := 'Votre addresse e-mail:</B><BR><I>'
	case sprache == "uk"
		anred := 'Your e-mail-address is as follows:</B><BR><I>'
	case sprache == "sp"
		anred := 'Su correo electr' + or + 'nico es:</B><BR><I>'
	case sprache == "pt"
		anred := 'Seu endere' + cc + 'o eletr' + or + 'nico ' + er + 's:</B><BR><I>'
	endcase
	text1 += '</I></TD><TD WIDTH="30%"><B>' + anred + alltrim( Felder[ I_EMAIL ] ) + '</I></TD><TD WIDTH="30%"><B>'
	do case
	case sprache == "de"
		anred := 'Ihre Webseite lautet:</B><BR><I>'
	case sprache == "fr"
		anred := 'Votre site de web:</B><BR><I>'
	case sprache == "uk"
		anred := 'Your website is as follows:</B><BR><I>'
	case sprache == "sp"
		anred := 'Su sitio web es:</B><BR><I>'
	case sprache == "pt"
		anred := 'Seu website ' + er + 's:</B><BR><I>'
	endcase
	text1 += anred + alltrim( Felder[ I_WEBSEITE ] ) + '</I></TD>'
	text1 += '<TD WIDTH="10%"><B>' + MEMVAR->texte[ tshirt, spr_xx ] + ':</B><BR><I>'

	do case
	case Felder[ I_SHIRT ] == "1"
		text1 += "S"
	case Felder[ I_SHIRT ] == "2"
		text1 += "M"
	case Felder[ I_SHIRT ] == "3"
		text1 += "L"
	case Felder[ I_SHIRT ] == "4"
		text1 += "XL"
	case Felder[ I_SHIRT ] == "5"
		text1 += "XXL"
	case Felder[ I_SHIRT ] == "6"
		text1 += "XS"
	case Felder[ I_SHIRT ] == "7"
		text1 += "XXXL"
	endcase

	text1 += '</I></TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>' + CRLF
	text1 += '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
	if ( Felder[ I_TEILNEHMER ] == "5" ) .or. Felder[ I_TEILNEHMER ] == "9"
		if ( Felder[ I_SAAL ] <> "0" ) .and. ( Felder[ I_SAAL ] <> NIL )
			aSaal := { "Saal 1", "Saal 2", "kleiner Saal" }
			aZeit := { "13:00", "14:30", "16:00", "17:30" }
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%"><B>' + MEMVAR->texte[ textpcw, spr_xx ] + '</B>' + NBSP + '<I>' + MEMVAR->texte[ textsaal, spr_xx ] + NBSP + aSaal[ val( Felder[ I_SAAL ] ) ]
			text1 += ',' + NBSP + MEMVAR->texte[ textzeit, spr_xx ] + NBSP + aZeit[ val( Felder[ I_ZEIT ] ) ] + ',' + NBSP + MEMVAR->texte[ textthema, spr_xx ] + '<BR>' + Felder[ I_THEMA ] + '</I></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
			text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
		endif
	endif
	if Felder[ I_LAPTOP ]
		text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">'
		do case
		case sprache == "de"
			text1 += '<B>Sie wollen Ihren eigenen Laptop mitbringen!'
		case sprache == "fr"
			text1 += "<B>Pr" + er + "f" + er + "rez vous d'emporter votre laptop!"
		case sprache == "uk"
			text1 += '<B>You are going to bring your laptop!'
		case sprache == "sp"
			text1 += '<B>Ud est' + ar + ' trayendo su laptop!'
		case sprache == "pt"
			text1 += '<B>Vc. est' + ar + ' trazendo seu computador port' + ar + 'vel!'
		endcase
		text1 += '</B><BR></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
		text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
	endif
	text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%"><B>'

	do case
	case spr_xx == spr_de
		if Felder[ I_SHUTTLE ] == "1"
			text1 += 'Sie wollen am 13.11.2007 um ' + Felder[ I_UHRAB ] + ' Uhr vom Flughafen Tegel (TXL) zum Konferenzhotel gebracht werden!'
		elseif Felder[ I_SHUTTLE ] == "2"
			text1 += 'Sie wollen am 13.11.2007 um ' + Felder[ I_UHRAB ] + ' Uhr vom Flughafen Sch' + oe + 'nefeld (SXF) zum Konferenzhotel gebracht werden!'
		else
			text1 += 'Sie wollen nicht vom Flughafen abgeholt werden!'
		endif
	case spr_xx == spr_fr
		if Felder[ I_SHUTTLE ] == "1"
			text1 += 'Le 13.11.2007 ' + al + " " + Felder[ I_UHRAB ] + 'h vous voulez ' + ed + "tre reconduit de  l'a" + er + "eroport Tegel (TXL) " + al + " l'h" + od + "tel de conference!"
		elseif Felder[ I_SHUTTLE ] == "2"
			text1 += 'Le 13.11.2007 ' + al + " " + Felder[ I_UHRAB ] + 'h vous voulez ' + ed + "tre reconduit de  l'a" + er + "eroport Sch' + oe + 'nefeld (SXF) " + al + " l'h" + od + "tel de conference!"
		else
			text1 += "Vous ne voulez pas qu'on vous recoit " + al + " l'a" + er + "roport!"
		endif
	case spr_xx == spr_sp
		if Felder[ I_SHUTTLE ] == "1"
			text1 += 'Ud. desea transporte el 13 de Noviembre a las ' + Felder[ I_UHRAB ] + ' hs (Horario Central Europeo) desde el aeropuerto Tegel (TXL) hasta el hotel de la conferencia!'
		elseif Felder[ I_SHUTTLE ] == "2"
			text1 += 'Ud. desea transporte el 13 de Noviembre a las ' + Felder[ I_UHRAB ] + ' hs (Horario Central Europeo) desde el aeropuerto Sch' + oe + 'nefeld (SXF) hasta el hotel de la conferencia!'
		else
			text1 += 'Ud no desea ser transportado desde el aeropuerto!'
		endif
	case spr_xx == spr_pt
		if Felder[ I_SHUTTLE ] == "1"
			text1 += 'Vc. deseja transporte no 13 de Novembro ' + ar + 's ' + Felder[ I_UHRAB ] + ' (Hor' + ar + 'rio Central Europeu) desde o aeroporto Tegel (TXL) at' + er + ' o hotel da confer' + ed + 'ncia!'
		elseif Felder[ I_SHUTTLE ] == "2"
			text1 += 'Vc. deseja transporte no 13 de Novembro ' + ar + 's ' + Felder[ I_UHRAB ] + ' (Hor' + ar + 'rio Central Europeu) desde o aeroporto Sch' + oe + 'nefeld (SXF) at' + er + ' o hotel da confer' + ed + 'ncia!'
		else
			text1 += 'Vc. n' + ati + 'o deseja ser transportado desde o aeroporto!'
		endif
	otherwise
		if Felder[ I_SHUTTLE ] == "1"
			text1 += 'You want to be picked up on November 13<SUP>th</SUP> at ' + Felder[ I_UHRAB ] + ' CET from Tegel airport (TXL) and taken to the conference hotel!'
		elseif Felder[ I_SHUTTLE ] == "2"
			text1 += 'You want to be picked up on November 13<SUP>th</SUP> at ' + Felder[ I_UHRAB ] + ' CET from Sch' + oe + 'nefeld airport (SXF) and taken to the conference hotel!'
		else
			text1 += 'You do not want to be picked up from the airport!'
		endif
	endcase
	text1 += '</B><BR><B>'
		do case
		case spr_xx == spr_de
			if Felder[ I_SHUTTLER ] == "1"
				text1 += 'Sie wollen am 16.11.2007 um ' + Felder[ I_UHRHIN ] + ' Uhr vom Konferenzhotel zum Flughafen Tegel (TXL) gebracht werden!'
			elseif Felder[ I_SHUTTLER ] == "2"
				text1 += 'Sie wollen am 16.11.2007 um ' + Felder[ I_UHRHIN ] + ' Uhr vom Konferenzhotel zum Flughafen Sch' + oe + 'nefeld (SXF) gebracht werden!'
			else
				text1 += 'Sie wollen nicht zum Flughafen gebracht werden!'
			endif
		case spr_xx == spr_fr
			if Felder[ I_SHUTTLER ] == "1"
				text1 += 'Le 16.11.2007 ' + al + " " + Felder[ I_UHRHIN ] + "h vous voulez " + ed + "tre reconduit de l'h" + od + "tel de conference " + al + " l'a" + er + "eroport Tegel (TXL)!"
			elseif Felder[ I_SHUTTLER ] == "2"
				text1 += 'Le 16.11.2007 ' + al + " " + Felder[ I_UHRHIN ] + "h vous voulez " + ed + "tre reconduit de l'h" + od + "tel de conference " + al + " l'a" + er + "eroport Sch' + oe + 'nefeld (SXF)!"
			else
				text1 += "Vous ne voulez pas qu'on vous reconduit " + al + " l'a" + er + "roport!"
			endif
		case spr_xx == spr_sp
			if Felder[ I_SHUTTLER ] == "1"
				text1 += 'Ud. desea transporte el 16 de Noviembre a las ' + Felder[ I_UHRHIN ] + ' hs (Horario Central Europeo) desde el hotel de la conferencia hasta el aeropuerto Tegel (TXL)!'
			elseif Felder[ I_SHUTTLER ] == "2"
				text1 += 'Ud. desea transporte el 16 de Noviembre a las ' + Felder[ I_UHRHIN ] + ' hs (Horario Central Europeo) desde el hotel de la conferencia hasta el aeropuerto Sch' + oe + 'nefeld (SXF)!'
			else
				text1 += 'Ud. no desea transporte hasta el aeropuerto!'
			endif
		case spr_xx == spr_pt
			if Felder[ I_SHUTTLER ] == "1"
				text1 += 'Vc. deseja transporte no 16 de Novembro a las ' + Felder[ I_UHRHIN ] + ' (Hor' + ar + 'rio Central Europeu) desde o hotel da confer' + ed + 'ncia at' + er + ' o aeroporto Tegel (TXL)!'
			elseif Felder[ I_SHUTTLER ] == "2"
				text1 += 'Vc. deseja transporte no 16 de Novembro a las ' + Felder[ I_UHRHIN ] + ' (Hor' + ar + 'rio Central Europeu) desde o hotel da confer' + ed + 'ncia at' + er + ' o aeroporto Sch' + oe + 'nefeld (SXF)!'
			else
				text1 += 'Vc. n' + ati + 'o deseja transporte at' + er + ' o aeroporto!'
			endif
		otherwise
			if Felder[ I_SHUTTLER ] == "1"
				text1 += 'You want to be taken from the conference hotel to Tegel airport (TXL) on November 16<SUP>th</SUP> at ' + Felder[ I_UHRHIN ] + " CET!"
			elseif Felder[ I_SHUTTLER ] == "2"
				text1 += 'You want to be taken from the conference hotel to Sch' + oe + 'nefeld airport (SXF) on November 16<SUP>th</SUP> at ' + Felder[ I_UHRHIN ] + " CET!"
			else
				text1 += 'You do not want to be taken to the airport!'
			endif
	endcase
	text1 += '</B><BR></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
	text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF

	text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">'
	nsum := 0.00
	nr := 0
	if .not. empty( Felder[ I_NACHNAME1 ] )
		nsum += iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) )
		nr++
	endif
	if .not. empty( Felder[ I_NACHNAME2 ] )
		nsum += iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) )
		nr++
	endif
	if .not. empty( Felder[ I_NACHNAME3 ] )
		nsum += iif( val( dtos( dDatum ) ) < MEMVAR->earlybird, MEMVAR->preiserm1, iif( val( dtos( dDatum ) ) < MEMVAR->latebird, MEMVAR->preiserm2, MEMVAR->preiserm3 ) )
		nr++
	endif
	if nr > 0
		if nr == 1
			do case
			case sprache == "de"
				text := 'Die folgende Person begleitet Sie'
			case sprache == "fr"
				text := 'La personne suivante accompagne vous'
			case sprache == "uk"
				text := 'The following person is joining you'
			case sprache == "sp"
				text := 'La siguiente persona le acompa' + nt + 'ar' + ar
			case sprache == "pt"
				text := 'A seguinte pessoa ir' + ar + ' lhe acompanhar'
			endcase
		else
			do case
			case sprache == "de"
				text := 'Die folgenden Personen begleiten Sie'
			case sprache == "fr"
				text := 'Les personnes suivantes accompagnent vous'
			case sprache == "uk"
				text := 'The following persons are joining you'
			case sprache == "sp"
				text := 'Las siguientes personas le acompa' + nt + 'ar' + ar + 'n'
			case sprache == "pt"
				text := 'As seguintes pessoas ir' + ati + 'o lhe acompanhar'
			endcase
		endif
		text1 += '<B>' + text + '</B><I>'
	endif

	if .not. empty( Felder[ I_NACHNAME1 ] )
		do case
		case sprache == "de"
			if Felder[ I_ANREDE1 ] $ "234"
				text1 += "<BR>Frau"
			else
				text1 += "<BR>Herr"
			endif
		case sprache == "fr"
			if Felder[ I_ANREDE1 ] $ "234"
				text1 += "<BR>Mme"
			else
				text1 += "<BR>M."
			endif
		case sprache == "uk"
			if Felder[ I_ANREDE1 ] == "2"
				text1 += "<BR>Mrs."
			elseif Felder[ I_ANREDE1 ] == "3"
				text1 := "<BR>Ms."
			elseif Felder[ I_ANREDE1 ] == "4"
				text1 := "<BR>Miss."
			else
				text1 += "<BR>Mr."
			endif
		case sprache == "sp"
			if Felder[ I_ANREDE1 ] == "2"
				text1 += "<BR>Sra."
			elseif Felder[ I_ANREDE1 ] $ "34"
				text1 := "<BR>Srita."
			else
				text1 += "<BR>Sr."
			endif
		case sprache == "pt"
			if Felder[ I_ANREDE1 ] == "2"
				text1 += "<BR>Sra."
			elseif Felder[ I_ANREDE1 ] $ "34"
				text1 += "<BR>Senhorita"
			else
				text1 += "<BR>Sr."
			endif
		endcase
		text1 += " " + alltrim( Felder[ I_VORNAME1 ] ) + " " + alltrim( Felder[ I_NACHNAME1 ] ) + " ("
		do case
		case Felder[ I_TEILNEHMER1 ] == "1"
			text1 += MEMVAR->texte[ teiltnehmer, spr_xx ]
		case Felder[ I_TEILNEHMER1 ] == "2"
			text1 += MEMVAR->texte[ teilpartner, spr_xx ]
		case Felder[ I_TEILNEHMER1 ] == "3"
			text1 += MEMVAR->texte[ teilkind, spr_xx ]
		case Felder[ I_TEILNEHMER1 ] == "4"
			text1 += MEMVAR->texte[ teilfreund, spr_xx ]
		case Felder[ I_TEILNEHMER1 ] == "5"
			text1 += MEMVAR->texte[ teilredner, spr_xx ]
		case Felder[ I_TEILNEHMER1 ] == "6"
			text1 += MEMVAR->texte[ teilorgan, spr_xx ]
		case Felder[ I_TEILNEHMER1 ] == "7"
			text1 += MEMVAR->texte[ teilsonst, spr_xx ]
		case Felder[ I_TEILNEHMER1 ] == "8"
			text1 += MEMVAR->texte[ teilbpart, spr_xx ]
		case Felder[ I_TEILNEHMER1 ] == "9"
			text1 += MEMVAR->texte[ teiltpart, spr_xx ]
		endcase

		do case
		case Felder[ I_SHIRT1 ] == "1"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": S"
		case Felder[ I_SHIRT1 ] == "2"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": M"
		case Felder[ I_SHIRT1 ] == "3"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": L"
		case Felder[ I_SHIRT1 ] == "4"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": XL"
		case Felder[ I_SHIRT1 ] == "5"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": XXL"
		case Felder[ I_SHIRT1 ] == "6"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": XS"
		case Felder[ I_SHIRT1 ] == "7"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": XXXL"
		endcase
		text1 += ")"
	endif
	if .not. empty( Felder[ I_NACHNAME2 ] )
		do case
		case sprache == "de"
			if Felder[ I_ANREDE2 ] $ "234"
				text1 += "<BR>Frau"
			else
				text1 += "<BR>Herr"
			endif
		case sprache == "fr"
			if Felder[ I_ANREDE2 ] $ "234"
				text1 += "<BR>Mme"
			else
				text1 += "<BR>M."
			endif
		case sprache == "uk"
			if Felder[ I_ANREDE2 ] == "2"
				text1 += "<BR>Mrs."
			elseif Felder[ I_ANREDE2 ] == "3"
				text1 := "<BR>Ms."
			elseif Felder[ I_ANREDE2 ] == "4"
				text1 := "<BR>Miss."
			else
				text1 += "<BR>Mr."
			endif
		case sprache == "sp"
			if Felder[ I_ANREDE2 ] == "2"
				text1 += "<BR>Sra."
			elseif Felder[ I_ANREDE2 ] $ "34"
				text1 := "<BR>Srita."
			else
				text1 += "<BR>Sr."
			endif
		case sprache == "pt"
			if Felder[ I_ANREDE2 ] == "2"
				text1 += "<BR>Sra."
			elseif Felder[ I_ANREDE2 ] $ "34"
				text1 += "<BR>Senhorita"
			else
				text1 += "<BR>Sr."
			endif
		endcase
		text1 += " " + alltrim( Felder[ I_VORNAME2 ] ) + " " + alltrim( Felder[ I_NACHNAME2 ] ) + " ("
		do case
		case Felder[ I_TEILNEHMER2 ] == "1"
			text1 += MEMVAR->texte[ teiltnehmer, spr_xx ]
		case Felder[ I_TEILNEHMER2 ] == "2"
			text1 += MEMVAR->texte[ teilpartner, spr_xx ]
		case Felder[ I_TEILNEHMER2 ] == "3"
			text1 += MEMVAR->texte[ teilkind, spr_xx ]
		case Felder[ I_TEILNEHMER2 ] == "4"
			text1 += MEMVAR->texte[ teilfreund, spr_xx ]
		case Felder[ I_TEILNEHMER2 ] == "5"
			text1 += MEMVAR->texte[ teilredner, spr_xx ]
		case Felder[ I_TEILNEHMER2 ] == "6"
			text1 += MEMVAR->texte[ teilorgan, spr_xx ]
		case Felder[ I_TEILNEHMER2 ] == "7"
			text1 += MEMVAR->texte[ teilsonst, spr_xx ]
		case Felder[ I_TEILNEHMER2 ] == "8"
			text1 += MEMVAR->texte[ teilbpart, spr_xx ]
		case Felder[ I_TEILNEHMER2 ] == "9"
			text1 += MEMVAR->texte[ teiltpart, spr_xx ]
		endcase

		do case
		case Felder[ I_SHIRT2 ] == "1"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": S"
		case Felder[ I_SHIRT2 ] == "2"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": M"
		case Felder[ I_SHIRT2 ] == "3"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": L"
		case Felder[ I_SHIRT2 ] == "4"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": XL"
		case Felder[ I_SHIRT2 ] == "5"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": XXL"
		case Felder[ I_SHIRT2 ] == "6"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": XS"
		case Felder[ I_SHIRT2 ] == "7"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": XXXL"
		endcase
		text1 += ")"
	endif
	if .not. empty( Felder[ I_NACHNAME3 ] )
		do case
		case sprache == "de"
			if Felder[ I_ANREDE3 ] $ "234"
				text1 += "<BR>Frau"
			else
				text1 += "<BR>Herr"
			endif
		case sprache == "fr"
			if Felder[ I_ANREDE3 ] $ "234"
				text1 += "<BR>Mme"
			else
				text1 += "<BR>M."
			endif
		case sprache == "uk"
			if Felder[ I_ANREDE3 ] == "2"
				text1 += "<BR>Mrs."
			elseif Felder[ I_ANREDE3 ] == "3"
				text1 := "<BR>Ms."
			elseif Felder[ I_ANREDE3 ] == "4"
				text1 := "<BR>Miss."
			else
				text1 += "<BR>Mr."
			endif
		case sprache == "sp"
			if Felder[ I_ANREDE3 ] == "2"
				text1 += "<BR>Sra."
			elseif Felder[ I_ANREDE3 ] $ "34"
				text1 := "<BR>Srita."
			else
				text1 += "<BR>Sr."
			endif
		case sprache == "pt"
			if Felder[ I_ANREDE3 ] == "2"
				text1 += "<BR>Sra."
			elseif Felder[ I_ANREDE3 ] $ "34"
				text1 += "<BR>Senhorita"
			else
				text1 += "<BR>Sr."
			endif
		endcase
		text1 += " " + alltrim( Felder[ I_VORNAME3 ] ) + " " + alltrim( Felder[ I_NACHNAME3 ] ) + " ("
		do case
		case Felder[ I_TEILNEHMER3 ] == "1"
			text1 += MEMVAR->texte[ teiltnehmer, spr_xx ]
		case Felder[ I_TEILNEHMER3 ] == "2"
			text1 += MEMVAR->texte[ teilpartner, spr_xx ]
		case Felder[ I_TEILNEHMER3 ] == "3"
			text1 += MEMVAR->texte[ teilkind, spr_xx ]
		case Felder[ I_TEILNEHMER3 ] == "4"
			text1 += MEMVAR->texte[ teilfreund, spr_xx ]
		case Felder[ I_TEILNEHMER3 ] == "5"
			text1 += MEMVAR->texte[ teilredner, spr_xx ]
		case Felder[ I_TEILNEHMER3 ] == "6"
			text1 += MEMVAR->texte[ teilorgan, spr_xx ]
		case Felder[ I_TEILNEHMER3 ] == "7"
			text1 += MEMVAR->texte[ teilsonst, spr_xx ]
		case Felder[ I_TEILNEHMER3 ] == "8"
			text1 += MEMVAR->texte[ teilbpart, spr_xx ]
		case Felder[ I_TEILNEHMER3 ] == "9"
			text1 += MEMVAR->texte[ teiltpart, spr_xx ]
		endcase

		do case
		case Felder[ I_SHIRT3 ] == "1"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": S"
		case Felder[ I_SHIRT3 ] == "2"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": M"
		case Felder[ I_SHIRT3 ] == "3"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": L"
		case Felder[ I_SHIRT3 ] == "4"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": XL"
		case Felder[ I_SHIRT3 ] == "5"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": XXL"
		case Felder[ I_SHIRT3 ] == "6"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": XS"
		case Felder[ I_SHIRT3 ] == "7"
			text1 += ", " + MEMVAR->texte[ tshirt, spr_xx ] + ": XXXL"
		endcase
		text1 += ")"
	endif

	if nr > 0
		text1 += '</I></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
		text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">'
	endif

	if ( nsum > 0 ) .and. ( Felder[ I_TEILNEHMER ] $ "59" )
		text1 += '<B>' + strtran( MEMVAR->texte[ ueberweistext, spr_xx ], "##**##", alltrim( str( nsum, 6, 2 ) ) ) + '</B></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
		text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%"><B>' + MEMVAR->texte[ zteilnehmerid, spr_xx ] + '</B><BR><FONT COLOR="#CC0000" SIZE=+1><B>' + sch + '</B></FONT>' + CRLF
		text1 += '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' + CRLF
		text1 += '<TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%"><B>' + MEMVAR->texte[ paypalhin, spr_xx ] + '</B><BR><CENTER>'

		bla := Felder[ I_LAND ]
		nr := val( Felder[ I_MUTTERSPRA ] )
		bla1 := ""
		bla2 := "en_US"
		do case
			case nr == 1
				bla1 := "DE"
				bla2 := "de_DE"
			case nr == 2
				bla1 := "FR"
				bla2 := "fr_FR"
			case nr == 3
				bla1 := "US"
			case nr == 4
				bla1 := "ES"
				bla2 := "es_ES"
			case nr == 5
				bla1 := "PT"
			case nr == 6
				bla1 := "DK"
			case nr == 7
				bla1 := "IT"
				bla2 := "it_IT"
			case nr == 8
				bla1 := "NL"
			case nr == 9
				bla1 := "NO"
			case nr == 10
				bla1 := "PL"
				bla2 := "pl_PL"
			case nr == 11
				bla1 := "FI"
			case nr == 12
				bla1 := "SE"
			case nr == 13
				bla1 := "TR"
			case nr == 14
				bla1 := "SK"
			case nr == 15
				bla1 := "HU"
			case nr == 18
				bla1 := "CZ"
		endcase
		do case
			case bla == "A"
				bla := "AT"
			case bla == "AUS"
				bla := "AU"
			case bla == "B"
				bla := "BE"
			case bla == "CDN"
				bla := "CA"
			case bla == "D"
				bla := "DE"
			case bla == "DOM"
				bla := "DO"
				if empty( bla1 )
					bla1 := "DO"
				endif
			case bla == "E"
				bla := "ES"
			case bla == "EST"
				bla := "EE"
				if empty( bla1 )
					bla1 := "EE"
				endif
			case bla == "F"
				bla := "FR"
			case bla == "FIN"
				bla := "FI"
			case bla == "H"
				bla := "HU"
			case bla == "I"
				bla := "IT"
			case bla == "IND"
				bla := "IN"
				if empty( bla1 )
					bla1 := "IN"
				endif
			case bla == "IRL"
				bla := "IE"
			case bla == "J"
				bla := "JP"
			case bla == "JA"
				bla := "JM"
			case bla == "L"
				bla := "LU"
				if empty( bla1 )
					bla1 := "LU"
				endif
			case bla == "M"
				bla := "MT"
				if empty( bla1 )
					bla1 := "MT"
				endif
			case bla == "MAL"
				bla := "MY"
				if empty( bla1 )
					bla1 := "MY"
				endif
			case bla == "MEX"
				bla := "MX"
				if empty( bla1 )
					bla1 := "MX"
				endif
			case bla == "N"
				bla := "NO"
			case bla == "P"
				bla := "PT"
			case bla == "RA"
				bla := "AR"
				if empty( bla1 )
					bla1 := "AR"
				endif
			case bla == "RC"
				bla := "CN"
			case bla == "RCH"
				bla := "CL"
				if empty( bla1 )
					bla1 := "CL"
				endif
			case bla == "ROK"
				bla := "KR"
			case bla == "ROU"
				bla := "UY"
			case bla == "S"
				bla := "SE"
			case bla == "SGP"
				bla := "SG"
				if empty( bla1 )
					bla1 := "SG"
				endif
			case bla == "SLO"
				bla := "SI"
				if empty( bla1 )
					bla1 := "SI"
				endif
			case bla == "T"
				bla := "TH"
			case bla == "USA"
				bla := "US"
			case bla == "YV"
				bla := "VE"
		endcase
		if empty( bla1 )
			bla1 := "US"
		endif

		text1 += '<form name="_xclick" action="https://www.paypal.com/cgi-bin/webscr" method="post">' + CRLF
		text1 += '<input type="hidden" name="form_charset" value="ISO-8859-1">' + CRLF
		text1 += '<input type="hidden" name="cmd" value="_xclick">' + CRLF
		text1 += '<input type="hidden" name="business" value="' + MEMVAR->paypalac + '">' + CRLF
		text1 += '<input type="hidden" name="currency_code" value="EUR">' + CRLF
		text1 += '<input type="hidden" name="item_name" value="' + "DevCon 2007 - ID: " + sch + '">' + CRLF
		text1 += '<input type="hidden" name="city" value="' + Felder[ I_ORT ] + '">' + CRLF
		text1 += '<input type="hidden" name="address1" value="' + Felder[ I_STRASSE ] + '">' + CRLF
		text1 += '<input type="hidden" name="country" value="' + bla + '">' + CRLF
		text1 += '<input type="hidden" name="email" value="' + Felder[ I_EMAIL ] + '">' + CRLF
		text1 += '<input type="hidden" name="first_name" value="' + Felder[ I_VORNAME ] + '">' + CRLF
		text1 += '<input type="hidden" name="last_name" value="' + Felder[ I_NACHNAME ] + '">' + CRLF
		text1 += '<input type="hidden" name="lc" value="' + upper( bla1 ) + '">' + CRLF
		if bla <> "DE"
			text1 += '<input type="hidden" name="state" value="' + Felder[ I_STAAT ] + '">' + CRLF
		endif
		text1 += '<input type="hidden" name="zip" value="' + Felder[ I_PLZ ] + '">' + CRLF

		text1 += '<input type="hidden" name="amount" value="' + alltrim( str( nsum, 6, 2 ) ) + '">' + CRLF
		text1 += '<input type="image" src="https://www.sandbox.paypal.com/' + bla2 + '/i/btn/x-click-but06.gif" border="0" name="submit" alt="' + MEMVAR->texte[ paypaltext, spr_xx ] + '">' + CRLF
		text1 += '</form>'
		text1 += '</CENTER>' + CRLF
	else
		text1 += '<B>' + MEMVAR->texte[ teilnehmerid, spr_xx ] + '</B><BR><FONT COLOR="#CC0000" SIZE=+1><B>' + sch + '</B></FONT>' + CRLF
		text1 += '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR><TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%">' + NBSP
	endif
	text1 += '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>' + CRLF
	text1 += '<BR></CENTER>' + CRLF
	text1 += MeldeFooter( oClient )

	if .not. File( APP_ROOT, "D" )
		CreateDir( APP_ROOT )
	endif
	if .not. File( bestaetigungspfad, "D" )
		CreateDir( bestaetigungspfad )
	endif
	if file( bestaetigungspfad + "\" + sch + ".html" )
		rename ( bestaetigungspfad + "\" + sch + ".html" ) to ( bestaetigungspfad + "\" + sch + "." + dtos( date() ) + "." + strtran( time(), ":" ) + ".html" )
	endif

	i := 0
	while ( ( nHandle := FCreate( bestaetigungspfad + "\" + sch + ".html" ) ) < 0 ) .and. ( ++i < 10 )
		Sleep(20)
	end
	if nHandle < 0
		do case
		case sprache == "de"
			ueberschr := "Datei nicht verf" + ue + "gbar"
			fehlertext := "Ihre Eingaben k" + oe + "nnen zur Zeit leider nicht verarbeitet werden!"
		case sprache == "fr"
			ueberschr := "Fichier n'est pas offert"
			fehlertext := "C'est pas possible de stocker votre entr" + er + "e au moment!"
		case sprache == "sp"
			ueberschr := "Fichero no disponible"
			fehlertext := "Disculpe, sus datos no pueden ser procesados en este momento!"
		case sprache == "pt"
			ueberschr := "Arquivo n" + ati + "o dispon" + ir + "vel"
			fehlertext := "Desculpe, seus dados n" + ati + "o poden serem processados neste momento!"
		otherwise
			ueberschr := "Unavailable file"
			fehlertext := "Sorry, your data cannot be processed at the moment!"
		endcase
		text1 := '<html><head><meta http-equiv="content-type" content="text/html; charset=ISO-8859-1"><title>' + ueberschr + '</title><link rel="stylesheet" href="devcon.css" type="text/css"></head><body BGCOLOR="' + MEMVAR->shinter + '">' + Fehlermeldung( ueberschr, fehlertext ) + "</BODY></HTML>"
	else
		FWrite(nHandle, text1 )
		FClose(nHandle)
		if file( APP_ROOT + "\BLAT.EXE" )
			do case
			case sprache == "de"
				anred := "Anmeldung zur DevCon 2007 - ID: "
			case sprache == "sp"
				anred := "Inscripcion para la DevCon 2007 - ID: "
			case sprache == "fr"
				anred := "Enregistrement du cours DevCon 2007 - ID: "
			case sprache == "pt"
				anred := "Inscricao para a DevCon 2007 - ID: "
			otherwise
				anred := "Registration for the DevCon 2007 - ID: "
			endcase
			anred  += sch
			RunShell( '/C ' + APP_ROOT + '\BLAT.EXE ' + bestaetigungspfad + '\' + sch + '.html -subject "' + anred + '" -to "' + alltrim( Felder[ I_EMAIL ] ) + '" -bcc "' + MEMVAR->cMailadress1 + ',' + MEMVAR->cMailadress2 + '" -server ' + MEMVAR->cSMTPserver + ' -html -f ' + MAILMASTER + ' -log ' + mlogpfad + '\' + dtos( date() ) + '_' + strtran( time(), ":", "" ) + '.log',,.t.,.t. )
		else
			SaveToFile( ConvToAnsiCp( "______ Xb2.NET ERROR __________ E-mail error _________________" + DtoC( Date() ) + "_" + Time() + CRLF + "E-mail cannot be send as BLAT.EXE is missing!" ), SERVER_ERR_LOG_FILE )
		endif
	endif
	if anzeige
		if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
			oClient:HTTPResponse:CompressLevel := 7
		endif
		oClient:HTTPResponse:Content := text1
		oClient:closeSession()
	endif
return

FUNCTION DC_ShowReg()
local oClient := ThreadObject(), sprache, text1, spr_xx, bla, alletei, teilart, tfarbe, hinter1, hinter2, hinter, thinter, uehint, ueber, i, j, sortn, sorta
sprache := oClient:GetVar("MenuVar")
sortn := oClient:GetVar("SortField")
sorta := oClient:GetVar("SortType")
if sortn == NIL
	sortn := "1"
endif
if sorta == NIL
	sorta := "u"
endif
if ( sprache == NIL )
	oClient:HTTPResponse:Content := redirekt()
elseif ( alltrim( str( val( sortn ) ) ) <> sortn ) .or. ( val( sortn ) < 1 ) .or. ( val( sortn ) > 8 ) .or. ( .not. ( lower( sorta ) $ "ud" ) )
	oClient:HTTPResponse:Content := redirekt()
else
	sprache := lower( sprache )
	sortn := lower( sortn )
	sorta := lower( sorta )
	do case
	case sprache == "de"
		spr_xx := spr_de
		SET COLLATION TO GERMAN
	case sprache == "uk"
		spr_xx := spr_uk
		SET COLLATION TO SYSTEM
	case sprache == "fr"
		spr_xx := spr_fr
		SET COLLATION TO FRENCH
	case sprache == "sp"
		spr_xx := spr_sp
		SET COLLATION TO SPANISH
	case sprache == "pt"
		spr_xx := spr_pt
		SET COLLATION TO PORTUGUESE
	otherwise
		oClient:HTTPResponse:Content := redirekt()
	endcase
	alletei := {}
	teilart := {}
	AAdd( teilart, MEMVAR->texte[ teiltnehmer, spr_xx ] )
	AAdd( teilart, MEMVAR->texte[ teilpartner, spr_xx ] )
	AAdd( teilart, MEMVAR->texte[ teilkind, spr_xx ] )
	AAdd( teilart, MEMVAR->texte[ teilfreund, spr_xx ] )
	AAdd( teilart, MEMVAR->texte[ teilredner, spr_xx ] )
	AAdd( teilart, MEMVAR->texte[ teilorgan, spr_xx ] )
	AAdd( teilart, MEMVAR->texte[ teilsonst, spr_xx ] )
	AAdd( teilart, MEMVAR->texte[ teilbpart, spr_xx ] )
	AAdd( teilart, MEMVAR->texte[ teiltpart, spr_xx ] )
	OpenDbf()
	Melde->( DbGoTop() )
	do while .not. Melde->( Eof() )
		if ( .not. Melde->( Deleted() ) ) .and. ( .not. Melde->ANONYM )
			hinter := alltrim( alltrim( Melde->FIRMA1 ) + " " + alltrim( Melde->FIRMA2 ) )
			if empty( hinter )
				hinter := NBSP
			endif
			AAdd( alletei, { dtos( Melde->ANMELDEDAT ), alltrim( alltrim( Melde->NACHNAME ) + ", " + alltrim( Melde->VORNAME ) ), hinter, alltrim( Melde->LAND ), alltrim( Melde->STAAT ), alltrim( Melde->ORT ), teilart[ Melde->TEILNEHMER ], iif( ( Melde->Preis <= 0 ), MEMVAR->texte[ istbez, spr_xx ], iif( empty( Melde->ZAHLEINGAN ), MEMVAR->texte[ istnbez, spr_xx ], MEMVAR->texte[ istbez, spr_xx ] ) ) } )
		endif
		Melde->( DbSkip() )
	enddo
	CloseDbf()
	hinter1 := "#00E3FF"
	hinter2 := "#00C3FF"
	hinter := ""
	tfarbe := "#000000"
	thinter := "#CCFFFF"
	uehint := "#003366"
	ueber := "#FFFFFF"

	if sorta == "u"
		asort( alletei,,, {|aX,aY| upper( aX[ val( sortn ) ] ) < upper( aY[ val( sortn ) ] ) } )   // Array alphabetisch sortieren
	else
		asort( alletei,,, {|aX,aY| upper( aX[ val( sortn ) ] ) > upper( aY[ val( sortn ) ] ) } )   // Array alphabetisch sortieren
	endif
	j := len( alletei )
	text1 := ConvToANSICp( "<HTML><HEAD>" ) + CRLF
	text1 += ConvToANSICp( '<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">' ) + CRLF
	text1 += ConvToANSICp( '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">' ) + CRLF
	text1 += ConvToANSICp( '<META HTTP-EQUIV="Cache-Control" CONTENT="no-cache">' ) + CRLF
	text1 += ConvToANSICp( '<META HTTP-EQUIV="Expires" CONTENT="-1">' ) + CRLF
	text1 += ConvToANSICp( "<TITLE>" + MEMVAR->texte[ teilnehmerueber, spr_xx ] + "</TITLE>" ) + CRLF
	text1 += ConvToANSICp( '<link rel="stylesheet" href="devcon.css" type="text/css"></HEAD><BODY' ) + CRLF
	text1 += ConvToANSICp( ' bgcolor="' + MEMVAR->shinter + '">' ) + CRLF

	text1 += ConvToANSICp( '<CENTER><TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + uehint + '"><TR><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="90%"><CENTER><FONT COLOR="' + ueber + '" SIZE=+1><B>' + MEMVAR->texte[ teilnehmerueber, spr_xx ] + '</B></FONT></CENTER></TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>' )
	text1 += CRLF + ConvToANSICp( '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + thinter + '"><THEAD><TR valign="top"><TH WIDTH="5%">' + NBSP + '</TH><TH WIDTH="10%">' + '<A href=/ShowReg?MenuVar=' + sprache + '&SortField=1&SortType=' + iif( sortn == "1", iif( sorta == "u", "d", "u" ), "u" ) + '>' + MEMVAR->texte[ meldedatum, spr_xx ] + '</A>' )
	text1 += CRLF + ConvToANSICp( '</TH><TH WIDTH="15%"><A href=/ShowReg?MenuVar=' + sprache + '&SortField=2&SortType=' + iif( sortn == "2", iif( sorta == "u", "d", "u" ), "u" ) + '>' + left( MEMVAR->texte[ nachname, spr_xx ], len( MEMVAR->texte[ nachname, spr_xx ] ) - 1 ) + ', ' + left( MEMVAR->texte[ vorname, spr_xx ], len( MEMVAR->texte[ vorname, spr_xx ] ) - 1 ) + '</A></TH><TH WIDTH="15%"><A href=/ShowReg?MenuVar=' + sprache + '&SortField=3&SortType=' + iif( sortn == "3", iif( sorta == "u", "d", "u" ), "u" ) + '>' + MEMVAR->texte[ firmaueb, spr_xx ] + '</A></TH><TH WIDTH="7%"><A href=/ShowReg?MenuVar=' + sprache + '&SortField=4&SortType=' + iif( sortn == "4", iif( sorta == "u", "d", "u" ), "u" ) + '>' )
	text1 += ConvToANSICp( MEMVAR->texte[ landueb, spr_xx ] + '</A></TH><TH WIDTH="10%"><A href=/ShowReg?MenuVar=' + sprache + '&SortField=5&SortType=' + iif( sortn == "5", iif( sorta == "u", "d", "u" ), "u" ) + '>' + strtran( MEMVAR->texte[ staatueb, spr_xx ], "/", "/<BR>" ) + '</A></TH><TH WIDTH="11%"><A href=/ShowReg?MenuVar=' + sprache + '&SortField=6&SortType=' + iif( sortn == "6", iif( sorta == "u", "d", "u" ), "u" ) + '>' + MEMVAR->texte[ stadtueb, spr_xx ] + '</A></TH><TH WIDTH="12%"><A href=/ShowReg?MenuVar=' + sprache + '&SortField=7&SortType=' + iif( sortn == "7", iif( sorta == "u", "d", "u" ), "u" ) + '>' + MEMVAR->texte[ typueb, spr_xx ] + '</A></TH><TH WIDTH="10%"><A href=/ShowReg?MenuVar=' + sprache + '&SortField=8&SortType=' + iif( sortn == "8", iif( sorta == "u", "d", "u" ), "u" ) + '>' )
	text1 += ConvToANSICp( MEMVAR->texte[ meldestatus, spr_xx ] + '</A></TH><TH WIDTH="5%">' + NBSP + '</TH></TR></THEAD><TBODY>' )
	for i := 1 to j
		if hinter == hinter1
			hinter := hinter2
		else
			hinter := hinter1
		endif
		text1 += CRLF + ConvToANSICp( '<TR valign="top"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="10%" BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe + '">' + alletei[ i, 1 ] + '</FONT></TD>' )
		text1 += CRLF + ConvToANSICp( '<TD WIDTH="15%" BGCOLOR="' + hinter +'">' + alltrim( alletei[ i, 2 ] ) + '</TD><TD WIDTH="15%" BGCOLOR="' + hinter +'">' + alletei[ i, 3 ] + '</TD><TD WIDTH="7%" BGCOLOR="' + hinter +'">' + alletei[ i, 4 ] + '</TD><TD WIDTH="10%" BGCOLOR="' + hinter +'">' + iif( empty( alletei[ i, 5 ] ), NBSP, alletei[ i, 5 ] ) + '</TD><TD WIDTH="11%" BGCOLOR="' + hinter +'">' + alletei[ i, 6 ] + '</TD><TD WIDTH="12%" BGCOLOR="' + hinter +'">' + alletei[ i, 7 ] + '</TD><TD WIDTH="10%" BGCOLOR="' + hinter +'">' + alletei[ i, 8 ] + '</TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' )
	next
	text1 += '</TBODY></TABLE>'

	if file( statistik + "\teilnehmer_" + sprache + ".jpg" )
		text1 += CRLF + '<P><HR WIDTH="80%"><P>'
		text1 += '<img src="/stats/teilnehmer_' + sprache + '.jpg" border="0">'
	endif
	text1 += '</CENTER>' + MeldeFooter()

	if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
		oClient:HTTPResponse:CompressLevel := 7
	endif
	oClient:HTTPResponse:Content := text1
	oClient:CloseSession()
endif
return .t.

FUNCTION DC_Check4State()
local oClient := ThreadObject()
local text1, text2, text3, text4, text5, text6, text7, text8, text9, bla, bla2, bla3, hinter, vorder, tfarbe1

	tfarbe1 := "#000000"

	text1 := '<html>' + CRLF
	text1 += '<head>' + CRLF
	text1 += '<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">' + CRLF
	text1 += '<meta http-equiv="refresh" content="900">' + CRLF
	text1 += '<Title>Serverinformationen</title>' + CRLF
	text1 += '</head> ' + CRLF
	text1 += '<body bgcolor="' + MEMVAR->shinter + '">' + CRLF
	text1 += '<table BORDER="0" CELLSPACING="0" CELLPADDING="0" ALIGN="CENTER" width="80%"><TR><TD valign="top"><H1>Serverinformation</H1></TD>'
	text1 += ConvToANSICp( '<TD valign="top"><H1>Overview of the logfiles</H1></TD></TR>' ) + CRLF

	text1 += ConvToANSICp( '<TR><TD valign="top"><H2>Webserver</H2>' ) + CRLF
	bla := MEMVAR->oWebServer:TimeStarted
	bla2 := int( bla / 3600 ) // hours
	text2 := right( "00" + alltrim( str( bla2 ) ), 2 ) + ":"
	bla -= ( bla2 * 3600 )
	bla2 := int( bla / 60 ) // minutes
	text2 += right( "00" + alltrim( str( bla2 ) ), 2 ) + ":"
	bla -= ( bla2 * 60 )
	text2 += right( "00" + alltrim( str( int( bla ) ) ), 2 )
	text1 += ConvToANSICp( 'Server started on ' + Dtoc( MEMVAR->oWebServer:DateStarted ) + ' at ' + text2 + '<BR>' ) + CRLF
	bla := MEMVAR->oWebServer:UpTime()
	text2 := alltrim( transform( bla[ UPTIME_DAY ], "@E ###,###" ) ) + " day" + iif( bla[ UPTIME_DAY ] <> 1, "s", "" )
	text2 += ", " + alltrim( str( bla[ UPTIME_HRS ] ) ) + " hour" + iif( bla[ UPTIME_HRS ] <> 1, "s", "" )
	text2 += ", " + alltrim( str( bla[ UPTIME_MIN ] ) ) + " minute" + iif( bla[ UPTIME_MIN ] <> 1, "s", "" )
	text2 += " and " + transform( bla[ UPTIME_SEC ], "@E 99.99" ) + " second" + iif( bla[ UPTIME_SEC ] <> 1, "s", "" )
	text1 += ConvToANSICp( 'Server is running since ' + text2 + '<BR>' ) + CRLF
	text1 += ConvToANSICp( 'Since then there have been ' + transform( MEMVAR->oWebServer:ConnectCount, "@E ###,###,###,###,###" ) + ' connections so far<BR>' ) + CRLF
	text1 += ConvToANSICp( 'Currently active connections: ' + Var2Char( MEMVAR->oWebServer:ActiveConnections() ) + '</TD>' ) + CRLF
	text1 += ConvToANSICp( '<TD valign="top">' )

	bla3 := 0
	if file( logpfad + SERVER_ERR_LOG_FILE ) // server errors
		text1 += '<UL>' + CRLF
		text1 += '<LI><A href="/ShowServerErrorLog?" target="_blank">Server errors</A></LI>' + CRLF
		bla3++
	endif
	if file( logpfad + WEB_LOG ) // Weblog
		if bla3 == 0
			text1 += '<UL>' + CRLF
		endif
		text1 += '<LI><A href="/ShowServerWeblog?" target="_blank">Weblog</A></LI>' + CRLF
		bla3++
	endif
	if bla3 == 0
		text1 += NBSP
	else
		text1 += '</UL>' + CRLF
	endif

	text1 += '</TD></TR>' + CRLF
	text1 += "<TR><TD>" + NBSP + "</TD><TD>" + NBSP + "</TD></TR>" + CRLF
	text1 += "<TR><TD>" + NBSP + "</TD><TD>" + NBSP + "</TD></TR>" + CRLF
	text1 += ConvToANSICp( '<TR><TD><H2>Registrations overview</H2></TD><TD>' + NBSP + '</TD></TR></TABLE>' ) + CRLF
	text1 += '<table BORDER="0" CELLSPACING="0" CELLPADDING="0" ALIGN="CENTER" width="80%">' + CRLF
	text2 := MemoRead( logpfad + MELDE_LOG )
	bla := MlCount( text2 )

	for bla2 := 1 to bla
		text3 := alltrim( MemoLine( text2, , bla2 ) )
		if .not. empty( text3 )
			if bla2 == 1
				hinter := MEMVAR->shinter
				vorder := "#000000"
			elseif hinter == "#00FF00"
				hinter := "#008080"
				vorder := "#00FF00"
			else
				hinter := "#00FF00"
				vorder := "#008080"
			endif
			bla3 := at( " ", text3 )
			text4 := alltrim( left( text3, bla3 ) )
			text3 := alltrim( substr( text3, bla3 ) )
			bla3 := at( " ", text3 )
			text5 := alltrim( left( text3, bla3 ) )
			text3 := alltrim( substr( text3, bla3 ) )
			bla3 := at( " ", text3 )
			text6 := alltrim( left( text3, bla3 ) )
			text3 := alltrim( substr( text3, bla3 ) )
			bla3 := at( " ", text3 )
			text7 := alltrim( left( text3, bla3 ) )
			text3 := alltrim( substr( text3, bla3 ) )
			text1 += '<TR><TD BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '">&nbsp;</FONT></TD><TD BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '">' + iif( bla2 == 1, "<B>", "" ) + text4 + iif( bla2 == 1, "</B>", "" ) + '</FONT></TD><TD BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '">&nbsp;</FONT></TD><TD BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '">' + iif( bla2 == 1, "<B>", "" ) + text5 + iif( bla2 == 1, "</B>", "" ) + '</FONT></TD><TD BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '">&nbsp;</FONT></TD><TD BGCOLOR="' + hinter +'" align="right"><FONT COLOR="' + tfarbe1 + '">' + iif( bla2 == 1, "<B>", "" ) + text6 + iif( bla2 == 1, "</B>", "" ) + '</FONT></TD><TD BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '">&nbsp;</FONT></TD><TD BGCOLOR="' + hinter +'" align="right"><FONT COLOR="' + tfarbe1 + '">' + iif( bla2 == 1, "<B>", "" ) + text7 + iif( bla2 == 1, "</B>", "" ) + '</FONT></TD><TD BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '">&nbsp;</FONT></TD><TD BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '">&nbsp;</FONT></TD><TD BGCOLOR="' + hinter +'" align="right"><FONT COLOR="' + tfarbe1 + '">' + iif( bla2 == 1, "<B>", "" ) + text3 + iif( bla2 == 1, "</B>", "" ) + '</FONT></TD><TD BGCOLOR="' + hinter +'"><FONT COLOR="' + tfarbe1 + '">&nbsp;</FONT></TD></TR>' + CRLF
		endif
	next
	text1 += '</TABLE>' + CRLF
	text1 += "<CENTER><BR><I>" + CRLF
  text1 += ConvToANSICp( 'In case of any problems with this web page please do not hesitate to contact the <A HREF="mailto:' + WEBMASTER + '"><B>Webmaster</B></A>!</I></CENTER>' ) + CRLF
	text1 += '<HR WIDTH="80%">' + CRLF
	text1 += '<P><table BORDER="0" CELLSPACING="0" CELLPADDING="0" ALIGN="CENTER" width="80%">' + CRLF
	text1 += '<tr><td width="10%">' + CRLF
	text1 += '<a href="http://www.alaska-software.com/" target="_blank"><img src="http://' + MEMVAR->cWebserver + '/headpic.gif" width="210" height="100" border="0" alt="Alaska Software"></a>' + CRLF
	text1 += '</td><td width="60%" align=center><a href="http://www.rmchart.com/" target="_blank"><img src="http://' + MEMVAR->cWebserver + '/rmchart.gif" width="228" height="99" border="0" alt="RMChart"></a></td><td width="10%">' + CRLF
	text1 += '<a href="http://www.xb2.net/" target="_blank"><img src="http://' + MEMVAR->cWebserver + '/powered.gif" width="102" height="70" border="0" alt="Xb2.NET" align="right"></a>' + CRLF
	text1 += '</td></tr></table>' + CRLF
	text1 += '</BODY></HTML>'
	if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
		oClient:HTTPResponse:CompressLevel := 7
	endif
	oClient:HTTPResponse:Content := text1
	oClient:CloseSession()

RETURN .t.

FUNCTION DC_ShowServerErrorLog()
local oClient := ThreadObject()
local text1
	text1 := '<html>' + CRLF
	text1 += '<head>' + CRLF
	text1 += '<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">' + CRLF
	text1 += '<Title>Logfile of server errors</title>' + CRLF
	text1 += '</head> ' + CRLF
	text1 += '<body bgcolor="' + MEMVAR->shinter + '">' + CRLF
	text1 += '<Center><H1>Logfile of server errors</H1></Center>' + CRLF
	text1 += '<pre>' + CRLF
	text1 += MemoRead( logpfad + SERVER_ERR_LOG_FILE )
	text1 += '</pre>' + CRLF
	text1 += '</BODY></HTML>'
	if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
		oClient:HTTPResponse:CompressLevel := 7
	endif
	oClient:HTTPResponse:Content := text1
	oClient:CloseSession()
RETURN .t.

FUNCTION DC_ShowServerWeblog()
local oClient := ThreadObject()
local text1, text2, text3
	text1 := '<html>' + CRLF
	text1 += '<head>' + CRLF
	text1 += '<Title>Logfile of web accesses</title>' + CRLF
	text1 += '</head> ' + CRLF
	text1 += '<body bgcolor="' + MEMVAR->shinter + '">' + CRLF
	text1 += '<Center><H1>Logfile of web accesses</H1></Center>' + CRLF
	text1 += '<pre>' + CRLF
	text2 := MemoRead( logpfad + WEB_LOG )
	text3 := strtran( text2, "<", "^" )
	text2 := strtran( text3, ">", "^" )
	text1 += text2
	text1 += '</pre>' + CRLF
	text1 += '</BODY></HTML>'
	if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
		oClient:HTTPResponse:CompressLevel := 7
	endif
	oClient:HTTPResponse:Content := text1
	oClient:CloseSession()
RETURN .t.

PROCEDURE DC_Login()
local oClient := ThreadObject()
local text1
	text1 := '<html>' + CRLF
	text1 += '<head>' + CRLF
	text1 += '<Title>Login to the DevCon server</title>' + CRLF
	text1 += '<link rel="stylesheet" href="devcon.css" type="text/css">' + CRLF
	text1 += '</head> ' + CRLF
	text1 += '<body bgcolor="' + MEMVAR->shinter + '" onload="self.focus();document.login.UID.focus()">' + CRLF
	text1 += '<Center><H1>Login to the DevCon server</H1></Center>' + CRLF
	text1 += '<table width=600 height=380 align=center>'
	text1 += CRLF + '<tr><td valign=top><br><br>'
	text1 += CRLF + '<table width=400 height=280 align=center>'
	text1 += CRLF + '<tr><td align=center>'
	text1 += CRLF + '<table cellspacing=1 cellpadding=0 align=center>'
	text1 += CRLF + '<form name="login" method="post" action="/Checklogin?">'
	text1 += CRLF + '<tr><td>User ID:&nbsp;</td><td><input type=text name="UID" maxlength=11 size=16></td></tr>'
	text1 += CRLF + '<tr><td>Password:&nbsp;</td><td><input type=password name="PWD" maxlength=11 size=16></td></tr>'
	text1 += CRLF + '<tr><td colspan=2><hr></td></tr>'
	text1 += CRLF + '<tr><td colspan=2><CENTER><input type=submit value="Login" width=100px style="width:80px; font:bold 12px verdana;"></CENTER></td></tr>'
	text1 += CRLF + '</form>'
	text1 += CRLF + '</table>'
	text1 += CRLF + '</table>'
	text1 += CRLF + '</table>'
	text1 += "<CENTER><BR><I>" + CRLF
  text1 += ConvToANSICp( 'In case of any problems with this web page please do not hesitate to contact the <A HREF="mailto:' + WEBMASTER + '"><B>Webmaster</B></A>!</I></CENTER>' ) + CRLF
	text1 += '<HR WIDTH="80%">' + CRLF
	text1 += '<P><table BORDER="0" CELLSPACING="0" CELLPADDING="0" ALIGN="CENTER" width="80%">' + CRLF
	text1 += '<tr><td width="10%">' + CRLF
	text1 += '<a href="http://www.alaska-software.com/" target="_blank"><img src="http://' + MEMVAR->cWebserver + '/headpic.gif" width="210" height="100" border="0" alt="Alaska Software"></a>' + CRLF
	text1 += '</td><td width="60%" align=center><a href="http://www.rmchart.com/" target="_blank"><img src="http://' + MEMVAR->cWebserver + '/rmchart.gif" width="228" height="99" border="0" alt="RMChart"></a></td><td width="10%">' + CRLF
	text1 += '<a href="http://www.xb2.net/" target="_blank"><img src="http://' + MEMVAR->cWebserver + '/powered.gif" width="102" height="70" border="0" alt="Xb2.NET" align="right"></a>' + CRLF
	text1 += '</td></tr></table>' + CRLF
	text1 += '</BODY></HTML>'
	if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
		oClient:HTTPResponse:CompressLevel := 7
	endif
	oClient:HTTPResponse:Content := text1
	oClient:CloseSession()
RETURN

PROCEDURE DC_Checklogin()
local oClient := ThreadObject()
local text1, text2, text3
Local cUID
Local cPWD

	cUID := oClient:GetVar("UID")
	cPWD := oClient:GetVar("PWD")
	if Empty(cUID)
		// no user ID specified - redisplay login screen
		DC_Login()
		Return
	endif

	if ! ( ( ( alltrim( cUID ) == alltrim( MEMVAR->User ) ) .and. ( alltrim( MEMVAR->Password ) == alltrim( cPWD ) ) ) .or. ( ( alltrim( cUID ) == alltrim( MEMVAR->BOUser ) ) .and. ( alltrim( MEMVAR->BOPassword ) == alltrim( cPWD ) ) ) )
		// invalid userid/password - go back to login screen
		DC_Login()
		Return
	endif
	oClient:setCargo( "UID", cUID )
	oClient:setCargo( "PWD", cPWD )
	if alltrim( cUID ) == alltrim( MEMVAR->User )
		DC_DoEditTable()
	elseif alltrim( cUID ) == alltrim( MEMVAR->BOUser )
		DC_DoBOTable()
	else
		DC_Login()
	endif
RETURN

PROCEDURE DC_DoBOTable()
local oClient := ThreadObject(), oServer := oClient:Parent
local text1, hinter, vorder, cUID, cPWD, text2, sum, idalt, bla, nI, aSaal, aZeit

	cUID := oClient:GetCargo("UID")
	cPWD := oClient:GetCargo("PWD")
	sum := 0
	text2 := ""
	if Empty(cUID)
		// no user ID specified - redisplay login screen
		DC_Login()
		Return
	endif
	if ! ( ( alltrim( cUID ) == alltrim( MEMVAR->BOUser ) ) .and. ( alltrim( MEMVAR->BOPassword ) == alltrim( cPWD ) ) )
		// invalid userid/password - go back to login screen
		DC_Login()
		Return
	endif
	oClient:setCargo( "UID", cUID )
	oClient:setCargo( "PWD", cPWD )
	OpenDbf()

	text1 := ConvToANSICp( '<html>' ) + CRLF
	text1 += ConvToANSICp( '<head>' ) + CRLF
	text1 += ConvToANSICp( '<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">' ) + CRLF
	text1 += ConvToANSICp( '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">' ) + CRLF
	text1 += ConvToANSICp( '<META HTTP-EQUIV="Cache-Control" CONTENT="no-cache">' ) + CRLF
	text1 += ConvToANSICp( '<META HTTP-EQUIV="Expires" CONTENT="-1">' ) + CRLF
	text1 += ConvToANSICp( '<Title>Speakers of the DevCon 2007</title>' ) + CRLF
	text1 += ConvToANSICp( '<link rel="stylesheet" href="devcon.css" type="text/css">' ) + CRLF
	text1 += ConvToANSICp( '</head> ' ) + CRLF
	text1 += ConvToANSICp( '<body bgcolor="' + MEMVAR->shinter + '">' ) + CRLF
	text1 += ConvToANSICp( '<Center><H1>Speakers of the DevCon 2007</H1>' ) + CRLF
	text1 += ConvToANSICp( '<P><HR WIDTH="80%"><P>'  )+ CRLF
	
	MEMVAR->pcws := {}
	select PCW
	PCW->( DbGoTop() )
	do while .not. PCW->( Eof() )
		hinter := ""
		if file( datenpfad + "\" + PCW->TEILNEHMID + ".pcw" )
			hinter := MemoRead( datenpfad + "\" + PCW->TEILNEHMID + ".pcw" )
		endif
		if ( PCW->SAAL > 0 ) .and. ( PCW->ZEIT > 0 ) .and. ( .not. empty( PCW->TEILNEHMID ) )
			Aadd( MEMVAR->pcws, { PCW->SAAL, PCW->ZEIT, PCW->TEILNEHMID, hinter } )
		endif
		PCW->( DbSkip() )
	enddo
	Asort( MEMVAR->pcws,,, { | aX, aY | iif( aX[ 1 ] <> aY[ 1 ], aX[1] < aY[1], aX[2] < aY[2] ) } )   // Array alphabetisch sortieren
	select Melde
	Melde->( DbGoTop() )
	hinter := ""
	vorder := "#000000"
	idalt := ""
	aSaal := { "hall 1", "hall 2", "little hall" }
	aZeit := { "13:00", "14:30", "16:00", "17:30" }
	do while .not. Melde->( Eof() )
		if ( Melde->TEILNEHMER == 5 ) .or. ( Melde->TEILNEHMER == 9 )
			if Melde->( Deleted() )
				hinter := "#CC0000"
				sum++
			else
				if idalt <> Melde->TEILNEHMID
					idalt := Melde->TEILNEHMID
					if hinter == "#00E3FF"
						hinter := "#00C3FF"
					else
						hinter := "#00E3FF"
					endif
				endif
			endif
			text2 += ConvToANSICp( '<TR valign="bottom"><TD WIDTH="5%" ALIGN="RIGHT"><a href=/DoBackOffice?' + oServer:SessionTag + '=' + oClient:GetSessionHandle() + '&DATSATZ=' + alltrim( str( Melde->( recno() ) ) ) + '&WAS=1><img src="/edit.gif" border=0 ALT="Edit Welcome ' + un + ' Vendor Day-workshop" width=16 height=16></A>' + NBSP + '</TD><TD WIDTH="25%" BGCOLOR="' + hinter +'"><FONT COLOR="' + vorder + '">' + NBSP + alltrim( Melde->VORNAME ) + '</FONT></TD><TD WIDTH="25%" BGCOLOR="' + hinter +'"><FONT COLOR="' + vorder + '">' + alltrim( Melde->NACHNAME ) + '</FONT></TD><TD WIDTH="25%" BGCOLOR="' + hinter +'"><FONT COLOR="' + vorder + '">' + alltrim( Melde->FIRMA1 ) + '</FONT></TD><TD WIDTH="15%" BGCOLOR="' + hinter +'"><FONT COLOR="' + vorder + '">' + alltrim( Melde->TEILNEHMID ) + '</FONT></TD><TD WIDTH="5%">' )
			text2 += ConvToANSICp( NBSP + '</TD></TR>' ) + CRLF
			if ( Melde->SHUTTLE > 0 ) .or. ( Melde->SHUTTLER > 0 )
				text2 += ConvToANSICp( '</TABLE>' ) + CRLF
				bla := "<I><B>Shuttle:</B> "
				if .not. empty( Melde->UHRAB )
					bla += left( right( "0000" + alltrim( Melde->UHRAB ), 4 ), 2 ) + ":" + right( "0000" + alltrim( Melde->UHRAB ), 2 ) + " o'clock "
				endif
				do case
				case Melde->SHUTTLE == 1
					bla += "from Tegel airport</I>"
				case Melde->SHUTTLE == 2
					bla += "from Sch" +oe + "nefeld airport</I>"
				otherwise
					bla := ""
				endcase
				text2 += ConvToANSICp( '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + MEMVAR->shinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="45%" BGCOLOR="' + hinter +'" align="center"><FONT COLOR="' + vorder + '">' + NBSP + bla + '</FONT></TD><TD WIDTH="45%" BGCOLOR="' + hinter +'" align="center"><FONT COLOR="' + vorder + '">' + NBSP )
				bla := "<I><B>Shuttle:</B> "
				if .not. empty( Melde->UHRHIN )
					bla += left( right( "0000" + alltrim( Melde->UHRHIN ), 4 ), 2 ) + ":" + right( "0000" + alltrim( Melde->UHRHIN ), 2 ) + " o'clock "
				endif
				do case
				case Melde->SHUTTLER == 1
					bla += "to Tegel airport</I>"
				case Melde->SHUTTLER == 2
					bla += "to Sch" +oe + "nefeld airport</I>"
				otherwise
					bla := ""
				endcase
				text2 += ConvToANSICp( bla + '</FONT></TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>' ) + CRLF
			endif
			nI := Ascan( MEMVAR->pcws, { |a| a[ 3 ] == idalt } )
			if nI > 0
				if ( Melde->SHUTTLE == 0 ) .and. ( Melde->SHUTTLER == 0 )
					text2 += ConvToANSICp( '</TABLE>' ) + CRLF
				endif
				bla := NBSP + "<I><B>Welcome " + un + " Vendor Day:</B><BR><CENTER>" + NBSP + aSaal[ MEMVAR->pcws[ nI, 1 ] ] + ", " + aZeit[ MEMVAR->pcws[ nI, 2 ] ] + " o'clock</CENTER></I>"
				text2 += ConvToANSICp( '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + MEMVAR->shinter + '"><TR valign="top"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="25%" BGCOLOR="' + hinter +'"><FONT COLOR="' + vorder + '">' + NBSP + bla + '</FONT></TD><TD WIDTH="65%" BGCOLOR="' + hinter +'"><FONT COLOR="' + vorder + '"><I>' + NBSP )
				text2 += MEMVAR->pcws[ nI, 4 ] + '</I></FONT></TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>' + CRLF
			endif
			if ( Melde->SHUTTLE > 0 ) .or. ( Melde->SHUTTLER > 0 ) .or. ( nI > 0 )
				text2 += ConvToANSICp( '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + MEMVAR->shinter + '">' )
			endif
		endif
		Melde->( DbSkip() )
	enddo

	text1 += ConvToANSICp( '<P><FONT COLOR="#CC0000"><B>' + alltrim( str( sum ) ) + ' deleted record' + iif( sum == 1, ' is', 's are' ) + ' having a red background colour!</B></FONT><P>'  )+ CRLF
	text1 += ConvToANSICp( '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + MEMVAR->shinter + '">' )
	text1 += ConvToANSICp( '<TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="25%"><B>' + NBSP + MEMVAR->texte[ vorname, spr_uk ] + '</B></TD><TD WIDTH="25%"><B>' + MEMVAR->texte[ nachname, spr_uk ] + '</B></TD><TD WIDTH="25%"><B>' + MEMVAR->texte[ firmaueb, spr_uk ] + '</B></TD><TD WIDTH="15%"><B>ID</B></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' ) + CRLF

	text1 += text2
	text1 += ConvToANSICp( '</TABLE>' ) + CRLF

	text1 += ConvToANSICp( '<BR><HR><BR>' ) + CRLF

	text1 += ConvToANSICp( '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + MEMVAR->shinter + '"><TR><TD WIDTH="50%" align="right">' )
	text1 += ConvToANSICp( "<FORM name='Uebersicht1' method='post' action='/DoBackOffice?'>" ) + CRLF
	text1 += ConvToANSICp( "<input type=hidden name='" + oServer:SessionTag + "' value='" + oClient:GetSessionHandle() + "'>" ) + CRLF
	text1 += ConvToANSICp( '<input type=hidden name="DATSATZ" value="0">' ) + CRLF
	text1 += ConvToANSICp( '<input type=hidden name="WAS" value="0">' ) + CRLF
	text1 += ConvToANSICp( '<input type="submit" value="Add a speaker">' ) + CRLF
	text1 += ConvToANSICp( '</FORM></TD><TD WIDTH="10%">' + NBSP + '</TD><TD WIDTH="40%">' )
	text1 += ConvToANSICp( "<FORM name='Uebersicht2' method='post' action='/DoBackOffice?'>" ) + CRLF
	text1 += ConvToANSICp( "<input type=hidden name='" + oServer:SessionTag + "' value='" + oClient:GetSessionHandle() + "'>" ) + CRLF
	text1 += ConvToANSICp( '<input type=hidden name="DATSATZ" value="0">' ) + CRLF
	text1 += ConvToANSICp( '<input type=hidden name="WAS" value="3">' ) + CRLF
	text1 += ConvToANSICp( '<input type="submit" value="' + MEMVAR->texte[ knopfende, spr_uk ] + '">' ) + CRLF
	text1 += ConvToANSICp( '</FORM></TD></TR></TABLE>' ) + CRLF

	text1 += ConvToANSICp( '</Center>' ) + MeldeFooter()

	CloseDbf()
	if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
		oClient:HTTPResponse:CompressLevel := 7
	endif
	oClient:HTTPResponse:Content := text1
RETURN

PROCEDURE DC_DoBackOffice()
	local oClient := ThreadObject()
	LOCAL Action, recnum
	local alleFelder, i
	local cUID, cPWD

	recnum := oClient:getVar( "DATSATZ" )
	Action := oClient:getVar( "WAS" )
	cUID := oClient:GetCargo("UID")
	cPWD := oClient:GetCargo("PWD")
	if Empty(cUID)
		// no user ID specified - redisplay login screen
		DC_Login()
		Return
	endif
	if ! ( ( alltrim( cUID ) == alltrim( MEMVAR->BOUser ) ) .and. ( alltrim( MEMVAR->BOPassword ) == alltrim( cPWD ) ) )
		// invalid userid/password - go back to login screen
		DC_Login()
		Return
	endif
	oClient:setCargo( "UID", cUID )
	oClient:setCargo( "PWD", cPWD )
	if ( Action == NIL ) .or. ( recnum == NIL )
		DC_DoBOTable()
	else
		do case
		case Action == "0"
			alleFelder := array( I_GESAMTFELDER )
			alleFelder[ I_ANREDE ] := "0"
			alleFelder[ I_VORNAME ] := ""
			alleFelder[ I_NACHNAME ] := ""
			alleFelder[ I_FIRMA1 ] := ""
			alleFelder[ I_FIRMA2 ] := ""
			alleFelder[ I_ABTEILUNG ] := ""
			alleFelder[ I_STRASSE ] := ""
			alleFelder[ I_STAAT ] := ""
			alleFelder[ I_PLZ ] := ""
			alleFelder[ I_ORT ] := ""
			alleFelder[ I_EMAIL ] := ""
			alleFelder[ I_WEBSEITE ] := ""
			alleFelder[ I_TEILNEHMER ] := "5" // Speaker
			alleFelder[ I_MUTTERSPRA ] := "0"
			alleFelder[ I_LAND ] := "0"
			alleFelder[ I_MUTTERSPSO ] := ""
			alleFelder[ I_FREMDSPRA1 ] := "0"
			alleFelder[ I_FREMDSPRA2 ] := "0"
			alleFelder[ I_VERSION ] := "0"
			alleFelder[ I_LAPTOP ] := .F.
			alleFelder[ I_ANONYM ] := .F.
			alleFelder[ I_ANONYM1 ] := .F.
			alleFelder[ I_ANONYM2 ] := .F.
			alleFelder[ I_ANONYM3 ] := .F.
			alleFelder[ I_SHIRT ] := "0"
			alleFelder[ I_TEILNEHMID ] := ""
			alleFelder[ I_ANREDE1 ] := "0"
			alleFelder[ I_VORNAME1 ] := ""
			alleFelder[ I_NACHNAME1 ] := ""
			alleFelder[ I_TEILNEHMER1 ] := "0"
			alleFelder[ I_SHIRT1 ] := "0"
			alleFelder[ I_ANREDE2 ] := "0"
			alleFelder[ I_VORNAME2 ] := ""
			alleFelder[ I_NACHNAME2 ] := ""
			alleFelder[ I_TEILNEHMER2 ] := "0"
			alleFelder[ I_SHIRT2 ] := "0"
			alleFelder[ I_ANREDE3 ] := "0"
			alleFelder[ I_VORNAME3 ] := ""
			alleFelder[ I_NACHNAME3 ] := ""
			alleFelder[ I_TEILNEHMER3 ] := "0"
			alleFelder[ I_SHIRT3 ] := "0"
			alleFelder[ I_SHUTTLE ] := "0"
			alleFelder[ I_SHUTTLER ] := "0"
			alleFelder[ I_UHRAB ] := ""
			alleFelder[ I_UHRHIN ] := ""
			alleFelder[ I_SAAL ] := "0"
			alleFelder[ I_ZEIT ] := "0"
			alleFelder[ I_THEMA ] := ""
			oClient:setCargo( "FELDER", alleFelder )
			AddSpeaker()
		case Action == "1"
			OpenDbf()
			select Melde
			goto val( recnum )
			if ( Melde->( recno() ) == val( recnum ) ) .and. .not. Melde->( eof() )
				alleFelder := array( I_GESAMTFELDER )
				alleFelder[ I_ANREDE ] := alltrim( str( Melde->ANREDE ) )
				alleFelder[ I_VORNAME ] := ConvToAnsiCP( alltrim( Melde->VORNAME ) )
				alleFelder[ I_NACHNAME ] := ConvToAnsiCP( alltrim( Melde->NACHNAME ) )
				alleFelder[ I_FIRMA1 ] := ConvToAnsiCP( alltrim( Melde->FIRMA1 ) )
				alleFelder[ I_FIRMA2 ] := ConvToAnsiCP( alltrim( Melde->FIRMA2 ) )
				alleFelder[ I_ABTEILUNG ] := ConvToAnsiCP( alltrim( Melde->ABTEILUNG ) )
				alleFelder[ I_STRASSE ] := ConvToAnsiCP( alltrim( Melde->STRASSE ) )
				alleFelder[ I_PLZ ] := ConvToAnsiCP( alltrim( Melde->PLZ ) )
				alleFelder[ I_ORT ] := ConvToAnsiCP( alltrim( Melde->ORT ) )
				alleFelder[ I_STAAT ] := ConvToAnsiCP( alltrim( Melde->STAAT ) )
				alleFelder[ I_LAND ] := ConvToAnsiCP( alltrim( Melde->LAND ) )
				alleFelder[ I_EMAIL ] := ConvToAnsiCP( alltrim( Melde->EMAIL ) )
				alleFelder[ I_WEBSEITE ] := ConvToAnsiCP( alltrim( Melde->WEBSEITE ) )
				alleFelder[ I_TEILNEHMER ] := alltrim( str( Melde->TEILNEHMER ) )
				alleFelder[ I_MUTTERSPRA ] := alltrim( str( Melde->MUTTERSPRA ) )
				alleFelder[ I_MUTTERSPSO ] := ConvToAnsiCP( alltrim( Melde->MUTTERSPSO ) )
				alleFelder[ I_FREMDSPRA1 ] := alltrim( str( Melde->FREMDSPRA1 ) )
				alleFelder[ I_FREMDSPRA2 ] := alltrim( str( Melde->FREMDSPRA2 ) )
				alleFelder[ I_LAPTOP ] := Melde->LAPTOP
				alleFelder[ I_ANONYM ] := Melde->ANONYM
				alleFelder[ I_TEILNEHMID ] := ConvToAnsiCP( alltrim( Melde->TEILNEHMID ) )
				alleFelder[ I_ZAHLEINGAN ] := iif( empty( Melde->ZAHLEINGAN ), "", DtoC( Melde->ZAHLEINGAN ) )
				alleFelder[ I_ZAHLART ] := alltrim( str( Melde->ZAHLART ) )
				alleFelder[ I_PREIS ] := alltrim( str( Melde->PREIS ) )
				alleFelder[ I_SHIRT ] := alltrim( str( Melde->SHIRT ) )
				alleFelder[ I_SHUTTLE ] := alltrim( str( Melde->SHUTTLE ) )
				alleFelder[ I_SHUTTLER ] := alltrim( str( Melde->SHUTTLER ) )
				alleFelder[ I_UHRAB ] := iif( empty( Melde->UHRAB ), "", left( right( "0000" + alltrim( Melde->UHRAB ), 4 ), 2 ) + ":" + right( "0000" + alltrim( Melde->UHRAB ), 2 ) )
				alleFelder[ I_UHRHIN ] := iif( empty( Melde->UHRHIN ), "", left( right( "0000" + alltrim( Melde->UHRHIN ), 4 ), 2 ) + ":" + right( "0000" + alltrim( Melde->UHRHIN ), 2 ) )
				i := Ascan( MEMVAR->pcws, { |a| a[ 3 ] == Melde->TEILNEHMID } )
				if i > 0
					alleFelder[ I_SAAL ] := str( MEMVAR->pcws[ i, 1 ], 1 )
					alleFelder[ I_ZEIT ] := str( MEMVAR->pcws[ i, 2 ], 1 )
					alleFelder[ I_THEMA ] := MEMVAR->pcws[ i, 4 ]
				else
					alleFelder[ I_SAAL ] := "0"
					alleFelder[ I_ZEIT ] := "0"
					alleFelder[ I_THEMA ] := ""
				endif
				oClient:setCargo( "FELDER", alleFelder )
				oClient:setCargo( "DATSATZ", recnum )
				CloseDbf()
				EditSpeaker()
			else
				CloseDbf()
				DC_DoBOTable()
			endif
		case Action == "3"
			oClient:HTTPResponse:Content := '<html><head><meta http-equiv="content-type" content="text/html; charset=ISO-8859-1"><title>TTFN!</title><link rel="stylesheet" href="devcon.css" type="text/css"></head><body BGCOLOR="#FFFFFF"><H1>TTFN!</H1></BODY></HTML>'
			oClient:closeSession()
		endcase
	endif
return

PROCEDURE EditSpeaker()
local oClient := ThreadObject(), oServer := oClient:Parent, text1

		OpenDbf()

		text1 := MeldeHeader( "Meldung_eingeben", "F_ANREDE", spr_uk )

		text1 += "<FORM name='Meldung_eingeben' method='post' action='/CheckEntry4?'>" + CRLF

		text1 += BuildTable( "uk", 4, .f., Date() )
		text1 += '<BR><HR><BR>' + CRLF

		text1 += '<input type=submit value="' + MEMVAR->texte[ knopfende, spr_uk ] + '"></FORM></CENTER>' + CRLF
		text1 += MeldeFooter()

		CloseDbf()

		oClient:HTTPResponse:Content := text1
return

FUNCTION DC_CheckEntry3()
	local oClient := ThreadObject(), oServer := oClient:Parent
	local fehlertext, ueberschr, fehlerobj
	local alleFelder, text1, sprache, cUID, cPWD
	local bla, bla2, datum2, sch, satz, std, minu, satz2

	cUID := oClient:GetCargo("UID")
	cPWD := oClient:GetCargo("PWD")
	alleFelder := oClient:getCargo( "FELDER" )
	if alleFelder == NIL
		alleFelder := array( I_GESAMTFELDER )
	endif
	alleFelder[ I_ANREDE ] := oClient:getVar( "F_ANREDE" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_VORNAME" ) ), 1 )
	alleFelder[ I_VORNAME ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_NACHNAME" ) ), 1 )
	alleFelder[ I_NACHNAME ] := bla2
	alleFelder[ I_FIRMA1 ] := erszeichen( oClient:getVar( "F_FIRMA1" ) )
	alleFelder[ I_FIRMA2 ] := erszeichen( oClient:getVar( "F_FIRMA2" ) )
	alleFelder[ I_ABTEILUNG ] := erszeichen( oClient:getVar( "F_ABTEILUNG" ) )
	alleFelder[ I_STRASSE ] := erszeichen( oClient:getVar( "F_STRASSE" ) )
	alleFelder[ I_LAND ] := oClient:getVar( "F_LAND" )
	alleFelder[ I_STAAT ] := upper( erszeichen( oClient:getVar( "F_STAAT" ) ) )
	alleFelder[ I_PLZ ] := erszeichen( oClient:getVar( "F_PLZ" ) )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_ORT" ) ), 1 )
	alleFelder[ I_ORT ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_EMAIL ] := erszeichen( oClient:getVar( "F_EMAIL" ) )
	alleFelder[ I_WEBSEITE ] := erszeichen( oClient:getVar( "F_WEBSEITE" ) )
	alleFelder[ I_TEILNEHMER ] := oClient:getVar( "F_TEILNEHMER" )
	alleFelder[ I_MUTTERSPRA ] := oClient:getVar( "F_MUTTERSPRA" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_MUTTERSPSO" ) ), 1 )
	alleFelder[ I_MUTTERSPSO ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_FREMDSPRA1 ] := oClient:getVar( "F_FREMDSPRA1" )
	alleFelder[ I_FREMDSPRA2 ] := oClient:getVar( "F_FREMDSPRA2" )
	alleFelder[ I_LAPTOP ] := ( oClient:getVar( "F_LAPTOP" ) == "on" )
	alleFelder[ I_ANONYM ] := ( oClient:getVar( "F_ANONYM" ) == "on" )
	alleFelder[ I_ANONYM1 ] := ( oClient:getVar( "F_ANONYM1" ) == "on" )
	alleFelder[ I_ANONYM2 ] := ( oClient:getVar( "F_ANONYM2" ) == "on" )
	alleFelder[ I_ANONYM3 ] := ( oClient:getVar( "F_ANONYM3" ) == "on" )
	alleFelder[ I_ANREDE1 ] := oClient:getVar( "F_ANREDE1" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_VORNAME1" ) ), 1 )
	alleFelder[ I_VORNAME1 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_NACHNAME1" ) ), 1 )
	alleFelder[ I_NACHNAME1 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_TEILNEHMER1 ] := oClient:getVar( "F_TEILNEHMER1" )
	alleFelder[ I_ANREDE2 ] := oClient:getVar( "F_ANREDE2" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_VORNAME2" ) ), 1 )
	alleFelder[ I_VORNAME2 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_NACHNAME2" ) ), 1 )
	alleFelder[ I_NACHNAME2 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_TEILNEHMER2 ] := oClient:getVar( "F_TEILNEHMER2" )
	alleFelder[ I_ANREDE3 ] := oClient:getVar( "F_ANREDE3" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_VORNAME3" ) ), 1 )
	alleFelder[ I_VORNAME3 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_NACHNAME3" ) ), 1 )
	alleFelder[ I_NACHNAME3 ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_TEILNEHMER3 ] := oClient:getVar( "F_TEILNEHMER3" )
	alleFelder[ I_SHIRT1 ] := oClient:getVar( "F_SHIRT1" )
	alleFelder[ I_SHIRT2 ] := oClient:getVar( "F_SHIRT2" )
	alleFelder[ I_SHIRT3 ] := oClient:getVar( "F_SHIRT3" )
	alleFelder[ I_SHIRT ] := oClient:getVar( "F_SHIRT" )
	alleFelder[ I_SHUTTLE ] := oClient:getVar( "F_SHUTTLE" )
	alleFelder[ I_SHUTTLER ] := oClient:getVar( "F_SHUTTLER" )
	alleFelder[ I_UHRAB ] := oClient:getVar( "F_UHRAB" )
	alleFelder[ I_UHRHIN ] := oClient:getVar( "F_UHRHIN" )
	alleFelder[ I_SAAL ] := oClient:getVar( "F_SAAL" )
	alleFelder[ I_ZEIT ] := oClient:getVar( "F_ZEIT" )
	alleFelder[ I_THEMA ] := oClient:getVar( "F_THEMA" )

	oClient:setCargo( "FELDER", alleFelder )
	oClient:setCargo( "UID", cUID )
	oClient:setCargo( "PWD", cPWD )
	fehlertext := ""
	ueberschr := ""
	fehlerobj := ""
	if alleFelder[ I_ANREDE ] == "0"
		fehlertext += "Choose Title!"
		if empty( fehlerobj )
			fehlerobj := "F_ANREDE"
		endif
	endif
	if empty( alleFelder[ I_VORNAME ] )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Enter first name!"
		if empty( fehlerobj )
			fehlerobj := "F_VORNAME"
		endif
	endif
	if empty( alleFelder[ I_NACHNAME ] )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Enter last name!"
		if empty( fehlerobj )
			fehlerobj := "F_NACHNAME"
		endif
	endif
	if empty( alleFelder[ I_STRASSE ] )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Enter street!"
		if empty( fehlerobj )
			fehlerobj := "F_STRASSE"
		endif
	endif
	if alleFelder[ I_LAND ] == "0"
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Choose country!"
		if empty( fehlerobj )
			fehlerobj := "F_LAND"
		endif
	endif
	if empty( alleFelder[ I_STAAT ] )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Enter county/region!"
		if empty( fehlerobj )
			fehlerobj := "F_STAAT"
		endif
	endif
	if empty( alleFelder[ I_PLZ ] )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Enter ZIP!"
		if empty( fehlerobj )
			fehlerobj := "F_PLZ"
		endif
	endif
	if empty( alleFelder[ I_ORT ] )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Enter City!"
		if empty( fehlerobj )
			fehlerobj := "F_ORT"
		endif
	endif
	if empty( alleFelder[ I_EMAIL ] )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Enter e-mail-address!"
		if empty( fehlerobj )
			fehlerobj := "F_EMAIL"
		endif
	else
		bla := alltrim( alleFelder[ I_EMAIL ] )
		datum2 := at( "@", bla )
		if ( datum2 == 0 ) .or. ( at( ".", bla, datum2 + 1 ) == 0 )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Enter a valid e-mail-address!"
			if empty( fehlerobj )
				fehlerobj := "F_EMAIL"
			endif
		endif
	endif
	if ( .not. empty( alleFelder[ I_WEBSEITE ] ) ) .and. ( at( ".", alltrim( alleFelder[ I_WEBSEITE ] ) ) == 0 )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Provide a valid website-address!"
		if empty( fehlerobj )
			fehlerobj := "F_WEBSEITE"
		endif
	endif
	if alleFelder[ I_MUTTERSPRA ] == "0"
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Choose native tongue!"
		if empty( fehlerobj )
			fehlerobj := "F_MUTTERSPRA"
		endif
	endif
	if empty( alleFelder[ I_MUTTERSPSO ] ) .and. ( alleFelder[ I_MUTTERSPRA ] == "99" )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Enter native tongue!"
		if empty( fehlerobj )
			fehlerobj := "F_MUTTERSPSO"
		endif
	endif
	if val( alleFelder[ I_SHIRT ] ) == 0
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Choose size of tee-shirt!"
		if empty( fehlerobj )
			fehlerobj := "F_SHIRT"
		endif
	endif

	if .not. ( empty( alleFelder[ I_VORNAME1 ] ) .and. empty( alleFelder[ I_NACHNAME1 ] ) )
		if alleFelder[ I_ANREDE1 ] == "0"
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Select the title of the first person joining!"
			if empty( fehlerobj )
				fehlerobj := "F_ANREDE1"
			endif
		endif
		if empty( alleFelder[ I_VORNAME1 ] )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Enter the first name of the first person joining!"
			if empty( fehlerobj )
				fehlerobj := "F_VORNAME1"
			endif
		endif
		if empty( alleFelder[ I_NACHNAME1 ] )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Enter the last name of the first person joining!"
			if empty( fehlerobj )
				fehlerobj := "F_NACHNAME1"
			endif
		endif
		if alleFelder[ I_TEILNEHMER1 ] == "0"
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Select the kind of relationship with the first person joining!"
			if empty( fehlerobj )
				fehlerobj := "F_TEILNEHMER1"
			endif
		endif
		if val( alleFelder[ I_SHIRT1 ] ) == 0
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Select the size of tee-shirt of the first person joining!"
			if empty( fehlerobj )
				fehlerobj := "F_SHIRT1"
			endif
		endif
	endif
	if .not. ( empty( alleFelder[ I_VORNAME2 ] ) .and. empty( alleFelder[ I_NACHNAME2 ] ) )
		if alleFelder[ I_ANREDE2 ] == "0"
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Select the title of the second person joining!"
			if empty( fehlerobj )
				fehlerobj := "F_ANREDE2"
			endif
		endif
		if empty( alleFelder[ I_VORNAME2 ] )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Enter the first name of the second person joining!"
			if empty( fehlerobj )
				fehlerobj := "F_VORNAME2"
			endif
		endif
		if empty( alleFelder[ I_NACHNAME2 ] )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Enter the last name of the third person joining!"
			if empty( fehlerobj )
				fehlerobj := "F_NACHNAME2"
			endif
		endif
		if alleFelder[ I_TEILNEHMER2 ] == "0"
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Select the kind of relationship with the second person joining!"
			if empty( fehlerobj )
				fehlerobj := "F_TEILNEHMER2"
			endif
		endif
		if val( alleFelder[ I_SHIRT2 ] ) == 0
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Select the size of tee-shirt of the second person joining!"
			if empty( fehlerobj )
				fehlerobj := "F_SHIRT2"
			endif
		endif
	endif
	if .not. ( empty( alleFelder[ I_VORNAME3 ] ) .and. empty( alleFelder[ I_NACHNAME3 ] ) )
		if alleFelder[ I_ANREDE3 ] == "0"
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Select the title of the third person joining!"
			if empty( fehlerobj )
				fehlerobj := "F_ANREDE3"
			endif
		endif
		if empty( alleFelder[ I_VORNAME3 ] )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Enter the first name of the third person joining!"
			if empty( fehlerobj )
				fehlerobj := "F_VORNAME3"
			endif
		endif
		if empty( alleFelder[ I_NACHNAME3 ] )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Enter the last name of the third person joining!"
			if empty( fehlerobj )
				fehlerobj := "F_NACHNAME3"
			endif
		endif
		if alleFelder[ I_TEILNEHMER3 ] == "0"
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Select the kind of relationship with the third person joining!"
			if empty( fehlerobj )
				fehlerobj := "F_TEILNEHMER3"
			endif
		endif
		if val( alleFelder[ I_SHIRT3 ] ) == 0
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Select the size of tee-shirt of the third person joining!"
			if empty( fehlerobj )
				fehlerobj := "F_SHIRT3"
			endif
		endif
	endif

	if ( alleFelder[ I_SHUTTLE ] <> "0" ) .and. ( empty( alleFelder[ I_UHRAB ] ) )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Provide a time to be picked up as the airport to be picked up from has been selected!"
		if empty( fehlerobj )
			fehlerobj := "F_UHRAB"
		endif
	elseif ( alleFelder[ I_SHUTTLE ] == "0" ) .and. ( .not. empty( alleFelder[ I_UHRAB ] ) )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Choose the airport to be picked from as the time to be picked up has been entered!"
		if empty( fehlerobj )
			fehlerobj := "F_SHUTTLE"
		endif
	elseif ( alleFelder[ I_SHUTTLE ] <> "0" ) .and. ( .not. empty( alleFelder[ I_UHRAB ] ) )
		satz2 := at( ":", alleFelder[ I_UHRAB ] )
		if satz2 > 0
			std := val( left( alleFelder[ I_UHRAB ], satz2 - 1 ) )
			minu := val( substr( alleFelder[ I_UHRAB ], satz2 + 1 ) )
		else
			std := val( left( right( "0000" + alltrim( alleFelder[ I_UHRAB ] ), 4 ), 2 ) )
			minu := val( right( "0000" + alltrim( alleFelder[ I_UHRAB ] ), 2 ) )
		endif
		if ( std < 0 ) .or. ( std > 24 ) .or. ( minu < 0 ) .or. ( minu > 59 )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Enter a valid pickup-time!"
			if empty( fehlerobj )
				fehlerobj := "F_UHRAB"
			endif
		else
			satz2 := (std * 100 ) + minu
			if ( satz2 < 800 ) .or. ( satz2 > 1200 )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				fehlertext += "Pickup at the airport is only possible between 08:00 CET and 12:00 CET!"
				if empty( fehlerobj )
					fehlerobj := "F_UHRAB"
				endif
			endif
		endif
		alleFelder[ I_UHRAB ] := right( "00" + alltrim( str( std ) ), 2 ) + ":" + right( "00" + alltrim( str( minu ) ), 2 )
	endif
	if ( alleFelder[ I_SHUTTLER ] <> "0" ) .and. ( empty( alleFelder[ I_UHRHIN ] ) )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Provide a time to be taken to the airport as the airport to be taken to has been selected!"
		if empty( fehlerobj )
			fehlerobj := "F_UHRHIN"
		endif
	elseif ( alleFelder[ I_SHUTTLER ] == "0" ) .and. ( .not. empty( alleFelder[ I_UHRHIN ] ) )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Choose the airport to be taken to as the time to be taken to the airport has been entered!"
		if empty( fehlerobj )
			fehlerobj := "F_SHUTTLER"
		endif
	elseif ( alleFelder[ I_SHUTTLER ] <> "0" ) .and. ( .not. empty( alleFelder[ I_UHRHIN ] ) )
		satz2 := at( ":", alleFelder[ I_UHRHIN ] )
		if satz2 > 0
			std := val( left( alleFelder[ I_UHRHIN ], satz2 - 1 ) )
			minu := val( substr( alleFelder[ I_UHRHIN ], satz2 + 1 ) )
		else
			std := val( left( right( "0000" + alltrim( alleFelder[ I_UHRHIN ] ), 4 ), 2 ) )
			minu := val( right( "0000" + alltrim( alleFelder[ I_UHRHIN ] ), 2 ) )
		endif
		if ( std < 0 ) .or. ( std > 24 ) .or. ( minu < 0 ) .or. ( minu > 59 )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Provide a valid departure time!"
			if empty( fehlerobj )
				fehlerobj := "F_UHRHIN"
			endif
		else
			satz2 := (std * 100 ) + minu
			if ( satz2 < 1700 ) .or. ( satz2 > 2100 )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				fehlertext += "One can only be taken to the airport between 17:00 CET and 21:00 CET!"
				if empty( fehlerobj )
					fehlerobj := "F_UHRHIN"
				endif
			endif
		endif
		alleFelder[ I_UHRHIN ] := right( "00" + alltrim( str( std ) ), 2 ) + ":" + right( "00" + alltrim( str( minu ) ), 2 )
	endif
	if ascan( MEMVAR->pcws, { |a| ( ( a[ 1 ] == val( alleFelder[ I_SAAL ] ) ) .and. ( a[ 2 ] == val( alleFelder[ I_ZEIT ] ) ) .and. ( .not. ( a[ 3 ] == alleFelder[ I_TEILNEHMID ] ) ) ) } ) > 0
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Slot already taken!"
		if empty( fehlerobj )
			fehlerobj := "F_SAAL"
		endif
	else
		if ( alleFelder[ I_SAAL ] <> "0" ) 
			if alleFelder[ I_ZEIT ] == "0"
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				fehlertext += "Choose a time for the PCW!"
				if empty( fehlerobj )
					fehlerobj := "F_ZEIT"
				endif
			endif
			if empty( alleFelder[ I_THEMA ] )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				fehlertext += "Enter subject of the PCW!"
				if empty( fehlerobj )
					fehlerobj := "F_THEMA"
				endif
			endif
		else
			if ( alleFelder[ I_ZEIT ] <> "0" ) 
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				fehlertext += "Select a hall for the PCW!"
				if empty( fehlerobj )
					fehlerobj := "F_SAAL"
				endif
				if empty( alleFelder[ I_THEMA ] )
					if .not. empty( fehlertext )
						fehlertext += "<BR>"
					endif
					fehlertext += "Enter subject of the PCW!"
					if empty( fehlerobj )
						fehlerobj := "F_THEMA"
					endif
				endif
			elseif .not. empty( alleFelder[ I_THEMA ] )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				fehlertext += "Select a hall for the PCW!"
				if empty( fehlerobj )
					fehlerobj := "F_SAAL"
				endif
				fehlertext += "<BR>"
				fehlertext += "Choose a time for the PCW!"
				if empty( fehlerobj )
					fehlerobj := "F_ZEIT"
				endif
			endif
		endif
	endif

	IF .not. Empty( fehlertext )
		ueberschr := "Wrong input, please correct"
	ENDIF

	if .not. empty( ueberschr )
		text1 := MeldeHeader( "Meldung_eingeben", fehlerobj, spr_uk )
		text1 += Fehlermeldung( ueberschr, fehlertext )

		text1 += "<FORM name='Meldung_eingeben' method='post' action='/CheckEntry3?'>" + CRLF
		text1 += "<input type=hidden name='" + oServer:SessionTag + "' value='" + oClient:GetSessionHandle() + "'>" + CRLF

		text1 += BuildTable( "uk", 3, .f., Date() )
		text1 += '<BR><HR><BR>' + CRLF

		text1 += '<input type=submit value="' + MEMVAR->texte[ knopfende, spr_uk ] + '">' + CRLF
		text1 += "</FORM></CENTER>" + MeldeFooter()


		if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
			oClient:HTTPResponse:CompressLevel := 7
		endif
		oClient:HTTPResponse:Content := text1

	else
		do case
		case val( alleFelder[ I_MUTTERSPRA ] ) == spr_de
			sprache := "de"
		case val( alleFelder[ I_MUTTERSPRA ] ) == spr_fr
			sprache := "fr"
		case val( alleFelder[ I_MUTTERSPRA ] ) == spr_sp
			sprache := "sp"
		case val( alleFelder[ I_MUTTERSPRA ] ) == spr_pt
			sprache := "pt"
		otherwise
			sprache := "uk"
		endcase
		OpenDbf()
		sch := ""
		satz := 0
		if SaveEntry( @satz, @sch, 3, .t., alleFelder )
			CloseDbf()
			Druckausgabe( sprache, sch, alleFelder, .f., Date() )
			DC_DoBOTable()
		else
			CloseDbf()
			return .f.
		endif
	endif
RETURN .t.

FUNCTION DC_CheckEntry4()
	local oClient := ThreadObject(), oServer := oClient:Parent
	local fehlertext, ueberschr, fehlerobj
	local alleFelder, text1, sprache, cUID, cPWD
	local bla, bla2, datum2, sch, satz, std, minu, satz2

	cUID := oClient:GetCargo("UID")
	cPWD := oClient:GetCargo("PWD")
	alleFelder := oClient:getCargo( "FELDER" )
	if alleFelder == NIL
		alleFelder := array( I_GESAMTFELDER )
	endif
	alleFelder[ I_SAAL ] := oClient:getVar( "F_SAAL" )
	alleFelder[ I_ZEIT ] := oClient:getVar( "F_ZEIT" )
	alleFelder[ I_THEMA ] := oClient:getVar( "F_THEMA" )

	oClient:setCargo( "FELDER", alleFelder )
	oClient:setCargo( "UID", cUID )
	oClient:setCargo( "PWD", cPWD )
	fehlertext := ""
	ueberschr := ""
	fehlerobj := ""
	if ascan( MEMVAR->pcws, { |a| ( ( a[ 1 ] == val( alleFelder[ I_SAAL ] ) ) .and. ( a[ 2 ] == val( alleFelder[ I_ZEIT ] ) ) .and. ( .not. ( a[ 3 ] == alleFelder[ I_TEILNEHMID ] ) ) ) } ) > 0
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Slot already taken!"
		if empty( fehlerobj )
			fehlerobj := "F_SAAL"
		endif
	else
		if ( alleFelder[ I_SAAL ] <> "0" ) 
			if alleFelder[ I_ZEIT ] == "0"
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				fehlertext += "Choose a time for the PCW!"
				if empty( fehlerobj )
					fehlerobj := "F_ZEIT"
				endif
			endif
			if empty( alleFelder[ I_THEMA ] )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				fehlertext += "Enter subject of the PCW!"
				if empty( fehlerobj )
					fehlerobj := "F_THEMA"
				endif
			endif
		else
			if ( alleFelder[ I_ZEIT ] <> "0" ) 
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				fehlertext += "Select a hall for the PCW!"
				if empty( fehlerobj )
					fehlerobj := "F_SAAL"
				endif
				if empty( alleFelder[ I_THEMA ] )
					if .not. empty( fehlertext )
						fehlertext += "<BR>"
					endif
					fehlertext += "Enter subject of the PCW!"
					if empty( fehlerobj )
						fehlerobj := "F_THEMA"
					endif
				endif
			elseif .not. empty( alleFelder[ I_THEMA ] )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				fehlertext += "Select a hall for the PCW!"
				if empty( fehlerobj )
					fehlerobj := "F_SAAL"
				endif
				fehlertext += "<BR>"
				fehlertext += "Choose a time for the PCW!"
				if empty( fehlerobj )
					fehlerobj := "F_ZEIT"
				endif
			endif
		endif
	endif

	IF .not. Empty( fehlertext )
		ueberschr := "Wrong input, please correct"
	ENDIF

	if .not. empty( ueberschr )
		text1 := MeldeHeader( "Meldung_eingeben", fehlerobj, spr_uk )
		text1 += Fehlermeldung( ueberschr, fehlertext )

		text1 += "<FORM name='Meldung_eingeben' method='post' action='/CheckEntry4?'>" + CRLF
		text1 += "<input type=hidden name='" + oServer:SessionTag + "' value='" + oClient:GetSessionHandle() + "'>" + CRLF

		text1 += BuildTable( "uk", 4, .f., Date() )
		text1 += '<BR><HR><BR>' + CRLF

		text1 += '<input type=submit value="' + MEMVAR->texte[ knopfende, spr_uk ] + '">' + CRLF
		text1 += "</FORM></CENTER>" + MeldeFooter()


		if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
			oClient:HTTPResponse:CompressLevel := 7
		endif
		oClient:HTTPResponse:Content := text1

	else
		do case
		case val( alleFelder[ I_MUTTERSPRA ] ) == spr_de
			sprache := "de"
		case val( alleFelder[ I_MUTTERSPRA ] ) == spr_fr
			sprache := "fr"
		case val( alleFelder[ I_MUTTERSPRA ] ) == spr_sp
			sprache := "sp"
		case val( alleFelder[ I_MUTTERSPRA ] ) == spr_pt
			sprache := "pt"
		otherwise
			sprache := "uk"
		endcase
		OpenDbf()
		sch := ""
		satz := 0
		if SaveEntry( @satz, @sch, 4, .t., alleFelder )
			CloseDbf()
			DC_DoBOTable()
		else
			CloseDbf()
			return .f.
		endif
	endif
RETURN .t.

PROCEDURE AddSpeaker()
local oClient := ThreadObject(), oServer := oClient:Parent, text1

		OpenDbf()

		text1 := MeldeHeader( "Meldung_eingeben", "F_ANREDE", spr_uk )

		text1 += "<FORM name='Meldung_eingeben' method='post' action='/CheckEntry3?'>" + CRLF

		text1 += BuildTable( "uk", 3, .f., Date() )
		text1 += '<BR><HR><BR>' + CRLF

		text1 += '<input type=submit value="' + MEMVAR->texte[ knopfende, spr_uk ] + '"></FORM></CENTER>' + CRLF
		text1 += MeldeFooter()

		CloseDbf()

		oClient:HTTPResponse:Content := text1
return

PROCEDURE DC_DoEditTable()
local oClient := ThreadObject(), oServer := oClient:Parent
local text1, hinter, vorder, cUID, cPWD, text2, sum, lsaeumig, nsaeumig, idalt, bla, nI, aSaal, aZeit, aPayPal, lMail

	cUID := oClient:GetCargo("UID")
	cPWD := oClient:GetCargo("PWD")
	sum := 0
	text2 := ""
	if Empty(cUID)
		// no user ID specified - redisplay login screen
		DC_Login()
		Return
	endif
	if ! ( ( alltrim( cUID ) == alltrim( MEMVAR->User ) ) .and. ( alltrim( MEMVAR->Password ) == allTrim( cPWD ) ) )
		// invalid userid/password - go back to login screen
		DC_Login()
		Return
	endif
	oClient:setCargo( "UID", cUID )
	oClient:setCargo( "PWD", cPWD )
	OpenDbf()

	text1 := ConvToANSICp( '<html>' ) + CRLF
	text1 += ConvToANSICp( '<head>' ) + CRLF
	text1 += ConvToANSICp( '<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">' ) + CRLF
	text1 += ConvToANSICp( '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">' ) + CRLF
	text1 += ConvToANSICp( '<META HTTP-EQUIV="Cache-Control" CONTENT="no-cache">' ) + CRLF
	text1 += ConvToANSICp( '<META HTTP-EQUIV="Expires" CONTENT="-1">' ) + CRLF
	text1 += ConvToANSICp( '<Title>Editing the DevCon registrations</title>' ) + CRLF
	text1 += ConvToANSICp( '<link rel="stylesheet" href="devcon.css" type="text/css">' ) + CRLF
	text1 += ConvToANSICp( '</head> ' ) + CRLF
	text1 += ConvToANSICp( '<body bgcolor="' + MEMVAR->shinter + '">' ) + CRLF
	text1 += ConvToANSICp( '<Center><H1>Editing the DevCon registrations</H1>' ) + CRLF
	text1 += ConvToANSICp( '<P><HR WIDTH="80%">'  )+ CRLF
	aPayPal := Directory( mempfad + "\DC07DE????.MEM" )
	if len( aPayPal ) > 0
		text1 += '<TABLE WIDTH="80%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + MEMVAR->shinter + '" ALIGN="CENTER">'
		text1 += '<TR><TD WIDTH="70%">' + NBSP + '</TD><TD WIDTH="30%"><marquee behavior="alternate"><A align="right" HREF="/PayPalStati?">unfinished PayPal-transactions</A></marquee><TD></TR></TABLE>'
	endif
	text1 += '<P>'
	MEMVAR->pcws := {}
	select PCW
	PCW->( DbGoTop() )
	do while .not. PCW->( Eof() )
		hinter := ""
		if file( datenpfad + "\" + PCW->TEILNEHMID + ".pcw" )
			hinter := MemoRead( datenpfad + "\" + PCW->TEILNEHMID + ".pcw" )
		endif
		if ( PCW->SAAL > 0 ) .and. ( PCW->ZEIT > 0 ) .and. ( .not. empty( PCW->TEILNEHMID ) )
			Aadd( MEMVAR->pcws, { PCW->SAAL, PCW->ZEIT, PCW->TEILNEHMID, hinter } )
		endif
		PCW->( DbSkip() )
	enddo
	Asort( MEMVAR->pcws,,, { | aX, aY | iif( aX[ 1 ] <> aY[ 1 ], aX[1] < aY[1], aX[2] < aY[2] ) } )
	select Melde
	Melde->( DbGoTop() )
	hinter := ""
	vorder := "#000000"
	nsaeumig := 0
	idalt := ""
	aSaal := { "hall 1", "hall 2", "little hall" }
	aZeit := { "13:00", "14:30", "16:00", "17:30" }
	do while .not. Melde->( Eof() )
		if Melde->( Deleted() )
			lsaeumig := .f.
			sum++
			lMail := .f.
		else
			lsaeumig := ( ( ( date() - 14 ) > Melde->ANMELDEDAT ) .and. empty( Melde->ZAHLEINGAN ) .and. ( ( Melde->TEILNEHMER < 5 ) .or. ( ( Melde->TEILNEHMER > 6 ) .and. ( Melde->TEILNEHMER < 9 ) ) ) )
			if idalt <> Melde->TEILNEHMID
				idalt := Melde->TEILNEHMID
				if hinter == "#00E3FF"
					hinter := "#00C3FF"
				else
					hinter := "#00E3FF"
				endif
				lMail := .t.
			else
				lMail := .f.
			endif
		endif
		if lsaeumig
			nsaeumig++
		endif
		text2 += ConvToANSICp( '<TR valign="bottom"><TD WIDTH="5%" ALIGN="RIGHT"><a href=/Dispatcher?' + oServer:SessionTag + '=' + oClient:GetSessionHandle() + '&DATSATZ=' + alltrim( str( Melde->( recno() ) ) ) + '&WAS=1><img src="/edit.gif" border=0 ALT="' + MEMVAR->texte[ bearbeiten, spr_uk ] + '" width=16 height=16></A>' + NBSP + '</TD><TD WIDTH="25%" BGCOLOR="' + iif( Melde->( Deleted() ), "#CC0000", hinter ) +'"><FONT COLOR="' + vorder + '">' + NBSP + alltrim( Melde->VORNAME ) + '</FONT></TD><TD WIDTH="25%" BGCOLOR="' + iif( Melde->( Deleted() ), "#CC0000", hinter ) +'"><FONT COLOR="' + vorder + '">' + alltrim( Melde->NACHNAME ) + '</FONT></TD><TD WIDTH="15%" BGCOLOR="' + iif( Melde->( Deleted() ), "#CC0000", hinter ) +'"><FONT COLOR="' + vorder + '">' + alltrim( Melde->TEILNEHMID ) + '</FONT>' + iif( lMail, NBSP + '<a href=/Dispatcher?' + oServer:SessionTag + '=' + oClient:GetSessionHandle() + '&DATSATZ=' + alltrim( str( Melde->( recno() ) ) ) + '&WAS=12><img src="/mail.gif" border=0 ALT="send receipt" width=16 height=16></A>', "" ) + '</TD><TD WIDTH="12%" BGCOLOR="' + iif( ( Melde->( Deleted() ) .or. lsaeumig ), "#CC0000", hinter ) +'" ALIGN="RIGHT"><FONT COLOR="' + vorder + '">' + iif( empty( Melde->ZAHLEINGAN ), iif( ( Melde->TEILNEHMER == 9 ), "<B>Technology Partner</B>", iif( ( Melde->TEILNEHMER == 5 ), "<B>Speaker</B>", iif( ( Melde->TEILNEHMER == 6 ), "<B>Organiser</B>", "<B>open</B>" ) ) ), DtoC( Melde->ZAHLEINGAN ) ) + NBSP + '</FONT></TD><TD WIDTH="13%" BGCOLOR="' + iif( Melde->( Deleted() ), "#CC0000", hinter ) +'" ALIGN="RIGHT"><FONT COLOR="' + vorder + '">' + transform( Melde->PREIS, "@E ###.##" ) + NBSP + "EUR" + NBSP + '</FONT></TD><TD WIDTH="5%">' )
		text2 += ConvToANSICp( NBSP + '<A HREF=/Dispatcher?' + oServer:SessionTag + '=' + oClient:GetSessionHandle() + '&DATSATZ=' + alltrim( str( Melde->( recno() ) ) ) + '&WAS=2><img src="/delete.gif" border=0 ALT="' + MEMVAR->texte[ loeschen, spr_uk ] + '" width=16 height=16></A></TD></TR>' ) + CRLF
		if ( Melde->SHUTTLE > 0 ) .or. ( Melde->SHUTTLER > 0 )
			text2 += ConvToANSICp( '</TABLE>' ) + CRLF
			bla := "<I><B>Shuttle:</B> "
			if .not. empty( Melde->UHRAB )
				bla += left( right( "0000" + alltrim( Melde->UHRAB ), 4 ), 2 ) + ":" + right( "0000" + alltrim( Melde->UHRAB ), 2 ) + " o'clock "
			endif
			do case
			case Melde->SHUTTLE == 1
				bla += "from Tegel airport</I>"
			case Melde->SHUTTLE == 2
				bla += "from Sch" +oe + "nefeld airport</I>"
			otherwise
				bla := ""
			endcase
			text2 += ConvToANSICp( '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + MEMVAR->shinter + '"><TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="45%" BGCOLOR="' + iif( Melde->( Deleted() ), "#CC0000", hinter ) +'" align="center"><FONT COLOR="' + vorder + '">' + NBSP + bla + '</FONT></TD><TD WIDTH="45%" BGCOLOR="' + iif( Melde->( Deleted() ), "#CC0000", hinter ) +'" align="center"><FONT COLOR="' + vorder + '">' + NBSP )
			bla := "<I><B>Shuttle:</B> "
			if .not. empty( Melde->UHRHIN )
				bla += left( right( "0000" + alltrim( Melde->UHRHIN ), 4 ), 2 ) + ":" + right( "0000" + alltrim( Melde->UHRHIN ), 2 ) + " o'clock "
			endif
			do case
			case Melde->SHUTTLER == 1
				bla += "to Tegel airport</I>"
			case Melde->SHUTTLER == 2
				bla += "to Sch" +oe + "nefeld airport</I>"
			otherwise
				bla := ""
			endcase
			text2 += ConvToANSICp( bla + '</FONT></TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>' ) + CRLF
		endif
		nI := Ascan( MEMVAR->pcws, { |a| a[ 3 ] == idalt } )
		if nI > 0
			if ( Melde->SHUTTLE == 0 ) .and. ( Melde->SHUTTLER == 0 )
				text2 += ConvToANSICp( '</TABLE>' ) + CRLF
			endif
			bla := NBSP + "<I><B>Welcome " + un + " Vendor Day:</B><BR><CENTER>" + NBSP + aSaal[ MEMVAR->pcws[ nI, 1 ] ] + ", " + aZeit[ MEMVAR->pcws[ nI, 2 ] ] + " o'clock</CENTER></I>"
			text2 += ConvToANSICp( '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + MEMVAR->shinter + '"><TR valign="top"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="25%" BGCOLOR="' + iif( Melde->( Deleted() ), "#CC0000", hinter ) +'"><FONT COLOR="' + vorder + '">' + NBSP + bla + '</FONT></TD><TD WIDTH="65%" BGCOLOR="' + iif( Melde->( Deleted() ), "#CC0000", hinter ) +'"><FONT COLOR="' + vorder + '"><I>' + NBSP )
			text2 += MEMVAR->pcws[ nI, 4 ] + '</I></FONT></TD><TD WIDTH="5%">' + NBSP + '</TD></TR></TABLE>' + CRLF
		endif
		if ( Melde->SHUTTLE > 0 ) .or. ( Melde->SHUTTLER > 0 ) .or. ( nI > 0 )
			text2 += ConvToANSICp( '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + MEMVAR->shinter + '">' )
		endif
		Melde->( Dbskip() )
	enddo

	text1 += ConvToANSICp( '<P><FONT COLOR="#CC0000"><B>' + alltrim( str( sum ) ) + ' deleted record' + iif( sum == 1, ' is', 's are' ) + ' having a red background colour!</B><BR><B>' + alltrim( str( nsaeumig ) ) + ' open payment' + iif( nsaeumig == 1, '', 's' ) + " since 14 days ('payment' is having a red backgrouund colour)!</B></FONT><P>"  )+ CRLF
	text1 += ConvToANSICp( '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + MEMVAR->shinter + '">' )
	text1 += ConvToANSICp( '<TR valign="bottom"><TD WIDTH="5%" ALIGN="RIGHT"><B><I>' + NBSP + MEMVAR->texte[ bearbeiten, spr_uk ] + NBSP + '</I></B></TD><TD WIDTH="90%" ALIGN="CENTER">' + NBSP + '</TD><TD WIDTH="5%"><B><I>' + NBSP + MEMVAR->texte[ loeschen, spr_uk ] + NBSP + '</I></B></TD></TR></TABLE>' )
	text1 += ConvToANSICp( '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + MEMVAR->shinter + '">' )
	text1 += ConvToANSICp( '<TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="25%"><B>' + NBSP + MEMVAR->texte[ vorname, spr_uk ] + '</B></TD><TD WIDTH="25%"><B>' + MEMVAR->texte[ nachname, spr_uk ] + '</B></TD><TD WIDTH="15%"><B>ID</B></TD><TD WIDTH="12%" ALIGN="RIGHT"><B>Payment</B></TD><TD WIDTH="13%" ALIGN="RIGHT"><B>Amount' + NBSP + '</B></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' ) + CRLF

	text1 += text2
	text1 += ConvToANSICp( '</TABLE>' ) + CRLF

	text1 += ConvToANSICp( '<BR><HR><BR>' ) + CRLF

	text1 += ConvToANSICp( "<FORM name='Uebersicht' method='post' action='/Dispatcher?'>" ) + CRLF
	text1 += ConvToANSICp( "<input type=hidden name='" + oServer:SessionTag + "' value='" + oClient:GetSessionHandle() + "'>" ) + CRLF
	text1 += ConvToANSICp( '<input type=hidden name="DATSATZ" value="0">' ) + CRLF
	text1 += ConvToANSICp( '<input type=hidden name="WAS" value="3">' ) + CRLF
	text1 += ConvToANSICp( '<input type="submit" value="' + MEMVAR->texte[ knopfende, spr_uk ] + '">' ) + CRLF
	text1 += ConvToANSICp( '</FORM>' ) + CRLF
	text1 += ConvToANSICp( '</Center>' ) + MeldeFooter()

	CloseDbf()
	if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
		oClient:HTTPResponse:CompressLevel := 7
	endif
	oClient:HTTPResponse:Content := text1
RETURN

PROCEDURE DC_PayPalStati()
local oClient := ThreadObject(), oServer := oClient:Parent
local hinter, vorder, cUID, cPWD, aPayPal, nI, nLen, text1, text2, satz2
local aPPDaten, nHandle, satz, bla, bla2, cStatus, aLogs, sum, nJ, nLen2, cStat

	cUID := oClient:GetCargo("UID")
	cPWD := oClient:GetCargo("PWD")
	sum := 0
	text2 := ""
	if Empty(cUID)
		// no user ID specified - redisplay login screen
		DC_Login()
		Return
	endif
	if ! ( ( alltrim( cUID ) == alltrim( MEMVAR->User ) ) .and. ( alltrim( MEMVAR->Password ) == allTrim( cPWD ) ) )
		// invalid userid/password - go back to login screen
		DC_Login()
		Return
	endif
	oClient:setCargo( "UID", cUID )
	oClient:setCargo( "PWD", cPWD )
	aPayPal := Directory( mempfad + "\DC07DE????.MEM" )
	nLen := len( aPayPal )
	if nLen > 0
		aPPDaten := {}
		for nI := 1 to nLen
			aLogs := Directory( mempfad + "\" + left( aPayPal[ nI, F_NAME ], 10 ) + ".*.LOG" )
			if len( aLogs ) == 0
				aLogs := Directory( mempfad + "\" + left( aPayPal[ nI, F_NAME ], 10 ) + ".MEM" )
				if len( aLogs ) > 0
					cStatus := "???, " + DtoC( aLogs[ 1, F_CREATION_DATE ] ) + ", " + aLogs[ 1, F_CREATION_TIME ]
				else
					cStatus := "??????"
				endif
				sum++
			else
				cStatus := "unknown"
				ASort( aLogs,,, { | aX, aY | aX[ F_NAME ] < aY[ F_NAME ] } )
				nLen2 := len( aLogs )
				for nJ := 1 to nLen2
					cStat := Memoread( mempfad + "\" + aLogs[ nJ, F_NAME ] )
					satz := at( '{"payment_status", "', cStat )
					if satz > 0
						satz += 20
						satz2 := at( '"},', cStat, satz )
						cStatus := substr( cStat, satz, satz2 - satz )
					endif
				next
			endif
			nHandle := FOpen( mempfad + "\" + aPayPal[ nI, F_NAME ] )
			satz := FSeek( nHandle, 0 , FS_END )
			bla := space( satz )
			FSeek( nHandle, 0 , FS_SET )
			FRead( nHandle, @bla, satz )
			FClose( nHandle )
			bla2 := Bin2Var( bla )
			AAdd( aPPDaten, { bla2[ I_VORNAME ], bla2[ I_NACHNAME ], bla2[ I_TEILNEHMID ], bla2[ I_PREIS ], cStatus } )
		next
		ASort( aPPDaten,,, {| aX, aY | left( upper( aX[ 2 ] ) + space( 30 ), 30 ) + left( upper( aX[ 1 ] ) + space( 30 ), 30 ) + upper( aX[ 3 ] ) < left( upper( aY[ 2 ] ) + space( 30 ), 30 ) + left( upper( aY[ 1 ] ) + space( 30 ), 30 ) + upper( aY[ 3 ] ) } )
		nLen := len( APPDaten )

		text1 := ConvToANSICp( '<html>' ) + CRLF
		text1 += ConvToANSICp( '<head>' ) + CRLF
		text1 += ConvToANSICp( '<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">' ) + CRLF
		text1 += ConvToANSICp( '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">' ) + CRLF
		text1 += ConvToANSICp( '<META HTTP-EQUIV="Cache-Control" CONTENT="no-cache">' ) + CRLF
		text1 += ConvToANSICp( '<META HTTP-EQUIV="Expires" CONTENT="-1">' ) + CRLF
		text1 += ConvToANSICp( '<Title>Checking unfinished PayPal transactions</title>' ) + CRLF
		text1 += ConvToANSICp( '<link rel="stylesheet" href="devcon.css" type="text/css">' ) + CRLF
		text1 += ConvToANSICp( '</head> ' ) + CRLF
		text1 += ConvToANSICp( '<body bgcolor="' + MEMVAR->shinter + '">' ) + CRLF
		text1 += ConvToANSICp( '<Center><H1>Checking unfinished PayPal transactions</H1>' ) + CRLF
		text1 += ConvToANSICp( '<P><HR WIDTH="80%">'  )+ CRLF
		aPayPal := Directory( rempfad + "\DC07DE????.MEM" )
		if len( aPayPal ) > 0
			text1 += '<TABLE WIDTH="80%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + MEMVAR->shinter + '" ALIGN="CENTER">'
			text1 += '<TR><TD WIDTH="70%">' + NBSP + '</TD><TD WIDTH="30%"><marquee behavior="alternate"><A align="right" HREF="/RemPayPal?">removed unfinished PayPal transactions</A></marquee><TD></TR></TABLE>'
		endif
		text1 += '<P>'
		hinter := ""
		vorder := "#000000"
		for nI := 1 to nLen
			if hinter == "#00E3FF"
				hinter := "#00C3FF"
			else
				hinter := "#00E3FF"
			endif
			text2 += '<TR valign="bottom"><TD WIDTH="5%" ALIGN="RIGHT">' + iif( left( aPPDaten[ nI, 5 ], 5 ) == "???, ", '<a href=/Dispatcher?' + oServer:SessionTag + '=' + oClient:GetSessionHandle() + '&DATSATZ=' + aPPDaten[ nI, 3 ] + '&WAS=4><img src="/okay.gif" border=0 ALT="Activate" width=16 height=16></A>', '' ) + NBSP + '</TD><TD WIDTH="25%" BGCOLOR="' + hinter +'"><FONT COLOR="' + vorder + '">' + NBSP + alltrim( aPPDaten[ nI, 1 ] ) + '</FONT></TD><TD WIDTH="25%" BGCOLOR="' + hinter +'"><FONT COLOR="' + vorder + '">' + alltrim( aPPDaten[ nI, 2 ] ) + '</FONT></TD><TD WIDTH="10%" BGCOLOR="' + hinter +'"><FONT COLOR="' + vorder + '">' + alltrim( aPPDaten[ nI, 3 ] ) + NBSP + '<A HREF=/Dispatcher?' + oServer:SessionTag + '=' + oClient:GetSessionHandle() + '&DATSATZ=' + aPPDaten[ nI, 3 ] + '&WAS=8><img src="/delete.gif" border=0 ALT="L' + oe + 'schen" width=16 height=16></A></FONT></TD><TD WIDTH="10%" BGCOLOR="' + hinter +'" ALIGN="RIGHT"><FONT COLOR="' + vorder + '">' + aPPDaten[ nI, 4 ] + NBSP + "EUR" + NBSP + '</FONT></TD><TD WIDTH="20%" BGCOLOR="' + hinter +'" ALIGN="CENTER"><FONT COLOR="' + vorder + '">' + alltrim( aPPDaten[ nI, 5 ] ) + '</FONT></TD><TD WIDTH="5%">'
			text2 += NBSP + '<A HREF=/Dispatcher?' + oServer:SessionTag + '=' + oClient:GetSessionHandle() + '&DATSATZ=' + aPPDaten[ nI, 3 ] + '&WAS=5><img src="/lens.gif" border=0 ALT="View" width=16 height=16></A></TD></TR>' + CRLF
		next
		text1 += ConvToANSICp( '<P><FONT COLOR="#CC0000"><B>' + alltrim( str( sum ) ) + ' cancelled/unfinished registration' + iif( sum == 1, '', 's' ) + ' can be activated!</B></FONT><P>'  )+ CRLF
		text1 += ConvToANSICp( '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + MEMVAR->shinter + '">' )
		text1 += ConvToANSICp( '<TR valign="bottom"><TD WIDTH="5%" ALIGN="RIGHT"><B><I>' + NBSP + 'Activate' + NBSP + '</I></B></TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%"><B><I>' + NBSP + 'View' + NBSP + '</I></B></TD></TR></TABLE>' )
		text1 += ConvToANSICp( '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + MEMVAR->shinter + '">' )
		text1 += ConvToANSICp( '<TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="25%"><B>' + NBSP + MEMVAR->texte[ vorname, spr_uk ] + '</B></TD><TD WIDTH="25%"><B>' + MEMVAR->texte[ nachname, spr_uk ] + '</B></TD><TD WIDTH="10%"><B>ID</B></TD><TD WIDTH="10%" ALIGN="RIGHT"><B>Amount' + NBSP + '</B></TD><TD WIDTH="20%" ALIGN="CENTER"><B>PayPal status</B></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' ) + CRLF

		text1 += text2
		text1 += ConvToANSICp( '</TABLE>' ) + CRLF

		text1 += ConvToANSICp( '<BR><HR><BR>' ) + CRLF

		text1 += ConvToANSICp( "<FORM name='PPUebersicht' method='post' action='/Dispatcher?'>" ) + CRLF
		text1 += ConvToANSICp( "<input type=hidden name='" + oServer:SessionTag + "' value='" + oClient:GetSessionHandle() + "'>" ) + CRLF
		text1 += ConvToANSICp( '<input type=hidden name="DATSATZ" value="0">' ) + CRLF
		text1 += ConvToANSICp( '<input type=hidden name="WAS" value="6">' ) + CRLF
		text1 += ConvToANSICp( '<input type="submit" value="Back">' ) + CRLF
		text1 += ConvToANSICp( '</FORM>' ) + CRLF
		text1 += ConvToANSICp( '</Center>' ) + MeldeFooter()
		if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
			oClient:HTTPResponse:CompressLevel := 7
		endif
		oClient:HTTPResponse:Content := text1
	else
		DC_DoEditTable()
	endif
RETURN

PROCEDURE DC_RemPayPal()
local oClient := ThreadObject(), oServer := oClient:Parent
local hinter, vorder, cUID, cPWD, aPayPal, nI, nLen, text1, text2, satz2
local aPPDaten, nHandle, satz, bla, bla2, cStatus, aLogs, sum, nJ, nLen2, cStat

	cUID := oClient:GetCargo("UID")
	cPWD := oClient:GetCargo("PWD")
	sum := 0
	text2 := ""
	if Empty(cUID)
		// no user ID specified - redisplay login screen
		DC_Login()
		Return
	endif
	if ! ( ( alltrim( cUID ) == alltrim( MEMVAR->User ) ) .and. ( alltrim( MEMVAR->Password ) == allTrim( cPWD ) ) )
		// invalid userid/password - go back to login screen
		DC_Login()
		Return
	endif
	oClient:setCargo( "UID", cUID )
	oClient:setCargo( "PWD", cPWD )
	aPayPal := Directory( rempfad + "\DC07DE????.MEM" )
	nLen := len( aPayPal )
	if nLen > 0
		aPPDaten := {}
		for nI := 1 to nLen
			aLogs := Directory( rempfad + "\" + left( aPayPal[ nI, F_NAME ], 10 ) + ".*.LOG" )
			if len( aLogs ) == 0
				aLogs := Directory( rempfad + "\" + left( aPayPal[ nI, F_NAME ], 10 ) + ".MEM" )
				if len( aLogs ) > 0
					cStatus := "???, " + DtoC( aLogs[ 1, F_CREATION_DATE ] ) + ", " + aLogs[ 1, F_CREATION_TIME ]
				else
					cStatus := "??????"
				endif
				sum++
			else
				cStatus := "unknown"
				ASort( aLogs,,, { | aX, aY | aX[ F_NAME ] < aY[ F_NAME ] } )
				nLen2 := len( aLogs )
				for nJ := 1 to nLen2
					cStat := Memoread( rempfad + "\" + aLogs[ nJ, F_NAME ] )
					satz := at( '{"payment_status", "', cStat )
					if satz > 0
						satz += 20
						satz2 := at( '"},', cStat, satz )
						cStatus := substr( cStat, satz, satz2 - satz )
					endif
				next
			endif
			nHandle := FOpen( rempfad + "\" + aPayPal[ nI, F_NAME ] )
			satz := FSeek( nHandle, 0 , FS_END )
			bla := space( satz )
			FSeek( nHandle, 0 , FS_SET )
			FRead( nHandle, @bla, satz )
			FClose( nHandle )
			bla2 := Bin2Var( bla )
			AAdd( aPPDaten, { bla2[ I_VORNAME ], bla2[ I_NACHNAME ], bla2[ I_TEILNEHMID ], bla2[ I_PREIS ], cStatus } )
		next
		ASort( aPPDaten,,, {| aX, aY | left( upper( aX[ 2 ] ) + space( 30 ), 30 ) + left( upper( aX[ 1 ] ) + space( 30 ), 30 ) + upper( aX[ 3 ] ) < left( upper( aY[ 2 ] ) + space( 30 ), 30 ) + left( upper( aY[ 1 ] ) + space( 30 ), 30 ) + upper( aY[ 3 ] ) } )
		nLen := len( APPDaten )

		text1 := ConvToANSICp( '<html>' ) + CRLF
		text1 += ConvToANSICp( '<head>' ) + CRLF
		text1 += ConvToANSICp( '<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">' ) + CRLF
		text1 += ConvToANSICp( '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">' ) + CRLF
		text1 += ConvToANSICp( '<META HTTP-EQUIV="Cache-Control" CONTENT="no-cache">' ) + CRLF
		text1 += ConvToANSICp( '<META HTTP-EQUIV="Expires" CONTENT="-1">' ) + CRLF
		text1 += ConvToANSICp( '<Title>deleted unfinished PayPal transactions</title>' ) + CRLF
		text1 += ConvToANSICp( '<link rel="stylesheet" href="devcon.css" type="text/css">' ) + CRLF
		text1 += ConvToANSICp( '</head> ' ) + CRLF
		text1 += ConvToANSICp( '<body bgcolor="' + MEMVAR->shinter + '">' ) + CRLF
		text1 += ConvToANSICp( '<Center><H1>deleted unfinished PayPal transactions</H1>' ) + CRLF
		text1 += ConvToANSICp( '<P><HR WIDTH="80%"><P>'  )+ CRLF
		hinter := ""
		vorder := "#000000"
		for nI := 1 to nLen
			if hinter == "#00E3FF"
				hinter := "#00C3FF"
			else
				hinter := "#00E3FF"
			endif
			text2 += '<TR valign="bottom"><TD WIDTH="5%" ALIGN="RIGHT"><a href=/Dispatcher?' + oServer:SessionTag + '=' + oClient:GetSessionHandle() + '&DATSATZ=' + aPPDaten[ nI, 3 ] + '&WAS=9><img src="/okay.gif" border=0 ALT="undelete" width=16 height=16></A>' + NBSP + '</TD><TD WIDTH="25%" BGCOLOR="' + hinter +'"><FONT COLOR="' + vorder + '">' + NBSP + alltrim( aPPDaten[ nI, 1 ] ) + '</FONT></TD><TD WIDTH="25%" BGCOLOR="' + hinter +'"><FONT COLOR="' + vorder + '">' + alltrim( aPPDaten[ nI, 2 ] ) + '</FONT></TD><TD WIDTH="10%" BGCOLOR="' + hinter +'"><FONT COLOR="' + vorder + '">' + alltrim( aPPDaten[ nI, 3 ] ) + '</FONT></TD><TD WIDTH="10%" BGCOLOR="' + hinter +'" ALIGN="RIGHT"><FONT COLOR="' + vorder + '">' + aPPDaten[ nI, 4 ] + NBSP + "EUR" + NBSP + '</FONT></TD><TD WIDTH="20%" BGCOLOR="' + hinter +'" ALIGN="CENTER"><FONT COLOR="' + vorder + '">' + alltrim( aPPDaten[ nI, 5 ] ) + '</FONT></TD><TD WIDTH="5%">'
			text2 += NBSP + '<A HREF=/Dispatcher?' + oServer:SessionTag + '=' + oClient:GetSessionHandle() + '&DATSATZ=' + aPPDaten[ nI, 3 ] + '&WAS=10><img src="/lens.gif" border=0 ALT="View" width=16 height=16></A></TD></TR>' + CRLF
		next
		text1 += ConvToANSICp( '<P><FONT COLOR="#CC0000"><B>' + alltrim( str( sum ) ) + ' deleted unfinished PayPal transaction' + iif( sum == 1, '', 's' ) + ' can be undeleted!</B></FONT><P>'  )+ CRLF
		text1 += ConvToANSICp( '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + MEMVAR->shinter + '">' )
		text1 += ConvToANSICp( '<TR valign="bottom"><TD WIDTH="5%" ALIGN="RIGHT"><B><I>' + NBSP + 'Undelete' + NBSP + '</I></B></TD><TD WIDTH="90%">' + NBSP + '</TD><TD WIDTH="5%"><B><I>' + NBSP + 'View' + NBSP + '</I></B></TD></TR></TABLE>' )
		text1 += ConvToANSICp( '<TABLE WIDTH="90%" BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR="' + MEMVAR->shinter + '">' )
		text1 += ConvToANSICp( '<TR valign="bottom"><TD WIDTH="5%">' + NBSP + '</TD><TD WIDTH="25%"><B>' + NBSP + MEMVAR->texte[ vorname, spr_uk ] + '</B></TD><TD WIDTH="25%"><B>' + MEMVAR->texte[ nachname, spr_uk ] + '</B></TD><TD WIDTH="10%"><B>ID</B></TD><TD WIDTH="10%" ALIGN="RIGHT"><B>Amount' + NBSP + '</B></TD><TD WIDTH="20%" ALIGN="CENTER"><B>PayPal status</B></TD><TD WIDTH="5%">' + NBSP + '</TD></TR>' ) + CRLF

		text1 += text2
		text1 += ConvToANSICp( '</TABLE>' ) + CRLF

		text1 += ConvToANSICp( '<BR><HR><BR>' ) + CRLF

		text1 += ConvToANSICp( "<FORM name='rPPUebersicht' method='post' action='/Dispatcher?'>" ) + CRLF
		text1 += ConvToANSICp( "<input type=hidden name='" + oServer:SessionTag + "' value='" + oClient:GetSessionHandle() + "'>" ) + CRLF
		text1 += ConvToANSICp( '<input type=hidden name="DATSATZ" value="0">' ) + CRLF
		text1 += ConvToANSICp( '<input type=hidden name="WAS" value="7">' ) + CRLF
		text1 += ConvToANSICp( '<input type="submit" value="Back">' ) + CRLF
		text1 += ConvToANSICp( '</FORM>' ) + CRLF
		text1 += ConvToANSICp( '</Center>' ) + MeldeFooter()
		if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
			oClient:HTTPResponse:CompressLevel := 7
		endif
		oClient:HTTPResponse:Content := text1
	else
		DC_PayPalStati()
	endif
RETURN

FUNCTION DC_CheckEntry2()
	local oClient := ThreadObject(), oServer := oClient:Parent
	local fehlertext, ueberschr, fehlerobj
	local alleFelder, text1
	local bla, bla2, datum2, sch, satz, std, minu, satz2

	alleFelder := oClient:getCargo( "FELDER" )
	satz := val( oClient:getCargo( "DATSATZ" ) )
	if alleFelder == NIL
		alleFelder := array( I_GESAMTFELDER )
	endif
	alleFelder[ I_ANREDE ] := oClient:getVar( "F_ANREDE" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_VORNAME" ) ), 1 )
	alleFelder[ I_VORNAME ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_NACHNAME" ) ), 1 )
	alleFelder[ I_NACHNAME ] := bla2
	alleFelder[ I_FIRMA1 ] := erszeichen( oClient:getVar( "F_FIRMA1" ) )
	alleFelder[ I_FIRMA2 ] := erszeichen( oClient:getVar( "F_FIRMA2" ) )
	alleFelder[ I_ABTEILUNG ] := erszeichen( oClient:getVar( "F_ABTEILUNG" ) )
	alleFelder[ I_STRASSE ] := erszeichen( oClient:getVar( "F_STRASSE" ) )
	alleFelder[ I_LAND ] := oClient:getVar( "F_LAND" )
	alleFelder[ I_STAAT ] := upper( erszeichen( oClient:getVar( "F_STAAT" ) ) )
	alleFelder[ I_PLZ ] := erszeichen( oClient:getVar( "F_PLZ" ) )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_ORT" ) ), 1 )
	alleFelder[ I_ORT ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_EMAIL ] := erszeichen( oClient:getVar( "F_EMAIL" ) )
	alleFelder[ I_WEBSEITE ] := erszeichen( oClient:getVar( "F_WEBSEITE" ) )
	alleFelder[ I_TEILNEHMER ] := oClient:getVar( "F_TEILNEHMER" )
	alleFelder[ I_MUTTERSPRA ] := oClient:getVar( "F_MUTTERSPRA" )
	bla2 := GrossKlein( erszeichen( oClient:getVar( "F_MUTTERSPSO" ) ), 1 )
	alleFelder[ I_MUTTERSPSO ] := upper( left( bla2, 1 ) ) + substr( bla2, 2 )
	alleFelder[ I_FREMDSPRA1 ] := oClient:getVar( "F_FREMDSPRA1" )
	alleFelder[ I_FREMDSPRA2 ] := oClient:getVar( "F_FREMDSPRA2" )
	alleFelder[ I_LAPTOP ] := ( oClient:getVar( "F_LAPTOP" ) == "on" )
	alleFelder[ I_ANONYM ] := ( oClient:getVar( "F_ANONYM" ) == "on" )
	alleFelder[ I_SHIRT ] := oClient:getVar( "F_SHIRT" )
	alleFelder[ I_SHUTTLE ] := oClient:getVar( "F_SHUTTLE" )
	alleFelder[ I_SHUTTLER ] := oClient:getVar( "F_SHUTTLER" )
	alleFelder[ I_UHRAB ] := oClient:getVar( "F_UHRAB" )
	alleFelder[ I_UHRHIN ] := oClient:getVar( "F_UHRHIN" )

	alleFelder[ I_ZAHLEINGAN ] := oClient:getVar( "F_ZAHLEINGAN" )
	alleFelder[ I_ZAHLART ] := oClient:getVar( "F_ZAHLART" )
	alleFelder[ I_PREIS ] := oClient:getVar( "F_PREIS" )
	oClient:setCargo( "FELDER", alleFelder )
	fehlertext := ""
	ueberschr := ""
	fehlerobj := ""
	if empty( alleFelder[ I_VORNAME ] )
		fehlertext += "Enter first name!"
		if empty( fehlerobj )
			fehlerobj := "F_VORNAME"
		endif
	endif
	if empty( alleFelder[ I_NACHNAME ] )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Enter last name!"
		if empty( fehlerobj )
			fehlerobj := "F_NACHNAME"
		endif
	endif
	if empty( alleFelder[ I_STRASSE ] )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Enter street!"
		if empty( fehlerobj )
			fehlerobj := "F_STRASSE"
		endif
	endif
	if empty( alleFelder[ I_STAAT ] )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Enter county/region!"
		if empty( fehlerobj )
			fehlerobj := "F_STAAT"
		endif
	endif
	if empty( alleFelder[ I_PLZ ] )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Enter ZIP!"
		if empty( fehlerobj )
			fehlerobj := "F_PLZ"
		endif
	endif
	if empty( alleFelder[ I_ORT ] )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Enter city!"
		if empty( fehlerobj )
			fehlerobj := "F_ORT"
		endif
	endif
	if empty( alleFelder[ I_EMAIL ] )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Enter e-mail-address!"
		if empty( fehlerobj )
			fehlerobj := "F_EMAIL"
		endif
	else
		bla := alltrim( alleFelder[ I_EMAIL ] )
		datum2 := at( "@", bla )
		if ( datum2 == 0 ) .or. ( at( ".", bla, datum2 + 1 ) == 0 )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Enter a valid e-mail-address!"
			if empty( fehlerobj )
				fehlerobj := "F_EMAIL"
			endif
		endif
	endif
	if ( .not. empty( alleFelder[ I_WEBSEITE ] ) ) .and. ( at( ".", alltrim( alleFelder[ I_WEBSEITE ] ) ) == 0 )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Provide a valid website-address!"
		if empty( fehlerobj )
			fehlerobj := "F_WEBSEITE"
		endif
	endif
	if empty( alleFelder[ I_MUTTERSPSO ] ) .and. ( alleFelder[ I_MUTTERSPRA ] == "99" )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Enter native tongue!"
		if empty( fehlerobj )
			fehlerobj := "F_MUTTERSPSO"
		endif
	endif
	if empty( CtoD( alleFelder[ I_ZAHLEINGAN ] ) ) .and. val( alleFelder[ I_ZAHLART ] ) > 0
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "As type of payment is chosen you have to provide a date of payment!"
		if empty( fehlerobj )
			fehlerobj := "F_ZAHLEINGAN"
		endif
	endif
	if .not. empty( CtoD( alleFelder[ I_ZAHLEINGAN ] ) ) .and. val( alleFelder[ I_ZAHLART ] ) == 0
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "As you entered a date of payment you have to choose a type of payment!"
		if empty( fehlerobj )
			fehlerobj := "F_ZAHLART"
		endif
	endif
	if CtoD( alleFelder[ I_ZAHLEINGAN ] ) > Date()
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Date of payment cannot be a date yet to come!"
		if empty( fehlerobj )
			fehlerobj := "F_ZAHLEINGAN"
		endif
	endif

	if ( alleFelder[ I_SHUTTLE ] <> "0" ) .and. ( empty( alleFelder[ I_UHRAB ] ) )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Provide a time to be picked up as the airport to be picked up from has been selected!"
		if empty( fehlerobj )
			fehlerobj := "F_UHRAB"
		endif
	elseif ( alleFelder[ I_SHUTTLE ] == "0" ) .and. ( .not. empty( alleFelder[ I_UHRAB ] ) )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Choose the airport to be picked from as the time to be picked up has been entered!"
		if empty( fehlerobj )
			fehlerobj := "F_SHUTTLE"
		endif
	elseif ( alleFelder[ I_SHUTTLE ] <> "0" ) .and. ( .not. empty( alleFelder[ I_UHRAB ] ) )
		satz2 := at( ":", alleFelder[ I_UHRAB ] )
		if satz2 > 0
			std := val( left( alleFelder[ I_UHRAB ], satz2 - 1 ) )
			minu := val( substr( alleFelder[ I_UHRAB ], satz2 + 1 ) )
		else
			std := val( left( right( "0000" + alltrim( alleFelder[ I_UHRAB ] ), 4 ), 2 ) )
			minu := val( right( "0000" + alltrim( alleFelder[ I_UHRAB ] ), 2 ) )
		endif
		if ( std < 0 ) .or. ( std > 24 ) .or. ( minu < 0 ) .or. ( minu > 59 )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Enter a valid pickup-time!"
			if empty( fehlerobj )
				fehlerobj := "F_UHRAB"
			endif
		else
			satz2 := (std * 100 ) + minu
			if ( satz2 < 800 ) .or. ( satz2 > 1200 )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				fehlertext += "Pickup at the airport is only possible between 08:00 CET and 12:00 CET!"
				if empty( fehlerobj )
					fehlerobj := "F_UHRAB"
				endif
			endif
		endif
		alleFelder[ I_UHRAB ] := right( "00" + alltrim( str( std ) ), 2 ) + ":" + right( "00" + alltrim( str( minu ) ), 2 )
	endif
	if ( alleFelder[ I_SHUTTLER ] <> "0" ) .and. ( empty( alleFelder[ I_UHRHIN ] ) )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Provide a time to be taken to the airport as the airport to be taken to has been selected!"
		if empty( fehlerobj )
			fehlerobj := "F_UHRHIN"
		endif
	elseif ( alleFelder[ I_SHUTTLER ] == "0" ) .and. ( .not. empty( alleFelder[ I_UHRHIN ] ) )
		if .not. empty( fehlertext )
			fehlertext += "<BR>"
		endif
		fehlertext += "Choose the airport to be taken to as the time to be taken to the airport has been entered!"
		if empty( fehlerobj )
			fehlerobj := "F_SHUTTLER"
		endif
	elseif ( alleFelder[ I_SHUTTLER ] <> "0" ) .and. ( .not. empty( alleFelder[ I_UHRHIN ] ) )
		satz2 := at( ":", alleFelder[ I_UHRHIN ] )
		if satz2 > 0
			std := val( left( alleFelder[ I_UHRHIN ], satz2 - 1 ) )
			minu := val( substr( alleFelder[ I_UHRHIN ], satz2 + 1 ) )
		else
			std := val( left( right( "0000" + alltrim( alleFelder[ I_UHRHIN ] ), 4 ), 2 ) )
			minu := val( right( "0000" + alltrim( alleFelder[ I_UHRHIN ] ), 2 ) )
		endif
		if ( std < 0 ) .or. ( std > 24 ) .or. ( minu < 0 ) .or. ( minu > 59 )
			if .not. empty( fehlertext )
				fehlertext += "<BR>"
			endif
			fehlertext += "Provide a valid departure time!"
			if empty( fehlerobj )
				fehlerobj := "F_UHRHIN"
			endif
		else
			satz2 := (std * 100 ) + minu
			if ( satz2 < 1700 ) .or. ( satz2 > 2100 )
				if .not. empty( fehlertext )
					fehlertext += "<BR>"
				endif
				fehlertext += "One can only be taken to the airport between 17:00 CET and 21:00 CET!"
				if empty( fehlerobj )
					fehlerobj := "F_UHRHIN"
				endif
			endif
		endif
		alleFelder[ I_UHRHIN ] := right( "00" + alltrim( str( std ) ), 2 ) + ":" + right( "00" + alltrim( str( minu ) ), 2 )
	endif

	IF .not. Empty( fehlertext )
		ueberschr := "Wrong input, please correct"
	ENDIF

	if .not. empty( ueberschr )
		text1 := EditAttendeeHeader( "Meldung_eingeben", fehlerobj, spr_uk )
		text1 += Fehlermeldung( ueberschr, fehlertext )

		text1 += "<FORM name='Meldung_eingeben' method='post' action='/CheckEntry2?'>" + CRLF
		text1 += "<input type=hidden name='" + oServer:SessionTag + "' value='" + oClient:GetSessionHandle() + "'>" + CRLF

		text1 += BuildTable( "uk", 2, .f., Date() )
		text1 += '<BR><HR><BR>' + CRLF

		text1 += '<input type=submit value="' + MEMVAR->texte[ knopfende, spr_uk ] + '">' + CRLF
		text1 += "</FORM></CENTER>" + MeldeFooter()


		if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
			oClient:HTTPResponse:CompressLevel := 7
		endif
		oClient:HTTPResponse:Content := text1

	else
		OpenDbf()
		sch := ""
		if SaveEntry( @satz, @sch, 2, .t., alleFelder )
			CloseDbf()
			DC_DoEditTable()
		else
			CloseDbf()
			return .f.
		endif
	endif
RETURN .t.

PROCEDURE EditAttendee()
local oClient := ThreadObject(), oServer := oClient:Parent, text1

		OpenDbf()

		text1 := EditAttendeeHeader( "Meldung_eingeben", "F_ANREDE", spr_uk )

		text1 += "<FORM name='Meldung_eingeben' method='post' action='/CheckEntry2?'>" + CRLF

		text1 += BuildTable( "uk", 2, .f., Date() )
		text1 += '<BR><HR><BR>' + CRLF

		text1 += '<input type=submit value="' + MEMVAR->texte[ knopfende, spr_uk ] + '"></FORM></CENTER>' + CRLF
		text1 += MeldeFooter()

		CloseDbf()

		oClient:HTTPResponse:Content := text1
return

PROCEDURE DC_Dispatcher()
	local oClient := ThreadObject(), oServer := oClient:Parent
	LOCAL recnum
	LOCAL Action
	local sprache, dDatum, aFile
	local alleFelder, spr_xx, bla, sch, lRLock, i
	local ueberschr, nHandle, text1
	local fehlertext, cUID, cPWD, anred

	recnum := oClient:getVar( "DATSATZ" )
	Action := oClient:getVar( "WAS" )
	cUID := oClient:GetCargo("UID")
	cPWD := oClient:GetCargo("PWD")
	if Empty(cUID)
		// no user ID specified - redisplay login screen
		DC_Login()
		Return
	endif
	if ! ( ( alltrim( cUID ) == alltrim( MEMVAR->User ) ) .and. ( alltrim( MEMVAR->Password ) == allTrim( cPWD ) ) )
		// invalid userid/password - go back to login screen
		DC_Login()
		Return
	endif
	oClient:setCargo( "UID", cUID )
	oClient:setCargo( "PWD", cPWD )
	if ( Action == NIL ) .or. ( recnum == NIL )
		DC_DoEditTable()
	else
		do case
		case Action == "1"
			OpenDbf()
			select Melde
			goto val( recnum )
			if ( Melde->( recno() ) == val( recnum ) ) .and. .not. Melde->( eof() )
				alleFelder := array( I_GESAMTFELDER )
				alleFelder[ I_ANREDE ] := alltrim( str( Melde->ANREDE ) )
				alleFelder[ I_VORNAME ] := ConvToAnsiCP( alltrim( Melde->VORNAME ) )
				alleFelder[ I_NACHNAME ] := ConvToAnsiCP( alltrim( Melde->NACHNAME ) )
				alleFelder[ I_FIRMA1 ] := ConvToAnsiCP( alltrim( Melde->FIRMA1 ) )
				alleFelder[ I_FIRMA2 ] := ConvToAnsiCP( alltrim( Melde->FIRMA2 ) )
				alleFelder[ I_ABTEILUNG ] := ConvToAnsiCP( alltrim( Melde->ABTEILUNG ) )
				alleFelder[ I_STRASSE ] := ConvToAnsiCP( alltrim( Melde->STRASSE ) )
				alleFelder[ I_PLZ ] := ConvToAnsiCP( alltrim( Melde->PLZ ) )
				alleFelder[ I_ORT ] := ConvToAnsiCP( alltrim( Melde->ORT ) )
				alleFelder[ I_STAAT ] := ConvToAnsiCP( alltrim( Melde->STAAT ) )
				alleFelder[ I_LAND ] := ConvToAnsiCP( alltrim( Melde->LAND ) )
				alleFelder[ I_EMAIL ] := ConvToAnsiCP( alltrim( Melde->EMAIL ) )
				alleFelder[ I_WEBSEITE ] := ConvToAnsiCP( alltrim( Melde->WEBSEITE ) )
				alleFelder[ I_TEILNEHMER ] := alltrim( str( Melde->TEILNEHMER ) )
				alleFelder[ I_MUTTERSPRA ] := alltrim( str( Melde->MUTTERSPRA ) )
				alleFelder[ I_MUTTERSPSO ] := ConvToAnsiCP( alltrim( Melde->MUTTERSPSO ) )
				alleFelder[ I_FREMDSPRA1 ] := alltrim( str( Melde->FREMDSPRA1 ) )
				alleFelder[ I_FREMDSPRA2 ] := alltrim( str( Melde->FREMDSPRA2 ) )
				alleFelder[ I_LAPTOP ] := Melde->LAPTOP
				alleFelder[ I_ANONYM ] := Melde->ANONYM
				alleFelder[ I_TEILNEHMID ] := ConvToAnsiCP( alltrim( Melde->TEILNEHMID ) )
				alleFelder[ I_ZAHLEINGAN ] := iif( empty( Melde->ZAHLEINGAN ), "", DtoC( Melde->ZAHLEINGAN ) )
				alleFelder[ I_ZAHLART ] := alltrim( str( Melde->ZAHLART ) )
				alleFelder[ I_PREIS ] := alltrim( str( Melde->PREIS ) )
				alleFelder[ I_SHIRT ] := alltrim( str( Melde->SHIRT ) )
				alleFelder[ I_SHUTTLE ] := alltrim( str( Melde->SHUTTLE ) )
				alleFelder[ I_SHUTTLER ] := alltrim( str( Melde->SHUTTLER ) )
				alleFelder[ I_UHRAB ] := iif( empty( Melde->UHRAB ), "", left( right( "0000" + alltrim( Melde->UHRAB ), 4 ), 2 ) + ":" + right( "0000" + alltrim( Melde->UHRAB ), 2 ) )
				alleFelder[ I_UHRHIN ] := iif( empty( Melde->UHRHIN ), "", left( right( "0000" + alltrim( Melde->UHRHIN ), 4 ), 2 ) + ":" + right( "0000" + alltrim( Melde->UHRHIN ), 2 ) )
				oClient:setCargo( "FELDER", alleFelder )
				oClient:setCargo( "DATSATZ", recnum )
				CloseDbf()
				EditAttendee()
			else
				CloseDbf()
				DC_DoEditTable()
			endif
		case Action == "2"
			ueberschr := ""
			fehlertext := ""
			OpenDbf()
			select Melde
			goto val( recnum )
			if ( Melde->( recno() ) == val( recnum ) ) .and. .not. Melde->( eof() )
				DO WHILE ( .NOT. ( lRLock := DbRLock( val( recnum ) ) ) ) .and. ( i < 3 )
					Sleep( 50 )
					i++
				ENDDO
				IF ! lRLock
					ueberschr := "Unavailable file"
					fehlertext := "Sorry, your data cannot be processed at the moment!"
					CloseDbf()
					oClient:HTTPResponse:Content := '<html><head><meta http-equiv="content-type" content="text/html; charset=ISO-8859-1"><title>' + ueberschr + '</title><link rel="stylesheet" href="devcon.css" type="text/css"></head><body BGCOLOR="#FFFFFF">' + Fehlermeldung( ueberschr, fehlertext ) + "</BODY></HTML>"
					RETURN
				ENDIF
				if Melde->( Deleted() )
					Melde->( DbRecall() )
				else
					Melde->( DbDelete() )
					i := Ascan( MEMVAR->pcws, { |a| a[ 3 ] == Melde->TEILNEHMID } )
					if i > 0
						Select PCW
						PCW->( DbCloseArea() )
						USE ( datenpfad + "\pcd" ) NEW ALIAS PCW EXCLUSIVE
						PCW->( DbGoTop() )
						do while ( .not. PCW->( eof() ) ) .and. ( PCW->TEILNEHMID <> Melde->TEILNEHMID )
							skip
						enddo
						if ( PCW->TEILNEHMID == Melde->TEILNEHMID )
							PCW->( DbDelete() )
							PCW->( DbPack() )
							delete file ( datenpfad + "\" + Melde->TEILNEHMID + ".pcw" )
						endif
					endif
				endif
				Melde->( DbCommit() )
			endif
			CloseDbf()
			DC_DoEditTable()
		case Action == "3"
			oClient:HTTPResponse:Content := '<html><head><meta http-equiv="content-type" content="text/html; charset=ISO-8859-1"><title>TTFN!</title><link rel="stylesheet" href="devcon.css" type="text/css"></head><body BGCOLOR="#FFFFFF"><H1>TTFN!</H1></BODY></HTML>'
			oClient:closeSession()
		case Action == "4"
			aFile := Directory( mempfad + "\" + recnum + ".MEM" )
			if len( aFile ) > 0
				dDatum := aFile[ 1, F_CREATION_DATE ]
			else
				dDatum := Date()
			endif
			nHandle := FOpen( mempfad + "\" + recnum + ".MEM" )
			sch := FSeek( nHandle, 0 , FS_END )
			bla := space( sch )
			FSeek( nHandle, 0 , FS_SET )
			FRead( nHandle, @bla, sch )
			FClose( nHandle )
			alleFelder := Bin2Var( bla )
			oClient:setCargo( "FELDER", alleFelder )

			text1 := MeldeHeader( "Meldung_anzeigen2", "F_ANREDE", spr_uk )

			text1 += ConvToANSICp( "<FORM name='Meldung_anzeigen' method='post' action='/Dispatcher?'>" ) + CRLF
			text1 += ConvToANSICp( "<input type=hidden name='" + oServer:SessionTag + "' value='" + oClient:GetSessionHandle() + "'>" ) + CRLF
			text1 += ConvToANSICp( '<input type=hidden name="DATSATZ" value="0">' ) + CRLF
			text1 += ConvToANSICp( '<input type=hidden name="WAS" value="7">' ) + CRLF
			text1 += ConvToANSICp( '<input type="submit" value="Back"></FORM>' ) + CRLF

			text1 += ConvToANSICp( "<FORM name='Meldung_anzeigen2' method='post' action='/CheckEntry5?'>" ) + CRLF
			text1 += ConvToANSICp( "<input type=hidden name='" + oServer:SessionTag + "' value='" + oClient:GetSessionHandle() + "'>" ) + CRLF
			text1 += ConvToANSICp( '<input type=hidden name="MenuVar" value="uk">' ) + CRLF
			text1 += ConvToANSICp( '<input type=hidden name="DevConID" value="' + recnum + '">' ) + CRLF
			text1 += ConvToANSICp( '<input type=hidden name="Datum" value="' + dtos( dDatum ) + '">' ) + CRLF

			text1 += BuildTable( "uk", 1, .t., dDatum )
			text1 += '<BR><HR><BR>' + CRLF

			text1 += '<input type=submit value="Submit"></FORM></CENTER>' + CRLF
			text1 += MeldeFooter()
			if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
				oClient:HTTPResponse:CompressLevel := 7
			endif
			oClient:HTTPResponse:Content := text1
		case Action == "5"
			nHandle := FOpen( mempfad + "\" + recnum + ".MEM" )
			sch := FSeek( nHandle, 0 , FS_END )
			bla := space( sch )
			FSeek( nHandle, 0 , FS_SET )
			FRead( nHandle, @bla, sch )
			FClose( nHandle )
			alleFelder := Bin2Var( bla )
			oClient:setCargo( "FELDER", alleFelder )

			text1 := MeldeHeader( "", "", spr_uk )

			text1 += ConvToANSICp( "<FORM name='Meldung_anzeigen' method='post' action='/Dispatcher?'>" ) + CRLF
			text1 += ConvToANSICp( "<input type=hidden name='" + oServer:SessionTag + "' value='" + oClient:GetSessionHandle() + "'>" ) + CRLF
			text1 += ConvToANSICp( '<input type=hidden name="DATSATZ" value="0">' ) + CRLF
			text1 += ConvToANSICp( '<input type=hidden name="WAS" value="7">' ) + CRLF

			text1 += BuildTable( "uk", 5, .f., Date() )
			text1 += '<BR><HR><BR>' + CRLF

			text1 += ConvToANSICp( '<input type="submit" value="Back"></FORM></CENTER>' ) + CRLF
			text1 += MeldeFooter()
			if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
				oClient:HTTPResponse:CompressLevel := 7
			endif
			oClient:HTTPResponse:Content := text1
		case Action == "6"
			DC_DoEditTable()
		case Action == "7"
			DC_PayPalStati()
		case Action =="8"
			if .not. File( rempfad, "D" )
				CreateDir( rempfad )
			endif
			if File( rempfad + '\' + recnum + '.MEM' )
				FErase( rempfad + '\' + recnum + '.MEM' )
			endif
			FRename( mempfad + '\' + recnum + '.MEM', rempfad + '\' + recnum + '.MEM' )
			DC_PayPalStati()
		case Action =="9"
			if File( mempfad + '\' + recnum + '.MEM' )
				FErase( mempfad + '\' + recnum + '.MEM' )
			endif
			FRename( rempfad + '\' + recnum + '.MEM', mempfad + '\' + recnum + '.MEM' )
			DC_RemPayPal()
		case Action == "10"
			nHandle := FOpen( rempfad + "\" + recnum + ".MEM" )
			sch := FSeek( nHandle, 0 , FS_END )
			bla := space( sch )
			FSeek( nHandle, 0 , FS_SET )
			FRead( nHandle, @bla, sch )
			FClose( nHandle )
			alleFelder := Bin2Var( bla )
			oClient:setCargo( "FELDER", alleFelder )

			text1 := MeldeHeader( "", "", spr_uk )

			text1 += ConvToANSICp( "<FORM name='Meldung_anzeigen' method='post' action='/Dispatcher?'>" ) + CRLF
			text1 += ConvToANSICp( "<input type=hidden name='" + oServer:SessionTag + "' value='" + oClient:GetSessionHandle() + "'>" ) + CRLF
			text1 += ConvToANSICp( '<input type=hidden name="DATSATZ" value="0">' ) + CRLF
			text1 += ConvToANSICp( '<input type=hidden name="WAS" value="11">' ) + CRLF

			text1 += BuildTable( "uk", 5, .f., Date() )
			text1 += '<BR><HR><BR>' + CRLF

			text1 += ConvToANSICp( '<input type="submit" value="Back"></FORM></CENTER>' ) + CRLF
			text1 += MeldeFooter()
			if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
				oClient:HTTPResponse:CompressLevel := 7
			endif
			oClient:HTTPResponse:Content := text1
		case Action == "11"
			DC_RemPayPal()
		case Action == "12"
			if file( APP_ROOT + "\BLAT.EXE" )
				OpenDbf()
				select Melde
				goto val( recnum )
				if ( Melde->( recno() ) == val( recnum ) ) .and. .not. Melde->( eof() )
					do case
					case Melde->MUTTERSPRA == 1
						anred := "Anmeldung zur DevCon 2007 - ID: "
					case Melde->MUTTERSPRA == 4
						anred := "Inscripcion para la DevCon 2007 - ID: "
					case Melde->MUTTERSPRA == 2
						anred := "Enregistrement du cours DevCon 2007 - ID: "
					case Melde->MUTTERSPRA == 5
						anred := "Inscricao para a DevCon 2007 - ID: "
					otherwise
						anred := "Registration for the DevCon 2007 - ID: "
					endcase
					sch := Melde->TEILNEHMID
					anred  += sch
					RunShell( '/C ' + APP_ROOT + '\BLAT.EXE ' + bestaetigungspfad + '\' + sch + '.html -subject "' + anred + '" -to "' + alltrim( Melde->EMAIL ) + '" -bcc "' + MEMVAR->cMailadress1 + ',' + MEMVAR->cMailadress2 + '" -server ' + MEMVAR->cSMTPserver + ' -u ' + MEMVAR->cMailuser + ' -pw ' + MEMVAR->cMailpassword + ' -html -f ' + MAILMASTER + ' -log ' + mlogpfad + '\' + dtos( date() ) + '_' + strtran( time(), ":", "" ) + '.log',,.t.,.t. )
				endif
				CloseDbf()
			else
				SaveToFile( ConvToAnsiCp( "______ Xb2.NET ERROR __________ E-mail error _________________" + DtoC( Date() ) + "_" + Time() + CRLF + "E-mail cannot be send as BLAT.EXE is missing!" ), SERVER_ERR_LOG_FILE )
			endif
			DC_DoEditTable()
		endcase
	endif

RETURN

FUNCTION DC_Stats()
local oClient := ThreadObject(), sprache, text1, spr_xx, bla
sprache := lower( oClient:GetVar("MenuVar") )
if sprache == NIL
	oClient:HTTPResponse:Content := redirekt()
else
	do case
	case sprache == "de"
		spr_xx := spr_de
	case sprache == "uk"
		spr_xx := spr_uk
	case sprache == "fr"
		spr_xx := spr_fr
	case sprache == "sp"
		spr_xx := spr_sp
	case sprache == "pt"
		spr_xx := spr_pt
	otherwise
		oClient:HTTPResponse:Content := redirekt()
	endcase
	text1 := ConvToANSICp( "<HTML><HEAD>" ) + CRLF
	text1 += ConvToANSICp( '<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">' ) + CRLF
	text1 += ConvToANSICp( '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">' ) + CRLF
	text1 += ConvToANSICp( '<META HTTP-EQUIV="Cache-Control" CONTENT="no-cache">' ) + CRLF
	text1 += ConvToANSICp( '<META HTTP-EQUIV="Expires" CONTENT="-1">' ) + CRLF
	bla := strtran( alltrim( MEMVAR->texte[ statsueber, spr_xx ] ), "</SUP>", "" )
	text1 += ConvToANSICp( "<TITLE>" + strtran( alltrim( bla ), "<SUP>", "" ) + "</TITLE>" ) + CRLF
	text1 += ConvToANSICp( '<link rel="stylesheet" href="devcon.css" type="text/css"></HEAD><BODY' ) + CRLF
	text1 += ConvToANSICp( ' bgcolor="' + MEMVAR->shinter + '">' ) + CRLF
	text1 += ConvToANSICp( '<CENTER>' )
	text1 += ConvToANSICp( '<H1>' + alltrim( MEMVAR->texte[ statsueber, spr_xx ] ) + "</H1></CENTER>" ) + CRLF
	text1 += ConvToANSICp( '<CENTER><H3>' + MEMVAR->texte[ charthinweis, spr_xx ] + "</H3></CENTER>" ) + CRLF
	text1 += ConvToANSICp( '<HR WIDTH="100%">' )
	text1 += ConvToANSICp( '<P><CENTER>' )
	text1 += ConvToANSICp( '<H2>' + alltrim( MEMVAR->texte[ statslaender, spr_xx ] ) + "</H2><P>" ) + CRLF
	if file( statistik + "\sprachen_" + sprache + ".jpg" )
		text1 += '<img src="/stats/sprachen_' + sprache + '.jpg" border="0">' + CRLF
	endif
	if file( statistik + "\laender_" + sprache + ".jpg" )
		text1 += '<img src="/stats/laender_' + sprache + '.jpg" border="0">' + CRLF
	endif
	if file( statistik + "\devcons_" + sprache + ".jpg" )
		text1 += '<img src="/stats/devcons_' + sprache + '.jpg" border="0">' + CRLF
	endif
	text1 += ConvToANSICp( '</CENTER><P><HR WIDTH="80%"><P><CENTER>' )
	text1 += ConvToANSICp( '<H2>' + alltrim( MEMVAR->texte[ statsxbase, spr_xx ] ) + "</H2><P>" ) + CRLF
	if file( statistik + "\xbnutzer_" + sprache + ".jpg" )
		text1 += '<img src="/stats/xbnutzer_' + sprache + '.jpg" border="0">' + CRLF
	endif
	if file( statistik + "\xbversion_" + sprache + ".jpg" )
		text1 += '<img src="/stats/xbversion_' + sprache + '.jpg" border="0">' + CRLF
	endif

	text1 += ConvToANSICp( '</CENTER><P><HR WIDTH="80%"><P><CENTER>' )
	text1 += ConvToANSICp( '<H2>' + alltrim( MEMVAR->texte[ statsinter, spr_xx ] ) + "</H2><P>" ) + CRLF
	if file( statistik + "\interessen_" + sprache + ".jpg" )
		text1 += '<img src="/stats/interessen_' + sprache + '.jpg" border="0">' + CRLF
	endif

	text1 += ConvToANSICp( '</CENTER><P><HR WIDTH="80%"><P><CENTER>' )
	text1 += ConvToANSICp( '<H2>' + alltrim( MEMVAR->texte[ statsxbspr, spr_xx ] ) + "</H2><BR>" ) + CRLF
	text1 += ConvToANSICp( '<I>' + alltrim( MEMVAR->texte[ klicknamespr, spr_xx ] ) + "</I><P>" ) + CRLF
	if file( statistik + "\xbasespralt_" + sprache + ".jpg" )
		text1 += '<div>'
		text1 += CRLF + '<map name="xbspralt">'
		text1 += CRLF + '<area shape="rect" coords="20,' + alltrim( str( MEMVAR->aMapGraSizes[ 1 ] - 79 ) ) + ' 102,' + alltrim( str( MEMVAR->aMapGraSizes[ 1 ] ) ) + '" href="/stats/ksdelphi_' + sprache + '.jpg" alt="Delphi" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="102,' + alltrim( str( MEMVAR->aMapGraSizes[ 1 ] - 79 ) ) + ' 185,' + alltrim( str( MEMVAR->aMapGraSizes[ 1 ] ) ) + '" href="/stats/ksfoxpro_' + sprache + '.jpg" alt="FoxPro" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="185,' + alltrim( str( MEMVAR->aMapGraSizes[ 1 ] - 79 ) ) + ' 267,' + alltrim( str( MEMVAR->aMapGraSizes[ 1 ] ) ) + '" href="/stats/ksflagship_' + sprache + '.jpg" alt="Flagship" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="267,' + alltrim( str( MEMVAR->aMapGraSizes[ 1 ] - 79 ) ) + ' 350,' + alltrim( str( MEMVAR->aMapGraSizes[ 1 ] ) ) + '" href="/stats/ksclipper_' + sprache + '.jpg" alt="Clipper" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="350,' + alltrim( str( MEMVAR->aMapGraSizes[ 1 ] - 79 ) ) + ' 432,' + alltrim( str( MEMVAR->aMapGraSizes[ 1 ] ) ) + '" href="/stats/ksclip4win_' + sprache + '.jpg" alt="Clip4Win" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="432,' + alltrim( str( MEMVAR->aMapGraSizes[ 1 ] - 79 ) ) + ' 515,' + alltrim( str( MEMVAR->aMapGraSizes[ 1 ] ) ) + '" href="/stats/ksdbase_' + sprache + '.jpg" alt="dBase" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="515,' + alltrim( str( MEMVAR->aMapGraSizes[ 1 ] - 79 ) ) + ' 597,' + alltrim( str( MEMVAR->aMapGraSizes[ 1 ] ) ) + '" href="/stats/ksvo_' + sprache + '.jpg" alt="Visual Objects" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="597,' + alltrim( str( MEMVAR->aMapGraSizes[ 1 ] - 79 ) ) + ' 680,' + alltrim( str( MEMVAR->aMapGraSizes[ 1 ] ) ) + '" href="/stats/ksxharbour_' + sprache + '.jpg" alt="xHarbour" target="_blank">'
		text1 += CRLF + '</map>'
		text1 += CRLF + '</div>'
		text1 += '<img src="/stats/xbasespralt_' + sprache + '.jpg" border="0" alt="' + alltrim( MEMVAR->texte[ statsxbspr, spr_xx ] ) + '" usemap="#xbspralt">' + CRLF
	endif
	if file( statistik + "\xbasespr_" + sprache + ".jpg" )
		text1 += '<div>'
		text1 += CRLF + '<map name="xbspr">'
		text1 += CRLF + '<area shape="rect" coords="20,' + alltrim( str( MEMVAR->aMapGraSizes[ 2 ] - 79 ) ) + ' 102,' + alltrim( str( MEMVAR->aMapGraSizes[ 2 ] ) ) + '" href="/stats/ksdelphi_' + sprache + '.jpg" alt="Delphi" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="102,' + alltrim( str( MEMVAR->aMapGraSizes[ 2 ] - 79 ) ) + ' 185,' + alltrim( str( MEMVAR->aMapGraSizes[ 2 ] ) ) + '" href="/stats/ksfoxpro_' + sprache + '.jpg" alt="FoxPro" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="185,' + alltrim( str( MEMVAR->aMapGraSizes[ 2 ] - 79 ) ) + ' 267,' + alltrim( str( MEMVAR->aMapGraSizes[ 2 ] ) ) + '" href="/stats/ksflagship_' + sprache + '.jpg" alt="Flagship" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="267,' + alltrim( str( MEMVAR->aMapGraSizes[ 2 ] - 79 ) ) + ' 350,' + alltrim( str( MEMVAR->aMapGraSizes[ 2 ] ) ) + '" href="/stats/ksclipper_' + sprache + '.jpg" alt="Clipper" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="350,' + alltrim( str( MEMVAR->aMapGraSizes[ 2 ] - 79 ) ) + ' 432,' + alltrim( str( MEMVAR->aMapGraSizes[ 2 ] ) ) + '" href="/stats/ksclip4win_' + sprache + '.jpg" alt="Clip4Win" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="432,' + alltrim( str( MEMVAR->aMapGraSizes[ 2 ] - 79 ) ) + ' 515,' + alltrim( str( MEMVAR->aMapGraSizes[ 2 ] ) ) + '" href="/stats/ksdbase_' + sprache + '.jpg" alt="dBase" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="515,' + alltrim( str( MEMVAR->aMapGraSizes[ 2 ] - 79 ) ) + ' 597,' + alltrim( str( MEMVAR->aMapGraSizes[ 2 ] ) ) + '" href="/stats/ksvo_' + sprache + '.jpg" alt="Visual Objects" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="597,' + alltrim( str( MEMVAR->aMapGraSizes[ 2 ] - 79 ) ) + ' 680,' + alltrim( str( MEMVAR->aMapGraSizes[ 2 ] ) ) + '" href="/stats/ksxharbour_' + sprache + '.jpg" alt="xHarbour" target="_blank">'
		text1 += CRLF + '</map>'
		text1 += CRLF + '</div>'
		text1 += '<img src="/stats/xbasespr_' + sprache + '.jpg" border="0" alt="' + alltrim( MEMVAR->texte[ statsxbspr, spr_xx ] ) + '" usemap="#xbspr">' + CRLF
	endif

	text1 += ConvToANSICp( '</CENTER><P><HR WIDTH="80%"><P><CENTER>' )
	text1 += ConvToANSICp( '<H2>' + alltrim( MEMVAR->texte[ statsaddon, spr_xx ] ) + "</H2><BR>" ) + CRLF
	text1 += ConvToANSICp( '<I>' + alltrim( MEMVAR->texte[ klicknameadd, spr_xx ] ) + "</I><P>" ) + CRLF
	if file( statistik + "\addons_" + sprache + ".jpg" )
		text1 += '<div>'
		text1 += CRLF + '<map name="xbadd">'
		text1 += CRLF + '<area shape="rect" coords="20,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] - 68 ) ) + ' 75,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] ) ) + '" href="/stats/kstopdown_' + sprache + '.jpg" alt="TopDown" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="75,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] - 68 ) ) + ' 130,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] ) ) + '" href="/stats/ksexpress_' + sprache + '.jpg" alt="eXpress++" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="130,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] - 68 ) ) + ' 185,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] ) ) + '" href="/stats/ksfivewin_' + sprache + '.jpg" alt="FiveWin" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="185,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] - 68 ) ) + ' 240,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] ) ) + '" href="/stats/kssql_' + sprache + '.jpg" alt="SQLExpress" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="240,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] - 68 ) ) + ' 295,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] ) ) + '" href="/stats/ksxb2_' + sprache + '.jpg" alt="Xb2.NET" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="295,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] - 68 ) ) + ' 350,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] ) ) + '" href="/stats/ksxcl_' + sprache + '.jpg" alt="XClass++" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="350,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] - 68 ) ) + ' 405,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] ) ) + '" href="/stats/ksxbh_' + sprache + '.jpg" alt="xbHCL" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="405,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] - 68 ) ) + ' 460,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] ) ) + '" href="/stats/kscock_' + sprache + '.jpg" alt="Cockpit" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="460,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] - 68 ) ) + ' 515,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] ) ) + '" href="/stats/ksmars_' + sprache + '.jpg" alt="MarshallSoft" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="515,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] - 68 ) ) + ' 570,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] ) ) + '" href="/stats/ksll_' + sprache + '.jpg" alt="List + Label" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="570,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] - 68 ) ) + ' 625,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] ) ) + '" href="/stats/ksvp_' + sprache + '.jpg" alt="VPE" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="625,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] - 68 ) ) + ' 680,' + alltrim( str( MEMVAR->aMapGraSizes[ 3 ] ) ) + '" href="/stats/ksrr_' + sprache + '.jpg" alt="R+R" target="_blank">'
		text1 += CRLF + '</map>'
		text1 += CRLF + '</div>'
		text1 += '<img src="/stats/addons_' + sprache + '.jpg" border="0" alt="' + alltrim( MEMVAR->texte[ statsaddon, spr_xx ] ) + '" usemap="#xbadd">' + CRLF
	endif
	if file( statistik + "\addonsw_" + sprache + ".jpg" )
		text1 += '<div>'
		text1 += CRLF + '<map name="xbaddw">'
		text1 += CRLF + '<area shape="rect" coords="20,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] - 68 ) ) + ' 75,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] ) ) + '" href="/stats/kstopdown_' + sprache + '.jpg" alt="TopDown" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="75,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] - 68 ) ) + ' 130,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] ) ) + '" href="/stats/ksexpress_' + sprache + '.jpg" alt="eXpress++" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="130,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] - 68 ) ) + ' 185,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] ) ) + '" href="/stats/ksfivewin_' + sprache + '.jpg" alt="FiveWin" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="185,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] - 68 ) ) + ' 240,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] ) ) + '" href="/stats/kssql_' + sprache + '.jpg" alt="SQLExpress" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="240,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] - 68 ) ) + ' 295,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] ) ) + '" href="/stats/ksxb2_' + sprache + '.jpg" alt="Xb2.NET" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="295,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] - 68 ) ) + ' 350,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] ) ) + '" href="/stats/ksxcl_' + sprache + '.jpg" alt="XClass++" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="350,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] - 68 ) ) + ' 405,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] ) ) + '" href="/stats/ksxbh_' + sprache + '.jpg" alt="xbHCL" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="405,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] - 68 ) ) + ' 460,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] ) ) + '" href="/stats/kscock_' + sprache + '.jpg" alt="Cockpit" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="460,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] - 68 ) ) + ' 515,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] ) ) + '" href="/stats/ksmars_' + sprache + '.jpg" alt="MarshallSoft" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="515,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] - 68 ) ) + ' 570,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] ) ) + '" href="/stats/ksll_' + sprache + '.jpg" alt="List + Label" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="570,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] - 68 ) ) + ' 625,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] ) ) + '" href="/stats/ksvp_' + sprache + '.jpg" alt="VPE" target="_blank">'
		text1 += CRLF + '<area shape="rect" coords="625,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] - 68 ) ) + ' 680,' + alltrim( str( MEMVAR->aMapGraSizes[ 4 ] ) ) + '" href="/stats/ksrr_' + sprache + '.jpg" alt="R+R" target="_blank">'
		text1 += CRLF + '</map>'
		text1 += CRLF + '</div>'
		text1 += '<img src="/stats/addonsw_' + sprache + '.jpg" border="0" alt="' + alltrim( MEMVAR->texte[ statsaddon, spr_xx ] ) + '" usemap="#xbaddw">' + CRLF
	endif
	text1 += '</CENTER>' + MeldeFooter()

	if "deflate" $ lower( var2char( oClient:HTTPRequest:AcceptEncoding() ) )
		oClient:HTTPResponse:CompressLevel := 7
	endif
	oClient:HTTPResponse:Content := text1
	oClient:CloseSession()
endif
RETURN .t.

FUNCTION GrossKlein( ctext, nmax )
local ctext1, ctext2, i, j, k, lgross
ctext1 := ""
ctext2 := ""
lgross := .f.
k := 0
i := len( ctext )
for j := 1 to i
	if isalpha( substr( ctext, j, 1 ) )
		ctext2 += substr( ctext, j, 1 )
		if isupper( substr( ctext, j, 1 ) )
			k ++
		endif
	else
		if k > nmax
			ctext2 := left( ctext2, 1 ) + lower( substr( ctext2, 2 ) )
		endif
		ctext1 += ctext2 + substr( ctext, j, 1 )
		ctext2 := ""
		k := 0
	endif
next
if isalpha( substr( ctext, i, 1 ) )
	if k > nmax
		ctext2 := left( ctext2, 1 ) + lower( substr( ctext2, 2 ) )
	endif
	ctext1 += ctext2
endif
return ctext1

FUNCTION erszeichen( ctext )
local ctext1, ctext2
ctext1 := alltrim( strtran( ctext, "&#180;", "'" ) )
ctext2 := strtran( ctext1, "&#269;", "c" )
ctext1 := strtran( ctext2, "&#324;", "n" )
ctext2 := strtran( ctext1, "&#281;", "e" )
ctext1 := strtran( ctext2, "&#380;", "z" )
ctext2 := strtran( ctext1, "&#347;", "s" )
ctext1 := strtran( ctext2, "&#322;", "l" )
ctext2 := strtran( ctext1, "<" )
ctext1 := strtran( ctext2, ">" )
ctext2 := strtran( ctext1, '"', "'" )
ctext1 := strtran( ctext2, "&#283;", "e" )
ctext2 := strtran( ctext1, "&#282;", "E" )
ctext1 := strtran( ctext2, "&#268;", "C" )
ctext2 := strtran( ctext1, chr( 7 ) )
ctext1 := strtran( ctext2, "&#345;", "r" )
ctext2 := strtran( ctext1, "&#336;", "O" )
ctext1 := strtran( ctext2, "&#344;", "R" )
ctext2 := strtran( ctext1, "&#357;", "tj" )
ctext1 := strtran( ctext2, "&#328;", "n" )
ctext2 := strtran( ctext1, "&#271;", "d" )
ctext1 := strtran( ctext2, "&#379;", "Z" )
ctext2 := strtran( ctext1, "&#261;", "a" )
ctext1 := strtran( ctext2, "&#318;", "l" )
ctext2 := strtran( ctext1, "&#352;", "S" )
ctext1 := strtran( ctext2, "&#353;", "s" )
ctext2 := strtran( ctext1, "&#323;", "N" )
ctext1 := strtran( ctext2, "&#346;", "S" )
ctext2 := strtran( ctext1, "&#321;", "L" )
ctext1 := strtran( ctext2, "&#378;", "z" )
ctext2 := strtran( ctext1, "&#262;", "C" )
ctext1 := strtran( ctext2, "&#366;", "U" )
return ctext1

procedure csvexport()
local nHandle, bla, aSaal, aZeit, nI
OpenDBF()
nHandle := FCreate( LW + "\DEVCONZIP\reg.csv" )
FWrite(nHandle, ConvToAnsiCP( "ParticipantsID;Title;First name;Last name;Company1;Company2;Department;Street;State/region;ZIP;City;Country;Website;E-mail;Participating as;Native tongue;First foreign language;Second foreign language;Xbaseversion;Laptop;Date of registration;Date of payment;Type of payment;Amount;Size of tee-shirt;Shuttleservice: 13/11/07;Shuttledienst 16/11/07;Hall for PCW;Subject" ) + CRLF)
MEMVAR->pcws := {}
select PCW
PCW->( DbGoTop() )
do while .not. PCW->( Eof() )
	bla := ""
	if file( datenpfad + "\" + PCW->TEILNEHMID + ".pcw" )
		bla := MemoRead( datenpfad + "\" + PCW->TEILNEHMID + ".pcw" )
	endif
	if ( PCW->SAAL > 0 ) .and. ( PCW->ZEIT > 0 ) .and. ( .not. empty( PCW->TEILNEHMID ) )
		Aadd( MEMVAR->pcws, { PCW->SAAL, PCW->ZEIT, PCW->TEILNEHMID, bla } )
	endif
	PCW->( DbSkip() )
enddo
Asort( MEMVAR->pcws,,, { | aX, aY | aX[3] < aY[3] } )
aSaal := { "hall 1", "hall 2", "little hall" }
aZeit := { "13:00", "14:30", "16:00", "17:30" }
select Melde
Melde->( DbGoTop() )
do while .not. Melde->( Eof() )
	if .not. Melde->( Deleted() )
		FWrite(nHandle, ConvToAnsiCP( alltrim( Melde->TEILNEHMID ) ) + ";" )
		do case
		case Melde->MUTTERSPRA == spr_de
			if Melde->ANREDE > 1
				bla := "Frau"
			else
				bla := "Herr"
			endif
		case Melde->MUTTERSPRA == spr_fr
			if Melde->ANREDE > 1
				bla := "Mme"
			else
				bla := "M."
			endif
		case Melde->MUTTERSPRA == spr_sp
			if Melde->ANREDE == 2
				bla := "Sra."
			elseif Melde->ANREDE == 3
				bla := "Srita."
			elseif Melde->ANREDE == 4
				bla := "Srita."
			else
				bla := "Sr."
			endif
		case Melde->MUTTERSPRA == spr_pt
			if Melde->ANREDE == 2
				bla := "Sra."
			elseif Melde->ANREDE == 3
				bla := "Senhorita"
			elseif Melde->ANREDE == 4
				bla := "Senhorita"
			else
				bla := "Sr."
			endif
		otherwise
			if Melde->ANREDE == 2
				bla := "Mrs."
			elseif Melde->ANREDE == 3
				bla := "Ms."
			elseif Melde->ANREDE == 4
				bla := "Miss."
			else
				bla := "Mr."
			endif
		endcase
		FWrite(nHandle, ConvToAnsiCP( bla ) + ";" )
		FWrite(nHandle, ConvToAnsiCP( alltrim( Melde->VORNAME ) ) + ";" )
		FWrite(nHandle, ConvToAnsiCP( alltrim( Melde->NACHNAME ) ) + ";" )
		FWrite(nHandle, ConvToAnsiCP( alltrim( Melde->FIRMA1 ) ) + ";" )
		FWrite(nHandle, ConvToAnsiCP( alltrim( Melde->FIRMA2 ) ) + ";" )
		FWrite(nHandle, ConvToAnsiCP( alltrim( Melde->ABTEILUNG ) ) + ";" )
		FWrite(nHandle, ConvToAnsiCP( alltrim( Melde->STRASSE ) ) + ";" )
		FWrite(nHandle, ConvToAnsiCP( alltrim( Melde->STAAT ) ) + ";" )
		FWrite(nHandle, ConvToAnsiCP( chr( 255 ) + alltrim( Melde->PLZ ) ) + ";" )
		FWrite(nHandle, ConvToAnsiCP( alltrim( Melde->ORT ) ) + ";" )
		FWrite(nHandle, ConvToAnsiCP( alltrim( Melde->LAND ) ) + ";" )
		FWrite(nHandle, ConvToAnsiCP( alltrim( Melde->WEBSEITE ) ) + ";" )
		FWrite(nHandle, ConvToAnsiCP( alltrim( Melde->EMAIL ) ) + ";" )
		do case
		case Melde->TEILNEHMER == 1
			bla := MEMVAR->texte[ teiltnehmer, spr_uk ]
		case Melde->TEILNEHMER == 2
			bla := MEMVAR->texte[ teilpartner, spr_uk ]
		case Melde->TEILNEHMER == 3
			bla := MEMVAR->texte[ teilkind, spr_uk ]
		case Melde->TEILNEHMER == 4
			bla := MEMVAR->texte[ teilfreund, spr_uk ]
		case Melde->TEILNEHMER == 5
			bla := MEMVAR->texte[ teilredner, spr_uk ]
		case Melde->TEILNEHMER == 6
			bla := MEMVAR->texte[ teilorgan, spr_uk ]
		case Melde->TEILNEHMER == 7
			bla := MEMVAR->texte[ teilsonst, spr_uk ]
		case Melde->TEILNEHMER == 8
			bla := MEMVAR->texte[ teilbpart, spr_uk ]
		case Melde->TEILNEHMER == 9
			bla := MEMVAR->texte[ teiltpart, spr_uk ]
		endcase
		FWrite(nHandle, ConvToAnsiCP( bla ) + ";" )
		do case
		case Melde->MUTTERSPRA == 1
			bla := "German"
		case Melde->MUTTERSPRA == 2
			bla := "French"
		case Melde->MUTTERSPRA == 3
			bla := "English"
		case Melde->MUTTERSPRA == 4
			bla := "Spanish"
		case Melde->MUTTERSPRA == 5
			bla := "Portuguese"
		case Melde->MUTTERSPRA == 6
			bla := "Dansk"
		case Melde->MUTTERSPRA == 7
			bla := "Italian"
		case Melde->MUTTERSPRA == 8
			bla := "Dutch"
		case Melde->MUTTERSPRA == 9
			bla := "Norwegian"
		case Melde->MUTTERSPRA == 10
			bla := "Polish"
		case Melde->MUTTERSPRA == 11
			bla := "Finnish"
		case Melde->MUTTERSPRA == 12
			bla := "Swedish"
		case Melde->MUTTERSPRA == 13
			bla := "Turkish"
		case Melde->MUTTERSPRA == 14
			bla := "Slovak"
		case Melde->MUTTERSPRA == 15
			bla := "Hungarian"
		case Melde->MUTTERSPRA == 16
			bla := "Romanian"
		case Melde->MUTTERSPRA == 17
			bla := "Croatian"
		case Melde->MUTTERSPRA == 18
			bla := "Czech"
		otherwise
			bla := alltrim( Melde->MUTTERSPSO )
		endcase
		FWrite(nHandle, ConvToAnsiCP( bla ) + ";" )
		do case
		case Melde->FREMDSPRA1 == 1
			bla := "German"
		case Melde->FREMDSPRA1 == 2
			bla := "French"
		case Melde->FREMDSPRA1 == 3
			bla := "English"
		case Melde->FREMDSPRA1 == 4
			bla := "Spanish"
		case Melde->FREMDSPRA1 == 5
			bla := "Portuguese"
		case Melde->FREMDSPRA1 == 6
			bla := "Dansk"
		case Melde->FREMDSPRA1 == 7
			bla := "Italian"
		case Melde->FREMDSPRA1 == 8
			bla := "Dutch"
		case Melde->FREMDSPRA1 == 9
			bla := "Norwegian"
		case Melde->FREMDSPRA1 == 10
			bla := "Polish"
		case Melde->FREMDSPRA1 == 11
			bla := "Finnish"
		case Melde->FREMDSPRA1 == 12
			bla := "Swedish"
		case Melde->FREMDSPRA1 == 13
			bla := "Turkish"
		case Melde->FREMDSPRA1 == 14
			bla := "Slovak"
		case Melde->FREMDSPRA1 == 15
			bla := "Hungarian"
		case Melde->FREMDSPRA1 == 16
			bla := "Romanian"
		case Melde->FREMDSPRA1 == 17
			bla := "Croatian"
		case Melde->FREMDSPRA1 == 18
			bla := "Czech"
		otherwise
			bla := ""
		endcase
		FWrite(nHandle, ConvToAnsiCP( bla ) + ";" )
		do case
		case Melde->FREMDSPRA2 == 1
			bla := "German"
		case Melde->FREMDSPRA2 == 2
			bla := "French"
		case Melde->FREMDSPRA2 == 3
			bla := "English"
		case Melde->FREMDSPRA2 == 4
			bla := "Spanish"
		case Melde->FREMDSPRA2 == 5
			bla := "Portuguese"
		case Melde->FREMDSPRA2 == 6
			bla := "Dansk"
		case Melde->FREMDSPRA2 == 7
			bla := "Italian"
		case Melde->FREMDSPRA2 == 8
			bla := "Dutch"
		case Melde->FREMDSPRA2 == 9
			bla := "Norwegian"
		case Melde->FREMDSPRA2 == 10
			bla := "Polish"
		case Melde->FREMDSPRA2 == 11
			bla := "Finnish"
		case Melde->FREMDSPRA2 == 12
			bla := "Swedish"
		case Melde->FREMDSPRA2 == 13
			bla := "Turkish"
		case Melde->FREMDSPRA2 == 14
			bla := "Slovak"
		case Melde->FREMDSPRA2 == 15
			bla := "Hungarian"
		case Melde->FREMDSPRA2 == 16
			bla := "Romanian"
		case Melde->FREMDSPRA2 == 17
			bla := "Croatian"
		case Melde->FREMDSPRA2 == 18
			bla := "Czech"
		otherwise
			bla := ""
		endcase
		FWrite(nHandle, ConvToAnsiCP( bla ) + ";" )
		do case
		case Melde->VERSION == 1
			bla := "< 1.5"
		case Melde->VERSION == 2
			bla := "1.5x"
		case Melde->VERSION == 3
			bla := "1.6x"
		case Melde->VERSION == 4
			bla := "1.7x"
		case Melde->VERSION == 5
			bla := "1.80"
		case Melde->VERSION == 6
			bla := "1.82.294"
		case Melde->VERSION == 7
			bla := "1.82.306"
		case Melde->VERSION == 8
			bla := "1.9x"
		otherwise
			bla := ""
		endcase
		FWrite(nHandle, ConvToAnsiCP( chr( 255 ) + bla ) + ";" )
		if Melde->LAPTOP
			bla := "Yes"
		else
			bla := "No"
		endif
		FWrite(nHandle, ConvToAnsiCP( bla ) + ";" )
		FWrite(nHandle, ConvToAnsiCP( alltrim( dtoc( Melde->ANMELDEDAT ) ) ) + ";" )
		FWrite(nHandle, ConvToAnsiCP( iif( .not. empty( Melde->ZAHLEINGAN ), alltrim( dtoc( Melde->ZAHLEINGAN ) ), "" ) ) + ";" )
		do case
		case Melde->ZAHLART == 1
			bla := "PayPal"
		case Melde->ZAHLART == 3
			bla := "money transfer"
		otherwise
			bla := ""
		endcase
		FWrite(nHandle, ConvToAnsiCP( bla ) + ";" )
		FWrite(nHandle, ConvToAnsiCP( alltrim( transform( Melde->PREIS, "@E ###.##" ) ) ) + ";" )
		do case
		case Melde->SHIRT == 1
			bla := "S"
		case Melde->SHIRT == 2
			bla := "M"
		case Melde->SHIRT == 3
			bla := "L"
		case Melde->SHIRT == 4
			bla := "XL"
		case Melde->SHIRT == 5
			bla := "XXL"
		case Melde->SHIRT == 6
			bla := "XS"
		case Melde->SHIRT == 7
			bla := "XXXL"
		otherwise
			bla := ""
		endcase
		FWrite(nHandle, ConvToAnsiCP( bla ) + ";" )
		bla := ""
		if .not. empty( Melde->UHRAB )
			bla := left( right( "0000" + alltrim( Melde->UHRAB ), 4 ), 2 ) + ":" + right( "0000" + alltrim( Melde->UHRAB ), 2 ) + " o'clock "
		endif
		do case
		case Melde->SHUTTLE == 1
			bla += "from Tegel airport"
		case Melde->SHUTTLE == 2
			bla += "from Schoenefeld airport"
		otherwise
			bla := ""
		endcase
		FWrite(nHandle, ConvToAnsiCP( bla ) + ";" )
		bla := ""
		if .not. empty( Melde->UHRHIN )
			bla := left( right( "0000" + alltrim( Melde->UHRHIN ), 4 ), 2 ) + ":" + right( "0000" + alltrim( Melde->UHRHIN ), 2 ) + " o'clock "
		endif
		do case
		case Melde->SHUTTLER == 1
			bla += "to Tegel airport"
		case Melde->SHUTTLER == 2
			bla += "to Schoenefeld airport"
		otherwise
			bla := ""
		endcase
		FWrite(nHandle, ConvToAnsiCP( bla ) + ";" )
		bla := ""
		nI := Ascan( MEMVAR->pcws, { |a| a[ 3 ] == Melde->TEILNEHMID } )
		if nI > 0
			bla := aSaal[ MEMVAR->pcws[ nI, 1 ] ] + ", " + aZeit[ MEMVAR->pcws[ nI, 2 ] ] + " o'clock"
		endif
		FWrite(nHandle, bla + ";" )
		bla := ""
		if nI > 0
			bla := MemoTran( MEMVAR->pcws[ nI, 4 ], " ", " " )
		endif
		FWrite(nHandle, bla + CRLF )
	endif
	Melde->( DbSkip() )
enddo
FClose(nHandle)
CloseDBF()
return

function PCDanlegen()
local retwert, astructure
retwert := .f.
astructure := {}
if .not. File( APP_ROOT, "D" )
	CreateDir( APP_ROOT )
endif
if .not. File( datenpfad, "D" )
	CreateDir( datenpfad )
endif
AAdd( aStructure, {"TEILNEHMID","C",10,0} )
AAdd( aStructure, {"ZEIT","N",1,0} )
AAdd( aStructure, {"SAAL","N",1,0} )

DbCreate( datenpfad + "\pcd.dbf", aStructure )
retwert := file( datenpfad + "\pcd.dbf" )
return retwert